#ifndef OT_GLYF_LOCA_HH
#define OT_GLYF_LOCA_HH


#include "../../hb-open-type.hh"


namespace OT {


/*
 * loca -- Index to Location
 * https://docs.microsoft.com/en-us/typography/opentype/spec/loca
 */
#define HB_OT_TAG_loca HB_TAG('l','o','c','a')

struct loca
{
  friend struct glyf;
  friend struct glyf_accelerator_t;

  static constexpr hb_tag_t tableTag = HB_OT_TAG_loca;

  bool sanitize (hb_sanitize_context_t *c HB_UNUSED) const
  {
    TRACE_SANITIZE (this);
    return_trace (true);
  }

  protected:
  UnsizedArrayOf<HBUINT8>
                dataZ;  /* Location data. */
  public:
  DEFINE_SIZE_MIN (0);  /* In reality, this is UNBOUNDED() type; but since we always
                         * check the size externally, allow Null() object of it by
                         * defining it _MIN instead. */
};


} /* namespace OT */


#endif /* OT_GLYF_LOCA_HH */
