/* Simple Plugin API */
/* SPDX-FileCopyrightText: Copyright © 2018 Wim Taymans */
/* SPDX-License-Identifier: MIT */

#ifndef SPA_PARAM_BUFFERS_H
#define SPA_PARAM_BUFFERS_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup spa_param
 * \{
 */

#include <spa/param/param.h>

/** properties for SPA_TYPE_OBJECT_ParamBuffers */
enum spa_param_buffers {
    SPA_PARAM_BUFFERS_START,
    SPA_PARAM_BUFFERS_buffers,    /**< number of buffers (Int) */
    SPA_PARAM_BUFFERS_blocks,    /**< number of data blocks per buffer (Int) */
    SPA_PARAM_BUFFERS_size,        /**< size of a data block memory (Int)*/
    SPA_PARAM_BUFFERS_stride,    /**< stride of data block memory (Int) */
    SPA_PARAM_BUFFERS_align,    /**< alignment of data block memory (Int) */
    SPA_PARAM_BUFFERS_dataType,    /**< possible memory types (Int, mask of enum spa_data_type) */
};

/** properties for SPA_TYPE_OBJECT_ParamMeta */
enum spa_param_meta {
    SPA_PARAM_META_START,
    SPA_PARAM_META_type,    /**< the metadata, one of enum spa_meta_type (Id enum spa_meta_type) */
    SPA_PARAM_META_size,    /**< the expected maximum size the meta (Int) */
};

/** properties for SPA_TYPE_OBJECT_ParamIO */
enum spa_param_io {
    SPA_PARAM_IO_START,
    SPA_PARAM_IO_id,    /**< type ID, uniquely identifies the io area (Id enum spa_io_type) */
    SPA_PARAM_IO_size,    /**< size of the io area (Int) */
};

/**
 * \}
 */

#ifdef __cplusplus
}  /* extern "C" */
#endif

#endif /* SPA_PARAM_BUFFERS_H */
