#line 1 "ad_aarch64.cpp"
//
// Copyright (c) 2003, 2023, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2021, Red Hat, Inc. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_aarch64.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "memory/allocation.inline.hpp"
#include "code/codeCache.hpp"
#include "code/compiledIC.hpp"
#include "code/nativeInst.hpp"
#include "code/vmreg.inline.hpp"
#include "gc/shared/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/compressedOops.hpp"
#include "oops/markWord.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "opto/c2_MacroAssembler.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/safepointMechanism.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "utilities/powerOfTwo.hpp"

//SourceForm

#line 1195 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"


  // Derived RegMask with conditionally allocatable registers

  void PhaseOutput::pd_perform_mach_node_analysis() {
  }

  int MachNode::pd_alignment_required() const {
    return 1;
  }

  int MachNode::compute_padding(int current_offset) const {
    return 0;
  }

  RegMask _ANY_REG32_mask;
  RegMask _ANY_REG_mask;
  RegMask _PTR_REG_mask;
  RegMask _NO_SPECIAL_REG32_mask;
  RegMask _NO_SPECIAL_REG_mask;
  RegMask _NO_SPECIAL_PTR_REG_mask;

  void reg_mask_init() {
    // We derive below RegMask(s) from the ones which are auto-generated from
    // adlc register classes to make AArch64 rheapbase (r27) and rfp (r29)
    // registers conditionally reserved.

    _ANY_REG32_mask = _ALL_REG32_mask;
    _ANY_REG32_mask.Remove(OptoReg::as_OptoReg(r31_sp->as_VMReg()));

    _ANY_REG_mask = _ALL_REG_mask;

    _PTR_REG_mask = _ALL_REG_mask;

    _NO_SPECIAL_REG32_mask = _ALL_REG32_mask;
    _NO_SPECIAL_REG32_mask.SUBTRACT(_NON_ALLOCATABLE_REG32_mask);

    _NO_SPECIAL_REG_mask = _ALL_REG_mask;
    _NO_SPECIAL_REG_mask.SUBTRACT(_NON_ALLOCATABLE_REG_mask);

    _NO_SPECIAL_PTR_REG_mask = _ALL_REG_mask;
    _NO_SPECIAL_PTR_REG_mask.SUBTRACT(_NON_ALLOCATABLE_REG_mask);

    // r27 is not allocatable when compressed oops is on and heapbase is not
    // zero, compressed klass pointers doesn't use r27 after JDK-8234794
    if (UseCompressedOops && (CompressedOops::ptrs_base() != NULL)) {
      _NO_SPECIAL_REG32_mask.Remove(OptoReg::as_OptoReg(r27->as_VMReg()));
      _NO_SPECIAL_REG_mask.Remove(OptoReg::as_OptoReg(r27->as_VMReg()));
      _NO_SPECIAL_PTR_REG_mask.Remove(OptoReg::as_OptoReg(r27->as_VMReg()));
    }

    // r29 is not allocatable when PreserveFramePointer is on
    if (PreserveFramePointer) {
      _NO_SPECIAL_REG32_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
      _NO_SPECIAL_REG_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
      _NO_SPECIAL_PTR_REG_mask.Remove(OptoReg::as_OptoReg(r29->as_VMReg()));
    }
  }

  // Optimizaton of volatile gets and puts
  // -------------------------------------
  //
  // AArch64 has ldar<x> and stlr<x> instructions which we can safely
  // use to implement volatile reads and writes. For a volatile read
  // we simply need
  //
  //   ldar<x>
  //
  // and for a volatile write we need
  //
  //   stlr<x>
  //
  // Alternatively, we can implement them by pairing a normal
  // load/store with a memory barrier. For a volatile read we need
  //
  //   ldr<x>
  //   dmb ishld
  //
  // for a volatile write
  //
  //   dmb ish
  //   str<x>
  //   dmb ish
  //
  // We can also use ldaxr and stlxr to implement compare and swap CAS
  // sequences. These are normally translated to an instruction
  // sequence like the following
  //
  //   dmb      ish
  // retry:
  //   ldxr<x>   rval raddr
  //   cmp       rval rold
  //   b.ne done
  //   stlxr<x>  rval, rnew, rold
  //   cbnz      rval retry
  // done:
  //   cset      r0, eq
  //   dmb ishld
  //
  // Note that the exclusive store is already using an stlxr
  // instruction. That is required to ensure visibility to other
  // threads of the exclusive write (assuming it succeeds) before that
  // of any subsequent writes.
  //
  // The following instruction sequence is an improvement on the above
  //
  // retry:
  //   ldaxr<x>  rval raddr
  //   cmp       rval rold
  //   b.ne done
  //   stlxr<x>  rval, rnew, rold
  //   cbnz      rval retry
  // done:
  //   cset      r0, eq
  //
  // We don't need the leading dmb ish since the stlxr guarantees
  // visibility of prior writes in the case that the swap is
  // successful. Crucially we don't have to worry about the case where
  // the swap is not successful since no valid program should be
  // relying on visibility of prior changes by the attempting thread
  // in the case where the CAS fails.
  //
  // Similarly, we don't need the trailing dmb ishld if we substitute
  // an ldaxr instruction since that will provide all the guarantees we
  // require regarding observation of changes made by other threads
  // before any change to the CAS address observed by the load.
  //
  // In order to generate the desired instruction sequence we need to
  // be able to identify specific 'signature' ideal graph node
  // sequences which i) occur as a translation of a volatile reads or
  // writes or CAS operations and ii) do not occur through any other
  // translation or graph transformation. We can then provide
  // alternative aldc matching rules which translate these node
  // sequences to the desired machine code sequences. Selection of the
  // alternative rules can be implemented by predicates which identify
  // the relevant node sequences.
  //
  // The ideal graph generator translates a volatile read to the node
  // sequence
  //
  //   LoadX[mo_acquire]
  //   MemBarAcquire
  //
  // As a special case when using the compressed oops optimization we
  // may also see this variant
  //
  //   LoadN[mo_acquire]
  //   DecodeN
  //   MemBarAcquire
  //
  // A volatile write is translated to the node sequence
  //
  //   MemBarRelease
  //   StoreX[mo_release] {CardMark}-optional
  //   MemBarVolatile
  //
  // n.b. the above node patterns are generated with a strict
  // 'signature' configuration of input and output dependencies (see
  // the predicates below for exact details). The card mark may be as
  // simple as a few extra nodes or, in a few GC configurations, may
  // include more complex control flow between the leading and
  // trailing memory barriers. However, whatever the card mark
  // configuration these signatures are unique to translated volatile
  // reads/stores -- they will not appear as a result of any other
  // bytecode translation or inlining nor as a consequence of
  // optimizing transforms.
  //
  // We also want to catch inlined unsafe volatile gets and puts and
  // be able to implement them using either ldar<x>/stlr<x> or some
  // combination of ldr<x>/stlr<x> and dmb instructions.
  //
  // Inlined unsafe volatiles puts manifest as a minor variant of the
  // normal volatile put node sequence containing an extra cpuorder
  // membar
  //
  //   MemBarRelease
  //   MemBarCPUOrder
  //   StoreX[mo_release] {CardMark}-optional
  //   MemBarCPUOrder
  //   MemBarVolatile
  //
  // n.b. as an aside, a cpuorder membar is not itself subject to
  // matching and translation by adlc rules.  However, the rule
  // predicates need to detect its presence in order to correctly
  // select the desired adlc rules.
  //
  // Inlined unsafe volatile gets manifest as a slightly different
  // node sequence to a normal volatile get because of the
  // introduction of some CPUOrder memory barriers to bracket the
  // Load. However, but the same basic skeleton of a LoadX feeding a
  // MemBarAcquire, possibly through an optional DecodeN, is still
  // present
  //
  //   MemBarCPUOrder
  //        ||       \\
  //   MemBarCPUOrder LoadX[mo_acquire]
  //        ||            |
  //        ||       {DecodeN} optional
  //        ||       /
  //     MemBarAcquire
  //
  // In this case the acquire membar does not directly depend on the
  // load. However, we can be sure that the load is generated from an
  // inlined unsafe volatile get if we see it dependent on this unique
  // sequence of membar nodes. Similarly, given an acquire membar we
  // can know that it was added because of an inlined unsafe volatile
  // get if it is fed and feeds a cpuorder membar and if its feed
  // membar also feeds an acquiring load.
  //
  // Finally an inlined (Unsafe) CAS operation is translated to the
  // following ideal graph
  //
  //   MemBarRelease
  //   MemBarCPUOrder
  //   CompareAndSwapX {CardMark}-optional
  //   MemBarCPUOrder
  //   MemBarAcquire
  //
  // So, where we can identify these volatile read and write
  // signatures we can choose to plant either of the above two code
  // sequences. For a volatile read we can simply plant a normal
  // ldr<x> and translate the MemBarAcquire to a dmb. However, we can
  // also choose to inhibit translation of the MemBarAcquire and
  // inhibit planting of the ldr<x>, instead planting an ldar<x>.
  //
  // When we recognise a volatile store signature we can choose to
  // plant at a dmb ish as a translation for the MemBarRelease, a
  // normal str<x> and then a dmb ish for the MemBarVolatile.
  // Alternatively, we can inhibit translation of the MemBarRelease
  // and MemBarVolatile and instead plant a simple stlr<x>
  // instruction.
  //
  // when we recognise a CAS signature we can choose to plant a dmb
  // ish as a translation for the MemBarRelease, the conventional
  // macro-instruction sequence for the CompareAndSwap node (which
  // uses ldxr<x>) and then a dmb ishld for the MemBarAcquire.
  // Alternatively, we can elide generation of the dmb instructions
  // and plant the alternative CompareAndSwap macro-instruction
  // sequence (which uses ldaxr<x>).
  //
  // Of course, the above only applies when we see these signature
  // configurations. We still want to plant dmb instructions in any
  // other cases where we may see a MemBarAcquire, MemBarRelease or
  // MemBarVolatile. For example, at the end of a constructor which
  // writes final/volatile fields we will see a MemBarRelease
  // instruction and this needs a 'dmb ish' lest we risk the
  // constructed object being visible without making the
  // final/volatile field writes visible.
  //
  // n.b. the translation rules below which rely on detection of the
  // volatile signatures and insert ldar<x> or stlr<x> are failsafe.
  // If we see anything other than the signature configurations we
  // always just translate the loads and stores to ldr<x> and str<x>
  // and translate acquire, release and volatile membars to the
  // relevant dmb instructions.
  //

  // is_CAS(int opcode, bool maybe_volatile)
  //
  // return true if opcode is one of the possible CompareAndSwapX
  // values otherwise false.

  bool is_CAS(int opcode, bool maybe_volatile)
  {
    switch(opcode) {
      // We handle these
    case Op_CompareAndSwapI:
    case Op_CompareAndSwapL:
    case Op_CompareAndSwapP:
    case Op_CompareAndSwapN:
    case Op_ShenandoahCompareAndSwapP:
    case Op_ShenandoahCompareAndSwapN:
    case Op_CompareAndSwapB:
    case Op_CompareAndSwapS:
    case Op_GetAndSetI:
    case Op_GetAndSetL:
    case Op_GetAndSetP:
    case Op_GetAndSetN:
    case Op_GetAndAddI:
    case Op_GetAndAddL:
      return true;
    case Op_CompareAndExchangeI:
    case Op_CompareAndExchangeN:
    case Op_CompareAndExchangeB:
    case Op_CompareAndExchangeS:
    case Op_CompareAndExchangeL:
    case Op_CompareAndExchangeP:
    case Op_WeakCompareAndSwapB:
    case Op_WeakCompareAndSwapS:
    case Op_WeakCompareAndSwapI:
    case Op_WeakCompareAndSwapL:
    case Op_WeakCompareAndSwapP:
    case Op_WeakCompareAndSwapN:
    case Op_ShenandoahWeakCompareAndSwapP:
    case Op_ShenandoahWeakCompareAndSwapN:
    case Op_ShenandoahCompareAndExchangeP:
    case Op_ShenandoahCompareAndExchangeN:
      return maybe_volatile;
    default:
      return false;
    }
  }

  // helper to determine the maximum number of Phi nodes we may need to
  // traverse when searching from a card mark membar for the merge mem
  // feeding a trailing membar or vice versa

// predicates controlling emit of ldr<x>/ldar<x>

bool unnecessary_acquire(const Node *barrier)
{
  assert(barrier->is_MemBar(), "expecting a membar");

  MemBarNode* mb = barrier->as_MemBar();

  if (mb->trailing_load()) {
    return true;
  }

  if (mb->trailing_load_store()) {
    Node* load_store = mb->in(MemBarNode::Precedent);
    assert(load_store->is_LoadStore(), "unexpected graph shape");
    return is_CAS(load_store->Opcode(), true);
  }

  return false;
}

bool needs_acquiring_load(const Node *n)
{
  assert(n->is_Load(), "expecting a load");
  LoadNode *ld = n->as_Load();
  return ld->is_acquire();
}

bool unnecessary_release(const Node *n)
{
  assert((n->is_MemBar() &&
          n->Opcode() == Op_MemBarRelease),
         "expecting a release membar");

  MemBarNode *barrier = n->as_MemBar();
  if (!barrier->leading()) {
    return false;
  } else {
    Node* trailing = barrier->trailing_membar();
    MemBarNode* trailing_mb = trailing->as_MemBar();
    assert(trailing_mb->trailing(), "Not a trailing membar?");
    assert(trailing_mb->leading_membar() == n, "inconsistent leading/trailing membars");

    Node* mem = trailing_mb->in(MemBarNode::Precedent);
    if (mem->is_Store()) {
      assert(mem->as_Store()->is_release(), "");
      assert(trailing_mb->Opcode() == Op_MemBarVolatile, "");
      return true;
    } else {
      assert(mem->is_LoadStore(), "");
      assert(trailing_mb->Opcode() == Op_MemBarAcquire, "");
      return is_CAS(mem->Opcode(), true);
    }
  }
  return false;
}

bool unnecessary_volatile(const Node *n)
{
  // assert n->is_MemBar();
  MemBarNode *mbvol = n->as_MemBar();

  bool release = mbvol->trailing_store();
  assert(!release || (mbvol->in(MemBarNode::Precedent)->is_Store() && mbvol->in(MemBarNode::Precedent)->as_Store()->is_release()), "");
#ifdef ASSERT
  if (release) {
    Node* leading = mbvol->leading_membar();
    assert(leading->Opcode() == Op_MemBarRelease, "");
    assert(leading->as_MemBar()->leading_store(), "");
    assert(leading->as_MemBar()->trailing_membar() == mbvol, "");
  }
#endif

  return release;
}

// predicates controlling emit of str<x>/stlr<x>

bool needs_releasing_store(const Node *n)
{
  // assert n->is_Store();
  StoreNode *st = n->as_Store();
  return st->trailing_membar() != NULL;
}

// predicate controlling translation of CAS
//
// returns true if CAS needs to use an acquiring load otherwise false

bool needs_acquiring_load_exclusive(const Node *n)
{
  assert(is_CAS(n->Opcode(), true), "expecting a compare and swap");
  LoadStoreNode* ldst = n->as_LoadStore();
  if (is_CAS(n->Opcode(), false)) {
    assert(ldst->trailing_membar() != NULL, "expected trailing membar");
  } else {
    return ldst->trailing_membar() != NULL;
  }

  // so we can just return true here
  return true;
}

#define __ _masm.

// advance declarations for helper functions to convert register
// indices to register objects

// the ad file has to provide implementations of certain methods
// expected by the generic code
//
// REQUIRED FUNCTIONALITY

//=============================================================================

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

int MachCallStaticJavaNode::ret_addr_offset()
{
  // call should be a simple bl
  int off = 4;
  return off;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  return 16; // movz, movk, movk, bl
}

int MachCallRuntimeNode::ret_addr_offset() {
  // for generated stubs the call will be
  //   bl(addr)
  // or with far branches
  //   bl(trampoline_stub)
  // for real runtime callouts it will be six instructions
  // see aarch64_enc_java_to_runtime
  //   adr(rscratch2, retaddr)
  //   lea(rscratch1, RuntimeAddress(addr)
  //   stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)))
  //   blr(rscratch1)
  CodeBlob *cb = CodeCache::find_blob(_entry_point);
  if (cb) {
    return 1 * NativeInstruction::instruction_size;
  } else {
    return 6 * NativeInstruction::instruction_size;
  }
}

//=============================================================================

#ifndef PRODUCT
void MachBreakpointNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  st->print("BREAKPOINT");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  __ brk(0);
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    C2_MacroAssembler _masm(&cbuf);
    for (int i = 0; i < _count; i++) {
      __ nop();
    }
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count * NativeInstruction::instruction_size;
  }

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("-- \t// MachConstantBaseNode (empty encoding)");
}
#endif

#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;

  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  if (C->output()->need_stack_bang(framesize))
    st->print("# stack bang size=%d\n\t", framesize);

  if (VM_Version::use_rop_protection()) {
    st->print("ldr  zr, [lr]\n\t");
    st->print("paciaz\n\t");
  }
  if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("sub  sp, sp, #%d\n\t", framesize);
    st->print("stp  rfp, lr, [sp, #%d]", framesize - 2 * wordSize);
    if (PreserveFramePointer) st->print("\n\tadd  rfp, sp, #%d", framesize - 2 * wordSize);
  } else {
    st->print("stp  lr, rfp, [sp, #%d]!\n\t", -(2 * wordSize));
    if (PreserveFramePointer) st->print("mov  rfp, sp\n\t");
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("sub  sp, sp, rscratch1");
  }
  if (C->stub_function() == NULL && BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
    st->print("\n\t");
    st->print("ldr  rscratch1, [guard]\n\t");
    st->print("dmb ishld\n\t");
    st->print("ldr  rscratch2, [rthread, #thread_disarmed_guard_value_offset]\n\t");
    st->print("cmp  rscratch1, rscratch2\n\t");
    st->print("b.eq skip");
    st->print("\n\t");
    st->print("blr #nmethod_entry_barrier_stub\n\t");
    st->print("b skip\n\t");
    st->print("guard: int\n\t");
    st->print("\n\t");
    st->print("skip:\n\t");
  }
}
#endif

void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);

  // n.b. frame size includes space for return pc and rfp
  const int framesize = C->output()->frame_size_in_bytes();

  // insert a nop at the start of the prolog so we can patch in a
  // branch if we need to invalidate the method later
  __ nop();

  if (C->clinit_barrier_on_entry()) {
    assert(!C->method()->holder()->is_not_initialized(), "initialization should have been started");

    Label L_skip_barrier;

    __ mov_metadata(rscratch2, C->method()->holder()->constant_encoding());
    __ clinit_barrier(rscratch2, rscratch1, &L_skip_barrier);
    __ far_jump(RuntimeAddress(SharedRuntime::get_handle_wrong_method_stub()));
    __ bind(L_skip_barrier);
  }

  if (C->max_vector_size() > 0) {
    __ reinitialize_ptrue();
  }

  int bangsize = C->output()->bang_size_in_bytes();
  if (C->output()->need_stack_bang(bangsize))
    __ generate_stack_overflow_check(bangsize);

  __ build_frame(framesize);

  if (C->stub_function() == NULL) {
    BarrierSetAssembler* bs = BarrierSet::barrier_set()->barrier_set_assembler();
    if (BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
      // Dummy labels for just measuring the code size
      Label dummy_slow_path;
      Label dummy_continuation;
      Label dummy_guard;
      Label* slow_path = &dummy_slow_path;
      Label* continuation = &dummy_continuation;
      Label* guard = &dummy_guard;
      if (!Compile::current()->output()->in_scratch_emit_size()) {
        // Use real labels from actual stub when not emitting code for the purpose of measuring its size
        C2EntryBarrierStub* stub = new (Compile::current()->comp_arena()) C2EntryBarrierStub();
        Compile::current()->output()->add_stub(stub);
        slow_path = &stub->entry();
        continuation = &stub->continuation();
        guard = &stub->guard();
      }
      // In the C2 code, we move the non-hot part of nmethod entry barriers out-of-line to a stub.
      bs->nmethod_entry_barrier(&_masm, slow_path, continuation, guard);
    }
  }

  if (VerifyStackAtCalls) {
    Unimplemented();
  }

  C->output()->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    ConstantTable& constant_table = C->output()->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0;
}

//=============================================================================

#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;
  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  st->print("# pop frame %d\n\t",framesize);

  if (framesize == 0) {
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("ldp  lr, rfp, [sp,#%d]\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, #%d\n\t", framesize);
  } else {
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, rscratch1\n\t");
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  }
  if (VM_Version::use_rop_protection()) {
    st->print("autiaz\n\t");
    st->print("ldr  zr, [lr]\n\t");
  }

  if (do_polling() && C->is_method_compilation()) {
    st->print("# test polling word\n\t");
    st->print("ldr  rscratch1, [rthread],#%d\n\t", in_bytes(JavaThread::polling_word_offset()));
    st->print("cmp  sp, rscratch1\n\t");
    st->print("bhi #slow_path");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);
  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  __ remove_frame(framesize);

  if (StackReservedPages > 0 && C->has_reserved_stack_access()) {
    __ reserved_stack_check();
  }

  if (do_polling() && C->is_method_compilation()) {
    Label dummy_label;
    Label* code_stub = &dummy_label;
    if (!C->output()->in_scratch_emit_size()) {
      C2SafepointPollStub* stub = new (C->comp_arena()) C2SafepointPollStub(__ offset());
      C->output()->add_stub(stub);
      code_stub = &stub->entry();
    }
    __ relocate(relocInfo::poll_return_type);
    __ safepoint_poll(*code_stub, true /* at_return */, false /* acquire */, true /* in_nmethod */);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // 1 for polling page.
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float or
// rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_predicate, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // we have 32 int registers * 2 halves
  int slots_of_int_registers = Register::number_of_registers * Register::max_slots_per_register;

  if (reg < slots_of_int_registers) {
    return rc_int;
  }

  // we have 32 float register * 8 halves
  int slots_of_float_registers = FloatRegister::number_of_registers * FloatRegister::max_slots_per_register;
  if (reg < slots_of_int_registers + slots_of_float_registers) {
    return rc_float;
  }

  int slots_of_predicate_registers = PRegister::number_of_registers * PRegister::max_slots_per_register;
  if (reg < slots_of_int_registers + slots_of_float_registers + slots_of_predicate_registers) {
    return rc_predicate;
  }

  // Between predicate regs & stack is the flags.
  assert(OptoReg::is_stack(reg), "blow up if spilling flags");

  return rc_stack;
}

uint MachSpillCopyNode::implementation(CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream *st) const {
  Compile* C = ra_->C;

  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");

  if (src_hi != OptoReg::Bad && !bottom_type()->isa_vectmask()) {
    assert((src_lo&1)==0 && src_lo+1==src_hi &&
           (dst_lo&1)==0 && dst_lo+1==dst_hi,
           "expected aligned-adjacent pairs");
  }

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  bool is64 = (src_lo & 1) == 0 && src_lo + 1 == src_hi &&
              (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi;
  int src_offset = ra_->reg2offset(src_lo);
  int dst_offset = ra_->reg2offset(dst_lo);

  if (bottom_type()->isa_vect() && !bottom_type()->isa_vectmask()) {
    uint ireg = ideal_reg();
    if (ireg == Op_VecA && cbuf) {
      C2_MacroAssembler _masm(cbuf);
      int sve_vector_reg_size_in_bytes = Matcher::scalable_vector_reg_size(T_BYTE);
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack->stack
        __ spill_copy_sve_vector_stack_to_stack(src_offset, dst_offset,
                                                sve_vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_stack) {
        __ spill_sve_vector(as_FloatRegister(Matcher::_regEncode[src_lo]), ra_->reg2offset(dst_lo),
                            sve_vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_float) {
        __ unspill_sve_vector(as_FloatRegister(Matcher::_regEncode[dst_lo]), ra_->reg2offset(src_lo),
                              sve_vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_float) {
        __ sve_orr(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
      } else {
        ShouldNotReachHere();
      }
    } else if (cbuf) {
      assert(ireg == Op_VecD || ireg == Op_VecX, "must be 64 bit or 128 bit vector");
      C2_MacroAssembler _masm(cbuf);
      assert((src_lo_rc != rc_int && dst_lo_rc != rc_int), "sanity");
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack->stack
        assert((src_offset & 7) == 0 && (dst_offset & 7) == 0, "unaligned stack offset");
        if (ireg == Op_VecD) {
          __ unspill(rscratch1, true, src_offset);
          __ spill(rscratch1, true, dst_offset);
        } else {
          __ spill_copy128(src_offset, dst_offset);
        }
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_float) {
        __ mov(as_FloatRegister(Matcher::_regEncode[dst_lo]),
               ireg == Op_VecD ? __ T8B : __ T16B,
               as_FloatRegister(Matcher::_regEncode[src_lo]));
      } else if (src_lo_rc == rc_float && dst_lo_rc == rc_stack) {
        __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                 ireg == Op_VecD ? __ D : __ Q,
                 ra_->reg2offset(dst_lo));
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_float) {
        __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   ireg == Op_VecD ? __ D : __ Q,
                   ra_->reg2offset(src_lo));
      } else {
        ShouldNotReachHere();
      }
    }
  } else if (cbuf) {
    C2_MacroAssembler _masm(cbuf);
    switch (src_lo_rc) {
    case rc_int:
      if (dst_lo_rc == rc_int) {  // gpr --> gpr copy
        if (is64) {
            __ mov(as_Register(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else {
            C2_MacroAssembler _masm(cbuf);
            __ movw(as_Register(Matcher::_regEncode[dst_lo]),
                    as_Register(Matcher::_regEncode[src_lo]));
        }
      } else if (dst_lo_rc == rc_float) { // gpr --> fpr copy
        if (is64) {
            __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_Register(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_Register(Matcher::_regEncode[src_lo]));
        }
      } else {                    // gpr --> stack spill
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ spill(as_Register(Matcher::_regEncode[src_lo]), is64, dst_offset);
      }
      break;
    case rc_float:
      if (dst_lo_rc == rc_int) {  // fpr --> gpr copy
        if (is64) {
            __ fmovd(as_Register(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_Register(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        }
      } else if (dst_lo_rc == rc_float) { // fpr --> fpr copy
        if (is64) {
            __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else {
            __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
        }
      } else {                    // fpr --> stack spill
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                 is64 ? __ D : __ S, dst_offset);
      }
      break;
    case rc_stack:
      if (dst_lo_rc == rc_int) {  // stack --> gpr load
        __ unspill(as_Register(Matcher::_regEncode[dst_lo]), is64, src_offset);
      } else if (dst_lo_rc == rc_float) { // stack --> fpr load
        __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   is64 ? __ D : __ S, src_offset);
      } else if (dst_lo_rc == rc_predicate) {
        __ unspill_sve_predicate(as_PRegister(Matcher::_regEncode[dst_lo]), ra_->reg2offset(src_lo),
                                 Matcher::scalable_vector_reg_size(T_BYTE) >> 3);
      } else {                    // stack --> stack copy
        assert(dst_lo_rc == rc_stack, "spill to bad register class");
        if (ideal_reg() == Op_RegVectMask) {
          __ spill_copy_sve_predicate_stack_to_stack(src_offset, dst_offset,
                                                     Matcher::scalable_vector_reg_size(T_BYTE) >> 3);
        } else {
          __ unspill(rscratch1, is64, src_offset);
          __ spill(rscratch1, is64, dst_offset);
        }
      }
      break;
    case rc_predicate:
      if (dst_lo_rc == rc_predicate) {
        __ sve_mov(as_PRegister(Matcher::_regEncode[dst_lo]), as_PRegister(Matcher::_regEncode[src_lo]));
      } else if (dst_lo_rc == rc_stack) {
        __ spill_sve_predicate(as_PRegister(Matcher::_regEncode[src_lo]), ra_->reg2offset(dst_lo),
                               Matcher::scalable_vector_reg_size(T_BYTE) >> 3);
      } else {
        assert(false, "bad src and dst rc_class combination.");
        ShouldNotReachHere();
      }
      break;
    default:
      assert(false, "bad rc_class for spill");
      ShouldNotReachHere();
    }
  }

  if (st) {
    st->print("spill ");
    if (src_lo_rc == rc_stack) {
      st->print("[sp, #%d] -> ", ra_->reg2offset(src_lo));
    } else {
      st->print("%s -> ", Matcher::regName[src_lo]);
    }
    if (dst_lo_rc == rc_stack) {
      st->print("[sp, #%d]", ra_->reg2offset(dst_lo));
    } else {
      st->print("%s", Matcher::regName[dst_lo]);
    }
    if (bottom_type()->isa_vect() && !bottom_type()->isa_vectmask()) {
      int vsize = 0;
      switch (ideal_reg()) {
      case Op_VecD:
        vsize = 64;
        break;
      case Op_VecX:
        vsize = 128;
        break;
      case Op_VecA:
        vsize = Matcher::scalable_vector_reg_size(T_BYTE) * 8;
        break;
      default:
        assert(false, "bad register type for spill");
        ShouldNotReachHere();
      }
      st->print("\t# vector spill size = %d", vsize);
    } else if (ideal_reg() == Op_RegVectMask) {
      assert(Matcher::supports_scalable_vector(), "bad register type for spill");
      int vsize = Matcher::scalable_predicate_reg_slots() * 32;
      st->print("\t# predicate spill size = %d", vsize);
    } else {
      st->print("\t# spill size = %d", is64 ? 64 : 32);
    }
  }

  return 0;

}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  if (!ra_)
    st->print("N%d = SpillCopy(N%d)", _idx, in(1)->_idx);
  else
    implementation(NULL, ra_, false, st);
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation(&cbuf, ra_, false, NULL);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("add %s, rsp, #%d]\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);

  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg    = ra_->get_encode(this);

  // This add will handle any 24-bit signed offset. 24 bits allows an
  // 8 megabyte stack frame.
  __ add(as_Register(reg), sp, offset);
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_).
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());

  if (Assembler::operand_valid_for_add_sub_immediate(offset)) {
    return NativeInstruction::instruction_size;
  } else {
    return 2 * NativeInstruction::instruction_size;
  }
}

//=============================================================================

#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  st->print_cr("# MachUEPNode");
  if (UseCompressedClassPointers) {
    st->print_cr("\tldrw rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    if (CompressedKlassPointers::shift() != 0) {
      st->print_cr("\tdecode_klass_not_null rscratch1, rscratch1");
    }
  } else {
   st->print_cr("\tldr rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
  }
  st->print_cr("\tcmp r0, rscratch1\t # Inline cache check");
  st->print_cr("\tbne, SharedRuntime::_ic_miss_stub");
}
#endif

void MachUEPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const
{
  // This is the unverified entry point.
  C2_MacroAssembler _masm(&cbuf);

  __ cmp_klass(j_rarg0, rscratch2, rscratch1);
  Label skip;
  // TODO
  // can we avoid this skip and still use a reloc?
  __ br(Assembler::EQ, skip);
  __ far_jump(RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  __ bind(skip);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_);
}

// REQUIRED EMIT CODE

//=============================================================================

// Emit exception handler code.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf)
{
  // mov rscratch1 #exception_blob_entry_point
  // br rscratch1
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_exception_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();
  __ far_jump(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf)
{
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_deopt_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();

  __ adr(lr, __ pc());
  __ far_jump(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));

  assert(__ offset() - offset == (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// REQUIRED MATCHER CODE

//=============================================================================

bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode))
    return false;

  switch (opcode) {
    case Op_OnSpinWait:
      return VM_Version::supports_on_spin_wait();
    case Op_CacheWB:
    case Op_CacheWBPreSync:
    case Op_CacheWBPostSync:
      if (!VM_Version::supports_data_cache_line_flush()) {
        return false;
      }
      break;
    case Op_ExpandBits:
    case Op_CompressBits:
      if (!VM_Version::supports_svebitperm()) {
        return false;
      }
      break;
    case Op_FmaF:
    case Op_FmaD:
    case Op_FmaVF:
    case Op_FmaVD:
      if (!UseFMA) {
        return false;
      }
      break;
  }

  return true; // Per default match rules are supported.
}

const RegMask* Matcher::predicate_reg_mask(void) {
  return &_PR_REG_mask;
}

const TypeVectMask* Matcher::predicate_reg_type(const Type* elemTy, int length) {
  return new TypeVectMask(elemTy, length);
}

// Vector calling convention not yet implemented.
bool Matcher::supports_vector_calling_convention(void) {
  return false;
}

OptoRegPair Matcher::vector_return_value(uint ideal_reg) {
  Unimplemented();
  return OptoRegPair(0, 0);
}

// Is this branch offset short enough that a short branch can be used?
//
// NOTE: If the platform does not provide any short branch variants, then
//       this method should return false for offset 0.
bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // The passed offset is relative to address of the branch.

  return (-32768 <= offset && offset < 32768);
}

// Vector width in bytes.
int Matcher::vector_width_in_bytes(BasicType bt) {
  // The MaxVectorSize should have been set by detecting SVE max vector register size.
  int size = MIN2((UseSVE > 0) ? 256 : 16, (int)MaxVectorSize);
  // Minimum 2 values in vector
  if (size < 2*type2aelembytes(bt)) size = 0;
  // But never < 4
  if (size < 4) size = 0;
  return size;
}

// Limits on vector size (number of elements) loaded into vector.
int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}

int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Limit the min vector size to 8 bytes.
  int size = 8 / type2aelembytes(bt);
  if (bt == T_BYTE) {
    // To support vector api shuffle/rearrange.
    size = 4;
  } else if (bt == T_BOOLEAN) {
    // To support vector api load/store mask.
    size = 2;
  }
  if (size < 2) size = 2;
  return MIN2(size, max_size);
}

int Matcher::superword_max_vector_size(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

// Actual max scalable vector register length.
int Matcher::scalable_vector_reg_size(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

// Vector ideal reg.
uint Matcher::vector_ideal_reg(int len) {
  if (UseSVE > 0 && 16 < len && len <= 256) {
    return Op_VecA;
  }
  switch(len) {
    // For 16-bit/32-bit mask vector, reuse VecD.
    case  2:
    case  4:
    case  8: return Op_VecD;
    case 16: return Op_VecX;
  }
  ShouldNotReachHere();
  return 0;
}

MachOper* Matcher::pd_specialize_generic_vector_operand(MachOper* generic_opnd, uint ideal_reg, bool is_temp) {
  assert(Matcher::is_generic_vector(generic_opnd), "not generic");
  switch (ideal_reg) {
    case Op_VecA: return new vecAOper();
    case Op_VecD: return new vecDOper();
    case Op_VecX: return new vecXOper();
  }
  ShouldNotReachHere();
  return NULL;
}

bool Matcher::is_reg2reg_move(MachNode* m) {
  return false;
}

bool Matcher::is_generic_vector(MachOper* opnd)  {
  return opnd->opcode() == VREG;
}

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  R0_num || reg == R0_H_num ||
    reg ==  R1_num || reg == R1_H_num ||
    reg ==  R2_num || reg == R2_H_num ||
    reg ==  R3_num || reg == R3_H_num ||
    reg ==  R4_num || reg == R4_H_num ||
    reg ==  R5_num || reg == R5_H_num ||
    reg ==  R6_num || reg == R6_H_num ||
    reg ==  R7_num || reg == R7_H_num ||
    reg ==  V0_num || reg == V0_H_num ||
    reg ==  V1_num || reg == V1_H_num ||
    reg ==  V2_num || reg == V2_H_num ||
    reg ==  V3_num || reg == V3_H_num ||
    reg ==  V4_num || reg == V4_H_num ||
    reg ==  V5_num || reg == V5_H_num ||
    reg ==  V6_num || reg == V6_H_num ||
    reg ==  V7_num || reg == V7_H_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

uint Matcher::int_pressure_limit()
{
  // JDK-8183543: When taking the number of available registers as int
  // register pressure threshold, the jtreg test:
  // test/hotspot/jtreg/compiler/regalloc/TestC2IntPressure.java
  // failed due to C2 compilation failure with
  // "COMPILE SKIPPED: failed spill-split-recycle sanity check".
  //
  // A derived pointer is live at CallNode and then is flagged by RA
  // as a spilled LRG. Spilling heuristics(Spill-USE) explicitly skip
  // derived pointers and lastly fail to spill after reaching maximum
  // number of iterations. Lowering the default pressure threshold to
  // (_NO_SPECIAL_REG32_mask.Size() minus 1) forces CallNode to become
  // a high register pressure area of the code so that split_DEF can
  // generate DefinitionSpillCopy for the derived pointer.
  uint default_int_pressure_threshold = _NO_SPECIAL_REG32_mask.Size() - 1;
  if (!PreserveFramePointer) {
    // When PreserveFramePointer is off, frame pointer is allocatable,
    // but different from other SOC registers, it is excluded from
    // fatproj's mask because its save type is No-Save. Decrease 1 to
    // ensure high pressure at fatproj when PreserveFramePointer is off.
    // See check_pressure_at_fatproj().
    default_int_pressure_threshold--;
  }
  return (INTPRESSURE == -1) ? default_int_pressure_threshold : INTPRESSURE;
}

uint Matcher::float_pressure_limit()
{
  // _FLOAT_REG_mask is generated by adlc from the float_reg register class.
  return (FLOATPRESSURE == -1) ? _FLOAT_REG_mask.Size() : FLOATPRESSURE;
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI.
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL.
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL.
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

bool size_fits_all_mem_uses(AddPNode* addp, int shift) {
  for (DUIterator_Fast imax, i = addp->fast_outs(imax); i < imax; i++) {
    Node* u = addp->fast_out(i);
    if (u->is_LoadStore()) {
      // On AArch64, LoadStoreNodes (i.e. compare and swap
      // instructions) only take register indirect as an operand, so
      // any attempt to use an AddPNode as an input to a LoadStoreNode
      // must fail.
      return false;
    }
    if (u->is_Mem()) {
      int opsize = u->as_Mem()->memory_size();
      assert(opsize > 0, "unexpected memory operand size");
      if (u->as_Mem()->memory_size() != (1<<shift)) {
        return false;
      }
    }
  }
  return true;
}

// Convert BootTest condition to Assembler condition.
// Replicate the logic of cmpOpOper::ccode() and cmpOpUOper::ccode().
Assembler::Condition to_assembler_cond(BoolTest::mask cond) {
  Assembler::Condition result;
  switch(cond) {
    case BoolTest::eq:
      result = Assembler::EQ; break;
    case BoolTest::ne:
      result = Assembler::NE; break;
    case BoolTest::le:
      result = Assembler::LE; break;
    case BoolTest::ge:
      result = Assembler::GE; break;
    case BoolTest::lt:
      result = Assembler::LT; break;
    case BoolTest::gt:
      result = Assembler::GT; break;
    case BoolTest::ule:
      result = Assembler::LS; break;
    case BoolTest::uge:
      result = Assembler::HS; break;
    case BoolTest::ult:
      result = Assembler::LO; break;
    case BoolTest::ugt:
      result = Assembler::HI; break;
    case BoolTest::overflow:
      result = Assembler::VS; break;
    case BoolTest::no_overflow:
      result = Assembler::VC; break;
    default:
      ShouldNotReachHere();
      return Assembler::Condition(-1);
  }

  // Check conversion
  if (cond & BoolTest::unsigned_compare) {
    assert(cmpOpUOper((BoolTest::mask)((int)cond & ~(BoolTest::unsigned_compare))).ccode() == result, "Invalid conversion");
  } else {
    assert(cmpOpOper(cond).ccode() == result, "Invalid conversion");
  }

  return result;
}

// Binary src (Replicate con)
bool is_valid_sve_arith_imm_pattern(Node* n, Node* m) {
  if (n == NULL || m == NULL) {
    return false;
  }

  if (UseSVE == 0 || m->Opcode() != Op_Replicate) {
    return false;
  }

  Node* imm_node = m->in(1);
  if (!imm_node->is_Con()) {
    return false;
  }

  const Type* t = imm_node->bottom_type();
  if (!(t->isa_int() || t->isa_long())) {
    return false;
  }

  switch (n->Opcode()) {
  case Op_AndV:
  case Op_OrV:
  case Op_XorV: {
    Assembler::SIMD_RegVariant T = Assembler::elemType_to_regVariant(Matcher::vector_element_basic_type(n));
    uint64_t value = t->isa_long() ? (uint64_t)imm_node->get_long() : (uint64_t)imm_node->get_int();
    return Assembler::operand_valid_for_sve_logical_immediate(Assembler::regVariant_to_elemBits(T), value);
  }
  case Op_AddVB:
    return (imm_node->get_int() <= 255 && imm_node->get_int() >= -255);
  case Op_AddVS:
  case Op_AddVI:
    return Assembler::operand_valid_for_sve_add_sub_immediate((int64_t)imm_node->get_int());
  case Op_AddVL:
    return Assembler::operand_valid_for_sve_add_sub_immediate(imm_node->get_long());
  default:
    return false;
  }
}

// (XorV src (Replicate m1))
// (XorVMask src (MaskAll m1))
bool is_vector_bitwise_not_pattern(Node* n, Node* m) {
  if (n != NULL && m != NULL) {
    return (n->Opcode() == Op_XorV || n->Opcode() == Op_XorVMask) &&
           VectorNode::is_all_ones_vector(m);
  }
  return false;
}

// Should the matcher clone input 'm' of node 'n'?
bool Matcher::pd_clone_node(Node* n, Node* m, Matcher::MStack& mstack) {
  if (is_vshift_con_pattern(n, m) ||
      is_vector_bitwise_not_pattern(n, m) ||
      is_valid_sve_arith_imm_pattern(n, m)) {
    mstack.push(m, Visit);
    return true;
  }
  return false;
}

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?
bool Matcher::pd_clone_address_expressions(AddPNode* m, Matcher::MStack& mstack, VectorSet& address_visited) {
  if (clone_base_plus_offset_address(m, mstack, address_visited)) {
    return true;
  }

  Node *off = m->in(AddPNode::Offset);
  if (off->Opcode() == Op_LShiftL && off->in(2)->is_Con() &&
      size_fits_all_mem_uses(m, off->in(2)->get_int()) &&
      // Are there other uses besides address expressions?
      !is_visited(off)) {
    address_visited.set(off->_idx); // Flag as address_visited
    mstack.push(off->in(2), Visit);
    Node *conv = off->in(1);
    if (conv->Opcode() == Op_ConvI2L &&
        // Are there other uses besides address expressions?
        !is_visited(conv)) {
      address_visited.set(conv->_idx); // Flag as address_visited
      mstack.push(conv->in(1), Pre_Visit);
    } else {
      mstack.push(conv, Pre_Visit);
    }
    address_visited.test_set(m->_idx); // Flag as address_visited
    mstack.push(m->in(AddPNode::Address), Pre_Visit);
    mstack.push(m->in(AddPNode::Base), Pre_Visit);
    return true;
  } else if (off->Opcode() == Op_ConvI2L &&
             // Are there other uses besides address expressions?
             !is_visited(off)) {
    address_visited.test_set(m->_idx); // Flag as address_visited
    address_visited.set(off->_idx); // Flag as address_visited
    mstack.push(off->in(1), Pre_Visit);
    mstack.push(m->in(AddPNode::Address), Pre_Visit);
    mstack.push(m->in(AddPNode::Base), Pre_Visit);
    return true;
  }
  return false;
}

#define MOV_VOLATILE(REG, BASE, INDEX, SCALE, DISP, SCRATCH, INSN)      \
  C2_MacroAssembler _masm(&cbuf);                                       \
  {                                                                     \
    guarantee(INDEX == -1, "mode not permitted for volatile");          \
    guarantee(DISP == 0, "mode not permitted for volatile");            \
    guarantee(SCALE == 0, "mode not permitted for volatile");           \
    __ INSN(REG, as_Register(BASE));                                    \
  }


static Address mem2address(int opcode, Register base, int index, int size, int disp)
  {
    Address::extend scale;

    // Hooboy, this is fugly.  We need a way to communicate to the
    // encoder that the index needs to be sign extended, so we have to
    // enumerate all the cases.
    switch (opcode) {
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDI2LN:
    case INDINDEXI2L:
    case INDINDEXI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      return Address(base, disp);
    } else {
      assert(disp == 0, "unsupported address mode: disp = %d", disp);
      return Address(base, as_Register(index), scale);
    }
  }


typedef void (MacroAssembler::* mem_insn)(Register Rt, const Address &adr);
typedef void (MacroAssembler::* mem_insn2)(Register Rt, Register adr);
typedef void (MacroAssembler::* mem_float_insn)(FloatRegister Rt, const Address &adr);
typedef void (MacroAssembler::* mem_vector_insn)(FloatRegister Rt,
                                  MacroAssembler::SIMD_RegVariant T, const Address &adr);

  // Used for all non-volatile memory accesses.  The use of
  // $mem->opcode() to discover whether this pattern uses sign-extended
  // offsets is something of a kludge.
  static void loadStore(C2_MacroAssembler masm, mem_insn insn,
                        Register reg, int opcode,
                        Register base, int index, int scale, int disp,
                        int size_in_memory)
  {
    Address addr = mem2address(opcode, base, index, scale, disp);
    if (addr.getMode() == Address::base_plus_offset) {
      /* If we get an out-of-range offset it is a bug in the compiler,
         so we assert here. */
      assert(Address::offset_ok_for_immed(addr.offset(), exact_log2(size_in_memory)),
             "c2 compiler bug");
      /* Fix up any out-of-range offsets. */
      assert_different_registers(rscratch1, base);
      assert_different_registers(rscratch1, reg);
      addr = masm.legitimize_address(addr, size_in_memory, rscratch1);
    }
    (masm.*insn)(reg, addr);
  }

  static void loadStore(C2_MacroAssembler masm, mem_float_insn insn,
                        FloatRegister reg, int opcode,
                        Register base, int index, int size, int disp,
                        int size_in_memory)
  {
    Address::extend scale;

    switch (opcode) {
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      /* If we get an out-of-range offset it is a bug in the compiler,
         so we assert here. */
      assert(Address::offset_ok_for_immed(disp, exact_log2(size_in_memory)), "c2 compiler bug");
      /* Fix up any out-of-range offsets. */
      assert_different_registers(rscratch1, base);
      Address addr = Address(base, disp);
      addr = masm.legitimize_address(addr, size_in_memory, rscratch1);
      (masm.*insn)(reg, addr);
    } else {
      assert(disp == 0, "unsupported address mode: disp = %d", disp);
      (masm.*insn)(reg, Address(base, as_Register(index), scale));
    }
  }

  static void loadStore(C2_MacroAssembler masm, mem_vector_insn insn,
                        FloatRegister reg, MacroAssembler::SIMD_RegVariant T,
                        int opcode, Register base, int index, int size, int disp)
  {
    if (index == -1) {
      (masm.*insn)(reg, T, Address(base, disp));
    } else {
      assert(disp == 0, "unsupported address mode");
      (masm.*insn)(reg, T, Address(base, as_Register(index), Address::lsl(size)));
    }
  }


#line 1660 "ad_aarch64.cpp"


//SourceForm

#line 91 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"


  typedef void (C2_MacroAssembler::* sve_mem_insn_predicate)(FloatRegister Rt, Assembler::SIMD_RegVariant T,
                                                             PRegister Pg, const Address &adr);

  // Predicated load/store, with optional ptrue to all elements of given predicate register.
  static void loadStoreA_predicated(C2_MacroAssembler masm, bool is_store, FloatRegister reg,
                                    PRegister pg, BasicType mem_elem_bt, BasicType vector_elem_bt,
                                    int opcode, Register base, int index, int size, int disp) {
    sve_mem_insn_predicate insn;
    int mesize = type2aelembytes(mem_elem_bt);
    if (index == -1) {
      assert(size == 0, "unsupported address mode: scale size = %d", size);
      switch(mesize) {
      case 1:
        insn = is_store ? &C2_MacroAssembler::sve_st1b : &C2_MacroAssembler::sve_ld1b;
        break;
      case 2:
        insn = is_store ? &C2_MacroAssembler::sve_st1h : &C2_MacroAssembler::sve_ld1h;
        break;
      case 4:
        insn = is_store ? &C2_MacroAssembler::sve_st1w : &C2_MacroAssembler::sve_ld1w;
        break;
      case 8:
        insn = is_store ? &C2_MacroAssembler::sve_st1d : &C2_MacroAssembler::sve_ld1d;
        break;
      default:
        assert(false, "unsupported");
        ShouldNotReachHere();
      }
      int imm4 = disp / mesize / Matcher::scalable_vector_reg_size(vector_elem_bt);
      (masm.*insn)(reg, Assembler::elemType_to_regVariant(vector_elem_bt), pg, Address(base, imm4));
    } else {
      assert(false, "unimplemented");
      ShouldNotReachHere();
    }
  }

  bool Matcher::match_rule_supported_superword(int opcode, int vlen, BasicType bt) {
    if (UseSVE == 0) {
      // These operations are not profitable to be vectorized on NEON, because no direct
      // NEON instructions support them. But the match rule support for them is profitable for
      // Vector API intrinsics.
      if ((opcode == Op_VectorCastD2X && bt == T_INT) ||
          (opcode == Op_VectorCastL2X && bt == T_FLOAT) ||
          (opcode == Op_CountLeadingZerosV && bt == T_LONG) ||
          (opcode == Op_CountTrailingZerosV && bt == T_LONG) ||
          // The vector implementation of Op_AddReductionVD/F is for the Vector API only.
          // It is not suitable for auto-vectorization because it does not add the elements
          // in the same order as sequential code, and FP addition is non-associative.
          opcode == Op_AddReductionVD || opcode == Op_AddReductionVF ||
          opcode == Op_MulReductionVD || opcode == Op_MulReductionVF ||
          opcode == Op_MulVL) {
        return false;
      }
    }
    return match_rule_supported_vector(opcode, vlen, bt);
  }

  // Identify extra cases that we might want to provide match rules for vector nodes and
  // other intrinsics guarded with vector length (vlen) and element type (bt).
  bool Matcher::match_rule_supported_vector(int opcode, int vlen, BasicType bt) {
    if (!match_rule_supported(opcode)) {
      return false;
    }

    int length_in_bytes = vlen * type2aelembytes(bt);
    if (UseSVE == 0 && length_in_bytes > 16) {
      return false;
    }

    // Check whether specific Op is supported.
    // Fail fast, otherwise fall through to common vector_size_supported() check.
    switch (opcode) {
      case Op_AndVMask:
      case Op_OrVMask:
      case Op_XorVMask:
      case Op_MaskAll:
      case Op_VectorMaskGen:
      case Op_LoadVectorMasked:
      case Op_StoreVectorMasked:
      case Op_LoadVectorGather:
      case Op_StoreVectorScatter:
      case Op_LoadVectorGatherMasked:
      case Op_StoreVectorScatterMasked:
      case Op_PopulateIndex:
      case Op_CompressM:
      case Op_CompressV:
        if (UseSVE == 0) {
          return false;
        }
        break;
      case Op_MulAddVS2VI:
        if (length_in_bytes != 16) {
          return false;
        }
        break;
      case Op_MulReductionVD:
      case Op_MulReductionVF:
      case Op_MulReductionVI:
      case Op_MulReductionVL:
        // No vector multiply reduction instructions, but we do
        // emit scalar instructions for 64/128-bit vectors.
        if (length_in_bytes != 8 && length_in_bytes != 16) {
          return false;
        }
        break;
      case Op_VectorMaskCmp:
        if (length_in_bytes < 8) {
          return false;
        }
        break;
      case Op_VectorLoadShuffle:
      case Op_VectorRearrange:
        if (vlen < 4) {
          return false;
        }
        break;
      case Op_ExpandV:
        if (UseSVE < 2 || is_subword_type(bt)) {
          return false;
        }
        break;
      case Op_VectorMaskToLong:
        if (UseSVE > 0 && vlen > 64) {
          return false;
        }
        break;
      case Op_VectorLongToMask:
        if (vlen > 64 || !VM_Version::supports_svebitperm()) {
          return false;
        }
        break;
      case Op_CompressBitsV:
      case Op_ExpandBitsV:
        if (!VM_Version::supports_svebitperm()) {
          return false;
        }
        break;
      default:
        break;
    }
    return vector_size_supported(bt, vlen);
  }

  bool Matcher::match_rule_supported_vector_masked(int opcode, int vlen, BasicType bt) {
    // Only SVE supports masked operations.
    if (UseSVE == 0) {
      return false;
    }

    // If an opcode does not support the masked version,
    // unpredicated node with VectorBlend node will be used instead.
    switch(opcode) {
      case Op_VectorRearrange:
      case Op_MulReductionVD:
      case Op_MulReductionVF:
      case Op_MulReductionVI:
      case Op_MulReductionVL:
      case Op_CompressBitsV:
      case Op_ExpandBitsV:
        return false;
      // We use Op_LoadVectorMasked to implement the predicated Op_LoadVector.
      // Hence we turn to check whether Op_LoadVectorMasked is supported. The
      // same as vector store/gather/scatter.
      case Op_LoadVector:
        opcode = Op_LoadVectorMasked;
        break;
      case Op_StoreVector:
        opcode = Op_StoreVectorMasked;
        break;
      case Op_LoadVectorGather:
        opcode = Op_LoadVectorGatherMasked;
        break;
      case Op_StoreVectorScatter:
        opcode = Op_StoreVectorScatterMasked;
        break;
      default:
        break;
    }

    return match_rule_supported_vector(opcode, vlen, bt);
  }

  bool Matcher::vector_needs_partial_operations(Node* node, const TypeVect* vt) {
    // Only SVE has partial vector operations
    if (UseSVE == 0) {
      return false;
    }

    switch(node->Opcode()) {
      case Op_VectorLoadMask:
      case Op_VectorMaskCmp:
      case Op_LoadVectorGather:
      case Op_StoreVectorScatter:
      case Op_AddReductionVF:
      case Op_AddReductionVD:
      case Op_AndReductionV:
      case Op_OrReductionV:
      case Op_XorReductionV:
      // Mask is needed for partial Op_VectorMaskFirstTrue, because when the
      // input predicate is all-false, the result should be the vector length
      // instead of the vector register size.
      case Op_VectorMaskFirstTrue:
        return true;
      case Op_MaskAll:
        return !node->in(1)->is_Con();
      case Op_LoadVector:
      case Op_StoreVector:
        // We use NEON load/store instructions if the vector length is <= 128 bits.
        return vt->length_in_bytes() > 16;
      case Op_AddReductionVI:
      case Op_AddReductionVL:
        // We may prefer using NEON instructions rather than SVE partial operations.
        return !VM_Version::use_neon_for_vector(vt->length_in_bytes());
      case Op_MinReductionV:
      case Op_MaxReductionV:
        // For BYTE/SHORT/INT/FLOAT/DOUBLE types, we may prefer using NEON
        // instructions rather than SVE partial operations.
        return vt->element_basic_type() == T_LONG ||
               !VM_Version::use_neon_for_vector(vt->length_in_bytes());
      default:
        // For other ops whose vector size is smaller than the max vector size, a
        // full-sized unpredicated operation does not impact the final vector result.
        return false;
    }
  }

  // Assert that the given node is not a variable shift.
  bool assert_not_var_shift(const Node* n) {
    assert(!n->as_ShiftV()->is_var_shift(), "illegal variable shift");
    return true;
  }

  Assembler::SIMD_Arrangement get_arrangement(const Node* n) {
    BasicType bt = Matcher::vector_element_basic_type(n);
    uint length_in_bytes = Matcher::vector_length_in_bytes(n);
    return Assembler::esize2arrangement((uint)type2aelembytes(bt),
                                        /* isQ */ length_in_bytes == 16);
  }

  Assembler::SIMD_RegVariant get_reg_variant(const Node* n) {
    BasicType bt = Matcher::vector_element_basic_type(n);
    return Assembler::elemType_to_regVariant(bt);
  }

#line 1912 "ad_aarch64.cpp"


//SourceForm

#line 32 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"


static void x_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp, uint8_t barrier_data) {
  if (barrier_data == XLoadBarrierElided) {
    return;
  }
  XLoadBarrierStubC2* const stub = XLoadBarrierStubC2::create(node, ref_addr, ref, tmp, barrier_data);
  __ ldr(tmp, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
  __ andr(tmp, tmp, ref);
  __ cbnz(tmp, *stub->entry());
  __ bind(*stub->continuation());
}

static void x_load_barrier_slow_path(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  XLoadBarrierStubC2* const stub = XLoadBarrierStubC2::create(node, ref_addr, ref, tmp, XLoadBarrierStrong);
  __ b(*stub->entry());
  __ bind(*stub->continuation());
}


#line 1938 "ad_aarch64.cpp"


//SourceForm

#line 32 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"


#include "gc/z/zBarrierSetAssembler.hpp"

static void z_color(MacroAssembler& _masm, const MachNode* node, Register dst, Register src) {
  assert_different_registers(src, dst);
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatStoreGoodBeforeMov);
  __ movzw(dst, barrier_Relocation::unpatched);
  __ orr(dst, dst, src, Assembler::LSL, ZPointerLoadShift);
}

static void z_uncolor(MacroAssembler& _masm, const MachNode* node, Register ref) {
  __ lsr(ref, ref, ZPointerLoadShift);
}

static void z_keep_alive_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatMarkBadBeforeMov);
  __ movzw(tmp, barrier_Relocation::unpatched);
  __ tst(ref, tmp);
  ZLoadBarrierStubC2Aarch64* const stub = ZLoadBarrierStubC2Aarch64::create(node, ref_addr, ref);
  __ br(Assembler::NE, *stub->entry());
  z_uncolor(_masm, node, ref);
  __ bind(*stub->continuation());
}

static void z_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  Assembler::InlineSkippedInstructionsCounter skipped_counter(&_masm);
  const bool on_non_strong =
      ((node->barrier_data() & ZBarrierWeak) != 0) ||
      ((node->barrier_data() & ZBarrierPhantom) != 0);

  if (on_non_strong) {
    z_keep_alive_load_barrier(_masm, node, ref_addr, ref, tmp);
    return;
  }

  if (node->barrier_data() == ZBarrierElided) {
    z_uncolor(_masm, node, ref);
    return;
  }

  ZLoadBarrierStubC2Aarch64* const stub = ZLoadBarrierStubC2Aarch64::create(node, ref_addr, ref, __ offset());
  if (stub->is_test_and_branch_reachable()) {
    __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatLoadGoodBeforeTbX);
    __ tbnz(ref, barrier_Relocation::unpatched, *stub->entry());
  } else {
    Label good;
    __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatLoadGoodBeforeTbX);
    __ tbz(ref, barrier_Relocation::unpatched, good);
    __ b(*stub->entry());
    __ bind(good);
  }
  z_uncolor(_masm, node, ref);
  __ bind(*stub->continuation());
}

static void z_store_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register rnew_zaddress, Register rnew_zpointer, Register tmp, bool is_atomic) {
  Assembler::InlineSkippedInstructionsCounter skipped_counter(&_masm);
  if (node->barrier_data() == ZBarrierElided) {
    z_color(_masm, node, rnew_zpointer, rnew_zaddress);
  } else {
    bool is_native = (node->barrier_data() & ZBarrierNative) != 0;
    ZStoreBarrierStubC2Aarch64* const stub = ZStoreBarrierStubC2Aarch64::create(node, ref_addr, rnew_zaddress, rnew_zpointer, is_native, is_atomic);
    ZBarrierSetAssembler* bs_asm = ZBarrierSet::assembler();
    bs_asm->store_barrier_fast(&_masm, ref_addr, rnew_zaddress, rnew_zpointer, tmp, true /* in_nmethod */, is_atomic, *stub->entry(), *stub->continuation());
  }
}


#line 2013 "ad_aarch64.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( INSN_COST == 100, "Expect (100) to equal 100");
  assert( BRANCH_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( CALL_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( VOLATILE_REF_COST == 1000, "Expect (10 * INSN_COST) to equal 1000");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'C', // R27
  'C', // R27_H
  'N', // R28
  'N', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'N', // R8
  'N', // R8_H
  'N', // R9
  'N', // R9_H
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'C', // V8
  'C', // V8_H
  'C', // V8_J
  'C', // V8_K
  'C', // V9
  'C', // V9_H
  'C', // V9_J
  'C', // V9_K
  'C', // V10
  'C', // V10_H
  'C', // V10_J
  'C', // V10_K
  'C', // V11
  'C', // V11_H
  'C', // V11_J
  'C', // V11_K
  'C', // V12
  'C', // V12_H
  'C', // V12_J
  'C', // V12_K
  'C', // V13
  'C', // V13_H
  'C', // V13_J
  'C', // V13_K
  'C', // V14
  'C', // V14_H
  'C', // V14_J
  'C', // V14_K
  'C', // V15
  'C', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C', // P0
  'C', // P1
  'C', // P2
  'C', // P3
  'C', // P4
  'C', // P5
  'C', // P6
  'C', // P8
  'C', // P9
  'C', // P10
  'C', // P11
  'C', // P12
  'C', // P13
  'C', // P14
  'C', // P15
  'C', // P7
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'E', // R19
  'E', // R19_H
  'E', // R20
  'E', // R20_H
  'E', // R21
  'E', // R21_H
  'E', // R22
  'E', // R22_H
  'E', // R23
  'E', // R23_H
  'E', // R24
  'E', // R24_H
  'E', // R25
  'E', // R25_H
  'E', // R26
  'E', // R26_H
  'E', // R27
  'E', // R27_H
  'E', // R28
  'E', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // R8
  'C', // R8_H
  'C', // R9
  'C', // R9_H
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'E', // V8
  'E', // V8_H
  'C', // V8_J
  'C', // V8_K
  'E', // V9
  'E', // V9_H
  'C', // V9_J
  'C', // V9_K
  'E', // V10
  'E', // V10_H
  'C', // V10_J
  'C', // V10_K
  'E', // V11
  'E', // V11_H
  'C', // V11_J
  'C', // V11_K
  'E', // V12
  'E', // V12_H
  'C', // V12_J
  'C', // V12_K
  'E', // V13
  'E', // V13_H
  'C', // V13_J
  'C', // V13_K
  'E', // V14
  'E', // V14_H
  'C', // V14_J
  'C', // V14_K
  'E', // V15
  'E', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C', // P0
  'C', // P1
  'C', // P2
  'C', // P3
  'C', // P4
  'C', // P5
  'C', // P6
  'C', // P8
  'C', // P9
  'C', // P10
  'C', // P11
  'C', // P12
  'C', // P13
  'C', // P14
  'C', // P15
  'C', // P7
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  Op_RegVectMask,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immIExt_rule,
  /*   13 */  immI_gt_1_rule,
  /*   14 */  immI_le_4_rule,
  /*   15 */  immI_16_rule,
  /*   16 */  immI_24_rule,
  /*   17 */  immI_32_rule,
  /*   18 */  immI_48_rule,
  /*   19 */  immI_56_rule,
  /*   20 */  immI_63_rule,
  /*   21 */  immI_64_rule,
  /*   22 */  immI_255_rule,
  /*   23 */  immI_65535_rule,
  /*   24 */  immI_positive_rule,
  /*   25 */  immI_cmp_cond_rule,
  /*   26 */  immI_cmpU_cond_rule,
  /*   27 */  immL_255_rule,
  /*   28 */  immL_65535_rule,
  /*   29 */  immL_4294967295_rule,
  /*   30 */  immL_bitmask_rule,
  /*   31 */  immI_bitmask_rule,
  /*   32 */  immL_positive_bitmaskI_rule,
  /*   33 */  immIScale_rule,
  /*   34 */  immI26_rule,
  /*   35 */  immI19_rule,
  /*   36 */  immI5_rule,
  /*   37 */  immIU7_rule,
  /*   38 */  immIU12_rule,
  /*   39 */  immLU12_rule,
  /*   40 */  immIOffset_rule,
  /*   41 */  immIOffset1_rule,
  /*   42 */  immIOffset2_rule,
  /*   43 */  immIOffset4_rule,
  /*   44 */  immIOffset8_rule,
  /*   45 */  immIOffset16_rule,
  /*   46 */  immLoffset_rule,
  /*   47 */  immLoffset1_rule,
  /*   48 */  immLoffset2_rule,
  /*   49 */  immLoffset4_rule,
  /*   50 */  immLoffset8_rule,
  /*   51 */  immLoffset16_rule,
  /*   52 */  immL5_rule,
  /*   53 */  immLU7_rule,
  /*   54 */  immI8_rule,
  /*   55 */  immI8_shift8_rule,
  /*   56 */  immL8_shift8_rule,
  /*   57 */  immBAddSubV_rule,
  /*   58 */  immIAddSub_rule,
  /*   59 */  immIAddSubV_rule,
  /*   60 */  immBLog_rule,
  /*   61 */  immSLog_rule,
  /*   62 */  immILog_rule,
  /*   63 */  immL_rule,
  /*   64 */  immL0_rule,
  /*   65 */  immL_1_rule,
  /*   66 */  immL_M1_rule,
  /*   67 */  immL_pc_off_rule,
  /*   68 */  immLAddSub_rule,
  /*   69 */  immLAddSubV_rule,
  /*   70 */  immLLog_rule,
  /*   71 */  immL_32bits_rule,
  /*   72 */  immP_rule,
  /*   73 */  immP0_rule,
  /*   74 */  immP_1_rule,
  /*   75 */  immByteMapBase_rule,
  /*   76 */  immP_M1_rule,
  /*   77 */  immP_M2_rule,
  /*   78 */  immD_rule,
  /*   79 */  immD0_rule,
  /*   80 */  immDPacked_rule,
  /*   81 */  immF_rule,
  /*   82 */  immF0_rule,
  /*   83 */  immFPacked_rule,
  /*   84 */  immN_rule,
  /*   85 */  immN0_rule,
  /*   86 */  immNKlass_rule,
  /*   87 */  iRegI_rule,
  /*   88 */  iRegINoSp_rule,
  /*   89 */  iRegL_rule,
  /*   90 */  iRegLNoSp_rule,
  /*   91 */  iRegP_rule,
  /*   92 */  iRegPNoSp_rule,
  /*   93 */  iRegP_R0_rule,
  /*   94 */  iRegP_R1_rule,
  /*   95 */  iRegP_R2_rule,
  /*   96 */  iRegP_R3_rule,
  /*   97 */  iRegP_R4_rule,
  /*   98 */  iRegP_R5_rule,
  /*   99 */  iRegP_R10_rule,
  /*  100 */  iRegL_R0_rule,
  /*  101 */  iRegL_R2_rule,
  /*  102 */  iRegL_R3_rule,
  /*  103 */  iRegL_R11_rule,
  /*  104 */  iRegP_FP_rule,
  /*  105 */  iRegI_R0_rule,
  /*  106 */  iRegI_R2_rule,
  /*  107 */  iRegI_R3_rule,
  /*  108 */  iRegI_R4_rule,
  /*  109 */  iRegN_rule,
  /*  110 */  iRegN_R0_rule,
  /*  111 */  iRegN_R2_rule,
  /*  112 */  iRegN_R3_rule,
  /*  113 */  iRegNNoSp_rule,
  /*  114 */  vRegF_rule,
  /*  115 */  vRegD_rule,
  /*  116 */  vReg_rule,
  /*  117 */  vecA_rule,
  /*  118 */  vecD_rule,
  /*  119 */  vecX_rule,
  /*  120 */  vRegD_V0_rule,
  /*  121 */  vRegD_V1_rule,
  /*  122 */  vRegD_V2_rule,
  /*  123 */  vRegD_V3_rule,
  /*  124 */  vRegD_V4_rule,
  /*  125 */  vRegD_V5_rule,
  /*  126 */  vRegD_V6_rule,
  /*  127 */  vRegD_V7_rule,
  /*  128 */  vRegD_V8_rule,
  /*  129 */  vRegD_V9_rule,
  /*  130 */  vRegD_V10_rule,
  /*  131 */  vRegD_V11_rule,
  /*  132 */  vRegD_V12_rule,
  /*  133 */  vRegD_V13_rule,
  /*  134 */  vRegD_V14_rule,
  /*  135 */  vRegD_V15_rule,
  /*  136 */  vRegD_V16_rule,
  /*  137 */  vRegD_V17_rule,
  /*  138 */  vRegD_V18_rule,
  /*  139 */  vRegD_V19_rule,
  /*  140 */  vRegD_V20_rule,
  /*  141 */  vRegD_V21_rule,
  /*  142 */  vRegD_V22_rule,
  /*  143 */  vRegD_V23_rule,
  /*  144 */  vRegD_V24_rule,
  /*  145 */  vRegD_V25_rule,
  /*  146 */  vRegD_V26_rule,
  /*  147 */  vRegD_V27_rule,
  /*  148 */  vRegD_V28_rule,
  /*  149 */  vRegD_V29_rule,
  /*  150 */  vRegD_V30_rule,
  /*  151 */  vRegD_V31_rule,
  /*  152 */  pReg_rule,
  /*  153 */  pRegGov_rule,
  /*  154 */  pRegGov_P0_rule,
  /*  155 */  pRegGov_P1_rule,
  /*  156 */  rFlagsReg_rule,
  /*  157 */  rFlagsRegU_rule,
  /*  158 */  inline_cache_RegP_rule,
  /*  159 */  thread_RegP_rule,
  /*  160 */  lr_RegP_rule,
  /*  161 */  indirect_rule,
  /*  162 */  indIndexScaledI2L_rule,
  /*  163 */  indIndexScaled_rule,
  /*  164 */  indIndexI2L_rule,
  /*  165 */  indIndex_rule,
  /*  166 */  indOffI_rule,
  /*  167 */  indOffI1_rule,
  /*  168 */  indOffI2_rule,
  /*  169 */  indOffI4_rule,
  /*  170 */  indOffI8_rule,
  /*  171 */  indOffI16_rule,
  /*  172 */  indOffL_rule,
  /*  173 */  indOffL1_rule,
  /*  174 */  indOffL2_rule,
  /*  175 */  indOffL4_rule,
  /*  176 */  indOffL8_rule,
  /*  177 */  indOffL16_rule,
  /*  178 */  indirectN_rule,
  /*  179 */  indIndexScaledI2LN_rule,
  /*  180 */  indIndexScaledN_rule,
  /*  181 */  indIndexI2LN_rule,
  /*  182 */  indIndexN_rule,
  /*  183 */  indOffIN_rule,
  /*  184 */  indOffLN_rule,
  /*  185 */  thread_anchor_pc_rule,
  /*  186 */  stackSlotP_rule,
  /*  187 */  stackSlotI_rule,
  /*  188 */  stackSlotF_rule,
  /*  189 */  stackSlotD_rule,
  /*  190 */  stackSlotL_rule,
  /*  191 */  cmpOp_rule,
  /*  192 */  cmpOpU_rule,
  /*  193 */  cmpOpEqNe_rule,
  /*  194 */  cmpOpLtGe_rule,
  /*  195 */  cmpOpUEqNeLtGe_rule,
  /*  196 */  iRegL2I_rule,
  /*  197 */  vmemA_immIOffset4_rule,
  /*  198 */  vmemA_immLOffset4_rule,
  /*  199 */  vmemA_indOffI4_rule,
  /*  200 */  vmemA_indOffL4_rule,
  // last operand
  /*  201 */  vmem2_rule,
  /*  202 */  vmem4_rule,
  /*  203 */  vmem8_rule,
  /*  204 */  vmem16_rule,
  /*  205 */  memory1_rule,
  /*  206 */  memory2_rule,
  /*  207 */  memory4_rule,
  /*  208 */  memory8_rule,
  /*  209 */  memory_rule,
  /*  210 */  iRegIorL2I_rule,
  /*  211 */  vmemA_rule,
  // last operand class
  /*  212 */  _ConvI2L_iRegI__rule,
  /*  213 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  214 */  _LShiftL_iRegL_immIScale_rule,
  /*  215 */  _DecodeN_iRegN__rule,
  /*  216 */  _LoadB_memory1__rule,
  /*  217 */  _LoadUB_memory1__rule,
  /*  218 */  _LoadS_memory2__rule,
  /*  219 */  _LoadUS_memory2__rule,
  /*  220 */  _LoadI_memory4__rule,
  /*  221 */  _ConvI2L__LoadI_memory4___rule,
  /*  222 */  _LoadB_indirect__rule,
  /*  223 */  _LoadUB_indirect__rule,
  /*  224 */  _LoadUS_indirect__rule,
  /*  225 */  _LoadS_indirect__rule,
  /*  226 */  _LoadI_indirect__rule,
  /*  227 */  _ConvI2L__LoadI_indirect___rule,
  /*  228 */  _LoadL_memory8__rule,
  /*  229 */  _CastP2X_iRegP__rule,
  /*  230 */  _CastP2X__DecodeN_iRegN___rule,
  /*  231 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  232 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  233 */  _Binary_iRegP_iRegP_rule,
  /*  234 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  235 */  _Binary_iRegI_iRegI_rule,
  /*  236 */  _Binary_iRegL_iRegL_rule,
  /*  237 */  _Binary_iRegN_iRegN_rule,
  /*  238 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  239 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  240 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  241 */  _Binary_immI0_iRegIorL2I_rule,
  /*  242 */  _Binary_iRegIorL2I_immI0_rule,
  /*  243 */  _Binary_immI_1_immI0_rule,
  /*  244 */  _Binary_iRegL_immL0_rule,
  /*  245 */  _Binary_immL0_iRegL_rule,
  /*  246 */  _Binary_iRegP_immP0_rule,
  /*  247 */  _Binary_immP0_iRegP_rule,
  /*  248 */  _Binary_iRegN_immN0_rule,
  /*  249 */  _Binary_immN0_iRegN_rule,
  /*  250 */  _Binary_vRegF_vRegF_rule,
  /*  251 */  _Binary_vRegD_vRegD_rule,
  /*  252 */  _ConvL2I_iRegL__rule,
  /*  253 */  _ConvI2L_iRegIorL2I__rule,
  /*  254 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  255 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  256 */  _SubI_immI0_iRegIorL2I_rule,
  /*  257 */  _MulL_iRegL_iRegL_rule,
  /*  258 */  _SubL_immL0_iRegL_rule,
  /*  259 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  260 */  _SubL_immL0__ConvI2L_iRegIorL2I__rule,
  /*  261 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  262 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  263 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  264 */  _URShiftL_iRegL_immI_rule,
  /*  265 */  _RShiftL_iRegL_immI_rule,
  /*  266 */  _LShiftL_iRegL_immI_rule,
  /*  267 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  268 */  _XorL_iRegL_immL_M1_rule,
  /*  269 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  270 */  _XorL_iRegL_iRegL_rule,
  /*  271 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  272 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  273 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  274 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  275 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  276 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  277 */  _RotateRight_iRegL_immI_rule,
  /*  278 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  279 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  280 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  281 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  282 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  283 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  284 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  285 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  286 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  287 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  288 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  289 */  _XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  290 */  _XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI_rule,
  /*  291 */  _XorL__RotateRight_iRegL_immI_iRegL_rule,
  /*  292 */  _XorL_iRegL__RotateRight_iRegL_immI_rule,
  /*  293 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  294 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  295 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  296 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  297 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  298 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /*  299 */  _AndL_iRegL_immL_bitmask_rule,
  /*  300 */  _LShiftI__AndI_iRegIorL2I_immI_bitmask_immI_rule,
  /*  301 */  _AndL_iRegL_immL_positive_bitmaskI_rule,
  /*  302 */  _LShiftL__AndL_iRegL_immL_positive_bitmaskI_immI_rule,
  /*  303 */  _ConvI2L__AndI_iRegIorL2I_immI_bitmask__rule,
  /*  304 */  _ConvL2I__AndL_iRegL_immL_positive_bitmaskI__rule,
  /*  305 */  _AndI_iRegI_immI_bitmask_rule,
  /*  306 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  307 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  308 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  309 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  310 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  311 */  _LShiftL_iRegL_immI_48_rule,
  /*  312 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  313 */  _LShiftL_iRegL_immI_32_rule,
  /*  314 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  315 */  _LShiftL_iRegL_immI_56_rule,
  /*  316 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  317 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  318 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  319 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  320 */  _AndL_iRegL_immL_255_rule,
  /*  321 */  _AndL_iRegL_immL_65535_rule,
  /*  322 */  _AndL_iRegL_immL_4294967295_rule,
  /*  323 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /*  324 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /*  325 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /*  326 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /*  327 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /*  328 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /*  329 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /*  330 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /*  331 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /*  332 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /*  333 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /*  334 */  _NegF_vRegF__rule,
  /*  335 */  _Binary_vRegF__NegF_vRegF__rule,
  /*  336 */  _NegD_vRegD__rule,
  /*  337 */  _Binary_vRegD__NegD_vRegD__rule,
  /*  338 */  _SubF_vRegF_vRegF_rule,
  /*  339 */  _SubD_vRegD_vRegD_rule,
  /*  340 */  _OverflowMulI_iRegIorL2I_iRegIorL2I_rule,
  /*  341 */  _OverflowMulL_iRegL_iRegL_rule,
  /*  342 */  _CmpI_iRegIorL2I_immI0_rule,
  /*  343 */  _CmpL_iRegL_immL0_rule,
  /*  344 */  _CmpP_iRegP_immP0_rule,
  /*  345 */  _CmpN_iRegN_immN0_rule,
  /*  346 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  347 */  _CmpU_iRegIorL2I_immI0_rule,
  /*  348 */  _CmpUL_iRegL_immL0_rule,
  /*  349 */  _AndL_iRegL_immL_rule,
  /*  350 */  _CmpL__AndL_iRegL_immL_immL0_rule,
  /*  351 */  _AndI_iRegIorL2I_immI_rule,
  /*  352 */  _CmpI__AndI_iRegIorL2I_immI_immI0_rule,
  /*  353 */  _AndL_iRegL_iRegL_rule,
  /*  354 */  _AndI_iRegIorL2I_iRegIorL2I_rule,
  /*  355 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  356 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  357 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  358 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  359 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  360 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  361 */  _Binary_iRegP_R3_immI_1_rule,
  /*  362 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  363 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /*  364 */  _Binary_vReg_pRegGov_rule,
  /*  365 */  _Binary_vReg_vReg_rule,
  /*  366 */  _Replicate_immBAddSubV__rule,
  /*  367 */  _Replicate_immIAddSubV__rule,
  /*  368 */  _Replicate_immLAddSubV__rule,
  /*  369 */  _Replicate_immBLog__rule,
  /*  370 */  _Replicate_immSLog__rule,
  /*  371 */  _Replicate_immILog__rule,
  /*  372 */  _Replicate_immLLog__rule,
  /*  373 */  _XorV_vReg_vReg_rule,
  /*  374 */  _Replicate_immI_M1__rule,
  /*  375 */  _Replicate_immL_M1__rule,
  /*  376 */  _Binary_vReg__Replicate_immI_M1__rule,
  /*  377 */  _Binary_vReg__Replicate_immL_M1__rule,
  /*  378 */  _XorV_vReg__Replicate_immI_M1__rule,
  /*  379 */  _XorV__Replicate_immI_M1__vReg_rule,
  /*  380 */  _XorV_vReg__Replicate_immL_M1__rule,
  /*  381 */  _XorV__Replicate_immL_M1__vReg_rule,
  /*  382 */  _Binary_vReg__XorV_vReg__Replicate_immI_M1__rule,
  /*  383 */  _Binary_vReg__XorV__Replicate_immI_M1__vReg_rule,
  /*  384 */  _Binary_vReg__XorV_vReg__Replicate_immL_M1__rule,
  /*  385 */  _Binary_vReg__XorV__Replicate_immL_M1__vReg_rule,
  /*  386 */  _SubVF_vReg_vReg_rule,
  /*  387 */  _SubVD_vReg_vReg_rule,
  /*  388 */  _SubVF__Binary_vReg_vReg_pRegGov_rule,
  /*  389 */  _SubVD__Binary_vReg_vReg_pRegGov_rule,
  /*  390 */  _MulVB_vReg_vReg_rule,
  /*  391 */  _MulVS_vReg_vReg_rule,
  /*  392 */  _MulVI_vReg_vReg_rule,
  /*  393 */  _MulVL_vReg_vReg_rule,
  /*  394 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /*  395 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /*  396 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /*  397 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /*  398 */  _NegVF_vReg__rule,
  /*  399 */  _Binary_vReg__NegVF_vReg__rule,
  /*  400 */  _NegVD_vReg__rule,
  /*  401 */  _Binary_vReg__NegVD_vReg__rule,
  /*  402 */  _Binary__NegVF_vReg__pRegGov_rule,
  /*  403 */  _Binary__NegVD_vReg__pRegGov_rule,
  /*  404 */  _LShiftCntV_immI__rule,
  /*  405 */  _RShiftCntV_immI_positive__rule,
  /*  406 */  _RShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /*  407 */  _RShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /*  408 */  _RShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /*  409 */  _RShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /*  410 */  _URShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /*  411 */  _URShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /*  412 */  _URShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /*  413 */  _URShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /*  414 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  415 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /*  416 */  _Binary_iRegIorL2I_vReg_rule,
  /*  417 */  _Binary_iRegL_vReg_rule,
  /*  418 */  _Binary_vRegF_vReg_rule,
  /*  419 */  _Binary_vRegD_vReg_rule,
  /*  420 */  _Binary_vReg_iRegIorL2I_rule,
  /*  421 */  _Binary_vReg_iRegL_rule,
  /*  422 */  _Binary_vReg_vRegF_rule,
  /*  423 */  _Binary_vReg_vRegD_rule,
  /*  424 */  _LoadVector_indirect__rule,
  /*  425 */  _LoadVectorMasked_vmemA_pRegGov_rule,
  /*  426 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /*  427 */  _Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov_rule,
  /*  428 */  _MaskAll_immI_M1__rule,
  /*  429 */  _XorVMask_pReg__MaskAll_immI_M1__rule,
  /*  430 */  _MaskAll_immL_M1__rule,
  /*  431 */  _XorVMask_pReg__MaskAll_immL_M1__rule,
  /*  432 */  _Replicate_immI0__rule,
  /*  433 */  _Binary_vReg__Replicate_immI0__rule,
  /*  434 */  _Replicate_immL0__rule,
  /*  435 */  _Binary_vReg__Replicate_immL0__rule,
  /*  436 */  _Replicate_immF0__rule,
  /*  437 */  _Binary_vReg__Replicate_immF0__rule,
  /*  438 */  _Replicate_immD0__rule,
  /*  439 */  _Binary_vReg__Replicate_immD0__rule,
  /*  440 */  _Replicate_immI5__rule,
  /*  441 */  _Binary_vReg__Replicate_immI5__rule,
  /*  442 */  _Replicate_immIU7__rule,
  /*  443 */  _Binary_vReg__Replicate_immIU7__rule,
  /*  444 */  _Replicate_immL5__rule,
  /*  445 */  _Binary_vReg__Replicate_immL5__rule,
  /*  446 */  _Replicate_immLU7__rule,
  /*  447 */  _Binary_vReg__Replicate_immLU7__rule,
  /*  448 */  _Binary_immI_pRegGov_rule,
  /*  449 */  _VectorStoreMask_vReg_immI_gt_1_rule,
  /*  450 */  _SubL_iRegL_iRegL_rule,
  /*  451 */  _Binary_vReg__Binary_vReg_pRegGov_rule,
  // last internally defined operand
  /*  452 */  iRegINoSp_rule,
  /*  453 */  iRegLNoSp_rule,
  /*  454 */  iRegPNoSp_rule,
  /*  455 */  iRegPNoSp_rule,
  /*  456 */  iRegPNoSp_rule,
  /*  457 */  iRegPNoSp_rule,
  /*  458 */  iRegNNoSp_rule,
  /*  459 */  iRegNNoSp_rule,
  /*  460 */  iRegNNoSp_rule,
  /*  461 */  vRegF_rule,
  /*  462 */  vRegF_rule,
  /*  463 */  vRegD_rule,
  /*  464 */  vRegD_rule,
  /*  465 */  iRegINoSp_rule,
  /*  466 */  iRegINoSp_rule,
  /*  467 */  iRegINoSp_rule,
  /*  468 */  iRegINoSp_rule,
  /*  469 */  iRegPNoSp_rule,
  /*  470 */  iRegLNoSp_rule,
  /*  471 */  iRegPNoSp_rule,
  /*  472 */  iRegPNoSp_rule,
  /*  473 */  iRegI_rule,
  /*  474 */  iRegL_rule,
  /*  475 */  vRegF_rule,
  /*  476 */  vRegD_rule,
  /*  477 */  vReg_rule,
  /*  478 */  pRegGov_rule,
  /*  479 */  iRegINoSp_rule,
  /*  480 */  iRegLNoSp_rule,
  /*  481 */  vRegF_rule,
  /*  482 */  vRegD_rule,
  /*  483 */  vRegF_rule,
  /*  484 */  vRegD_rule,
  /*  485 */  iRegINoSp_rule,
  /*  486 */  vRegF_rule,
  /*  487 */  iRegLNoSp_rule,
  /*  488 */  vRegD_rule,
  /*  489 */  iRegINoSp_rule,
  /*  490 */  vRegF_rule,
  /*  491 */  iRegLNoSp_rule,
  /*  492 */  vRegD_rule,
  /*  493 */  rFlagsReg_rule,
  /*  494 */  rFlagsReg_rule,
  /*  495 */  rFlagsReg_rule,
  /*  496 */  rFlagsReg_rule,
  /*  497 */  rFlagsReg_rule,
  /*  498 */  rFlagsReg_rule,
  /*  499 */  rFlagsReg_rule,
  /*  500 */  rFlagsReg_rule,
  /*  501 */  rFlagsReg_rule,
  /*  502 */  rFlagsReg_rule,
  /*  503 */  rFlagsReg_rule,
  /*  504 */  rFlagsReg_rule,
  /*  505 */  rFlagsReg_rule,
  /*  506 */  rFlagsReg_rule,
  /*  507 */  rFlagsReg_rule,
  /*  508 */  rFlagsReg_rule,
  /*  509 */  rFlagsRegU_rule,
  /*  510 */  rFlagsRegU_rule,
  /*  511 */  rFlagsRegU_rule,
  /*  512 */  rFlagsRegU_rule,
  /*  513 */  rFlagsReg_rule,
  /*  514 */  rFlagsReg_rule,
  /*  515 */  rFlagsReg_rule,
  /*  516 */  rFlagsReg_rule,
  /*  517 */  rFlagsRegU_rule,
  /*  518 */  rFlagsRegU_rule,
  /*  519 */  rFlagsRegU_rule,
  /*  520 */  rFlagsRegU_rule,
  /*  521 */  rFlagsRegU_rule,
  /*  522 */  rFlagsRegU_rule,
  /*  523 */  rFlagsRegU_rule,
  /*  524 */  rFlagsRegU_rule,
  /*  525 */  rFlagsReg_rule,
  /*  526 */  rFlagsReg_rule,
  /*  527 */  rFlagsReg_rule,
  /*  528 */  rFlagsReg_rule,
  /*  529 */  0,
  /*  530 */  rFlagsReg_rule,
  /*  531 */  rFlagsReg_rule,
  /*  532 */  rFlagsReg_rule,
  /*  533 */  rFlagsReg_rule,
  /*  534 */  rFlagsReg_rule,
  /*  535 */  rFlagsReg_rule,
  /*  536 */  rFlagsReg_rule,
  /*  537 */  thread_RegP_rule,
  /*  538 */  vReg_rule,
  /*  539 */  vReg_rule,
  /*  540 */  vReg_rule,
  /*  541 */  vReg_rule,
  /*  542 */  vReg_rule,
  /*  543 */  vReg_rule,
  /*  544 */  vReg_rule,
  /*  545 */  vReg_rule,
  /*  546 */  vReg_rule,
  /*  547 */  vReg_rule,
  /*  548 */  vReg_rule,
  /*  549 */  vReg_rule,
  /*  550 */  vReg_rule,
  /*  551 */  vReg_rule,
  /*  552 */  vReg_rule,
  /*  553 */  vReg_rule,
  /*  554 */  vReg_rule,
  /*  555 */  vReg_rule,
  /*  556 */  vReg_rule,
  /*  557 */  vReg_rule,
  /*  558 */  vReg_rule,
  /*  559 */  vReg_rule,
  /*  560 */  vReg_rule,
  /*  561 */  vReg_rule,
  /*  562 */  vReg_rule,
  /*  563 */  vReg_rule,
  /*  564 */  vReg_rule,
  /*  565 */  vReg_rule,
  /*  566 */  vReg_rule,
  /*  567 */  vReg_rule,
  /*  568 */  vReg_rule,
  /*  569 */  vReg_rule,
  /*  570 */  vReg_rule,
  /*  571 */  vReg_rule,
  /*  572 */  vReg_rule,
  /*  573 */  vReg_rule,
  /*  574 */  vReg_rule,
  /*  575 */  vReg_rule,
  /*  576 */  vReg_rule,
  /*  577 */  vReg_rule,
  /*  578 */  vReg_rule,
  /*  579 */  vReg_rule,
  /*  580 */  vReg_rule,
  /*  581 */  vReg_rule,
  /*  582 */  pReg_rule,
  /*  583 */  pReg_rule,
  /*  584 */  pReg_rule,
  /*  585 */  iRegINoSp_rule,
  /*  586 */  iRegINoSp_rule,
  /*  587 */  iRegINoSp_rule,
  /*  588 */  iRegLNoSp_rule,
  /*  589 */  vReg_rule,
  /*  590 */  vReg_rule,
  /*  591 */  rFlagsReg_rule,
  /*  592 */  rFlagsReg_rule,
  /*  593 */  rFlagsReg_rule,
  /*  594 */  rFlagsReg_rule,
  /*  595 */  vReg_rule,
  /*  596 */  vReg_rule,
  /*  597 */  vReg_rule,
  /*  598 */  vReg_rule,
  /*  599 */  vReg_rule,
  /*  600 */  iRegINoSp_rule,
  /*  601 */  iRegLNoSp_rule,
  /*  602 */  iRegINoSp_rule,
  /*  603 */  iRegLNoSp_rule,
  /*  604 */  iRegINoSp_rule,
  /*  605 */  iRegLNoSp_rule,
  /*  606 */  iRegINoSp_rule,
  /*  607 */  iRegLNoSp_rule,
  /*  608 */  iRegINoSp_rule,
  /*  609 */  iRegLNoSp_rule,
  /*  610 */  iRegLNoSp_rule,
  /*  611 */  iRegLNoSp_rule,
  /*  612 */  iRegINoSp_rule,
  /*  613 */  iRegPNoSp_rule,
  /*  614 */  iRegNNoSp_rule,
  /*  615 */  iRegPNoSp_rule,
  /*  616 */  iRegNNoSp_rule,
  /*  617 */  vRegF_rule,
  /*  618 */  vRegD_rule,
  /*  619 */  Universe_rule,
  /*  620 */  Universe_rule,
  /*  621 */  Universe_rule,
  /*  622 */  Universe_rule,
  /*  623 */  Universe_rule,
  /*  624 */  Universe_rule,
  /*  625 */  Universe_rule,
  /*  626 */  Universe_rule,
  /*  627 */  Universe_rule,
  /*  628 */  Universe_rule,
  /*  629 */  Universe_rule,
  /*  630 */  Universe_rule,
  /*  631 */  Universe_rule,
  /*  632 */  Universe_rule,
  /*  633 */  Universe_rule,
  /*  634 */  Universe_rule,
  /*  635 */  Universe_rule,
  /*  636 */  Universe_rule,
  /*  637 */  iRegINoSp_rule,
  /*  638 */  iRegLNoSp_rule,
  /*  639 */  iRegINoSp_rule,
  /*  640 */  iRegLNoSp_rule,
  /*  641 */  iRegINoSp_rule,
  /*  642 */  iRegINoSp_rule,
  /*  643 */  iRegLNoSp_rule,
  /*  644 */  iRegLNoSp_rule,
  /*  645 */  iRegINoSp_rule,
  /*  646 */  iRegLNoSp_rule,
  /*  647 */  iRegLNoSp_rule,
  /*  648 */  iRegPNoSp_rule,
  /*  649 */  iRegNNoSp_rule,
  /*  650 */  vRegF_rule,
  /*  651 */  vRegD_rule,
  /*  652 */  Universe_rule,
  /*  653 */  Universe_rule,
  /*  654 */  Universe_rule,
  /*  655 */  Universe_rule,
  /*  656 */  Universe_rule,
  /*  657 */  Universe_rule,
  /*  658 */  Universe_rule,
  /*  659 */  Universe_rule,
  /*  660 */  Universe_rule,
  /*  661 */  Universe_rule,
  /*  662 */  Universe_rule,
  /*  663 */  Universe_rule,
  /*  664 */  Universe_rule,
  /*  665 */  Universe_rule,
  /*  666 */  Universe_rule,
  /*  667 */  Universe_rule,
  /*  668 */  Universe_rule,
  /*  669 */  iRegINoSp_rule,
  /*  670 */  iRegLNoSp_rule,
  /*  671 */  iRegINoSp_rule,
  /*  672 */  iRegINoSp_rule,
  /*  673 */  iRegINoSp_rule,
  /*  674 */  iRegINoSp_rule,
  /*  675 */  iRegINoSp_rule,
  /*  676 */  iRegINoSp_rule,
  /*  677 */  Universe_rule,
  /*  678 */  Universe_rule,
  /*  679 */  Universe_rule,
  /*  680 */  Universe_rule,
  /*  681 */  Universe_rule,
  /*  682 */  Universe_rule,
  /*  683 */  Universe_rule,
  /*  684 */  Universe_rule,
  /*  685 */  Universe_rule,
  /*  686 */  Universe_rule,
  /*  687 */  Universe_rule,
  /*  688 */  Universe_rule,
  /*  689 */  iRegINoSp_rule,
  /*  690 */  iRegINoSp_rule,
  /*  691 */  iRegNNoSp_rule,
  /*  692 */  iRegNNoSp_rule,
  /*  693 */  iRegPNoSp_rule,
  /*  694 */  iRegPNoSp_rule,
  /*  695 */  iRegNNoSp_rule,
  /*  696 */  iRegPNoSp_rule,
  /*  697 */  iRegINoSp_rule,
  /*  698 */  iRegINoSp_rule,
  /*  699 */  iRegINoSp_rule,
  /*  700 */  iRegINoSp_rule,
  /*  701 */  iRegINoSp_rule,
  /*  702 */  iRegINoSp_rule,
  /*  703 */  iRegINoSp_rule,
  /*  704 */  iRegINoSp_rule,
  /*  705 */  iRegINoSp_rule,
  /*  706 */  iRegINoSp_rule,
  /*  707 */  iRegINoSp_rule,
  /*  708 */  iRegINoSp_rule,
  /*  709 */  iRegINoSp_rule,
  /*  710 */  iRegINoSp_rule,
  /*  711 */  iRegINoSp_rule,
  /*  712 */  iRegLNoSp_rule,
  /*  713 */  iRegNNoSp_rule,
  /*  714 */  iRegPNoSp_rule,
  /*  715 */  iRegINoSp_rule,
  /*  716 */  iRegINoSp_rule,
  /*  717 */  iRegINoSp_rule,
  /*  718 */  iRegLNoSp_rule,
  /*  719 */  iRegNNoSp_rule,
  /*  720 */  iRegPNoSp_rule,
  /*  721 */  iRegINoSp_rule,
  /*  722 */  iRegINoSp_rule,
  /*  723 */  iRegINoSp_rule,
  /*  724 */  iRegINoSp_rule,
  /*  725 */  iRegINoSp_rule,
  /*  726 */  iRegINoSp_rule,
  /*  727 */  iRegINoSp_rule,
  /*  728 */  iRegINoSp_rule,
  /*  729 */  iRegINoSp_rule,
  /*  730 */  iRegINoSp_rule,
  /*  731 */  iRegINoSp_rule,
  /*  732 */  iRegINoSp_rule,
  /*  733 */  iRegINoSp_rule,
  /*  734 */  iRegLNoSp_rule,
  /*  735 */  iRegINoSp_rule,
  /*  736 */  iRegPNoSp_rule,
  /*  737 */  iRegINoSp_rule,
  /*  738 */  iRegLNoSp_rule,
  /*  739 */  iRegINoSp_rule,
  /*  740 */  iRegPNoSp_rule,
  /*  741 */  iRegLNoSp_rule,
  /*  742 */  Universe_rule,
  /*  743 */  iRegLNoSp_rule,
  /*  744 */  Universe_rule,
  /*  745 */  iRegINoSp_rule,
  /*  746 */  Universe_rule,
  /*  747 */  iRegINoSp_rule,
  /*  748 */  Universe_rule,
  /*  749 */  iRegLNoSp_rule,
  /*  750 */  Universe_rule,
  /*  751 */  iRegLNoSp_rule,
  /*  752 */  Universe_rule,
  /*  753 */  iRegINoSp_rule,
  /*  754 */  Universe_rule,
  /*  755 */  iRegINoSp_rule,
  /*  756 */  Universe_rule,
  /*  757 */  iRegINoSp_rule,
  /*  758 */  iRegINoSp_rule,
  /*  759 */  iRegINoSp_rule,
  /*  760 */  iRegINoSp_rule,
  /*  761 */  iRegINoSp_rule,
  /*  762 */  iRegINoSp_rule,
  /*  763 */  iRegINoSp_rule,
  /*  764 */  iRegINoSp_rule,
  /*  765 */  iRegINoSp_rule,
  /*  766 */  iRegINoSp_rule,
  /*  767 */  iRegINoSp_rule,
  /*  768 */  iRegINoSp_rule,
  /*  769 */  iRegINoSp_rule,
  /*  770 */  iRegINoSp_rule,
  /*  771 */  iRegLNoSp_rule,
  /*  772 */  iRegLNoSp_rule,
  /*  773 */  iRegLNoSp_rule,
  /*  774 */  iRegLNoSp_rule,
  /*  775 */  iRegLNoSp_rule,
  /*  776 */  iRegLNoSp_rule,
  /*  777 */  iRegPNoSp_rule,
  /*  778 */  iRegPNoSp_rule,
  /*  779 */  iRegPNoSp_rule,
  /*  780 */  iRegPNoSp_rule,
  /*  781 */  iRegPNoSp_rule,
  /*  782 */  iRegPNoSp_rule,
  /*  783 */  iRegNNoSp_rule,
  /*  784 */  iRegNNoSp_rule,
  /*  785 */  iRegNNoSp_rule,
  /*  786 */  iRegNNoSp_rule,
  /*  787 */  iRegNNoSp_rule,
  /*  788 */  iRegNNoSp_rule,
  /*  789 */  vRegF_rule,
  /*  790 */  vRegF_rule,
  /*  791 */  vRegD_rule,
  /*  792 */  vRegD_rule,
  /*  793 */  iRegINoSp_rule,
  /*  794 */  iRegINoSp_rule,
  /*  795 */  iRegINoSp_rule,
  /*  796 */  iRegPNoSp_rule,
  /*  797 */  iRegPNoSp_rule,
  /*  798 */  iRegPNoSp_rule,
  /*  799 */  iRegPNoSp_rule,
  /*  800 */  iRegLNoSp_rule,
  /*  801 */  iRegPNoSp_rule,
  /*  802 */  iRegLNoSp_rule,
  /*  803 */  iRegLNoSp_rule,
  /*  804 */  iRegINoSp_rule,
  /*  805 */  iRegINoSp_rule,
  /*  806 */  iRegLNoSp_rule,
  /*  807 */  iRegLNoSp_rule,
  /*  808 */  iRegINoSp_rule,
  /*  809 */  iRegLNoSp_rule,
  /*  810 */  iRegINoSp_rule,
  /*  811 */  iRegLNoSp_rule,
  /*  812 */  iRegLNoSp_rule,
  /*  813 */  iRegLNoSp_rule,
  /*  814 */  iRegLNoSp_rule,
  /*  815 */  iRegLNoSp_rule,
  /*  816 */  iRegINoSp_rule,
  /*  817 */  iRegINoSp_rule,
  /*  818 */  iRegINoSp_rule,
  /*  819 */  iRegINoSp_rule,
  /*  820 */  iRegINoSp_rule,
  /*  821 */  iRegLNoSp_rule,
  /*  822 */  iRegLNoSp_rule,
  /*  823 */  iRegLNoSp_rule,
  /*  824 */  iRegLNoSp_rule,
  /*  825 */  iRegLNoSp_rule,
  /*  826 */  iRegLNoSp_rule,
  /*  827 */  iRegLNoSp_rule,
  /*  828 */  iRegLNoSp_rule,
  /*  829 */  iRegLNoSp_rule,
  /*  830 */  iRegLNoSp_rule,
  /*  831 */  iRegLNoSp_rule,
  /*  832 */  iRegLNoSp_rule,
  /*  833 */  iRegLNoSp_rule,
  /*  834 */  iRegINoSp_rule,
  /*  835 */  iRegINoSp_rule,
  /*  836 */  iRegLNoSp_rule,
  /*  837 */  iRegINoSp_rule,
  /*  838 */  iRegLNoSp_rule,
  /*  839 */  iRegINoSp_rule,
  /*  840 */  iRegLNoSp_rule,
  /*  841 */  iRegINoSp_rule,
  /*  842 */  iRegLNoSp_rule,
  /*  843 */  iRegINoSp_rule,
  /*  844 */  iRegINoSp_rule,
  /*  845 */  iRegINoSp_rule,
  /*  846 */  iRegINoSp_rule,
  /*  847 */  iRegINoSp_rule,
  /*  848 */  iRegINoSp_rule,
  /*  849 */  iRegLNoSp_rule,
  /*  850 */  iRegLNoSp_rule,
  /*  851 */  iRegLNoSp_rule,
  /*  852 */  iRegLNoSp_rule,
  /*  853 */  iRegLNoSp_rule,
  /*  854 */  iRegLNoSp_rule,
  /*  855 */  iRegLNoSp_rule,
  /*  856 */  iRegLNoSp_rule,
  /*  857 */  iRegINoSp_rule,
  /*  858 */  iRegINoSp_rule,
  /*  859 */  iRegINoSp_rule,
  /*  860 */  iRegINoSp_rule,
  /*  861 */  iRegLNoSp_rule,
  /*  862 */  iRegLNoSp_rule,
  /*  863 */  iRegLNoSp_rule,
  /*  864 */  iRegINoSp_rule,
  /*  865 */  iRegINoSp_rule,
  /*  866 */  iRegLNoSp_rule,
  /*  867 */  iRegLNoSp_rule,
  /*  868 */  iRegINoSp_rule,
  /*  869 */  iRegINoSp_rule,
  /*  870 */  iRegLNoSp_rule,
  /*  871 */  iRegLNoSp_rule,
  /*  872 */  iRegINoSp_rule,
  /*  873 */  iRegINoSp_rule,
  /*  874 */  iRegLNoSp_rule,
  /*  875 */  iRegLNoSp_rule,
  /*  876 */  iRegINoSp_rule,
  /*  877 */  iRegINoSp_rule,
  /*  878 */  iRegLNoSp_rule,
  /*  879 */  iRegLNoSp_rule,
  /*  880 */  iRegINoSp_rule,
  /*  881 */  iRegINoSp_rule,
  /*  882 */  iRegLNoSp_rule,
  /*  883 */  iRegLNoSp_rule,
  /*  884 */  iRegINoSp_rule,
  /*  885 */  iRegINoSp_rule,
  /*  886 */  iRegLNoSp_rule,
  /*  887 */  iRegLNoSp_rule,
  /*  888 */  iRegINoSp_rule,
  /*  889 */  iRegINoSp_rule,
  /*  890 */  iRegLNoSp_rule,
  /*  891 */  iRegLNoSp_rule,
  /*  892 */  iRegINoSp_rule,
  /*  893 */  iRegINoSp_rule,
  /*  894 */  iRegINoSp_rule,
  /*  895 */  iRegINoSp_rule,
  /*  896 */  iRegLNoSp_rule,
  /*  897 */  iRegLNoSp_rule,
  /*  898 */  iRegLNoSp_rule,
  /*  899 */  iRegLNoSp_rule,
  /*  900 */  iRegINoSp_rule,
  /*  901 */  iRegINoSp_rule,
  /*  902 */  iRegINoSp_rule,
  /*  903 */  iRegINoSp_rule,
  /*  904 */  iRegLNoSp_rule,
  /*  905 */  iRegLNoSp_rule,
  /*  906 */  iRegLNoSp_rule,
  /*  907 */  iRegLNoSp_rule,
  /*  908 */  iRegINoSp_rule,
  /*  909 */  iRegINoSp_rule,
  /*  910 */  iRegINoSp_rule,
  /*  911 */  iRegINoSp_rule,
  /*  912 */  iRegLNoSp_rule,
  /*  913 */  iRegLNoSp_rule,
  /*  914 */  iRegLNoSp_rule,
  /*  915 */  iRegLNoSp_rule,
  /*  916 */  iRegINoSp_rule,
  /*  917 */  iRegINoSp_rule,
  /*  918 */  iRegINoSp_rule,
  /*  919 */  iRegINoSp_rule,
  /*  920 */  iRegLNoSp_rule,
  /*  921 */  iRegLNoSp_rule,
  /*  922 */  iRegLNoSp_rule,
  /*  923 */  iRegLNoSp_rule,
  /*  924 */  iRegINoSp_rule,
  /*  925 */  iRegINoSp_rule,
  /*  926 */  iRegLNoSp_rule,
  /*  927 */  iRegLNoSp_rule,
  /*  928 */  iRegINoSp_rule,
  /*  929 */  iRegINoSp_rule,
  /*  930 */  iRegLNoSp_rule,
  /*  931 */  iRegLNoSp_rule,
  /*  932 */  iRegINoSp_rule,
  /*  933 */  iRegINoSp_rule,
  /*  934 */  iRegLNoSp_rule,
  /*  935 */  iRegLNoSp_rule,
  /*  936 */  iRegINoSp_rule,
  /*  937 */  iRegINoSp_rule,
  /*  938 */  iRegLNoSp_rule,
  /*  939 */  iRegLNoSp_rule,
  /*  940 */  iRegINoSp_rule,
  /*  941 */  iRegINoSp_rule,
  /*  942 */  iRegLNoSp_rule,
  /*  943 */  iRegLNoSp_rule,
  /*  944 */  iRegINoSp_rule,
  /*  945 */  iRegINoSp_rule,
  /*  946 */  iRegLNoSp_rule,
  /*  947 */  iRegLNoSp_rule,
  /*  948 */  iRegINoSp_rule,
  /*  949 */  iRegINoSp_rule,
  /*  950 */  iRegLNoSp_rule,
  /*  951 */  iRegLNoSp_rule,
  /*  952 */  iRegINoSp_rule,
  /*  953 */  iRegINoSp_rule,
  /*  954 */  iRegLNoSp_rule,
  /*  955 */  iRegLNoSp_rule,
  /*  956 */  iRegINoSp_rule,
  /*  957 */  iRegINoSp_rule,
  /*  958 */  iRegLNoSp_rule,
  /*  959 */  iRegLNoSp_rule,
  /*  960 */  iRegINoSp_rule,
  /*  961 */  iRegINoSp_rule,
  /*  962 */  iRegLNoSp_rule,
  /*  963 */  iRegLNoSp_rule,
  /*  964 */  iRegINoSp_rule,
  /*  965 */  iRegINoSp_rule,
  /*  966 */  iRegLNoSp_rule,
  /*  967 */  iRegLNoSp_rule,
  /*  968 */  iRegINoSp_rule,
  /*  969 */  iRegINoSp_rule,
  /*  970 */  iRegLNoSp_rule,
  /*  971 */  iRegLNoSp_rule,
  /*  972 */  iRegINoSp_rule,
  /*  973 */  iRegINoSp_rule,
  /*  974 */  iRegLNoSp_rule,
  /*  975 */  iRegLNoSp_rule,
  /*  976 */  iRegINoSp_rule,
  /*  977 */  iRegINoSp_rule,
  /*  978 */  iRegLNoSp_rule,
  /*  979 */  iRegLNoSp_rule,
  /*  980 */  iRegINoSp_rule,
  /*  981 */  iRegINoSp_rule,
  /*  982 */  iRegLNoSp_rule,
  /*  983 */  iRegLNoSp_rule,
  /*  984 */  iRegINoSp_rule,
  /*  985 */  iRegINoSp_rule,
  /*  986 */  iRegLNoSp_rule,
  /*  987 */  iRegLNoSp_rule,
  /*  988 */  iRegINoSp_rule,
  /*  989 */  iRegINoSp_rule,
  /*  990 */  iRegLNoSp_rule,
  /*  991 */  iRegLNoSp_rule,
  /*  992 */  iRegINoSp_rule,
  /*  993 */  iRegINoSp_rule,
  /*  994 */  iRegLNoSp_rule,
  /*  995 */  iRegLNoSp_rule,
  /*  996 */  iRegINoSp_rule,
  /*  997 */  iRegINoSp_rule,
  /*  998 */  iRegLNoSp_rule,
  /*  999 */  iRegLNoSp_rule,
  /* 1000 */  iRegINoSp_rule,
  /* 1001 */  iRegLNoSp_rule,
  /* 1002 */  iRegINoSp_rule,
  /* 1003 */  iRegLNoSp_rule,
  /* 1004 */  iRegINoSp_rule,
  /* 1005 */  iRegLNoSp_rule,
  /* 1006 */  iRegLNoSp_rule,
  /* 1007 */  iRegINoSp_rule,
  /* 1008 */  iRegLNoSp_rule,
  /* 1009 */  iRegINoSp_rule,
  /* 1010 */  iRegINoSp_rule,
  /* 1011 */  iRegLNoSp_rule,
  /* 1012 */  iRegLNoSp_rule,
  /* 1013 */  iRegINoSp_rule,
  /* 1014 */  iRegLNoSp_rule,
  /* 1015 */  iRegLNoSp_rule,
  /* 1016 */  iRegINoSp_rule,
  /* 1017 */  iRegLNoSp_rule,
  /* 1018 */  iRegINoSp_rule,
  /* 1019 */  iRegLNoSp_rule,
  /* 1020 */  iRegLNoSp_rule,
  /* 1021 */  iRegLNoSp_rule,
  /* 1022 */  iRegINoSp_rule,
  /* 1023 */  iRegINoSp_rule,
  /* 1024 */  iRegLNoSp_rule,
  /* 1025 */  iRegLNoSp_rule,
  /* 1026 */  iRegINoSp_rule,
  /* 1027 */  iRegINoSp_rule,
  /* 1028 */  iRegINoSp_rule,
  /* 1029 */  iRegLNoSp_rule,
  /* 1030 */  iRegINoSp_rule,
  /* 1031 */  iRegLNoSp_rule,
  /* 1032 */  iRegINoSp_rule,
  /* 1033 */  iRegLNoSp_rule,
  /* 1034 */  iRegLNoSp_rule,
  /* 1035 */  iRegLNoSp_rule,
  /* 1036 */  iRegLNoSp_rule,
  /* 1037 */  iRegINoSp_rule,
  /* 1038 */  iRegINoSp_rule,
  /* 1039 */  iRegINoSp_rule,
  /* 1040 */  iRegINoSp_rule,
  /* 1041 */  iRegINoSp_rule,
  /* 1042 */  iRegINoSp_rule,
  /* 1043 */  iRegLNoSp_rule,
  /* 1044 */  iRegLNoSp_rule,
  /* 1045 */  iRegLNoSp_rule,
  /* 1046 */  iRegLNoSp_rule,
  /* 1047 */  iRegLNoSp_rule,
  /* 1048 */  iRegLNoSp_rule,
  /* 1049 */  iRegLNoSp_rule,
  /* 1050 */  iRegLNoSp_rule,
  /* 1051 */  iRegINoSp_rule,
  /* 1052 */  iRegINoSp_rule,
  /* 1053 */  iRegINoSp_rule,
  /* 1054 */  iRegINoSp_rule,
  /* 1055 */  iRegLNoSp_rule,
  /* 1056 */  iRegLNoSp_rule,
  /* 1057 */  iRegLNoSp_rule,
  /* 1058 */  iRegLNoSp_rule,
  /* 1059 */  iRegLNoSp_rule,
  /* 1060 */  iRegLNoSp_rule,
  /* 1061 */  iRegINoSp_rule,
  /* 1062 */  iRegINoSp_rule,
  /* 1063 */  iRegLNoSp_rule,
  /* 1064 */  iRegLNoSp_rule,
  /* 1065 */  iRegLNoSp_rule,
  /* 1066 */  iRegLNoSp_rule,
  /* 1067 */  iRegLNoSp_rule,
  /* 1068 */  iRegLNoSp_rule,
  /* 1069 */  iRegLNoSp_rule,
  /* 1070 */  iRegLNoSp_rule,
  /* 1071 */  iRegLNoSp_rule,
  /* 1072 */  iRegLNoSp_rule,
  /* 1073 */  iRegLNoSp_rule,
  /* 1074 */  iRegLNoSp_rule,
  /* 1075 */  iRegINoSp_rule,
  /* 1076 */  iRegINoSp_rule,
  /* 1077 */  iRegINoSp_rule,
  /* 1078 */  iRegINoSp_rule,
  /* 1079 */  iRegINoSp_rule,
  /* 1080 */  iRegINoSp_rule,
  /* 1081 */  iRegLNoSp_rule,
  /* 1082 */  iRegLNoSp_rule,
  /* 1083 */  iRegLNoSp_rule,
  /* 1084 */  iRegLNoSp_rule,
  /* 1085 */  iRegLNoSp_rule,
  /* 1086 */  iRegLNoSp_rule,
  /* 1087 */  iRegLNoSp_rule,
  /* 1088 */  iRegLNoSp_rule,
  /* 1089 */  iRegLNoSp_rule,
  /* 1090 */  iRegLNoSp_rule,
  /* 1091 */  iRegLNoSp_rule,
  /* 1092 */  iRegLNoSp_rule,
  /* 1093 */  iRegINoSp_rule,
  /* 1094 */  iRegINoSp_rule,
  /* 1095 */  iRegINoSp_rule,
  /* 1096 */  iRegINoSp_rule,
  /* 1097 */  iRegINoSp_rule,
  /* 1098 */  iRegINoSp_rule,
  /* 1099 */  0,
  /* 1100 */  0,
  /* 1101 */  0,
  /* 1102 */  0,
  /* 1103 */  0,
  /* 1104 */  0,
  /* 1105 */  0,
  /* 1106 */  0,
  /* 1107 */  iRegINoSp_rule,
  /* 1108 */  iRegINoSp_rule,
  /* 1109 */  iRegINoSp_rule,
  /* 1110 */  iRegINoSp_rule,
  /* 1111 */  iRegINoSp_rule,
  /* 1112 */  iRegINoSp_rule,
  /* 1113 */  iRegINoSp_rule,
  /* 1114 */  iRegINoSp_rule,
  /* 1115 */  iRegINoSp_rule,
  /* 1116 */  iRegINoSp_rule,
  /* 1117 */  iRegINoSp_rule,
  /* 1118 */  iRegINoSp_rule,
  /* 1119 */  vRegF_rule,
  /* 1120 */  vRegD_rule,
  /* 1121 */  vRegF_rule,
  /* 1122 */  vRegD_rule,
  /* 1123 */  vRegF_rule,
  /* 1124 */  vRegD_rule,
  /* 1125 */  vRegF_rule,
  /* 1126 */  vRegD_rule,
  /* 1127 */  vRegF_rule,
  /* 1128 */  vRegD_rule,
  /* 1129 */  vRegF_rule,
  /* 1130 */  vRegD_rule,
  /* 1131 */  vRegF_rule,
  /* 1132 */  vRegD_rule,
  /* 1133 */  vRegF_rule,
  /* 1134 */  vRegF_rule,
  /* 1135 */  vRegD_rule,
  /* 1136 */  vRegD_rule,
  /* 1137 */  vRegF_rule,
  /* 1138 */  vRegD_rule,
  /* 1139 */  iRegINoSp_rule,
  /* 1140 */  iRegLNoSp_rule,
  /* 1141 */  vRegF_rule,
  /* 1142 */  vRegD_rule,
  /* 1143 */  vRegD_rule,
  /* 1144 */  vRegF_rule,
  /* 1145 */  vRegD_rule,
  /* 1146 */  vRegD_rule,
  /* 1147 */  vRegF_rule,
  /* 1148 */  vRegD_rule,
  /* 1149 */  vRegF_rule,
  /* 1150 */  Universe_rule,
  /* 1151 */  iRegINoSp_rule,
  /* 1152 */  iRegINoSp_rule,
  /* 1153 */  iRegINoSp_rule,
  /* 1154 */  iRegINoSp_rule,
  /* 1155 */  iRegINoSp_rule,
  /* 1156 */  iRegINoSp_rule,
  /* 1157 */  iRegLNoSp_rule,
  /* 1158 */  iRegLNoSp_rule,
  /* 1159 */  iRegLNoSp_rule,
  /* 1160 */  iRegLNoSp_rule,
  /* 1161 */  iRegLNoSp_rule,
  /* 1162 */  iRegLNoSp_rule,
  /* 1163 */  iRegLNoSp_rule,
  /* 1164 */  iRegLNoSp_rule,
  /* 1165 */  iRegINoSp_rule,
  /* 1166 */  vRegF_rule,
  /* 1167 */  vRegD_rule,
  /* 1168 */  iRegINoSp_rule,
  /* 1169 */  iRegLNoSp_rule,
  /* 1170 */  iRegINoSp_rule,
  /* 1171 */  vRegF_rule,
  /* 1172 */  vRegF_rule,
  /* 1173 */  vRegF_rule,
  /* 1174 */  iRegINoSp_rule,
  /* 1175 */  iRegLNoSp_rule,
  /* 1176 */  vRegD_rule,
  /* 1177 */  vRegD_rule,
  /* 1178 */  iRegLNoSp_rule,
  /* 1179 */  iRegINoSp_rule,
  /* 1180 */  stackSlotI_rule,
  /* 1181 */  stackSlotF_rule,
  /* 1182 */  stackSlotL_rule,
  /* 1183 */  stackSlotD_rule,
  /* 1184 */  Universe_rule,
  /* 1185 */  Universe_rule,
  /* 1186 */  Universe_rule,
  /* 1187 */  Universe_rule,
  /* 1188 */  iRegINoSp_rule,
  /* 1189 */  iRegINoSp_rule,
  /* 1190 */  iRegINoSp_rule,
  /* 1191 */  iRegINoSp_rule,
  /* 1192 */  iRegINoSp_rule,
  /* 1193 */  iRegINoSp_rule,
  /* 1194 */  iRegINoSp_rule,
  /* 1195 */  iRegINoSp_rule,
  /* 1196 */  Universe_rule,
  /* 1197 */  Universe_rule,
  /* 1198 */  Universe_rule,
  /* 1199 */  Universe_rule,
  /* 1200 */  Universe_rule,
  /* 1201 */  Universe_rule,
  /* 1202 */  Universe_rule,
  /* 1203 */  Universe_rule,
  /* 1204 */  Universe_rule,
  /* 1205 */  Universe_rule,
  /* 1206 */  Universe_rule,
  /* 1207 */  Universe_rule,
  /* 1208 */  Universe_rule,
  /* 1209 */  Universe_rule,
  /* 1210 */  Universe_rule,
  /* 1211 */  Universe_rule,
  /* 1212 */  Universe_rule,
  /* 1213 */  Universe_rule,
  /* 1214 */  Universe_rule,
  /* 1215 */  Universe_rule,
  /* 1216 */  Universe_rule,
  /* 1217 */  Universe_rule,
  /* 1218 */  Universe_rule,
  /* 1219 */  Universe_rule,
  /* 1220 */  Universe_rule,
  /* 1221 */  Universe_rule,
  /* 1222 */  Universe_rule,
  /* 1223 */  iRegP_R0_rule,
  /* 1224 */  Universe_rule,
  /* 1225 */  Universe_rule,
  /* 1226 */  Universe_rule,
  /* 1227 */  iRegP_R5_rule,
  /* 1228 */  iRegI_R0_rule,
  /* 1229 */  iRegI_R0_rule,
  /* 1230 */  iRegI_R0_rule,
  /* 1231 */  iRegI_R0_rule,
  /* 1232 */  iRegI_R0_rule,
  /* 1233 */  iRegI_R0_rule,
  /* 1234 */  iRegI_R0_rule,
  /* 1235 */  iRegI_R0_rule,
  /* 1236 */  iRegI_R0_rule,
  /* 1237 */  iRegI_R0_rule,
  /* 1238 */  iRegI_R0_rule,
  /* 1239 */  iRegI_R0_rule,
  /* 1240 */  iRegI_R0_rule,
  /* 1241 */  iRegI_R0_rule,
  /* 1242 */  iRegI_R0_rule,
  /* 1243 */  iRegI_R0_rule,
  /* 1244 */  iRegI_R0_rule,
  /* 1245 */  iRegI_R0_rule,
  /* 1246 */  iRegI_R0_rule,
  /* 1247 */  iRegI_R0_rule,
  /* 1248 */  iRegI_R0_rule,
  /* 1249 */  iRegI_R0_rule,
  /* 1250 */  iRegI_R0_rule,
  /* 1251 */  iRegI_R0_rule,
  /* 1252 */  Universe_rule,
  /* 1253 */  iRegI_R0_rule,
  /* 1254 */  iRegI_R0_rule,
  /* 1255 */  iRegINoSp_rule,
  /* 1256 */  iRegINoSp_rule,
  /* 1257 */  iRegLNoSp_rule,
  /* 1258 */  iRegLNoSp_rule,
  /* 1259 */  iRegINoSp_rule,
  /* 1260 */  iRegINoSp_rule,
  /* 1261 */  iRegLNoSp_rule,
  /* 1262 */  iRegINoSp_rule,
  /* 1263 */  vReg_rule,
  /* 1264 */  Universe_rule,
  /* 1265 */  vReg_rule,
  /* 1266 */  Universe_rule,
  /* 1267 */  vReg_rule,
  /* 1268 */  Universe_rule,
  /* 1269 */  vReg_rule,
  /* 1270 */  Universe_rule,
  /* 1271 */  vReg_rule,
  /* 1272 */  Universe_rule,
  /* 1273 */  vReg_rule,
  /* 1274 */  Universe_rule,
  /* 1275 */  vReg_rule,
  /* 1276 */  vReg_rule,
  /* 1277 */  vReg_rule,
  /* 1278 */  vReg_rule,
  /* 1279 */  vReg_rule,
  /* 1280 */  vReg_rule,
  /* 1281 */  vReg_rule,
  /* 1282 */  vReg_rule,
  /* 1283 */  vReg_rule,
  /* 1284 */  vReg_rule,
  /* 1285 */  vReg_rule,
  /* 1286 */  vReg_rule,
  /* 1287 */  vReg_rule,
  /* 1288 */  vReg_rule,
  /* 1289 */  vReg_rule,
  /* 1290 */  vReg_rule,
  /* 1291 */  vReg_rule,
  /* 1292 */  vReg_rule,
  /* 1293 */  vReg_rule,
  /* 1294 */  vReg_rule,
  /* 1295 */  vReg_rule,
  /* 1296 */  vReg_rule,
  /* 1297 */  vReg_rule,
  /* 1298 */  vReg_rule,
  /* 1299 */  vReg_rule,
  /* 1300 */  vReg_rule,
  /* 1301 */  vReg_rule,
  /* 1302 */  vReg_rule,
  /* 1303 */  vReg_rule,
  /* 1304 */  vReg_rule,
  /* 1305 */  vReg_rule,
  /* 1306 */  vReg_rule,
  /* 1307 */  vReg_rule,
  /* 1308 */  vReg_rule,
  /* 1309 */  vReg_rule,
  /* 1310 */  vReg_rule,
  /* 1311 */  vReg_rule,
  /* 1312 */  vReg_rule,
  /* 1313 */  vReg_rule,
  /* 1314 */  vReg_rule,
  /* 1315 */  vReg_rule,
  /* 1316 */  vReg_rule,
  /* 1317 */  vReg_rule,
  /* 1318 */  vReg_rule,
  /* 1319 */  vReg_rule,
  /* 1320 */  vReg_rule,
  /* 1321 */  vReg_rule,
  /* 1322 */  vReg_rule,
  /* 1323 */  vReg_rule,
  /* 1324 */  vReg_rule,
  /* 1325 */  vReg_rule,
  /* 1326 */  vReg_rule,
  /* 1327 */  vReg_rule,
  /* 1328 */  vReg_rule,
  /* 1329 */  vReg_rule,
  /* 1330 */  vReg_rule,
  /* 1331 */  vReg_rule,
  /* 1332 */  vReg_rule,
  /* 1333 */  vReg_rule,
  /* 1334 */  vReg_rule,
  /* 1335 */  vReg_rule,
  /* 1336 */  vReg_rule,
  /* 1337 */  vReg_rule,
  /* 1338 */  vReg_rule,
  /* 1339 */  vReg_rule,
  /* 1340 */  vReg_rule,
  /* 1341 */  vReg_rule,
  /* 1342 */  vReg_rule,
  /* 1343 */  vReg_rule,
  /* 1344 */  vReg_rule,
  /* 1345 */  vReg_rule,
  /* 1346 */  vReg_rule,
  /* 1347 */  vReg_rule,
  /* 1348 */  vReg_rule,
  /* 1349 */  vReg_rule,
  /* 1350 */  vReg_rule,
  /* 1351 */  vReg_rule,
  /* 1352 */  vReg_rule,
  /* 1353 */  vReg_rule,
  /* 1354 */  vReg_rule,
  /* 1355 */  vReg_rule,
  /* 1356 */  vReg_rule,
  /* 1357 */  vReg_rule,
  /* 1358 */  vReg_rule,
  /* 1359 */  vReg_rule,
  /* 1360 */  vReg_rule,
  /* 1361 */  vReg_rule,
  /* 1362 */  vReg_rule,
  /* 1363 */  vReg_rule,
  /* 1364 */  vReg_rule,
  /* 1365 */  vReg_rule,
  /* 1366 */  vReg_rule,
  /* 1367 */  vReg_rule,
  /* 1368 */  vReg_rule,
  /* 1369 */  vReg_rule,
  /* 1370 */  vReg_rule,
  /* 1371 */  vReg_rule,
  /* 1372 */  vReg_rule,
  /* 1373 */  vReg_rule,
  /* 1374 */  vReg_rule,
  /* 1375 */  vReg_rule,
  /* 1376 */  vReg_rule,
  /* 1377 */  vReg_rule,
  /* 1378 */  vReg_rule,
  /* 1379 */  vReg_rule,
  /* 1380 */  vReg_rule,
  /* 1381 */  vReg_rule,
  /* 1382 */  vReg_rule,
  /* 1383 */  vReg_rule,
  /* 1384 */  vReg_rule,
  /* 1385 */  vReg_rule,
  /* 1386 */  vReg_rule,
  /* 1387 */  vReg_rule,
  /* 1388 */  vReg_rule,
  /* 1389 */  vReg_rule,
  /* 1390 */  vReg_rule,
  /* 1391 */  vReg_rule,
  /* 1392 */  vReg_rule,
  /* 1393 */  vReg_rule,
  /* 1394 */  vReg_rule,
  /* 1395 */  vReg_rule,
  /* 1396 */  vReg_rule,
  /* 1397 */  vReg_rule,
  /* 1398 */  vReg_rule,
  /* 1399 */  vReg_rule,
  /* 1400 */  vReg_rule,
  /* 1401 */  vReg_rule,
  /* 1402 */  vReg_rule,
  /* 1403 */  vReg_rule,
  /* 1404 */  vReg_rule,
  /* 1405 */  vReg_rule,
  /* 1406 */  vReg_rule,
  /* 1407 */  vReg_rule,
  /* 1408 */  vReg_rule,
  /* 1409 */  vReg_rule,
  /* 1410 */  vReg_rule,
  /* 1411 */  vReg_rule,
  /* 1412 */  vReg_rule,
  /* 1413 */  vReg_rule,
  /* 1414 */  vReg_rule,
  /* 1415 */  vReg_rule,
  /* 1416 */  vReg_rule,
  /* 1417 */  vReg_rule,
  /* 1418 */  vReg_rule,
  /* 1419 */  vReg_rule,
  /* 1420 */  vReg_rule,
  /* 1421 */  vReg_rule,
  /* 1422 */  vReg_rule,
  /* 1423 */  vReg_rule,
  /* 1424 */  vReg_rule,
  /* 1425 */  vReg_rule,
  /* 1426 */  vReg_rule,
  /* 1427 */  vReg_rule,
  /* 1428 */  vReg_rule,
  /* 1429 */  vReg_rule,
  /* 1430 */  vReg_rule,
  /* 1431 */  vReg_rule,
  /* 1432 */  vReg_rule,
  /* 1433 */  vReg_rule,
  /* 1434 */  vReg_rule,
  /* 1435 */  vReg_rule,
  /* 1436 */  vReg_rule,
  /* 1437 */  vReg_rule,
  /* 1438 */  vReg_rule,
  /* 1439 */  vReg_rule,
  /* 1440 */  vReg_rule,
  /* 1441 */  vReg_rule,
  /* 1442 */  vReg_rule,
  /* 1443 */  vReg_rule,
  /* 1444 */  vReg_rule,
  /* 1445 */  vReg_rule,
  /* 1446 */  vReg_rule,
  /* 1447 */  vReg_rule,
  /* 1448 */  vReg_rule,
  /* 1449 */  vReg_rule,
  /* 1450 */  vReg_rule,
  /* 1451 */  vReg_rule,
  /* 1452 */  vReg_rule,
  /* 1453 */  vReg_rule,
  /* 1454 */  vReg_rule,
  /* 1455 */  vReg_rule,
  /* 1456 */  vReg_rule,
  /* 1457 */  vReg_rule,
  /* 1458 */  vReg_rule,
  /* 1459 */  vReg_rule,
  /* 1460 */  vReg_rule,
  /* 1461 */  vReg_rule,
  /* 1462 */  vReg_rule,
  /* 1463 */  vReg_rule,
  /* 1464 */  vReg_rule,
  /* 1465 */  vReg_rule,
  /* 1466 */  vReg_rule,
  /* 1467 */  vReg_rule,
  /* 1468 */  vReg_rule,
  /* 1469 */  vReg_rule,
  /* 1470 */  vReg_rule,
  /* 1471 */  vReg_rule,
  /* 1472 */  vReg_rule,
  /* 1473 */  vReg_rule,
  /* 1474 */  vReg_rule,
  /* 1475 */  vReg_rule,
  /* 1476 */  vReg_rule,
  /* 1477 */  vReg_rule,
  /* 1478 */  vReg_rule,
  /* 1479 */  vReg_rule,
  /* 1480 */  vReg_rule,
  /* 1481 */  vReg_rule,
  /* 1482 */  vReg_rule,
  /* 1483 */  vReg_rule,
  /* 1484 */  vReg_rule,
  /* 1485 */  vReg_rule,
  /* 1486 */  vReg_rule,
  /* 1487 */  vReg_rule,
  /* 1488 */  vReg_rule,
  /* 1489 */  vReg_rule,
  /* 1490 */  vReg_rule,
  /* 1491 */  vReg_rule,
  /* 1492 */  vReg_rule,
  /* 1493 */  vReg_rule,
  /* 1494 */  vReg_rule,
  /* 1495 */  vReg_rule,
  /* 1496 */  vReg_rule,
  /* 1497 */  vReg_rule,
  /* 1498 */  vReg_rule,
  /* 1499 */  vReg_rule,
  /* 1500 */  vReg_rule,
  /* 1501 */  vReg_rule,
  /* 1502 */  vReg_rule,
  /* 1503 */  vReg_rule,
  /* 1504 */  vReg_rule,
  /* 1505 */  vReg_rule,
  /* 1506 */  vReg_rule,
  /* 1507 */  vReg_rule,
  /* 1508 */  vReg_rule,
  /* 1509 */  vReg_rule,
  /* 1510 */  vReg_rule,
  /* 1511 */  vReg_rule,
  /* 1512 */  vReg_rule,
  /* 1513 */  vReg_rule,
  /* 1514 */  vReg_rule,
  /* 1515 */  vReg_rule,
  /* 1516 */  vReg_rule,
  /* 1517 */  vReg_rule,
  /* 1518 */  vReg_rule,
  /* 1519 */  vReg_rule,
  /* 1520 */  vReg_rule,
  /* 1521 */  vReg_rule,
  /* 1522 */  vReg_rule,
  /* 1523 */  vReg_rule,
  /* 1524 */  vReg_rule,
  /* 1525 */  vReg_rule,
  /* 1526 */  vReg_rule,
  /* 1527 */  vReg_rule,
  /* 1528 */  vReg_rule,
  /* 1529 */  vReg_rule,
  /* 1530 */  iRegINoSp_rule,
  /* 1531 */  iRegINoSp_rule,
  /* 1532 */  iRegLNoSp_rule,
  /* 1533 */  iRegLNoSp_rule,
  /* 1534 */  vRegF_rule,
  /* 1535 */  vRegF_rule,
  /* 1536 */  vRegF_rule,
  /* 1537 */  vRegD_rule,
  /* 1538 */  vRegD_rule,
  /* 1539 */  iRegINoSp_rule,
  /* 1540 */  iRegLNoSp_rule,
  /* 1541 */  vRegF_rule,
  /* 1542 */  vRegD_rule,
  /* 1543 */  iRegINoSp_rule,
  /* 1544 */  iRegLNoSp_rule,
  /* 1545 */  vRegF_rule,
  /* 1546 */  vRegD_rule,
  /* 1547 */  iRegINoSp_rule,
  /* 1548 */  iRegINoSp_rule,
  /* 1549 */  iRegLNoSp_rule,
  /* 1550 */  iRegLNoSp_rule,
  /* 1551 */  iRegINoSp_rule,
  /* 1552 */  iRegLNoSp_rule,
  /* 1553 */  iRegINoSp_rule,
  /* 1554 */  iRegINoSp_rule,
  /* 1555 */  iRegLNoSp_rule,
  /* 1556 */  iRegLNoSp_rule,
  /* 1557 */  iRegINoSp_rule,
  /* 1558 */  iRegLNoSp_rule,
  /* 1559 */  iRegINoSp_rule,
  /* 1560 */  iRegINoSp_rule,
  /* 1561 */  iRegLNoSp_rule,
  /* 1562 */  iRegLNoSp_rule,
  /* 1563 */  iRegINoSp_rule,
  /* 1564 */  iRegLNoSp_rule,
  /* 1565 */  iRegINoSp_rule,
  /* 1566 */  iRegINoSp_rule,
  /* 1567 */  iRegLNoSp_rule,
  /* 1568 */  iRegLNoSp_rule,
  /* 1569 */  vRegF_rule,
  /* 1570 */  vRegD_rule,
  /* 1571 */  iRegINoSp_rule,
  /* 1572 */  iRegLNoSp_rule,
  /* 1573 */  vRegF_rule,
  /* 1574 */  vRegD_rule,
  /* 1575 */  iRegINoSp_rule,
  /* 1576 */  iRegINoSp_rule,
  /* 1577 */  iRegLNoSp_rule,
  /* 1578 */  iRegLNoSp_rule,
  /* 1579 */  vRegF_rule,
  /* 1580 */  vRegD_rule,
  /* 1581 */  iRegINoSp_rule,
  /* 1582 */  iRegLNoSp_rule,
  /* 1583 */  vRegF_rule,
  /* 1584 */  vRegD_rule,
  /* 1585 */  vReg_rule,
  /* 1586 */  vReg_rule,
  /* 1587 */  vReg_rule,
  /* 1588 */  vReg_rule,
  /* 1589 */  vReg_rule,
  /* 1590 */  vReg_rule,
  /* 1591 */  vReg_rule,
  /* 1592 */  vReg_rule,
  /* 1593 */  vReg_rule,
  /* 1594 */  vReg_rule,
  /* 1595 */  vReg_rule,
  /* 1596 */  vReg_rule,
  /* 1597 */  vReg_rule,
  /* 1598 */  vReg_rule,
  /* 1599 */  vReg_rule,
  /* 1600 */  vReg_rule,
  /* 1601 */  vReg_rule,
  /* 1602 */  vReg_rule,
  /* 1603 */  vReg_rule,
  /* 1604 */  vReg_rule,
  /* 1605 */  vReg_rule,
  /* 1606 */  vReg_rule,
  /* 1607 */  vReg_rule,
  /* 1608 */  iRegINoSp_rule,
  /* 1609 */  iRegINoSp_rule,
  /* 1610 */  iRegINoSp_rule,
  /* 1611 */  iRegINoSp_rule,
  /* 1612 */  iRegINoSp_rule,
  /* 1613 */  iRegINoSp_rule,
  /* 1614 */  iRegINoSp_rule,
  /* 1615 */  iRegINoSp_rule,
  /* 1616 */  iRegINoSp_rule,
  /* 1617 */  iRegLNoSp_rule,
  /* 1618 */  iRegLNoSp_rule,
  /* 1619 */  vRegF_rule,
  /* 1620 */  vRegD_rule,
  /* 1621 */  pReg_rule,
  /* 1622 */  pReg_rule,
  /* 1623 */  pReg_rule,
  /* 1624 */  pReg_rule,
  /* 1625 */  vReg_rule,
  /* 1626 */  vReg_rule,
  /* 1627 */  vReg_rule,
  /* 1628 */  vReg_rule,
  /* 1629 */  pReg_rule,
  /* 1630 */  pReg_rule,
  /* 1631 */  pReg_rule,
  /* 1632 */  pReg_rule,
  /* 1633 */  Universe_rule,
  /* 1634 */  Universe_rule,
  /* 1635 */  Universe_rule,
  /* 1636 */  Universe_rule,
  /* 1637 */  pReg_rule,
  /* 1638 */  pReg_rule,
  /* 1639 */  pReg_rule,
  /* 1640 */  pReg_rule,
  /* 1641 */  pReg_rule,
  /* 1642 */  vReg_rule,
  /* 1643 */  vReg_rule,
  /* 1644 */  vReg_rule,
  /* 1645 */  vReg_rule,
  /* 1646 */  vReg_rule,
  /* 1647 */  pReg_rule,
  /* 1648 */  pReg_rule,
  /* 1649 */  pReg_rule,
  /* 1650 */  pReg_rule,
  /* 1651 */  pReg_rule,
  /* 1652 */  pReg_rule,
  /* 1653 */  pReg_rule,
  /* 1654 */  pReg_rule,
  /* 1655 */  iRegINoSp_rule,
  /* 1656 */  iRegINoSp_rule,
  /* 1657 */  iRegINoSp_rule,
  /* 1658 */  iRegINoSp_rule,
  /* 1659 */  iRegINoSp_rule,
  /* 1660 */  iRegLNoSp_rule,
  /* 1661 */  pReg_rule,
  /* 1662 */  pReg_rule,
  /* 1663 */  pReg_rule,
  /* 1664 */  pReg_rule,
  /* 1665 */  pReg_rule,
  /* 1666 */  pReg_rule,
  /* 1667 */  pReg_rule,
  /* 1668 */  pReg_rule,
  /* 1669 */  pReg_rule,
  /* 1670 */  pReg_rule,
  /* 1671 */  pReg_rule,
  /* 1672 */  vReg_rule,
  /* 1673 */  vReg_rule,
  /* 1674 */  vReg_rule,
  /* 1675 */  vReg_rule,
  /* 1676 */  vReg_rule,
  /* 1677 */  vReg_rule,
  /* 1678 */  vReg_rule,
  /* 1679 */  vReg_rule,
  /* 1680 */  vReg_rule,
  /* 1681 */  vReg_rule,
  /* 1682 */  vReg_rule,
  /* 1683 */  vReg_rule,
  /* 1684 */  vReg_rule,
  /* 1685 */  vReg_rule,
  /* 1686 */  vReg_rule,
  /* 1687 */  Universe_rule,
  /* 1688 */  Universe_rule,
  /* 1689 */  Universe_rule,
  /* 1690 */  Universe_rule,
  /* 1691 */  vReg_rule,
  /* 1692 */  vReg_rule,
  /* 1693 */  vReg_rule,
  /* 1694 */  vReg_rule,
  /* 1695 */  vReg_rule,
  /* 1696 */  pReg_rule,
  /* 1697 */  vReg_rule,
  /* 1698 */  vReg_rule,
  /* 1699 */  vReg_rule,
  /* 1700 */  vReg_rule,
  /* 1701 */  vReg_rule,
  /* 1702 */  vReg_rule,
  /* 1703 */  vReg_rule,
  /* 1704 */  vReg_rule,
  /* 1705 */  vReg_rule,
  /* 1706 */  vReg_rule,
  /* 1707 */  iRegINoSp_rule,
  /* 1708 */  iRegINoSp_rule,
  /* 1709 */  iRegINoSp_rule,
  /* 1710 */  iRegINoSp_rule,
  /* 1711 */  iRegNNoSp_rule,
  /* 1712 */  iRegPNoSp_rule,
  /* 1713 */  iRegNNoSp_rule,
  /* 1714 */  iRegPNoSp_rule,
  /* 1715 */  iRegINoSp_rule,
  /* 1716 */  iRegINoSp_rule,
  /* 1717 */  iRegINoSp_rule,
  /* 1718 */  iRegINoSp_rule,
  /* 1719 */  iRegPNoSp_rule,
  /* 1720 */  iRegPNoSp_rule,
  /* 1721 */  iRegINoSp_rule,
  /* 1722 */  iRegINoSp_rule,
  /* 1723 */  iRegINoSp_rule,
  /* 1724 */  iRegINoSp_rule,
  /* 1725 */  iRegPNoSp_rule,
  /* 1726 */  iRegPNoSp_rule,
  /* 1727 */  iRegPNoSp_rule,
  /* 1728 */  iRegPNoSp_rule,
  /* 1729 */  iRegPNoSp_rule,
  /* 1730 */  iRegPNoSp_rule,
  /* 1731 */  Universe_rule,
  /* 1732 */  Universe_rule,
  /* 1733 */  iRegINoSp_rule,
  /* 1734 */  iRegINoSp_rule,
  /* 1735 */  iRegINoSp_rule,
  /* 1736 */  iRegINoSp_rule,
  /* 1737 */  iRegPNoSp_rule,
  /* 1738 */  iRegPNoSp_rule,
  /* 1739 */  iRegPNoSp_rule,
  /* 1740 */  iRegPNoSp_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  0,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  0,
  /*  160 */  0,
  /*  161 */  0,
  /*  162 */  iRegP_rule,
  /*  163 */  iRegP_rule,
  /*  164 */  iRegP_rule,
  /*  165 */  iRegP_rule,
  /*  166 */  iRegP_rule,
  /*  167 */  iRegP_rule,
  /*  168 */  iRegP_rule,
  /*  169 */  iRegP_rule,
  /*  170 */  iRegP_rule,
  /*  171 */  iRegP_rule,
  /*  172 */  iRegP_rule,
  /*  173 */  iRegP_rule,
  /*  174 */  iRegP_rule,
  /*  175 */  iRegP_rule,
  /*  176 */  iRegP_rule,
  /*  177 */  iRegP_rule,
  /*  178 */  iRegN_rule,
  /*  179 */  _DecodeN_iRegN__rule,
  /*  180 */  _DecodeN_iRegN__rule,
  /*  181 */  _DecodeN_iRegN__rule,
  /*  182 */  _DecodeN_iRegN__rule,
  /*  183 */  _DecodeN_iRegN__rule,
  /*  184 */  _DecodeN_iRegN__rule,
  /*  185 */  thread_RegP_rule,
  /*  186 */  0,
  /*  187 */  0,
  /*  188 */  0,
  /*  189 */  0,
  /*  190 */  0,
  /*  191 */  0,
  /*  192 */  0,
  /*  193 */  0,
  /*  194 */  0,
  /*  195 */  0,
  /*  196 */  iRegL_rule,
  /*  197 */  0,
  /*  198 */  0,
  /*  199 */  iRegP_rule,
  /*  200 */  iRegP_rule,
  // last operand
  /*  201 */  0,
  /*  202 */  0,
  /*  203 */  0,
  /*  204 */  0,
  /*  205 */  0,
  /*  206 */  0,
  /*  207 */  0,
  /*  208 */  0,
  /*  209 */  0,
  /*  210 */  0,
  /*  211 */  0,
  // last operand class
  /*  212 */  iRegI_rule,
  /*  213 */  _ConvI2L_iRegI__rule,
  /*  214 */  iRegL_rule,
  /*  215 */  iRegN_rule,
  /*  216 */  memory1_rule,
  /*  217 */  memory1_rule,
  /*  218 */  memory2_rule,
  /*  219 */  memory2_rule,
  /*  220 */  memory4_rule,
  /*  221 */  _LoadI_memory4__rule,
  /*  222 */  indirect_rule,
  /*  223 */  indirect_rule,
  /*  224 */  indirect_rule,
  /*  225 */  indirect_rule,
  /*  226 */  indirect_rule,
  /*  227 */  _LoadI_indirect__rule,
  /*  228 */  memory8_rule,
  /*  229 */  iRegP_rule,
  /*  230 */  _DecodeN_iRegN__rule,
  /*  231 */  iRegINoSp_rule,
  /*  232 */  iRegLNoSp_rule,
  /*  233 */  iRegP_rule,
  /*  234 */  iRegNNoSp_rule,
  /*  235 */  iRegI_rule,
  /*  236 */  iRegL_rule,
  /*  237 */  iRegN_rule,
  /*  238 */  cmpOp_rule,
  /*  239 */  iRegIorL2I_rule,
  /*  240 */  cmpOpU_rule,
  /*  241 */  immI0_rule,
  /*  242 */  iRegIorL2I_rule,
  /*  243 */  immI_1_rule,
  /*  244 */  iRegL_rule,
  /*  245 */  immL0_rule,
  /*  246 */  iRegP_rule,
  /*  247 */  immP0_rule,
  /*  248 */  iRegN_rule,
  /*  249 */  immN0_rule,
  /*  250 */  vRegF_rule,
  /*  251 */  vRegD_rule,
  /*  252 */  iRegL_rule,
  /*  253 */  iRegIorL2I_rule,
  /*  254 */  _ConvI2L_iRegIorL2I__rule,
  /*  255 */  iRegIorL2I_rule,
  /*  256 */  immI0_rule,
  /*  257 */  iRegL_rule,
  /*  258 */  immL0_rule,
  /*  259 */  _ConvI2L_iRegIorL2I__rule,
  /*  260 */  immL0_rule,
  /*  261 */  iRegIorL2I_rule,
  /*  262 */  iRegIorL2I_rule,
  /*  263 */  iRegIorL2I_rule,
  /*  264 */  iRegL_rule,
  /*  265 */  iRegL_rule,
  /*  266 */  iRegL_rule,
  /*  267 */  iRegIorL2I_rule,
  /*  268 */  iRegL_rule,
  /*  269 */  iRegIorL2I_rule,
  /*  270 */  iRegL_rule,
  /*  271 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  272 */  _URShiftL_iRegL_immI_rule,
  /*  273 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  274 */  _RShiftL_iRegL_immI_rule,
  /*  275 */  iRegIorL2I_rule,
  /*  276 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  277 */  iRegL_rule,
  /*  278 */  _RotateRight_iRegL_immI_rule,
  /*  279 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  280 */  _LShiftL_iRegL_immI_rule,
  /*  281 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  282 */  iRegIorL2I_rule,
  /*  283 */  _URShiftL_iRegL_immI_rule,
  /*  284 */  iRegL_rule,
  /*  285 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  286 */  iRegIorL2I_rule,
  /*  287 */  _RShiftL_iRegL_immI_rule,
  /*  288 */  iRegL_rule,
  /*  289 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  290 */  iRegIorL2I_rule,
  /*  291 */  _RotateRight_iRegL_immI_rule,
  /*  292 */  iRegL_rule,
  /*  293 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  294 */  iRegIorL2I_rule,
  /*  295 */  _LShiftL_iRegL_immI_rule,
  /*  296 */  iRegL_rule,
  /*  297 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  298 */  iRegIorL2I_rule,
  /*  299 */  iRegL_rule,
  /*  300 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /*  301 */  iRegL_rule,
  /*  302 */  _AndL_iRegL_immL_positive_bitmaskI_rule,
  /*  303 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /*  304 */  _AndL_iRegL_immL_positive_bitmaskI_rule,
  /*  305 */  iRegI_rule,
  /*  306 */  iRegIorL2I_rule,
  /*  307 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  308 */  iRegIorL2I_rule,
  /*  309 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  310 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  311 */  iRegL_rule,
  /*  312 */  _LShiftL_iRegL_immI_48_rule,
  /*  313 */  iRegL_rule,
  /*  314 */  _LShiftL_iRegL_immI_32_rule,
  /*  315 */  iRegL_rule,
  /*  316 */  _LShiftL_iRegL_immI_56_rule,
  /*  317 */  _LShiftL_iRegL_immI_56_rule,
  /*  318 */  iRegIorL2I_rule,
  /*  319 */  iRegIorL2I_rule,
  /*  320 */  iRegL_rule,
  /*  321 */  iRegL_rule,
  /*  322 */  iRegL_rule,
  /*  323 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  324 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  325 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  326 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  327 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  328 */  _ConvI2L_iRegIorL2I__rule,
  /*  329 */  _AndL_iRegL_immL_255_rule,
  /*  330 */  _AndL_iRegL_immL_65535_rule,
  /*  331 */  _AndL_iRegL_immL_4294967295_rule,
  /*  332 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  333 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  334 */  vRegF_rule,
  /*  335 */  vRegF_rule,
  /*  336 */  vRegD_rule,
  /*  337 */  vRegD_rule,
  /*  338 */  vRegF_rule,
  /*  339 */  vRegD_rule,
  /*  340 */  iRegIorL2I_rule,
  /*  341 */  iRegL_rule,
  /*  342 */  iRegIorL2I_rule,
  /*  343 */  iRegL_rule,
  /*  344 */  iRegP_rule,
  /*  345 */  iRegN_rule,
  /*  346 */  _DecodeN_iRegN__rule,
  /*  347 */  iRegIorL2I_rule,
  /*  348 */  iRegL_rule,
  /*  349 */  iRegL_rule,
  /*  350 */  _AndL_iRegL_immL_rule,
  /*  351 */  iRegIorL2I_rule,
  /*  352 */  _AndI_iRegIorL2I_immI_rule,
  /*  353 */  iRegL_rule,
  /*  354 */  iRegIorL2I_rule,
  /*  355 */  iRegP_R4_rule,
  /*  356 */  iRegP_R1_rule,
  /*  357 */  iRegP_R3_rule,
  /*  358 */  iRegP_R1_rule,
  /*  359 */  iRegP_R3_rule,
  /*  360 */  iRegP_R3_rule,
  /*  361 */  iRegP_R3_rule,
  /*  362 */  iRegP_R1_rule,
  /*  363 */  iRegP_R1_rule,
  /*  364 */  vReg_rule,
  /*  365 */  vReg_rule,
  /*  366 */  immBAddSubV_rule,
  /*  367 */  immIAddSubV_rule,
  /*  368 */  immLAddSubV_rule,
  /*  369 */  immBLog_rule,
  /*  370 */  immSLog_rule,
  /*  371 */  immILog_rule,
  /*  372 */  immLLog_rule,
  /*  373 */  vReg_rule,
  /*  374 */  immI_M1_rule,
  /*  375 */  immL_M1_rule,
  /*  376 */  vReg_rule,
  /*  377 */  vReg_rule,
  /*  378 */  vReg_rule,
  /*  379 */  _Replicate_immI_M1__rule,
  /*  380 */  vReg_rule,
  /*  381 */  _Replicate_immL_M1__rule,
  /*  382 */  vReg_rule,
  /*  383 */  vReg_rule,
  /*  384 */  vReg_rule,
  /*  385 */  vReg_rule,
  /*  386 */  vReg_rule,
  /*  387 */  vReg_rule,
  /*  388 */  _Binary_vReg_vReg_rule,
  /*  389 */  _Binary_vReg_vReg_rule,
  /*  390 */  vReg_rule,
  /*  391 */  vReg_rule,
  /*  392 */  vReg_rule,
  /*  393 */  vReg_rule,
  /*  394 */  vReg_rule,
  /*  395 */  vReg_rule,
  /*  396 */  vReg_rule,
  /*  397 */  vReg_rule,
  /*  398 */  vReg_rule,
  /*  399 */  vReg_rule,
  /*  400 */  vReg_rule,
  /*  401 */  vReg_rule,
  /*  402 */  _NegVF_vReg__rule,
  /*  403 */  _NegVD_vReg__rule,
  /*  404 */  immI_rule,
  /*  405 */  immI_positive_rule,
  /*  406 */  vReg_rule,
  /*  407 */  vReg_rule,
  /*  408 */  vReg_rule,
  /*  409 */  vReg_rule,
  /*  410 */  vReg_rule,
  /*  411 */  vReg_rule,
  /*  412 */  vReg_rule,
  /*  413 */  vReg_rule,
  /*  414 */  vReg_rule,
  /*  415 */  vReg_rule,
  /*  416 */  iRegIorL2I_rule,
  /*  417 */  iRegL_rule,
  /*  418 */  vRegF_rule,
  /*  419 */  vRegD_rule,
  /*  420 */  vReg_rule,
  /*  421 */  vReg_rule,
  /*  422 */  vReg_rule,
  /*  423 */  vReg_rule,
  /*  424 */  indirect_rule,
  /*  425 */  vmemA_rule,
  /*  426 */  pReg_rule,
  /*  427 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /*  428 */  immI_M1_rule,
  /*  429 */  pReg_rule,
  /*  430 */  immL_M1_rule,
  /*  431 */  pReg_rule,
  /*  432 */  immI0_rule,
  /*  433 */  vReg_rule,
  /*  434 */  immL0_rule,
  /*  435 */  vReg_rule,
  /*  436 */  immF0_rule,
  /*  437 */  vReg_rule,
  /*  438 */  immD0_rule,
  /*  439 */  vReg_rule,
  /*  440 */  immI5_rule,
  /*  441 */  vReg_rule,
  /*  442 */  immIU7_rule,
  /*  443 */  vReg_rule,
  /*  444 */  immL5_rule,
  /*  445 */  vReg_rule,
  /*  446 */  immLU7_rule,
  /*  447 */  vReg_rule,
  /*  448 */  immI_rule,
  /*  449 */  vReg_rule,
  /*  450 */  iRegL_rule,
  /*  451 */  vReg_rule,
  // last internally defined operand
  /*  452 */  immI_rule,
  /*  453 */  immL_rule,
  /*  454 */  immP_rule,
  /*  455 */  immP0_rule,
  /*  456 */  immP_1_rule,
  /*  457 */  immByteMapBase_rule,
  /*  458 */  immN_rule,
  /*  459 */  immN0_rule,
  /*  460 */  immNKlass_rule,
  /*  461 */  immFPacked_rule,
  /*  462 */  immF_rule,
  /*  463 */  immDPacked_rule,
  /*  464 */  immD_rule,
  /*  465 */  iRegIorL2I_rule,
  /*  466 */  iRegL_rule,
  /*  467 */  iRegIorL2I_rule,
  /*  468 */  iRegL_rule,
  /*  469 */  iRegL_rule,
  /*  470 */  iRegP_rule,
  /*  471 */  iRegPNoSp_rule,
  /*  472 */  iRegPNoSp_rule,
  /*  473 */  iRegI_rule,
  /*  474 */  iRegL_rule,
  /*  475 */  vRegF_rule,
  /*  476 */  vRegD_rule,
  /*  477 */  vReg_rule,
  /*  478 */  pRegGov_rule,
  /*  479 */  iRegIorL2I_rule,
  /*  480 */  iRegL_rule,
  /*  481 */  vRegF_rule,
  /*  482 */  vRegD_rule,
  /*  483 */  vRegF_rule,
  /*  484 */  vRegD_rule,
  /*  485 */  stackSlotF_rule,
  /*  486 */  stackSlotI_rule,
  /*  487 */  stackSlotD_rule,
  /*  488 */  stackSlotL_rule,
  /*  489 */  vRegF_rule,
  /*  490 */  iRegI_rule,
  /*  491 */  vRegD_rule,
  /*  492 */  iRegL_rule,
  /*  493 */  iRegIorL2I_rule,
  /*  494 */  iRegIorL2I_rule,
  /*  495 */  iRegL_rule,
  /*  496 */  iRegL_rule,
  /*  497 */  iRegIorL2I_rule,
  /*  498 */  iRegIorL2I_rule,
  /*  499 */  iRegL_rule,
  /*  500 */  iRegL_rule,
  /*  501 */  immI0_rule,
  /*  502 */  immI0_rule,
  /*  503 */  iRegIorL2I_rule,
  /*  504 */  iRegL_rule,
  /*  505 */  iRegI_rule,
  /*  506 */  iRegI_rule,
  /*  507 */  iRegI_rule,
  /*  508 */  iRegI_rule,
  /*  509 */  iRegI_rule,
  /*  510 */  iRegI_rule,
  /*  511 */  iRegI_rule,
  /*  512 */  iRegI_rule,
  /*  513 */  iRegL_rule,
  /*  514 */  iRegL_rule,
  /*  515 */  iRegL_rule,
  /*  516 */  iRegL_rule,
  /*  517 */  iRegL_rule,
  /*  518 */  iRegL_rule,
  /*  519 */  iRegL_rule,
  /*  520 */  iRegL_rule,
  /*  521 */  iRegP_rule,
  /*  522 */  iRegN_rule,
  /*  523 */  iRegP_rule,
  /*  524 */  iRegN_rule,
  /*  525 */  vRegF_rule,
  /*  526 */  vRegF_rule,
  /*  527 */  vRegD_rule,
  /*  528 */  vRegD_rule,
  /*  529 */  0,
  /*  530 */  _AndL_iRegL_immL_rule,
  /*  531 */  _AndI_iRegIorL2I_immI_rule,
  /*  532 */  _AndL_iRegL_iRegL_rule,
  /*  533 */  _AndI_iRegIorL2I_iRegIorL2I_rule,
  /*  534 */  iRegP_rule,
  /*  535 */  iRegP_rule,
  /*  536 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  537 */  0,
  /*  538 */  immI0_rule,
  /*  539 */  vReg_rule,
  /*  540 */  vReg_rule,
  /*  541 */  vReg_rule,
  /*  542 */  vReg_rule,
  /*  543 */  vReg_rule,
  /*  544 */  vReg_rule,
  /*  545 */  vReg_rule,
  /*  546 */  vReg_rule,
  /*  547 */  vReg_rule,
  /*  548 */  vReg_rule,
  /*  549 */  vReg_rule,
  /*  550 */  vReg_rule,
  /*  551 */  iRegIorL2I_rule,
  /*  552 */  iRegIorL2I_rule,
  /*  553 */  vReg_rule,
  /*  554 */  vReg_rule,
  /*  555 */  vReg_rule,
  /*  556 */  vReg_rule,
  /*  557 */  vReg_rule,
  /*  558 */  vReg_rule,
  /*  559 */  vReg_rule,
  /*  560 */  vReg_rule,
  /*  561 */  vReg_rule,
  /*  562 */  vReg_rule,
  /*  563 */  vReg_rule,
  /*  564 */  vReg_rule,
  /*  565 */  vReg_rule,
  /*  566 */  vReg_rule,
  /*  567 */  vReg_rule,
  /*  568 */  vReg_rule,
  /*  569 */  iRegIorL2I_rule,
  /*  570 */  iRegL_rule,
  /*  571 */  vRegF_rule,
  /*  572 */  vRegD_rule,
  /*  573 */  immI_rule,
  /*  574 */  immI8_rule,
  /*  575 */  immI8_shift8_rule,
  /*  576 */  immL_rule,
  /*  577 */  immL8_shift8_rule,
  /*  578 */  vReg_rule,
  /*  579 */  vReg_rule,
  /*  580 */  vReg_rule,
  /*  581 */  vReg_rule,
  /*  582 */  pReg_rule,
  /*  583 */  pReg_rule,
  /*  584 */  pReg_rule,
  /*  585 */  pReg_rule,
  /*  586 */  vReg_rule,
  /*  587 */  vReg_rule,
  /*  588 */  vReg_rule,
  /*  589 */  vReg_rule,
  /*  590 */  vReg_rule,
  /*  591 */  vReg_rule,
  /*  592 */  pReg_rule,
  /*  593 */  vReg_rule,
  /*  594 */  pReg_rule,
  /*  595 */  vReg_rule,
  /*  596 */  vReg_rule,
  /*  597 */  vReg_rule,
  /*  598 */  vReg_rule,
  /*  599 */  vReg_rule,
  /*  600 */  memory1_rule,
  /*  601 */  _LoadB_memory1__rule,
  /*  602 */  memory1_rule,
  /*  603 */  _LoadUB_memory1__rule,
  /*  604 */  memory2_rule,
  /*  605 */  _LoadS_memory2__rule,
  /*  606 */  memory2_rule,
  /*  607 */  _LoadUS_memory2__rule,
  /*  608 */  memory4_rule,
  /*  609 */  _LoadI_memory4__rule,
  /*  610 */  _ConvI2L__LoadI_memory4___rule,
  /*  611 */  memory8_rule,
  /*  612 */  memory4_rule,
  /*  613 */  memory8_rule,
  /*  614 */  memory4_rule,
  /*  615 */  memory8_rule,
  /*  616 */  memory4_rule,
  /*  617 */  memory4_rule,
  /*  618 */  memory8_rule,
  /*  619 */  memory1_rule,
  /*  620 */  memory1_rule,
  /*  621 */  memory1_rule,
  /*  622 */  memory1_rule,
  /*  623 */  memory2_rule,
  /*  624 */  memory2_rule,
  /*  625 */  memory4_rule,
  /*  626 */  memory4_rule,
  /*  627 */  memory8_rule,
  /*  628 */  memory8_rule,
  /*  629 */  memory8_rule,
  /*  630 */  memory8_rule,
  /*  631 */  memory4_rule,
  /*  632 */  memory4_rule,
  /*  633 */  memory4_rule,
  /*  634 */  memory8_rule,
  /*  635 */  memory4_rule,
  /*  636 */  memory8_rule,
  /*  637 */  indirect_rule,
  /*  638 */  _LoadB_indirect__rule,
  /*  639 */  indirect_rule,
  /*  640 */  _LoadUB_indirect__rule,
  /*  641 */  indirect_rule,
  /*  642 */  indirect_rule,
  /*  643 */  _LoadUS_indirect__rule,
  /*  644 */  _LoadS_indirect__rule,
  /*  645 */  indirect_rule,
  /*  646 */  _ConvI2L__LoadI_indirect___rule,
  /*  647 */  indirect_rule,
  /*  648 */  indirect_rule,
  /*  649 */  indirect_rule,
  /*  650 */  indirect_rule,
  /*  651 */  indirect_rule,
  /*  652 */  indirect_rule,
  /*  653 */  indirect_rule,
  /*  654 */  indirect_rule,
  /*  655 */  indirect_rule,
  /*  656 */  indirect_rule,
  /*  657 */  indirect_rule,
  /*  658 */  indirect_rule,
  /*  659 */  indirect_rule,
  /*  660 */  indirect_rule,
  /*  661 */  indirect_rule,
  /*  662 */  indirect_rule,
  /*  663 */  indirect_rule,
  /*  664 */  indirect_rule,
  /*  665 */  indirect_rule,
  /*  666 */  indirect_rule,
  /*  667 */  0,
  /*  668 */  0,
  /*  669 */  iRegIorL2I_rule,
  /*  670 */  iRegL_rule,
  /*  671 */  iRegIorL2I_rule,
  /*  672 */  iRegIorL2I_rule,
  /*  673 */  iRegIorL2I_rule,
  /*  674 */  _LoadI_memory4__rule,
  /*  675 */  iRegL_rule,
  /*  676 */  _LoadL_memory8__rule,
  /*  677 */  0,
  /*  678 */  0,
  /*  679 */  0,
  /*  680 */  0,
  /*  681 */  0,
  /*  682 */  0,
  /*  683 */  0,
  /*  684 */  0,
  /*  685 */  0,
  /*  686 */  0,
  /*  687 */  0,
  /*  688 */  0,
  /*  689 */  _CastP2X_iRegP__rule,
  /*  690 */  _CastP2X__DecodeN_iRegN___rule,
  /*  691 */  iRegP_rule,
  /*  692 */  iRegP_rule,
  /*  693 */  iRegN_rule,
  /*  694 */  iRegN_rule,
  /*  695 */  iRegP_rule,
  /*  696 */  iRegN_rule,
  /*  697 */  indirect_rule,
  /*  698 */  indirect_rule,
  /*  699 */  indirect_rule,
  /*  700 */  indirect_rule,
  /*  701 */  indirect_rule,
  /*  702 */  indirect_rule,
  /*  703 */  indirect_rule,
  /*  704 */  indirect_rule,
  /*  705 */  indirect_rule,
  /*  706 */  indirect_rule,
  /*  707 */  indirect_rule,
  /*  708 */  indirect_rule,
  /*  709 */  indirect_rule,
  /*  710 */  indirect_rule,
  /*  711 */  indirect_rule,
  /*  712 */  indirect_rule,
  /*  713 */  indirect_rule,
  /*  714 */  indirect_rule,
  /*  715 */  indirect_rule,
  /*  716 */  indirect_rule,
  /*  717 */  indirect_rule,
  /*  718 */  indirect_rule,
  /*  719 */  indirect_rule,
  /*  720 */  indirect_rule,
  /*  721 */  indirect_rule,
  /*  722 */  indirect_rule,
  /*  723 */  indirect_rule,
  /*  724 */  indirect_rule,
  /*  725 */  indirect_rule,
  /*  726 */  indirect_rule,
  /*  727 */  indirect_rule,
  /*  728 */  indirect_rule,
  /*  729 */  indirect_rule,
  /*  730 */  indirect_rule,
  /*  731 */  indirect_rule,
  /*  732 */  indirect_rule,
  /*  733 */  indirect_rule,
  /*  734 */  indirect_rule,
  /*  735 */  indirect_rule,
  /*  736 */  indirect_rule,
  /*  737 */  indirect_rule,
  /*  738 */  indirect_rule,
  /*  739 */  indirect_rule,
  /*  740 */  indirect_rule,
  /*  741 */  indirect_rule,
  /*  742 */  indirect_rule,
  /*  743 */  indirect_rule,
  /*  744 */  indirect_rule,
  /*  745 */  indirect_rule,
  /*  746 */  indirect_rule,
  /*  747 */  indirect_rule,
  /*  748 */  indirect_rule,
  /*  749 */  indirect_rule,
  /*  750 */  indirect_rule,
  /*  751 */  indirect_rule,
  /*  752 */  indirect_rule,
  /*  753 */  indirect_rule,
  /*  754 */  indirect_rule,
  /*  755 */  indirect_rule,
  /*  756 */  indirect_rule,
  /*  757 */  iRegI_rule,
  /*  758 */  iRegI_rule,
  /*  759 */  iRegL_rule,
  /*  760 */  iRegL_rule,
  /*  761 */  iRegL_rule,
  /*  762 */  iRegL_rule,
  /*  763 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  764 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  765 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  766 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  767 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  768 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  769 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  770 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  771 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  772 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  773 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  774 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  775 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  776 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  777 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  778 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  779 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  780 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  781 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  782 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  783 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  784 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  785 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  786 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  787 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  788 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  789 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  790 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  791 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  792 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  793 */  iRegIorL2I_rule,
  /*  794 */  iRegIorL2I_rule,
  /*  795 */  _ConvL2I_iRegL__rule,
  /*  796 */  iRegP_rule,
  /*  797 */  iRegP_rule,
  /*  798 */  iRegP_rule,
  /*  799 */  iRegP_rule,
  /*  800 */  _ConvI2L_iRegIorL2I__rule,
  /*  801 */  iRegP_rule,
  /*  802 */  iRegL_rule,
  /*  803 */  iRegL_rule,
  /*  804 */  iRegIorL2I_rule,
  /*  805 */  iRegIorL2I_rule,
  /*  806 */  iRegL_rule,
  /*  807 */  iRegL_rule,
  /*  808 */  immI0_rule,
  /*  809 */  immL0_rule,
  /*  810 */  iRegIorL2I_rule,
  /*  811 */  _ConvI2L_iRegIorL2I__rule,
  /*  812 */  _ConvI2L_iRegIorL2I__rule,
  /*  813 */  iRegL_rule,
  /*  814 */  iRegL_rule,
  /*  815 */  iRegL_rule,
  /*  816 */  iRegIorL2I_rule,
  /*  817 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  818 */  iRegIorL2I_rule,
  /*  819 */  _SubI_immI0_iRegIorL2I_rule,
  /*  820 */  iRegIorL2I_rule,
  /*  821 */  iRegL_rule,
  /*  822 */  _MulL_iRegL_iRegL_rule,
  /*  823 */  iRegL_rule,
  /*  824 */  _SubL_immL0_iRegL_rule,
  /*  825 */  iRegL_rule,
  /*  826 */  iRegLNoSp_rule,
  /*  827 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  828 */  iRegLNoSp_rule,
  /*  829 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  830 */  iRegLNoSp_rule,
  /*  831 */  iRegLNoSp_rule,
  /*  832 */  _SubL_immL0__ConvI2L_iRegIorL2I__rule,
  /*  833 */  _ConvI2L_iRegIorL2I__rule,
  /*  834 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  835 */  iRegIorL2I_rule,
  /*  836 */  iRegL_rule,
  /*  837 */  iRegIorL2I_rule,
  /*  838 */  iRegL_rule,
  /*  839 */  iRegIorL2I_rule,
  /*  840 */  iRegL_rule,
  /*  841 */  iRegIorL2I_rule,
  /*  842 */  iRegL_rule,
  /*  843 */  iRegIorL2I_rule,
  /*  844 */  iRegIorL2I_rule,
  /*  845 */  iRegIorL2I_rule,
  /*  846 */  iRegIorL2I_rule,
  /*  847 */  iRegIorL2I_rule,
  /*  848 */  iRegIorL2I_rule,
  /*  849 */  iRegL_rule,
  /*  850 */  iRegL_rule,
  /*  851 */  iRegL_rule,
  /*  852 */  iRegL_rule,
  /*  853 */  _CastP2X_iRegP__rule,
  /*  854 */  iRegL_rule,
  /*  855 */  iRegL_rule,
  /*  856 */  iRegL_rule,
  /*  857 */  iRegIorL2I_rule,
  /*  858 */  immI0_rule,
  /*  859 */  immI0_rule,
  /*  860 */  immI0_rule,
  /*  861 */  immL0_rule,
  /*  862 */  immL0_rule,
  /*  863 */  immL0_rule,
  /*  864 */  iRegIorL2I_rule,
  /*  865 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  866 */  iRegL_rule,
  /*  867 */  _XorL_iRegL_immL_M1_rule,
  /*  868 */  iRegIorL2I_rule,
  /*  869 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  870 */  iRegL_rule,
  /*  871 */  _XorL_iRegL_immL_M1_rule,
  /*  872 */  immI_M1_rule,
  /*  873 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  874 */  immL_M1_rule,
  /*  875 */  _XorL_iRegL_iRegL_rule,
  /*  876 */  iRegIorL2I_rule,
  /*  877 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  878 */  iRegL_rule,
  /*  879 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  880 */  iRegIorL2I_rule,
  /*  881 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  882 */  iRegL_rule,
  /*  883 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  884 */  iRegIorL2I_rule,
  /*  885 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  886 */  iRegL_rule,
  /*  887 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  888 */  iRegIorL2I_rule,
  /*  889 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  890 */  iRegL_rule,
  /*  891 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  892 */  immI_M1_rule,
  /*  893 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  894 */  immI_M1_rule,
  /*  895 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  896 */  immL_M1_rule,
  /*  897 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  898 */  immL_M1_rule,
  /*  899 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  900 */  immI_M1_rule,
  /*  901 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  902 */  immI_M1_rule,
  /*  903 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  904 */  immL_M1_rule,
  /*  905 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  906 */  immL_M1_rule,
  /*  907 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  908 */  immI_M1_rule,
  /*  909 */  _XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  910 */  immI_M1_rule,
  /*  911 */  _XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI_rule,
  /*  912 */  immL_M1_rule,
  /*  913 */  _XorL__RotateRight_iRegL_immI_iRegL_rule,
  /*  914 */  immL_M1_rule,
  /*  915 */  _XorL_iRegL__RotateRight_iRegL_immI_rule,
  /*  916 */  immI_M1_rule,
  /*  917 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  918 */  immI_M1_rule,
  /*  919 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  920 */  immL_M1_rule,
  /*  921 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  922 */  immL_M1_rule,
  /*  923 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  924 */  iRegIorL2I_rule,
  /*  925 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  926 */  iRegL_rule,
  /*  927 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  928 */  iRegIorL2I_rule,
  /*  929 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  930 */  iRegL_rule,
  /*  931 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  932 */  iRegIorL2I_rule,
  /*  933 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  934 */  iRegL_rule,
  /*  935 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  936 */  iRegIorL2I_rule,
  /*  937 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  938 */  iRegL_rule,
  /*  939 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  940 */  iRegIorL2I_rule,
  /*  941 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  942 */  iRegL_rule,
  /*  943 */  _URShiftL_iRegL_immI_rule,
  /*  944 */  iRegIorL2I_rule,
  /*  945 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  946 */  iRegL_rule,
  /*  947 */  _RShiftL_iRegL_immI_rule,
  /*  948 */  iRegIorL2I_rule,
  /*  949 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  950 */  iRegL_rule,
  /*  951 */  _LShiftL_iRegL_immI_rule,
  /*  952 */  iRegIorL2I_rule,
  /*  953 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  954 */  iRegL_rule,
  /*  955 */  _RotateRight_iRegL_immI_rule,
  /*  956 */  iRegIorL2I_rule,
  /*  957 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  958 */  iRegL_rule,
  /*  959 */  _URShiftL_iRegL_immI_rule,
  /*  960 */  iRegIorL2I_rule,
  /*  961 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  962 */  iRegL_rule,
  /*  963 */  _RShiftL_iRegL_immI_rule,
  /*  964 */  iRegIorL2I_rule,
  /*  965 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  966 */  iRegL_rule,
  /*  967 */  _LShiftL_iRegL_immI_rule,
  /*  968 */  iRegIorL2I_rule,
  /*  969 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  970 */  iRegL_rule,
  /*  971 */  _RotateRight_iRegL_immI_rule,
  /*  972 */  iRegIorL2I_rule,
  /*  973 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  974 */  iRegL_rule,
  /*  975 */  _URShiftL_iRegL_immI_rule,
  /*  976 */  iRegIorL2I_rule,
  /*  977 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  978 */  iRegL_rule,
  /*  979 */  _RShiftL_iRegL_immI_rule,
  /*  980 */  iRegIorL2I_rule,
  /*  981 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  982 */  iRegL_rule,
  /*  983 */  _LShiftL_iRegL_immI_rule,
  /*  984 */  iRegIorL2I_rule,
  /*  985 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  986 */  iRegL_rule,
  /*  987 */  _RotateRight_iRegL_immI_rule,
  /*  988 */  iRegIorL2I_rule,
  /*  989 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  990 */  iRegL_rule,
  /*  991 */  _URShiftL_iRegL_immI_rule,
  /*  992 */  iRegIorL2I_rule,
  /*  993 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  994 */  iRegL_rule,
  /*  995 */  _RShiftL_iRegL_immI_rule,
  /*  996 */  iRegIorL2I_rule,
  /*  997 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  998 */  iRegL_rule,
  /*  999 */  _LShiftL_iRegL_immI_rule,
  /* 1000 */  iRegIorL2I_rule,
  /* 1001 */  iRegL_rule,
  /* 1002 */  iRegIorL2I_rule,
  /* 1003 */  iRegL_rule,
  /* 1004 */  iRegIorL2I_rule,
  /* 1005 */  iRegL_rule,
  /* 1006 */  _LShiftL_iRegL_immI_rule,
  /* 1007 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1008 */  _LShiftL_iRegL_immI_rule,
  /* 1009 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1010 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1011 */  _URShiftL_iRegL_immI_rule,
  /* 1012 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /* 1013 */  _AndI_iRegIorL2I_immI_bitmask_rule,
  /* 1014 */  _AndL_iRegL_immL_bitmask_rule,
  /* 1015 */  _LShiftI__AndI_iRegIorL2I_immI_bitmask_immI_rule,
  /* 1016 */  _LShiftL__AndL_iRegL_immL_positive_bitmaskI_immI_rule,
  /* 1017 */  _ConvI2L__AndI_iRegIorL2I_immI_bitmask__rule,
  /* 1018 */  _ConvL2I__AndL_iRegL_immL_positive_bitmaskI__rule,
  /* 1019 */  _AndI_iRegI_immI_bitmask_rule,
  /* 1020 */  _LShiftL_iRegL_immI_rule,
  /* 1021 */  _URShiftL_iRegL_immI_rule,
  /* 1022 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1023 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1024 */  _LShiftL_iRegL_immI_rule,
  /* 1025 */  _URShiftL_iRegL_immI_rule,
  /* 1026 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1027 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1028 */  iRegI_rule,
  /* 1029 */  iRegL_rule,
  /* 1030 */  iRegI_rule,
  /* 1031 */  iRegL_rule,
  /* 1032 */  iRegI_rule,
  /* 1033 */  iRegL_rule,
  /* 1034 */  iRegL_rule,
  /* 1035 */  _ConvI2L_iRegIorL2I__rule,
  /* 1036 */  iRegL_rule,
  /* 1037 */  iRegIorL2I_rule,
  /* 1038 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /* 1039 */  iRegIorL2I_rule,
  /* 1040 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1041 */  iRegIorL2I_rule,
  /* 1042 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1043 */  iRegL_rule,
  /* 1044 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /* 1045 */  iRegL_rule,
  /* 1046 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /* 1047 */  iRegL_rule,
  /* 1048 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1049 */  iRegL_rule,
  /* 1050 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1051 */  iRegIorL2I_rule,
  /* 1052 */  _AndI_iRegIorL2I_immI_255_rule,
  /* 1053 */  iRegIorL2I_rule,
  /* 1054 */  _AndI_iRegIorL2I_immI_65535_rule,
  /* 1055 */  iRegL_rule,
  /* 1056 */  _AndL_iRegL_immL_255_rule,
  /* 1057 */  iRegL_rule,
  /* 1058 */  _AndL_iRegL_immL_65535_rule,
  /* 1059 */  iRegL_rule,
  /* 1060 */  _AndL_iRegL_immL_4294967295_rule,
  /* 1061 */  iRegIorL2I_rule,
  /* 1062 */  iRegIorL2I_rule,
  /* 1063 */  iRegL_rule,
  /* 1064 */  iRegL_rule,
  /* 1065 */  iRegL_rule,
  /* 1066 */  iRegL_rule,
  /* 1067 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /* 1068 */  iRegL_rule,
  /* 1069 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /* 1070 */  iRegL_rule,
  /* 1071 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /* 1072 */  iRegL_rule,
  /* 1073 */  iRegL_rule,
  /* 1074 */  iRegL_rule,
  /* 1075 */  iRegIorL2I_rule,
  /* 1076 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /* 1077 */  iRegIorL2I_rule,
  /* 1078 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /* 1079 */  iRegIorL2I_rule,
  /* 1080 */  iRegIorL2I_rule,
  /* 1081 */  iRegL_rule,
  /* 1082 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /* 1083 */  iRegL_rule,
  /* 1084 */  iRegL_rule,
  /* 1085 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /* 1086 */  iRegL_rule,
  /* 1087 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /* 1088 */  iRegL_rule,
  /* 1089 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /* 1090 */  iRegL_rule,
  /* 1091 */  iRegL_rule,
  /* 1092 */  iRegL_rule,
  /* 1093 */  iRegIorL2I_rule,
  /* 1094 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /* 1095 */  iRegIorL2I_rule,
  /* 1096 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /* 1097 */  iRegIorL2I_rule,
  /* 1098 */  iRegIorL2I_rule,
  /* 1099 */  0,
  /* 1100 */  0,
  /* 1101 */  0,
  /* 1102 */  0,
  /* 1103 */  0,
  /* 1104 */  0,
  /* 1105 */  0,
  /* 1106 */  0,
  /* 1107 */  iRegIorL2I_rule,
  /* 1108 */  immI0_rule,
  /* 1109 */  iRegIorL2I_rule,
  /* 1110 */  immI_1_rule,
  /* 1111 */  iRegIorL2I_rule,
  /* 1112 */  immI_M1_rule,
  /* 1113 */  iRegIorL2I_rule,
  /* 1114 */  immI0_rule,
  /* 1115 */  iRegIorL2I_rule,
  /* 1116 */  immI_1_rule,
  /* 1117 */  iRegIorL2I_rule,
  /* 1118 */  immI_M1_rule,
  /* 1119 */  vRegF_rule,
  /* 1120 */  vRegD_rule,
  /* 1121 */  vRegF_rule,
  /* 1122 */  vRegD_rule,
  /* 1123 */  vRegF_rule,
  /* 1124 */  vRegD_rule,
  /* 1125 */  vRegF_rule,
  /* 1126 */  vRegD_rule,
  /* 1127 */  vRegF_rule,
  /* 1128 */  vRegD_rule,
  /* 1129 */  _NegF_vRegF__rule,
  /* 1130 */  _NegD_vRegD__rule,
  /* 1131 */  _NegF_vRegF__rule,
  /* 1132 */  _NegD_vRegD__rule,
  /* 1133 */  vRegF_rule,
  /* 1134 */  vRegF_rule,
  /* 1135 */  vRegD_rule,
  /* 1136 */  vRegD_rule,
  /* 1137 */  vRegF_rule,
  /* 1138 */  vRegD_rule,
  /* 1139 */  iRegIorL2I_rule,
  /* 1140 */  iRegL_rule,
  /* 1141 */  _SubF_vRegF_vRegF_rule,
  /* 1142 */  _SubD_vRegD_vRegD_rule,
  /* 1143 */  vRegD_rule,
  /* 1144 */  vRegF_rule,
  /* 1145 */  vRegD_rule,
  /* 1146 */  vRegD_rule,
  /* 1147 */  vRegF_rule,
  /* 1148 */  vRegD_rule,
  /* 1149 */  vRegF_rule,
  /* 1150 */  0,
  /* 1151 */  iRegIorL2I_rule,
  /* 1152 */  iRegIorL2I_rule,
  /* 1153 */  iRegIorL2I_rule,
  /* 1154 */  iRegIorL2I_rule,
  /* 1155 */  iRegIorL2I_rule,
  /* 1156 */  iRegIorL2I_rule,
  /* 1157 */  iRegL_rule,
  /* 1158 */  iRegL_rule,
  /* 1159 */  iRegL_rule,
  /* 1160 */  iRegL_rule,
  /* 1161 */  iRegL_rule,
  /* 1162 */  iRegL_rule,
  /* 1163 */  iRegIorL2I_rule,
  /* 1164 */  _ConvI2L_iRegIorL2I__rule,
  /* 1165 */  iRegL_rule,
  /* 1166 */  vRegD_rule,
  /* 1167 */  vRegF_rule,
  /* 1168 */  vRegF_rule,
  /* 1169 */  vRegF_rule,
  /* 1170 */  vRegF_rule,
  /* 1171 */  iRegINoSp_rule,
  /* 1172 */  iRegIorL2I_rule,
  /* 1173 */  iRegL_rule,
  /* 1174 */  vRegD_rule,
  /* 1175 */  vRegD_rule,
  /* 1176 */  iRegIorL2I_rule,
  /* 1177 */  iRegL_rule,
  /* 1178 */  vRegD_rule,
  /* 1179 */  vRegF_rule,
  /* 1180 */  vRegF_rule,
  /* 1181 */  iRegI_rule,
  /* 1182 */  vRegD_rule,
  /* 1183 */  iRegL_rule,
  /* 1184 */  iRegL_R11_rule,
  /* 1185 */  immL_rule,
  /* 1186 */  cmpOp_rule,
  /* 1187 */  cmpOp_rule,
  /* 1188 */  vRegF_rule,
  /* 1189 */  vRegD_rule,
  /* 1190 */  vRegF_rule,
  /* 1191 */  vRegD_rule,
  /* 1192 */  iRegIorL2I_rule,
  /* 1193 */  iRegIorL2I_rule,
  /* 1194 */  iRegIorL2I_rule,
  /* 1195 */  iRegIorL2I_rule,
  /* 1196 */  0,
  /* 1197 */  cmpOp_rule,
  /* 1198 */  cmpOpU_rule,
  /* 1199 */  cmpOpEqNe_rule,
  /* 1200 */  cmpOpEqNe_rule,
  /* 1201 */  cmpOpEqNe_rule,
  /* 1202 */  cmpOpEqNe_rule,
  /* 1203 */  cmpOpEqNe_rule,
  /* 1204 */  cmpOpUEqNeLtGe_rule,
  /* 1205 */  cmpOpUEqNeLtGe_rule,
  /* 1206 */  cmpOpLtGe_rule,
  /* 1207 */  cmpOpLtGe_rule,
  /* 1208 */  cmpOpEqNe_rule,
  /* 1209 */  cmpOpEqNe_rule,
  /* 1210 */  cmpOpLtGe_rule,
  /* 1211 */  cmpOpLtGe_rule,
  /* 1212 */  cmpOpEqNe_rule,
  /* 1213 */  cmpOpEqNe_rule,
  /* 1214 */  cmpOp_rule,
  /* 1215 */  iRegP_rule,
  /* 1216 */  0,
  /* 1217 */  0,
  /* 1218 */  0,
  /* 1219 */  0,
  /* 1220 */  0,
  /* 1221 */  iRegPNoSp_rule,
  /* 1222 */  iRegPNoSp_rule,
  /* 1223 */  0,
  /* 1224 */  0,
  /* 1225 */  0,
  /* 1226 */  0,
  /* 1227 */  iRegP_R4_rule,
  /* 1228 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1229 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1230 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1231 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1232 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1233 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1234 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1235 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1236 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1237 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1238 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1239 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1240 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1241 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /* 1242 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1243 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1244 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1245 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1246 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /* 1247 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /* 1248 */  iRegP_R1_rule,
  /* 1249 */  iRegP_R1_rule,
  /* 1250 */  iRegP_R1_rule,
  /* 1251 */  iRegP_R2_rule,
  /* 1252 */  iRegP_R0_rule,
  /* 1253 */  iRegP_R2_rule,
  /* 1254 */  iRegP_R2_rule,
  /* 1255 */  iRegIorL2I_rule,
  /* 1256 */  _LoadI_memory4__rule,
  /* 1257 */  iRegL_rule,
  /* 1258 */  _LoadL_memory8__rule,
  /* 1259 */  iRegIorL2I_rule,
  /* 1260 */  _LoadI_memory4__rule,
  /* 1261 */  iRegL_rule,
  /* 1262 */  _LoadL_memory8__rule,
  /* 1263 */  vmem2_rule,
  /* 1264 */  vmem2_rule,
  /* 1265 */  vmem4_rule,
  /* 1266 */  vmem4_rule,
  /* 1267 */  vmem8_rule,
  /* 1268 */  vmem8_rule,
  /* 1269 */  vmem16_rule,
  /* 1270 */  vmem16_rule,
  /* 1271 */  vmemA_rule,
  /* 1272 */  vmemA_rule,
  /* 1273 */  vmemA_rule,
  /* 1274 */  vmemA_rule,
  /* 1275 */  vReg_rule,
  /* 1276 */  vReg_rule,
  /* 1277 */  vReg_rule,
  /* 1278 */  vReg_rule,
  /* 1279 */  vReg_rule,
  /* 1280 */  vReg_rule,
  /* 1281 */  _Binary_vReg_vReg_rule,
  /* 1282 */  _Binary_vReg_vReg_rule,
  /* 1283 */  _Binary_vReg_vReg_rule,
  /* 1284 */  _Binary_vReg_vReg_rule,
  /* 1285 */  _Binary_vReg_vReg_rule,
  /* 1286 */  _Binary_vReg_vReg_rule,
  /* 1287 */  vReg_rule,
  /* 1288 */  _Replicate_immBAddSubV__rule,
  /* 1289 */  vReg_rule,
  /* 1290 */  _Replicate_immIAddSubV__rule,
  /* 1291 */  vReg_rule,
  /* 1292 */  _Replicate_immIAddSubV__rule,
  /* 1293 */  vReg_rule,
  /* 1294 */  _Replicate_immLAddSubV__rule,
  /* 1295 */  vReg_rule,
  /* 1296 */  vReg_rule,
  /* 1297 */  vReg_rule,
  /* 1298 */  vReg_rule,
  /* 1299 */  vReg_rule,
  /* 1300 */  vReg_rule,
  /* 1301 */  _Binary_vReg_vReg_rule,
  /* 1302 */  _Binary_vReg_vReg_rule,
  /* 1303 */  _Binary_vReg_vReg_rule,
  /* 1304 */  _Binary_vReg_vReg_rule,
  /* 1305 */  _Binary_vReg_vReg_rule,
  /* 1306 */  _Binary_vReg_vReg_rule,
  /* 1307 */  vReg_rule,
  /* 1308 */  vReg_rule,
  /* 1309 */  vReg_rule,
  /* 1310 */  vReg_rule,
  /* 1311 */  vReg_rule,
  /* 1312 */  vReg_rule,
  /* 1313 */  vReg_rule,
  /* 1314 */  vReg_rule,
  /* 1315 */  vReg_rule,
  /* 1316 */  vReg_rule,
  /* 1317 */  _Binary_vReg_vReg_rule,
  /* 1318 */  _Binary_vReg_vReg_rule,
  /* 1319 */  _Binary_vReg_vReg_rule,
  /* 1320 */  _Binary_vReg_vReg_rule,
  /* 1321 */  _Binary_vReg_vReg_rule,
  /* 1322 */  _Binary_vReg_vReg_rule,
  /* 1323 */  vReg_rule,
  /* 1324 */  vReg_rule,
  /* 1325 */  vReg_rule,
  /* 1326 */  vReg_rule,
  /* 1327 */  _Binary_vReg_vReg_rule,
  /* 1328 */  _Binary_vReg_vReg_rule,
  /* 1329 */  vReg_rule,
  /* 1330 */  _Binary_vReg_vReg_rule,
  /* 1331 */  vReg_rule,
  /* 1332 */  _Replicate_immBLog__rule,
  /* 1333 */  vReg_rule,
  /* 1334 */  _Replicate_immSLog__rule,
  /* 1335 */  vReg_rule,
  /* 1336 */  _Replicate_immILog__rule,
  /* 1337 */  vReg_rule,
  /* 1338 */  _Replicate_immLLog__rule,
  /* 1339 */  vReg_rule,
  /* 1340 */  _Binary_vReg_vReg_rule,
  /* 1341 */  vReg_rule,
  /* 1342 */  _Replicate_immBLog__rule,
  /* 1343 */  vReg_rule,
  /* 1344 */  _Replicate_immSLog__rule,
  /* 1345 */  vReg_rule,
  /* 1346 */  _Replicate_immILog__rule,
  /* 1347 */  vReg_rule,
  /* 1348 */  _Replicate_immLLog__rule,
  /* 1349 */  vReg_rule,
  /* 1350 */  _Binary_vReg_vReg_rule,
  /* 1351 */  vReg_rule,
  /* 1352 */  _Replicate_immBLog__rule,
  /* 1353 */  vReg_rule,
  /* 1354 */  _Replicate_immSLog__rule,
  /* 1355 */  vReg_rule,
  /* 1356 */  _Replicate_immILog__rule,
  /* 1357 */  vReg_rule,
  /* 1358 */  _Replicate_immLLog__rule,
  /* 1359 */  vReg_rule,
  /* 1360 */  _XorV_vReg_vReg_rule,
  /* 1361 */  vReg_rule,
  /* 1362 */  _XorV_vReg_vReg_rule,
  /* 1363 */  vReg_rule,
  /* 1364 */  _Replicate_immI_M1__rule,
  /* 1365 */  vReg_rule,
  /* 1366 */  _Replicate_immL_M1__rule,
  /* 1367 */  _Binary_vReg__Replicate_immI_M1__rule,
  /* 1368 */  _Binary_vReg__Replicate_immL_M1__rule,
  /* 1369 */  vReg_rule,
  /* 1370 */  _XorV_vReg__Replicate_immI_M1__rule,
  /* 1371 */  vReg_rule,
  /* 1372 */  _XorV__Replicate_immI_M1__vReg_rule,
  /* 1373 */  vReg_rule,
  /* 1374 */  _XorV_vReg__Replicate_immL_M1__rule,
  /* 1375 */  vReg_rule,
  /* 1376 */  _XorV__Replicate_immL_M1__vReg_rule,
  /* 1377 */  _Binary_vReg__XorV_vReg__Replicate_immI_M1__rule,
  /* 1378 */  _Binary_vReg__XorV__Replicate_immI_M1__vReg_rule,
  /* 1379 */  _Binary_vReg__XorV_vReg__Replicate_immL_M1__rule,
  /* 1380 */  _Binary_vReg__XorV__Replicate_immL_M1__vReg_rule,
  /* 1381 */  vReg_rule,
  /* 1382 */  vReg_rule,
  /* 1383 */  vReg_rule,
  /* 1384 */  vReg_rule,
  /* 1385 */  vReg_rule,
  /* 1386 */  vReg_rule,
  /* 1387 */  _SubVF_vReg_vReg_rule,
  /* 1388 */  _SubVD_vReg_vReg_rule,
  /* 1389 */  _SubVF_vReg_vReg_rule,
  /* 1390 */  _SubVD_vReg_vReg_rule,
  /* 1391 */  _SubVF__Binary_vReg_vReg_pRegGov_rule,
  /* 1392 */  _SubVD__Binary_vReg_vReg_pRegGov_rule,
  /* 1393 */  vReg_rule,
  /* 1394 */  vReg_rule,
  /* 1395 */  vReg_rule,
  /* 1396 */  vReg_rule,
  /* 1397 */  vReg_rule,
  /* 1398 */  vReg_rule,
  /* 1399 */  vReg_rule,
  /* 1400 */  vReg_rule,
  /* 1401 */  vReg_rule,
  /* 1402 */  vReg_rule,
  /* 1403 */  _Binary_vReg_vReg_rule,
  /* 1404 */  vReg_rule,
  /* 1405 */  vReg_rule,
  /* 1406 */  vReg_rule,
  /* 1407 */  vReg_rule,
  /* 1408 */  _Binary_vReg_vReg_rule,
  /* 1409 */  vReg_rule,
  /* 1410 */  _MulVB_vReg_vReg_rule,
  /* 1411 */  vReg_rule,
  /* 1412 */  _MulVS_vReg_vReg_rule,
  /* 1413 */  vReg_rule,
  /* 1414 */  _MulVI_vReg_vReg_rule,
  /* 1415 */  vReg_rule,
  /* 1416 */  _MulVL_vReg_vReg_rule,
  /* 1417 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /* 1418 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /* 1419 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /* 1420 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /* 1421 */  vReg_rule,
  /* 1422 */  vReg_rule,
  /* 1423 */  _Binary_vReg_vReg_rule,
  /* 1424 */  _Binary_vReg_vReg_rule,
  /* 1425 */  vReg_rule,
  /* 1426 */  vReg_rule,
  /* 1427 */  vReg_rule,
  /* 1428 */  vReg_rule,
  /* 1429 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /* 1430 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /* 1431 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /* 1432 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /* 1433 */  vReg_rule,
  /* 1434 */  vReg_rule,
  /* 1435 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1436 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1437 */  _NegVF_vReg__rule,
  /* 1438 */  _NegVD_vReg__rule,
  /* 1439 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1440 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1441 */  _NegVF_vReg__rule,
  /* 1442 */  _NegVD_vReg__rule,
  /* 1443 */  _Binary_vReg_vReg_rule,
  /* 1444 */  _Binary_vReg_vReg_rule,
  /* 1445 */  vReg_rule,
  /* 1446 */  vReg_rule,
  /* 1447 */  vReg_rule,
  /* 1448 */  vReg_rule,
  /* 1449 */  vReg_rule,
  /* 1450 */  vReg_rule,
  /* 1451 */  vReg_rule,
  /* 1452 */  vReg_rule,
  /* 1453 */  vReg_rule,
  /* 1454 */  vReg_rule,
  /* 1455 */  vReg_rule,
  /* 1456 */  vReg_rule,
  /* 1457 */  vReg_rule,
  /* 1458 */  vReg_rule,
  /* 1459 */  vReg_rule,
  /* 1460 */  vReg_rule,
  /* 1461 */  vReg_rule,
  /* 1462 */  vReg_rule,
  /* 1463 */  vReg_rule,
  /* 1464 */  vReg_rule,
  /* 1465 */  vReg_rule,
  /* 1466 */  vReg_rule,
  /* 1467 */  vReg_rule,
  /* 1468 */  vReg_rule,
  /* 1469 */  vReg_rule,
  /* 1470 */  vReg_rule,
  /* 1471 */  vReg_rule,
  /* 1472 */  vReg_rule,
  /* 1473 */  vReg_rule,
  /* 1474 */  vReg_rule,
  /* 1475 */  vReg_rule,
  /* 1476 */  vReg_rule,
  /* 1477 */  vReg_rule,
  /* 1478 */  vReg_rule,
  /* 1479 */  vReg_rule,
  /* 1480 */  vReg_rule,
  /* 1481 */  vReg_rule,
  /* 1482 */  vReg_rule,
  /* 1483 */  vReg_rule,
  /* 1484 */  vReg_rule,
  /* 1485 */  vReg_rule,
  /* 1486 */  vReg_rule,
  /* 1487 */  vReg_rule,
  /* 1488 */  vReg_rule,
  /* 1489 */  vReg_rule,
  /* 1490 */  vReg_rule,
  /* 1491 */  _RShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1492 */  vReg_rule,
  /* 1493 */  _RShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1494 */  vReg_rule,
  /* 1495 */  _RShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1496 */  vReg_rule,
  /* 1497 */  _RShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1498 */  vReg_rule,
  /* 1499 */  _URShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1500 */  vReg_rule,
  /* 1501 */  _URShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1502 */  vReg_rule,
  /* 1503 */  _URShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1504 */  vReg_rule,
  /* 1505 */  _URShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1506 */  _Binary_vReg_vReg_rule,
  /* 1507 */  _Binary_vReg_vReg_rule,
  /* 1508 */  _Binary_vReg_vReg_rule,
  /* 1509 */  _Binary_vReg_vReg_rule,
  /* 1510 */  _Binary_vReg_vReg_rule,
  /* 1511 */  _Binary_vReg_vReg_rule,
  /* 1512 */  _Binary_vReg_vReg_rule,
  /* 1513 */  _Binary_vReg_vReg_rule,
  /* 1514 */  _Binary_vReg_vReg_rule,
  /* 1515 */  _Binary_vReg_vReg_rule,
  /* 1516 */  _Binary_vReg_vReg_rule,
  /* 1517 */  _Binary_vReg_vReg_rule,
  /* 1518 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1519 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1520 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1521 */  _Binary_vReg__LShiftCntV_immI__rule,
  /* 1522 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1523 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1524 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1525 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1526 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1527 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1528 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1529 */  _Binary_vReg__RShiftCntV_immI_positive__rule,
  /* 1530 */  iRegIorL2I_rule,
  /* 1531 */  iRegIorL2I_rule,
  /* 1532 */  iRegL_rule,
  /* 1533 */  iRegL_rule,
  /* 1534 */  vRegF_rule,
  /* 1535 */  vRegF_rule,
  /* 1536 */  vRegF_rule,
  /* 1537 */  vRegD_rule,
  /* 1538 */  vRegD_rule,
  /* 1539 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1540 */  _Binary_iRegL_vReg_rule,
  /* 1541 */  _Binary_vRegF_vReg_rule,
  /* 1542 */  _Binary_vRegD_vReg_rule,
  /* 1543 */  iRegIorL2I_rule,
  /* 1544 */  iRegL_rule,
  /* 1545 */  vRegF_rule,
  /* 1546 */  vRegD_rule,
  /* 1547 */  iRegIorL2I_rule,
  /* 1548 */  iRegIorL2I_rule,
  /* 1549 */  iRegL_rule,
  /* 1550 */  iRegL_rule,
  /* 1551 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1552 */  _Binary_iRegL_vReg_rule,
  /* 1553 */  iRegIorL2I_rule,
  /* 1554 */  iRegIorL2I_rule,
  /* 1555 */  iRegL_rule,
  /* 1556 */  iRegL_rule,
  /* 1557 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1558 */  _Binary_iRegL_vReg_rule,
  /* 1559 */  iRegIorL2I_rule,
  /* 1560 */  iRegIorL2I_rule,
  /* 1561 */  iRegL_rule,
  /* 1562 */  iRegL_rule,
  /* 1563 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1564 */  _Binary_iRegL_vReg_rule,
  /* 1565 */  iRegIorL2I_rule,
  /* 1566 */  iRegIorL2I_rule,
  /* 1567 */  iRegL_rule,
  /* 1568 */  iRegL_rule,
  /* 1569 */  vRegF_rule,
  /* 1570 */  vRegD_rule,
  /* 1571 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1572 */  _Binary_iRegL_vReg_rule,
  /* 1573 */  _Binary_vRegF_vReg_rule,
  /* 1574 */  _Binary_vRegD_vReg_rule,
  /* 1575 */  iRegIorL2I_rule,
  /* 1576 */  iRegIorL2I_rule,
  /* 1577 */  iRegL_rule,
  /* 1578 */  iRegL_rule,
  /* 1579 */  vRegF_rule,
  /* 1580 */  vRegD_rule,
  /* 1581 */  _Binary_iRegIorL2I_vReg_rule,
  /* 1582 */  _Binary_iRegL_vReg_rule,
  /* 1583 */  _Binary_vRegF_vReg_rule,
  /* 1584 */  _Binary_vRegD_vReg_rule,
  /* 1585 */  vReg_rule,
  /* 1586 */  vReg_rule,
  /* 1587 */  vReg_rule,
  /* 1588 */  vReg_rule,
  /* 1589 */  vReg_rule,
  /* 1590 */  vReg_rule,
  /* 1591 */  vReg_rule,
  /* 1592 */  vReg_rule,
  /* 1593 */  vReg_rule,
  /* 1594 */  vReg_rule,
  /* 1595 */  vReg_rule,
  /* 1596 */  vReg_rule,
  /* 1597 */  vReg_rule,
  /* 1598 */  _Binary_vReg_iRegIorL2I_rule,
  /* 1599 */  _Binary_vReg_iRegIorL2I_rule,
  /* 1600 */  _Binary_vReg_iRegIorL2I_rule,
  /* 1601 */  _Binary_vReg_iRegL_rule,
  /* 1602 */  _Binary_vReg_iRegL_rule,
  /* 1603 */  _Binary_vReg_vRegF_rule,
  /* 1604 */  _Binary_vReg_vRegF_rule,
  /* 1605 */  _Binary_vReg_vRegF_rule,
  /* 1606 */  _Binary_vReg_vRegD_rule,
  /* 1607 */  _Binary_vReg_vRegD_rule,
  /* 1608 */  vReg_rule,
  /* 1609 */  vReg_rule,
  /* 1610 */  vReg_rule,
  /* 1611 */  vReg_rule,
  /* 1612 */  vReg_rule,
  /* 1613 */  vReg_rule,
  /* 1614 */  vReg_rule,
  /* 1615 */  vReg_rule,
  /* 1616 */  vReg_rule,
  /* 1617 */  vReg_rule,
  /* 1618 */  vReg_rule,
  /* 1619 */  vReg_rule,
  /* 1620 */  vReg_rule,
  /* 1621 */  vReg_rule,
  /* 1622 */  vReg_rule,
  /* 1623 */  vReg_rule,
  /* 1624 */  vReg_rule,
  /* 1625 */  vReg_rule,
  /* 1626 */  vReg_rule,
  /* 1627 */  pReg_rule,
  /* 1628 */  pReg_rule,
  /* 1629 */  _LoadVector_indirect__rule,
  /* 1630 */  _LoadVector_indirect__rule,
  /* 1631 */  _LoadVectorMasked_vmemA_pRegGov_rule,
  /* 1632 */  _LoadVectorMasked_vmemA_pRegGov_rule,
  /* 1633 */  indirect_rule,
  /* 1634 */  indirect_rule,
  /* 1635 */  vmemA_rule,
  /* 1636 */  vmemA_rule,
  /* 1637 */  pReg_rule,
  /* 1638 */  pReg_rule,
  /* 1639 */  pReg_rule,
  /* 1640 */  pReg_rule,
  /* 1641 */  pReg_rule,
  /* 1642 */  _Binary_vReg_vReg_rule,
  /* 1643 */  _Binary_vReg__Replicate_immI0__rule,
  /* 1644 */  _Binary_vReg__Replicate_immL0__rule,
  /* 1645 */  _Binary_vReg__Replicate_immF0__rule,
  /* 1646 */  _Binary_vReg__Replicate_immD0__rule,
  /* 1647 */  _Binary_vReg_vReg_rule,
  /* 1648 */  _Binary_vReg__Replicate_immI5__rule,
  /* 1649 */  _Binary_vReg__Replicate_immIU7__rule,
  /* 1650 */  _Binary_vReg__Replicate_immL5__rule,
  /* 1651 */  _Binary_vReg__Replicate_immLU7__rule,
  /* 1652 */  _Binary_vReg_vReg_rule,
  /* 1653 */  pReg_rule,
  /* 1654 */  pReg_rule,
  /* 1655 */  vReg_rule,
  /* 1656 */  _VectorStoreMask_vReg_immI_gt_1_rule,
  /* 1657 */  pReg_rule,
  /* 1658 */  pReg_rule,
  /* 1659 */  pReg_rule,
  /* 1660 */  pReg_rule,
  /* 1661 */  iRegL_rule,
  /* 1662 */  immI_rule,
  /* 1663 */  iRegIorL2I_rule,
  /* 1664 */  iRegIorL2I_rule,
  /* 1665 */  immL_rule,
  /* 1666 */  iRegL_rule,
  /* 1667 */  iRegL_rule,
  /* 1668 */  _ConvI2L_iRegIorL2I__rule,
  /* 1669 */  iRegL_rule,
  /* 1670 */  immL_rule,
  /* 1671 */  _SubL_iRegL_iRegL_rule,
  /* 1672 */  vReg_rule,
  /* 1673 */  vReg_rule,
  /* 1674 */  _Binary_vReg_vReg_rule,
  /* 1675 */  _Binary_vReg_vReg_rule,
  /* 1676 */  vReg_rule,
  /* 1677 */  vReg_rule,
  /* 1678 */  vReg_rule,
  /* 1679 */  vReg_rule,
  /* 1680 */  vReg_rule,
  /* 1681 */  vReg_rule,
  /* 1682 */  vReg_rule,
  /* 1683 */  indirect_rule,
  /* 1684 */  indirect_rule,
  /* 1685 */  indirect_rule,
  /* 1686 */  indirect_rule,
  /* 1687 */  indirect_rule,
  /* 1688 */  indirect_rule,
  /* 1689 */  indirect_rule,
  /* 1690 */  indirect_rule,
  /* 1691 */  vReg_rule,
  /* 1692 */  vReg_rule,
  /* 1693 */  vReg_rule,
  /* 1694 */  vReg_rule,
  /* 1695 */  iRegIorL2I_rule,
  /* 1696 */  pReg_rule,
  /* 1697 */  vReg_rule,
  /* 1698 */  vReg_rule,
  /* 1699 */  vReg_rule,
  /* 1700 */  vReg_rule,
  /* 1701 */  vReg_rule,
  /* 1702 */  vReg_rule,
  /* 1703 */  vReg_rule,
  /* 1704 */  vReg_rule,
  /* 1705 */  vReg_rule,
  /* 1706 */  vReg_rule,
  /* 1707 */  indirect_rule,
  /* 1708 */  indirect_rule,
  /* 1709 */  indirect_rule,
  /* 1710 */  indirect_rule,
  /* 1711 */  indirect_rule,
  /* 1712 */  indirect_rule,
  /* 1713 */  indirect_rule,
  /* 1714 */  indirect_rule,
  /* 1715 */  indirect_rule,
  /* 1716 */  indirect_rule,
  /* 1717 */  indirect_rule,
  /* 1718 */  indirect_rule,
  /* 1719 */  memory8_rule,
  /* 1720 */  indirect_rule,
  /* 1721 */  indirect_rule,
  /* 1722 */  indirect_rule,
  /* 1723 */  indirect_rule,
  /* 1724 */  indirect_rule,
  /* 1725 */  indirect_rule,
  /* 1726 */  indirect_rule,
  /* 1727 */  indirect_rule,
  /* 1728 */  indirect_rule,
  /* 1729 */  memory8_rule,
  /* 1730 */  indirect_rule,
  /* 1731 */  memory_rule,
  /* 1732 */  indirect_rule,
  /* 1733 */  indirect_rule,
  /* 1734 */  indirect_rule,
  /* 1735 */  indirect_rule,
  /* 1736 */  indirect_rule,
  /* 1737 */  indirect_rule,
  /* 1738 */  indirect_rule,
  /* 1739 */  indirect_rule,
  /* 1740 */  indirect_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  0,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  0,
  /*  160 */  0,
  /*  161 */  0,
  /*  162 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  163 */  _LShiftL_iRegL_immIScale_rule,
  /*  164 */  _ConvI2L_iRegI__rule,
  /*  165 */  iRegL_rule,
  /*  166 */  immIOffset_rule,
  /*  167 */  immIOffset1_rule,
  /*  168 */  immIOffset2_rule,
  /*  169 */  immIOffset4_rule,
  /*  170 */  immIOffset8_rule,
  /*  171 */  immIOffset16_rule,
  /*  172 */  immLoffset_rule,
  /*  173 */  immLoffset1_rule,
  /*  174 */  immLoffset2_rule,
  /*  175 */  immLoffset4_rule,
  /*  176 */  immLoffset8_rule,
  /*  177 */  immLoffset16_rule,
  /*  178 */  0,
  /*  179 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  180 */  _LShiftL_iRegL_immIScale_rule,
  /*  181 */  _ConvI2L_iRegI__rule,
  /*  182 */  iRegL_rule,
  /*  183 */  immIOffset_rule,
  /*  184 */  immLoffset_rule,
  /*  185 */  immL_pc_off_rule,
  /*  186 */  0,
  /*  187 */  0,
  /*  188 */  0,
  /*  189 */  0,
  /*  190 */  0,
  /*  191 */  0,
  /*  192 */  0,
  /*  193 */  0,
  /*  194 */  0,
  /*  195 */  0,
  /*  196 */  0,
  /*  197 */  0,
  /*  198 */  0,
  /*  199 */  vmemA_immIOffset4_rule,
  /*  200 */  vmemA_immLOffset4_rule,
  // last operand
  /*  201 */  0,
  /*  202 */  0,
  /*  203 */  0,
  /*  204 */  0,
  /*  205 */  0,
  /*  206 */  0,
  /*  207 */  0,
  /*  208 */  0,
  /*  209 */  0,
  /*  210 */  0,
  /*  211 */  0,
  // last operand class
  /*  212 */  0,
  /*  213 */  immIScale_rule,
  /*  214 */  immIScale_rule,
  /*  215 */  0,
  /*  216 */  0,
  /*  217 */  0,
  /*  218 */  0,
  /*  219 */  0,
  /*  220 */  0,
  /*  221 */  0,
  /*  222 */  0,
  /*  223 */  0,
  /*  224 */  0,
  /*  225 */  0,
  /*  226 */  0,
  /*  227 */  0,
  /*  228 */  0,
  /*  229 */  0,
  /*  230 */  0,
  /*  231 */  iRegINoSp_rule,
  /*  232 */  iRegLNoSp_rule,
  /*  233 */  iRegP_rule,
  /*  234 */  iRegNNoSp_rule,
  /*  235 */  iRegI_rule,
  /*  236 */  iRegL_rule,
  /*  237 */  iRegN_rule,
  /*  238 */  rFlagsReg_rule,
  /*  239 */  iRegIorL2I_rule,
  /*  240 */  rFlagsRegU_rule,
  /*  241 */  iRegIorL2I_rule,
  /*  242 */  immI0_rule,
  /*  243 */  immI0_rule,
  /*  244 */  immL0_rule,
  /*  245 */  iRegL_rule,
  /*  246 */  immP0_rule,
  /*  247 */  iRegP_rule,
  /*  248 */  immN0_rule,
  /*  249 */  iRegN_rule,
  /*  250 */  vRegF_rule,
  /*  251 */  vRegD_rule,
  /*  252 */  0,
  /*  253 */  0,
  /*  254 */  immIScale_rule,
  /*  255 */  iRegIorL2I_rule,
  /*  256 */  iRegIorL2I_rule,
  /*  257 */  iRegL_rule,
  /*  258 */  iRegL_rule,
  /*  259 */  _ConvI2L_iRegIorL2I__rule,
  /*  260 */  _ConvI2L_iRegIorL2I__rule,
  /*  261 */  immI_rule,
  /*  262 */  immI_rule,
  /*  263 */  immI_rule,
  /*  264 */  immI_rule,
  /*  265 */  immI_rule,
  /*  266 */  immI_rule,
  /*  267 */  immI_M1_rule,
  /*  268 */  immL_M1_rule,
  /*  269 */  iRegIorL2I_rule,
  /*  270 */  iRegL_rule,
  /*  271 */  immI_M1_rule,
  /*  272 */  immL_M1_rule,
  /*  273 */  immI_M1_rule,
  /*  274 */  immL_M1_rule,
  /*  275 */  immI_rule,
  /*  276 */  immI_M1_rule,
  /*  277 */  immI_rule,
  /*  278 */  immL_M1_rule,
  /*  279 */  immI_M1_rule,
  /*  280 */  immL_M1_rule,
  /*  281 */  iRegIorL2I_rule,
  /*  282 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  283 */  iRegL_rule,
  /*  284 */  _URShiftL_iRegL_immI_rule,
  /*  285 */  iRegIorL2I_rule,
  /*  286 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  287 */  iRegL_rule,
  /*  288 */  _RShiftL_iRegL_immI_rule,
  /*  289 */  iRegIorL2I_rule,
  /*  290 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  291 */  iRegL_rule,
  /*  292 */  _RotateRight_iRegL_immI_rule,
  /*  293 */  iRegIorL2I_rule,
  /*  294 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  295 */  iRegL_rule,
  /*  296 */  _LShiftL_iRegL_immI_rule,
  /*  297 */  immI_bitmask_rule,
  /*  298 */  immI_bitmask_rule,
  /*  299 */  immL_bitmask_rule,
  /*  300 */  immI_rule,
  /*  301 */  immL_positive_bitmaskI_rule,
  /*  302 */  immI_rule,
  /*  303 */  0,
  /*  304 */  0,
  /*  305 */  immI_bitmask_rule,
  /*  306 */  immI_16_rule,
  /*  307 */  immI_16_rule,
  /*  308 */  immI_24_rule,
  /*  309 */  immI_24_rule,
  /*  310 */  immI_24_rule,
  /*  311 */  immI_48_rule,
  /*  312 */  immI_48_rule,
  /*  313 */  immI_32_rule,
  /*  314 */  immI_32_rule,
  /*  315 */  immI_56_rule,
  /*  316 */  immI_56_rule,
  /*  317 */  immI_56_rule,
  /*  318 */  immI_255_rule,
  /*  319 */  immI_65535_rule,
  /*  320 */  immL_255_rule,
  /*  321 */  immL_65535_rule,
  /*  322 */  immL_4294967295_rule,
  /*  323 */  immIExt_rule,
  /*  324 */  immIExt_rule,
  /*  325 */  immIExt_rule,
  /*  326 */  immIExt_rule,
  /*  327 */  immIExt_rule,
  /*  328 */  immIExt_rule,
  /*  329 */  immIExt_rule,
  /*  330 */  immIExt_rule,
  /*  331 */  immIExt_rule,
  /*  332 */  immIExt_rule,
  /*  333 */  immIExt_rule,
  /*  334 */  0,
  /*  335 */  _NegF_vRegF__rule,
  /*  336 */  0,
  /*  337 */  _NegD_vRegD__rule,
  /*  338 */  vRegF_rule,
  /*  339 */  vRegD_rule,
  /*  340 */  iRegIorL2I_rule,
  /*  341 */  iRegL_rule,
  /*  342 */  immI0_rule,
  /*  343 */  immL0_rule,
  /*  344 */  immP0_rule,
  /*  345 */  immN0_rule,
  /*  346 */  immP0_rule,
  /*  347 */  immI0_rule,
  /*  348 */  immL0_rule,
  /*  349 */  immL_rule,
  /*  350 */  immL0_rule,
  /*  351 */  immI_rule,
  /*  352 */  immI0_rule,
  /*  353 */  iRegL_rule,
  /*  354 */  iRegIorL2I_rule,
  /*  355 */  iRegP_R0_rule,
  /*  356 */  iRegI_R2_rule,
  /*  357 */  iRegI_R4_rule,
  /*  358 */  iRegI_R4_rule,
  /*  359 */  iRegI_R2_rule,
  /*  360 */  immI_le_4_rule,
  /*  361 */  immI_1_rule,
  /*  362 */  iRegP_R3_rule,
  /*  363 */  iRegI_R3_rule,
  /*  364 */  pRegGov_rule,
  /*  365 */  vReg_rule,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  vReg_rule,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  _Replicate_immI_M1__rule,
  /*  377 */  _Replicate_immL_M1__rule,
  /*  378 */  _Replicate_immI_M1__rule,
  /*  379 */  vReg_rule,
  /*  380 */  _Replicate_immL_M1__rule,
  /*  381 */  vReg_rule,
  /*  382 */  _XorV_vReg__Replicate_immI_M1__rule,
  /*  383 */  _XorV__Replicate_immI_M1__vReg_rule,
  /*  384 */  _XorV_vReg__Replicate_immL_M1__rule,
  /*  385 */  _XorV__Replicate_immL_M1__vReg_rule,
  /*  386 */  vReg_rule,
  /*  387 */  vReg_rule,
  /*  388 */  pRegGov_rule,
  /*  389 */  pRegGov_rule,
  /*  390 */  vReg_rule,
  /*  391 */  vReg_rule,
  /*  392 */  vReg_rule,
  /*  393 */  vReg_rule,
  /*  394 */  _MulVB_vReg_vReg_rule,
  /*  395 */  _MulVS_vReg_vReg_rule,
  /*  396 */  _MulVI_vReg_vReg_rule,
  /*  397 */  _MulVL_vReg_vReg_rule,
  /*  398 */  0,
  /*  399 */  _NegVF_vReg__rule,
  /*  400 */  0,
  /*  401 */  _NegVD_vReg__rule,
  /*  402 */  pRegGov_rule,
  /*  403 */  pRegGov_rule,
  /*  404 */  0,
  /*  405 */  0,
  /*  406 */  _RShiftCntV_immI_positive__rule,
  /*  407 */  _RShiftCntV_immI_positive__rule,
  /*  408 */  _RShiftCntV_immI_positive__rule,
  /*  409 */  _RShiftCntV_immI_positive__rule,
  /*  410 */  _RShiftCntV_immI_positive__rule,
  /*  411 */  _RShiftCntV_immI_positive__rule,
  /*  412 */  _RShiftCntV_immI_positive__rule,
  /*  413 */  _RShiftCntV_immI_positive__rule,
  /*  414 */  _LShiftCntV_immI__rule,
  /*  415 */  _RShiftCntV_immI_positive__rule,
  /*  416 */  vReg_rule,
  /*  417 */  vReg_rule,
  /*  418 */  vReg_rule,
  /*  419 */  vReg_rule,
  /*  420 */  iRegIorL2I_rule,
  /*  421 */  iRegL_rule,
  /*  422 */  vRegF_rule,
  /*  423 */  vRegD_rule,
  /*  424 */  0,
  /*  425 */  pRegGov_rule,
  /*  426 */  immI_gt_1_rule,
  /*  427 */  pRegGov_rule,
  /*  428 */  0,
  /*  429 */  _MaskAll_immI_M1__rule,
  /*  430 */  0,
  /*  431 */  _MaskAll_immL_M1__rule,
  /*  432 */  0,
  /*  433 */  _Replicate_immI0__rule,
  /*  434 */  0,
  /*  435 */  _Replicate_immL0__rule,
  /*  436 */  0,
  /*  437 */  _Replicate_immF0__rule,
  /*  438 */  0,
  /*  439 */  _Replicate_immD0__rule,
  /*  440 */  0,
  /*  441 */  _Replicate_immI5__rule,
  /*  442 */  0,
  /*  443 */  _Replicate_immIU7__rule,
  /*  444 */  0,
  /*  445 */  _Replicate_immL5__rule,
  /*  446 */  0,
  /*  447 */  _Replicate_immLU7__rule,
  /*  448 */  pRegGov_rule,
  /*  449 */  immI_gt_1_rule,
  /*  450 */  iRegL_rule,
  /*  451 */  _Binary_vReg_pRegGov_rule,
  // last internally defined operand
  /*  452 */  0,
  /*  453 */  0,
  /*  454 */  0,
  /*  455 */  0,
  /*  456 */  0,
  /*  457 */  0,
  /*  458 */  0,
  /*  459 */  0,
  /*  460 */  0,
  /*  461 */  0,
  /*  462 */  0,
  /*  463 */  0,
  /*  464 */  0,
  /*  465 */  0,
  /*  466 */  0,
  /*  467 */  0,
  /*  468 */  0,
  /*  469 */  0,
  /*  470 */  0,
  /*  471 */  0,
  /*  472 */  0,
  /*  473 */  0,
  /*  474 */  0,
  /*  475 */  0,
  /*  476 */  0,
  /*  477 */  0,
  /*  478 */  0,
  /*  479 */  0,
  /*  480 */  0,
  /*  481 */  0,
  /*  482 */  0,
  /*  483 */  0,
  /*  484 */  0,
  /*  485 */  0,
  /*  486 */  0,
  /*  487 */  0,
  /*  488 */  0,
  /*  489 */  0,
  /*  490 */  0,
  /*  491 */  0,
  /*  492 */  0,
  /*  493 */  iRegIorL2I_rule,
  /*  494 */  immIAddSub_rule,
  /*  495 */  iRegL_rule,
  /*  496 */  immLAddSub_rule,
  /*  497 */  iRegIorL2I_rule,
  /*  498 */  immIAddSub_rule,
  /*  499 */  iRegL_rule,
  /*  500 */  immLAddSub_rule,
  /*  501 */  iRegIorL2I_rule,
  /*  502 */  iRegL_rule,
  /*  503 */  iRegIorL2I_rule,
  /*  504 */  iRegL_rule,
  /*  505 */  iRegI_rule,
  /*  506 */  immI0_rule,
  /*  507 */  immIAddSub_rule,
  /*  508 */  immI_rule,
  /*  509 */  iRegI_rule,
  /*  510 */  immI0_rule,
  /*  511 */  immIAddSub_rule,
  /*  512 */  immI_rule,
  /*  513 */  iRegL_rule,
  /*  514 */  immL0_rule,
  /*  515 */  immLAddSub_rule,
  /*  516 */  immL_rule,
  /*  517 */  iRegL_rule,
  /*  518 */  immL0_rule,
  /*  519 */  immLAddSub_rule,
  /*  520 */  immL_rule,
  /*  521 */  iRegP_rule,
  /*  522 */  iRegN_rule,
  /*  523 */  immP0_rule,
  /*  524 */  immN0_rule,
  /*  525 */  vRegF_rule,
  /*  526 */  immF0_rule,
  /*  527 */  vRegD_rule,
  /*  528 */  immD0_rule,
  /*  529 */  0,
  /*  530 */  immL0_rule,
  /*  531 */  immI0_rule,
  /*  532 */  immL0_rule,
  /*  533 */  immI0_rule,
  /*  534 */  iRegP_rule,
  /*  535 */  iRegP_rule,
  /*  536 */  immP0_rule,
  /*  537 */  0,
  /*  538 */  0,
  /*  539 */  0,
  /*  540 */  0,
  /*  541 */  0,
  /*  542 */  0,
  /*  543 */  0,
  /*  544 */  0,
  /*  545 */  0,
  /*  546 */  0,
  /*  547 */  0,
  /*  548 */  0,
  /*  549 */  0,
  /*  550 */  0,
  /*  551 */  0,
  /*  552 */  0,
  /*  553 */  0,
  /*  554 */  0,
  /*  555 */  0,
  /*  556 */  0,
  /*  557 */  0,
  /*  558 */  0,
  /*  559 */  0,
  /*  560 */  0,
  /*  561 */  0,
  /*  562 */  0,
  /*  563 */  0,
  /*  564 */  0,
  /*  565 */  0,
  /*  566 */  0,
  /*  567 */  0,
  /*  568 */  0,
  /*  569 */  0,
  /*  570 */  0,
  /*  571 */  0,
  /*  572 */  0,
  /*  573 */  0,
  /*  574 */  0,
  /*  575 */  0,
  /*  576 */  0,
  /*  577 */  0,
  /*  578 */  0,
  /*  579 */  0,
  /*  580 */  0,
  /*  581 */  0,
  /*  582 */  0,
  /*  583 */  0,
  /*  584 */  0,
  /*  585 */  0,
  /*  586 */  0,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  0,
  /*  590 */  0,
  /*  591 */  vReg_rule,
  /*  592 */  pReg_rule,
  /*  593 */  vReg_rule,
  /*  594 */  pReg_rule,
  /*  595 */  0,
  /*  596 */  0,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  0,
  /*  600 */  0,
  /*  601 */  0,
  /*  602 */  0,
  /*  603 */  0,
  /*  604 */  0,
  /*  605 */  0,
  /*  606 */  0,
  /*  607 */  0,
  /*  608 */  0,
  /*  609 */  0,
  /*  610 */  immL_32bits_rule,
  /*  611 */  0,
  /*  612 */  0,
  /*  613 */  0,
  /*  614 */  0,
  /*  615 */  0,
  /*  616 */  0,
  /*  617 */  0,
  /*  618 */  0,
  /*  619 */  immI0_rule,
  /*  620 */  immI0_rule,
  /*  621 */  iRegIorL2I_rule,
  /*  622 */  immI0_rule,
  /*  623 */  iRegIorL2I_rule,
  /*  624 */  immI0_rule,
  /*  625 */  iRegIorL2I_rule,
  /*  626 */  immI0_rule,
  /*  627 */  iRegL_rule,
  /*  628 */  immL0_rule,
  /*  629 */  iRegP_rule,
  /*  630 */  immP0_rule,
  /*  631 */  iRegN_rule,
  /*  632 */  immN0_rule,
  /*  633 */  vRegF_rule,
  /*  634 */  vRegD_rule,
  /*  635 */  iRegN_rule,
  /*  636 */  0,
  /*  637 */  0,
  /*  638 */  0,
  /*  639 */  0,
  /*  640 */  0,
  /*  641 */  0,
  /*  642 */  0,
  /*  643 */  0,
  /*  644 */  0,
  /*  645 */  0,
  /*  646 */  immL_32bits_rule,
  /*  647 */  0,
  /*  648 */  0,
  /*  649 */  0,
  /*  650 */  0,
  /*  651 */  0,
  /*  652 */  iRegIorL2I_rule,
  /*  653 */  immI0_rule,
  /*  654 */  iRegIorL2I_rule,
  /*  655 */  immI0_rule,
  /*  656 */  iRegIorL2I_rule,
  /*  657 */  immI0_rule,
  /*  658 */  iRegL_rule,
  /*  659 */  immL0_rule,
  /*  660 */  iRegP_rule,
  /*  661 */  immP0_rule,
  /*  662 */  iRegN_rule,
  /*  663 */  immN0_rule,
  /*  664 */  vRegF_rule,
  /*  665 */  vRegD_rule,
  /*  666 */  0,
  /*  667 */  0,
  /*  668 */  0,
  /*  669 */  0,
  /*  670 */  0,
  /*  671 */  0,
  /*  672 */  0,
  /*  673 */  0,
  /*  674 */  0,
  /*  675 */  0,
  /*  676 */  0,
  /*  677 */  0,
  /*  678 */  0,
  /*  679 */  0,
  /*  680 */  0,
  /*  681 */  0,
  /*  682 */  0,
  /*  683 */  0,
  /*  684 */  0,
  /*  685 */  0,
  /*  686 */  0,
  /*  687 */  0,
  /*  688 */  0,
  /*  689 */  0,
  /*  690 */  0,
  /*  691 */  0,
  /*  692 */  0,
  /*  693 */  0,
  /*  694 */  0,
  /*  695 */  0,
  /*  696 */  0,
  /*  697 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  698 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  699 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  700 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  701 */  _Binary_iRegP_iRegP_rule,
  /*  702 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  703 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  704 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  705 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  706 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  707 */  _Binary_iRegP_iRegP_rule,
  /*  708 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  709 */  _Binary_iRegI_iRegI_rule,
  /*  710 */  _Binary_iRegI_iRegI_rule,
  /*  711 */  _Binary_iRegI_iRegI_rule,
  /*  712 */  _Binary_iRegL_iRegL_rule,
  /*  713 */  _Binary_iRegN_iRegN_rule,
  /*  714 */  _Binary_iRegP_iRegP_rule,
  /*  715 */  _Binary_iRegI_iRegI_rule,
  /*  716 */  _Binary_iRegI_iRegI_rule,
  /*  717 */  _Binary_iRegI_iRegI_rule,
  /*  718 */  _Binary_iRegL_iRegL_rule,
  /*  719 */  _Binary_iRegN_iRegN_rule,
  /*  720 */  _Binary_iRegP_iRegP_rule,
  /*  721 */  _Binary_iRegI_iRegI_rule,
  /*  722 */  _Binary_iRegI_iRegI_rule,
  /*  723 */  _Binary_iRegI_iRegI_rule,
  /*  724 */  _Binary_iRegL_iRegL_rule,
  /*  725 */  _Binary_iRegN_iRegN_rule,
  /*  726 */  _Binary_iRegP_iRegP_rule,
  /*  727 */  _Binary_iRegI_iRegI_rule,
  /*  728 */  _Binary_iRegI_iRegI_rule,
  /*  729 */  _Binary_iRegI_iRegI_rule,
  /*  730 */  _Binary_iRegL_iRegL_rule,
  /*  731 */  _Binary_iRegN_iRegN_rule,
  /*  732 */  _Binary_iRegP_iRegP_rule,
  /*  733 */  iRegI_rule,
  /*  734 */  iRegL_rule,
  /*  735 */  iRegN_rule,
  /*  736 */  iRegP_rule,
  /*  737 */  iRegI_rule,
  /*  738 */  iRegL_rule,
  /*  739 */  iRegN_rule,
  /*  740 */  iRegP_rule,
  /*  741 */  iRegL_rule,
  /*  742 */  iRegL_rule,
  /*  743 */  immLAddSub_rule,
  /*  744 */  immLAddSub_rule,
  /*  745 */  iRegIorL2I_rule,
  /*  746 */  iRegIorL2I_rule,
  /*  747 */  immIAddSub_rule,
  /*  748 */  immIAddSub_rule,
  /*  749 */  iRegL_rule,
  /*  750 */  iRegL_rule,
  /*  751 */  immLAddSub_rule,
  /*  752 */  immLAddSub_rule,
  /*  753 */  iRegIorL2I_rule,
  /*  754 */  iRegIorL2I_rule,
  /*  755 */  immIAddSub_rule,
  /*  756 */  immIAddSub_rule,
  /*  757 */  iRegI_rule,
  /*  758 */  immIAddSub_rule,
  /*  759 */  iRegL_rule,
  /*  760 */  immLAddSub_rule,
  /*  761 */  iRegL_rule,
  /*  762 */  immLAddSub_rule,
  /*  763 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  764 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  765 */  _Binary_immI0_iRegIorL2I_rule,
  /*  766 */  _Binary_immI0_iRegIorL2I_rule,
  /*  767 */  _Binary_iRegIorL2I_immI0_rule,
  /*  768 */  _Binary_iRegIorL2I_immI0_rule,
  /*  769 */  _Binary_immI_1_immI0_rule,
  /*  770 */  _Binary_immI_1_immI0_rule,
  /*  771 */  _Binary_iRegL_iRegL_rule,
  /*  772 */  _Binary_iRegL_iRegL_rule,
  /*  773 */  _Binary_iRegL_immL0_rule,
  /*  774 */  _Binary_iRegL_immL0_rule,
  /*  775 */  _Binary_immL0_iRegL_rule,
  /*  776 */  _Binary_immL0_iRegL_rule,
  /*  777 */  _Binary_iRegP_iRegP_rule,
  /*  778 */  _Binary_iRegP_iRegP_rule,
  /*  779 */  _Binary_iRegP_immP0_rule,
  /*  780 */  _Binary_iRegP_immP0_rule,
  /*  781 */  _Binary_immP0_iRegP_rule,
  /*  782 */  _Binary_immP0_iRegP_rule,
  /*  783 */  _Binary_iRegN_iRegN_rule,
  /*  784 */  _Binary_iRegN_iRegN_rule,
  /*  785 */  _Binary_iRegN_immN0_rule,
  /*  786 */  _Binary_iRegN_immN0_rule,
  /*  787 */  _Binary_immN0_iRegN_rule,
  /*  788 */  _Binary_immN0_iRegN_rule,
  /*  789 */  _Binary_vRegF_vRegF_rule,
  /*  790 */  _Binary_vRegF_vRegF_rule,
  /*  791 */  _Binary_vRegD_vRegD_rule,
  /*  792 */  _Binary_vRegD_vRegD_rule,
  /*  793 */  iRegIorL2I_rule,
  /*  794 */  immIAddSub_rule,
  /*  795 */  immIAddSub_rule,
  /*  796 */  iRegL_rule,
  /*  797 */  _ConvI2L_iRegIorL2I__rule,
  /*  798 */  _LShiftL_iRegL_immIScale_rule,
  /*  799 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  800 */  immI_rule,
  /*  801 */  immLAddSub_rule,
  /*  802 */  iRegL_rule,
  /*  803 */  immLAddSub_rule,
  /*  804 */  iRegIorL2I_rule,
  /*  805 */  immIAddSub_rule,
  /*  806 */  iRegL_rule,
  /*  807 */  immLAddSub_rule,
  /*  808 */  iRegIorL2I_rule,
  /*  809 */  iRegL_rule,
  /*  810 */  iRegIorL2I_rule,
  /*  811 */  _ConvI2L_iRegIorL2I__rule,
  /*  812 */  _ConvI2L_iRegIorL2I__rule,
  /*  813 */  iRegL_rule,
  /*  814 */  iRegL_rule,
  /*  815 */  iRegL_rule,
  /*  816 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  817 */  iRegIorL2I_rule,
  /*  818 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  819 */  iRegIorL2I_rule,
  /*  820 */  _SubI_immI0_iRegIorL2I_rule,
  /*  821 */  _MulL_iRegL_iRegL_rule,
  /*  822 */  iRegL_rule,
  /*  823 */  _MulL_iRegL_iRegL_rule,
  /*  824 */  iRegL_rule,
  /*  825 */  _SubL_immL0_iRegL_rule,
  /*  826 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  827 */  iRegLNoSp_rule,
  /*  828 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  829 */  iRegLNoSp_rule,
  /*  830 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  831 */  _MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I__rule,
  /*  832 */  _ConvI2L_iRegIorL2I__rule,
  /*  833 */  _SubL_immL0__ConvI2L_iRegIorL2I__rule,
  /*  834 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  835 */  iRegIorL2I_rule,
  /*  836 */  iRegL_rule,
  /*  837 */  iRegIorL2I_rule,
  /*  838 */  iRegL_rule,
  /*  839 */  iRegIorL2I_rule,
  /*  840 */  iRegL_rule,
  /*  841 */  iRegIorL2I_rule,
  /*  842 */  iRegL_rule,
  /*  843 */  iRegIorL2I_rule,
  /*  844 */  immI_rule,
  /*  845 */  iRegIorL2I_rule,
  /*  846 */  immI_rule,
  /*  847 */  iRegIorL2I_rule,
  /*  848 */  immI_rule,
  /*  849 */  iRegIorL2I_rule,
  /*  850 */  immI_rule,
  /*  851 */  iRegIorL2I_rule,
  /*  852 */  immI_rule,
  /*  853 */  immI_rule,
  /*  854 */  iRegIorL2I_rule,
  /*  855 */  immI_rule,
  /*  856 */  immL_M1_rule,
  /*  857 */  immI_M1_rule,
  /*  858 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  859 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  860 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  861 */  _URShiftL_iRegL_immI_rule,
  /*  862 */  _RShiftL_iRegL_immI_rule,
  /*  863 */  _LShiftL_iRegL_immI_rule,
  /*  864 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  865 */  iRegIorL2I_rule,
  /*  866 */  _XorL_iRegL_immL_M1_rule,
  /*  867 */  iRegL_rule,
  /*  868 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  869 */  iRegIorL2I_rule,
  /*  870 */  _XorL_iRegL_immL_M1_rule,
  /*  871 */  iRegL_rule,
  /*  872 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  873 */  immI_M1_rule,
  /*  874 */  _XorL_iRegL_iRegL_rule,
  /*  875 */  immL_M1_rule,
  /*  876 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  877 */  iRegIorL2I_rule,
  /*  878 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  879 */  iRegL_rule,
  /*  880 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  881 */  iRegIorL2I_rule,
  /*  882 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  883 */  iRegL_rule,
  /*  884 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  885 */  iRegIorL2I_rule,
  /*  886 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  887 */  iRegL_rule,
  /*  888 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  889 */  iRegIorL2I_rule,
  /*  890 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  891 */  iRegL_rule,
  /*  892 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  893 */  immI_M1_rule,
  /*  894 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  895 */  immI_M1_rule,
  /*  896 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  897 */  immL_M1_rule,
  /*  898 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  899 */  immL_M1_rule,
  /*  900 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  901 */  immI_M1_rule,
  /*  902 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  903 */  immI_M1_rule,
  /*  904 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  905 */  immL_M1_rule,
  /*  906 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  907 */  immL_M1_rule,
  /*  908 */  _XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  909 */  immI_M1_rule,
  /*  910 */  _XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI_rule,
  /*  911 */  immI_M1_rule,
  /*  912 */  _XorL__RotateRight_iRegL_immI_iRegL_rule,
  /*  913 */  immL_M1_rule,
  /*  914 */  _XorL_iRegL__RotateRight_iRegL_immI_rule,
  /*  915 */  immL_M1_rule,
  /*  916 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  917 */  immI_M1_rule,
  /*  918 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  919 */  immI_M1_rule,
  /*  920 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  921 */  immL_M1_rule,
  /*  922 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  923 */  immL_M1_rule,
  /*  924 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  925 */  iRegIorL2I_rule,
  /*  926 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  927 */  iRegL_rule,
  /*  928 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  929 */  iRegIorL2I_rule,
  /*  930 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  931 */  iRegL_rule,
  /*  932 */  _XorI__RotateRight_iRegIorL2I_immI_immI_M1_rule,
  /*  933 */  iRegIorL2I_rule,
  /*  934 */  _XorL__RotateRight_iRegL_immI_immL_M1_rule,
  /*  935 */  iRegL_rule,
  /*  936 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  937 */  iRegIorL2I_rule,
  /*  938 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  939 */  iRegL_rule,
  /*  940 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  941 */  iRegIorL2I_rule,
  /*  942 */  _URShiftL_iRegL_immI_rule,
  /*  943 */  iRegL_rule,
  /*  944 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  945 */  iRegIorL2I_rule,
  /*  946 */  _RShiftL_iRegL_immI_rule,
  /*  947 */  iRegL_rule,
  /*  948 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  949 */  iRegIorL2I_rule,
  /*  950 */  _LShiftL_iRegL_immI_rule,
  /*  951 */  iRegL_rule,
  /*  952 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  953 */  iRegIorL2I_rule,
  /*  954 */  _RotateRight_iRegL_immI_rule,
  /*  955 */  iRegL_rule,
  /*  956 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  957 */  iRegIorL2I_rule,
  /*  958 */  _URShiftL_iRegL_immI_rule,
  /*  959 */  iRegL_rule,
  /*  960 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  961 */  iRegIorL2I_rule,
  /*  962 */  _RShiftL_iRegL_immI_rule,
  /*  963 */  iRegL_rule,
  /*  964 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  965 */  iRegIorL2I_rule,
  /*  966 */  _LShiftL_iRegL_immI_rule,
  /*  967 */  iRegL_rule,
  /*  968 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  969 */  iRegIorL2I_rule,
  /*  970 */  _RotateRight_iRegL_immI_rule,
  /*  971 */  iRegL_rule,
  /*  972 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  973 */  iRegIorL2I_rule,
  /*  974 */  _URShiftL_iRegL_immI_rule,
  /*  975 */  iRegL_rule,
  /*  976 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  977 */  iRegIorL2I_rule,
  /*  978 */  _RShiftL_iRegL_immI_rule,
  /*  979 */  iRegL_rule,
  /*  980 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  981 */  iRegIorL2I_rule,
  /*  982 */  _LShiftL_iRegL_immI_rule,
  /*  983 */  iRegL_rule,
  /*  984 */  _RotateRight_iRegIorL2I_immI_rule,
  /*  985 */  iRegIorL2I_rule,
  /*  986 */  _RotateRight_iRegL_immI_rule,
  /*  987 */  iRegL_rule,
  /*  988 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  989 */  iRegIorL2I_rule,
  /*  990 */  _URShiftL_iRegL_immI_rule,
  /*  991 */  iRegL_rule,
  /*  992 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  993 */  iRegIorL2I_rule,
  /*  994 */  _RShiftL_iRegL_immI_rule,
  /*  995 */  iRegL_rule,
  /*  996 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  997 */  iRegIorL2I_rule,
  /*  998 */  _LShiftL_iRegL_immI_rule,
  /*  999 */  iRegL_rule,
  /* 1000 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1001 */  _URShiftL_iRegL_immI_rule,
  /* 1002 */  _RShiftI_iRegIorL2I_immI_rule,
  /* 1003 */  _RShiftL_iRegL_immI_rule,
  /* 1004 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1005 */  _LShiftL_iRegL_immI_rule,
  /* 1006 */  immI_rule,
  /* 1007 */  immI_rule,
  /* 1008 */  immI_rule,
  /* 1009 */  immI_rule,
  /* 1010 */  immI_bitmask_rule,
  /* 1011 */  immL_bitmask_rule,
  /* 1012 */  0,
  /* 1013 */  immI_rule,
  /* 1014 */  immI_rule,
  /* 1015 */  0,
  /* 1016 */  0,
  /* 1017 */  immI_rule,
  /* 1018 */  immI_rule,
  /* 1019 */  0,
  /* 1020 */  _URShiftL_iRegL_immI_rule,
  /* 1021 */  _LShiftL_iRegL_immI_rule,
  /* 1022 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1023 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1024 */  _URShiftL_iRegL_immI_rule,
  /* 1025 */  _LShiftL_iRegL_immI_rule,
  /* 1026 */  _URShiftI_iRegIorL2I_immI_rule,
  /* 1027 */  _LShiftI_iRegIorL2I_immI_rule,
  /* 1028 */  immI_rule,
  /* 1029 */  immI_rule,
  /* 1030 */  iRegI_rule,
  /* 1031 */  iRegI_rule,
  /* 1032 */  iRegI_rule,
  /* 1033 */  iRegI_rule,
  /* 1034 */  _ConvI2L_iRegIorL2I__rule,
  /* 1035 */  iRegL_rule,
  /* 1036 */  _ConvI2L_iRegIorL2I__rule,
  /* 1037 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /* 1038 */  iRegIorL2I_rule,
  /* 1039 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1040 */  iRegIorL2I_rule,
  /* 1041 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /* 1042 */  iRegIorL2I_rule,
  /* 1043 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /* 1044 */  iRegL_rule,
  /* 1045 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /* 1046 */  iRegL_rule,
  /* 1047 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1048 */  iRegL_rule,
  /* 1049 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /* 1050 */  iRegL_rule,
  /* 1051 */  _AndI_iRegIorL2I_immI_255_rule,
  /* 1052 */  iRegIorL2I_rule,
  /* 1053 */  _AndI_iRegIorL2I_immI_65535_rule,
  /* 1054 */  iRegIorL2I_rule,
  /* 1055 */  _AndL_iRegL_immL_255_rule,
  /* 1056 */  iRegL_rule,
  /* 1057 */  _AndL_iRegL_immL_65535_rule,
  /* 1058 */  iRegL_rule,
  /* 1059 */  _AndL_iRegL_immL_4294967295_rule,
  /* 1060 */  iRegL_rule,
  /* 1061 */  _AndI_iRegIorL2I_immI_255_rule,
  /* 1062 */  _AndI_iRegIorL2I_immI_65535_rule,
  /* 1063 */  _AndL_iRegL_immL_255_rule,
  /* 1064 */  _AndL_iRegL_immL_65535_rule,
  /* 1065 */  _AndL_iRegL_immL_4294967295_rule,
  /* 1066 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /* 1067 */  iRegL_rule,
  /* 1068 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /* 1069 */  iRegL_rule,
  /* 1070 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /* 1071 */  iRegL_rule,
  /* 1072 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt_rule,
  /* 1073 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt_rule,
  /* 1074 */  _LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt_rule,
  /* 1075 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /* 1076 */  iRegIorL2I_rule,
  /* 1077 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /* 1078 */  iRegIorL2I_rule,
  /* 1079 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt_rule,
  /* 1080 */  _LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt_rule,
  /* 1081 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /* 1082 */  iRegL_rule,
  /* 1083 */  _LShiftL__ConvI2L_iRegIorL2I__immIExt_rule,
  /* 1084 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /* 1085 */  iRegL_rule,
  /* 1086 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /* 1087 */  iRegL_rule,
  /* 1088 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /* 1089 */  iRegL_rule,
  /* 1090 */  _LShiftL__AndL_iRegL_immL_255_immIExt_rule,
  /* 1091 */  _LShiftL__AndL_iRegL_immL_65535_immIExt_rule,
  /* 1092 */  _LShiftL__AndL_iRegL_immL_4294967295_immIExt_rule,
  /* 1093 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /* 1094 */  iRegIorL2I_rule,
  /* 1095 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /* 1096 */  iRegIorL2I_rule,
  /* 1097 */  _LShiftI__AndI_iRegIorL2I_immI_255_immIExt_rule,
  /* 1098 */  _LShiftI__AndI_iRegIorL2I_immI_65535_immIExt_rule,
  /* 1099 */  0,
  /* 1100 */  0,
  /* 1101 */  0,
  /* 1102 */  0,
  /* 1103 */  0,
  /* 1104 */  0,
  /* 1105 */  0,
  /* 1106 */  0,
  /* 1107 */  immI0_rule,
  /* 1108 */  iRegIorL2I_rule,
  /* 1109 */  immI_1_rule,
  /* 1110 */  iRegIorL2I_rule,
  /* 1111 */  immI_M1_rule,
  /* 1112 */  iRegIorL2I_rule,
  /* 1113 */  immI0_rule,
  /* 1114 */  iRegIorL2I_rule,
  /* 1115 */  immI_1_rule,
  /* 1116 */  iRegIorL2I_rule,
  /* 1117 */  immI_M1_rule,
  /* 1118 */  iRegIorL2I_rule,
  /* 1119 */  vRegF_rule,
  /* 1120 */  vRegD_rule,
  /* 1121 */  vRegF_rule,
  /* 1122 */  vRegD_rule,
  /* 1123 */  vRegF_rule,
  /* 1124 */  vRegD_rule,
  /* 1125 */  _Binary_vRegF_vRegF_rule,
  /* 1126 */  _Binary_vRegD_vRegD_rule,
  /* 1127 */  _Binary_vRegF__NegF_vRegF__rule,
  /* 1128 */  _Binary_vRegD__NegD_vRegD__rule,
  /* 1129 */  _Binary_vRegF__NegF_vRegF__rule,
  /* 1130 */  _Binary_vRegD__NegD_vRegD__rule,
  /* 1131 */  _Binary_vRegF_vRegF_rule,
  /* 1132 */  _Binary_vRegD_vRegD_rule,
  /* 1133 */  vRegF_rule,
  /* 1134 */  vRegF_rule,
  /* 1135 */  vRegD_rule,
  /* 1136 */  vRegD_rule,
  /* 1137 */  vRegF_rule,
  /* 1138 */  vRegD_rule,
  /* 1139 */  0,
  /* 1140 */  0,
  /* 1141 */  0,
  /* 1142 */  0,
  /* 1143 */  0,
  /* 1144 */  0,
  /* 1145 */  immI_rule,
  /* 1146 */  _Binary_vRegD_vRegD_rule,
  /* 1147 */  vRegF_rule,
  /* 1148 */  _Binary_vRegD_vRegD_rule,
  /* 1149 */  _Binary_vRegF_vRegF_rule,
  /* 1150 */  0,
  /* 1151 */  iRegIorL2I_rule,
  /* 1152 */  immILog_rule,
  /* 1153 */  iRegIorL2I_rule,
  /* 1154 */  immILog_rule,
  /* 1155 */  iRegIorL2I_rule,
  /* 1156 */  immILog_rule,
  /* 1157 */  iRegL_rule,
  /* 1158 */  immLLog_rule,
  /* 1159 */  iRegL_rule,
  /* 1160 */  immLLog_rule,
  /* 1161 */  iRegL_rule,
  /* 1162 */  immLLog_rule,
  /* 1163 */  0,
  /* 1164 */  immL_32bits_rule,
  /* 1165 */  0,
  /* 1166 */  0,
  /* 1167 */  0,
  /* 1168 */  0,
  /* 1169 */  0,
  /* 1170 */  0,
  /* 1171 */  0,
  /* 1172 */  0,
  /* 1173 */  0,
  /* 1174 */  0,
  /* 1175 */  0,
  /* 1176 */  0,
  /* 1177 */  0,
  /* 1178 */  0,
  /* 1179 */  0,
  /* 1180 */  0,
  /* 1181 */  0,
  /* 1182 */  0,
  /* 1183 */  0,
  /* 1184 */  iRegP_R10_rule,
  /* 1185 */  iRegP_R10_rule,
  /* 1186 */  _OverflowMulI_iRegIorL2I_iRegIorL2I_rule,
  /* 1187 */  _OverflowMulL_iRegL_iRegL_rule,
  /* 1188 */  vRegF_rule,
  /* 1189 */  vRegD_rule,
  /* 1190 */  immF0_rule,
  /* 1191 */  immD0_rule,
  /* 1192 */  iRegIorL2I_rule,
  /* 1193 */  immI0_rule,
  /* 1194 */  iRegIorL2I_rule,
  /* 1195 */  iRegIorL2I_rule,
  /* 1196 */  0,
  /* 1197 */  rFlagsReg_rule,
  /* 1198 */  rFlagsRegU_rule,
  /* 1199 */  _CmpI_iRegIorL2I_immI0_rule,
  /* 1200 */  _CmpL_iRegL_immL0_rule,
  /* 1201 */  _CmpP_iRegP_immP0_rule,
  /* 1202 */  _CmpN_iRegN_immN0_rule,
  /* 1203 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /* 1204 */  _CmpU_iRegIorL2I_immI0_rule,
  /* 1205 */  _CmpUL_iRegL_immL0_rule,
  /* 1206 */  _CmpL_iRegL_immL0_rule,
  /* 1207 */  _CmpI_iRegIorL2I_immI0_rule,
  /* 1208 */  _CmpL__AndL_iRegL_immL_immL0_rule,
  /* 1209 */  _CmpI__AndI_iRegIorL2I_immI_immI0_rule,
  /* 1210 */  _CmpL_iRegL_immL0_rule,
  /* 1211 */  _CmpI_iRegIorL2I_immI0_rule,
  /* 1212 */  _CmpL__AndL_iRegL_immL_immL0_rule,
  /* 1213 */  _CmpI__AndI_iRegIorL2I_immI_immI0_rule,
  /* 1214 */  rFlagsReg_rule,
  /* 1215 */  0,
  /* 1216 */  0,
  /* 1217 */  0,
  /* 1218 */  0,
  /* 1219 */  0,
  /* 1220 */  0,
  /* 1221 */  inline_cache_RegP_rule,
  /* 1222 */  iRegP_R0_rule,
  /* 1223 */  0,
  /* 1224 */  0,
  /* 1225 */  0,
  /* 1226 */  0,
  /* 1227 */  iRegP_R0_rule,
  /* 1228 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1229 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1230 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1231 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1232 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1233 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1234 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1235 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /* 1236 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /* 1237 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /* 1238 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /* 1239 */  _Binary_iRegP_R3_immI_le_4_rule,
  /* 1240 */  _Binary_iRegP_R3_immI_le_4_rule,
  /* 1241 */  _Binary_iRegP_R3_immI_1_rule,
  /* 1242 */  iRegI_R3_rule,
  /* 1243 */  iRegI_R3_rule,
  /* 1244 */  iRegI_R3_rule,
  /* 1245 */  iRegI_R3_rule,
  /* 1246 */  iRegI_R4_rule,
  /* 1247 */  iRegI_R4_rule,
  /* 1248 */  iRegP_R2_rule,
  /* 1249 */  iRegP_R2_rule,
  /* 1250 */  iRegI_R2_rule,
  /* 1251 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /* 1252 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /* 1253 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /* 1254 */  _Binary_iRegP_R1_iRegI_R3_rule,
  /* 1255 */  iRegIorL2I_rule,
  /* 1256 */  immI_rule,
  /* 1257 */  iRegL_rule,
  /* 1258 */  immL_rule,
  /* 1259 */  iRegIorL2I_rule,
  /* 1260 */  immI_rule,
  /* 1261 */  iRegL_rule,
  /* 1262 */  immL_rule,
  /* 1263 */  0,
  /* 1264 */  vReg_rule,
  /* 1265 */  0,
  /* 1266 */  vReg_rule,
  /* 1267 */  0,
  /* 1268 */  vReg_rule,
  /* 1269 */  0,
  /* 1270 */  vReg_rule,
  /* 1271 */  0,
  /* 1272 */  vReg_rule,
  /* 1273 */  pRegGov_rule,
  /* 1274 */  _Binary_vReg_pRegGov_rule,
  /* 1275 */  vReg_rule,
  /* 1276 */  vReg_rule,
  /* 1277 */  vReg_rule,
  /* 1278 */  vReg_rule,
  /* 1279 */  vReg_rule,
  /* 1280 */  vReg_rule,
  /* 1281 */  pRegGov_rule,
  /* 1282 */  pRegGov_rule,
  /* 1283 */  pRegGov_rule,
  /* 1284 */  pRegGov_rule,
  /* 1285 */  pRegGov_rule,
  /* 1286 */  pRegGov_rule,
  /* 1287 */  _Replicate_immBAddSubV__rule,
  /* 1288 */  vReg_rule,
  /* 1289 */  _Replicate_immIAddSubV__rule,
  /* 1290 */  vReg_rule,
  /* 1291 */  _Replicate_immIAddSubV__rule,
  /* 1292 */  vReg_rule,
  /* 1293 */  _Replicate_immLAddSubV__rule,
  /* 1294 */  vReg_rule,
  /* 1295 */  vReg_rule,
  /* 1296 */  vReg_rule,
  /* 1297 */  vReg_rule,
  /* 1298 */  vReg_rule,
  /* 1299 */  vReg_rule,
  /* 1300 */  vReg_rule,
  /* 1301 */  pRegGov_rule,
  /* 1302 */  pRegGov_rule,
  /* 1303 */  pRegGov_rule,
  /* 1304 */  pRegGov_rule,
  /* 1305 */  pRegGov_rule,
  /* 1306 */  pRegGov_rule,
  /* 1307 */  vReg_rule,
  /* 1308 */  vReg_rule,
  /* 1309 */  vReg_rule,
  /* 1310 */  vReg_rule,
  /* 1311 */  vReg_rule,
  /* 1312 */  vReg_rule,
  /* 1313 */  vReg_rule,
  /* 1314 */  vReg_rule,
  /* 1315 */  vReg_rule,
  /* 1316 */  vReg_rule,
  /* 1317 */  pRegGov_rule,
  /* 1318 */  pRegGov_rule,
  /* 1319 */  pRegGov_rule,
  /* 1320 */  pRegGov_rule,
  /* 1321 */  pRegGov_rule,
  /* 1322 */  pRegGov_rule,
  /* 1323 */  vReg_rule,
  /* 1324 */  vReg_rule,
  /* 1325 */  vReg_rule,
  /* 1326 */  vReg_rule,
  /* 1327 */  pRegGov_rule,
  /* 1328 */  pRegGov_rule,
  /* 1329 */  vReg_rule,
  /* 1330 */  pRegGov_rule,
  /* 1331 */  _Replicate_immBLog__rule,
  /* 1332 */  vReg_rule,
  /* 1333 */  _Replicate_immSLog__rule,
  /* 1334 */  vReg_rule,
  /* 1335 */  _Replicate_immILog__rule,
  /* 1336 */  vReg_rule,
  /* 1337 */  _Replicate_immLLog__rule,
  /* 1338 */  vReg_rule,
  /* 1339 */  vReg_rule,
  /* 1340 */  pRegGov_rule,
  /* 1341 */  _Replicate_immBLog__rule,
  /* 1342 */  vReg_rule,
  /* 1343 */  _Replicate_immSLog__rule,
  /* 1344 */  vReg_rule,
  /* 1345 */  _Replicate_immILog__rule,
  /* 1346 */  vReg_rule,
  /* 1347 */  _Replicate_immLLog__rule,
  /* 1348 */  vReg_rule,
  /* 1349 */  vReg_rule,
  /* 1350 */  pRegGov_rule,
  /* 1351 */  _Replicate_immBLog__rule,
  /* 1352 */  vReg_rule,
  /* 1353 */  _Replicate_immSLog__rule,
  /* 1354 */  vReg_rule,
  /* 1355 */  _Replicate_immILog__rule,
  /* 1356 */  vReg_rule,
  /* 1357 */  _Replicate_immLLog__rule,
  /* 1358 */  vReg_rule,
  /* 1359 */  _XorV_vReg_vReg_rule,
  /* 1360 */  vReg_rule,
  /* 1361 */  _XorV_vReg_vReg_rule,
  /* 1362 */  vReg_rule,
  /* 1363 */  _Replicate_immI_M1__rule,
  /* 1364 */  vReg_rule,
  /* 1365 */  _Replicate_immL_M1__rule,
  /* 1366 */  vReg_rule,
  /* 1367 */  pRegGov_rule,
  /* 1368 */  pRegGov_rule,
  /* 1369 */  _XorV_vReg__Replicate_immI_M1__rule,
  /* 1370 */  vReg_rule,
  /* 1371 */  _XorV__Replicate_immI_M1__vReg_rule,
  /* 1372 */  vReg_rule,
  /* 1373 */  _XorV_vReg__Replicate_immL_M1__rule,
  /* 1374 */  vReg_rule,
  /* 1375 */  _XorV__Replicate_immL_M1__vReg_rule,
  /* 1376 */  vReg_rule,
  /* 1377 */  pRegGov_rule,
  /* 1378 */  pRegGov_rule,
  /* 1379 */  pRegGov_rule,
  /* 1380 */  pRegGov_rule,
  /* 1381 */  pRegGov_rule,
  /* 1382 */  pRegGov_rule,
  /* 1383 */  pRegGov_rule,
  /* 1384 */  pRegGov_rule,
  /* 1385 */  pRegGov_rule,
  /* 1386 */  pRegGov_rule,
  /* 1387 */  0,
  /* 1388 */  0,
  /* 1389 */  0,
  /* 1390 */  0,
  /* 1391 */  pRegGov_rule,
  /* 1392 */  pRegGov_rule,
  /* 1393 */  pRegGov_rule,
  /* 1394 */  pRegGov_rule,
  /* 1395 */  pRegGov_rule,
  /* 1396 */  pRegGov_rule,
  /* 1397 */  pRegGov_rule,
  /* 1398 */  pRegGov_rule,
  /* 1399 */  vReg_rule,
  /* 1400 */  vReg_rule,
  /* 1401 */  vReg_rule,
  /* 1402 */  vReg_rule,
  /* 1403 */  pRegGov_rule,
  /* 1404 */  vReg_rule,
  /* 1405 */  vReg_rule,
  /* 1406 */  vReg_rule,
  /* 1407 */  vReg_rule,
  /* 1408 */  pRegGov_rule,
  /* 1409 */  _MulVB_vReg_vReg_rule,
  /* 1410 */  vReg_rule,
  /* 1411 */  _MulVS_vReg_vReg_rule,
  /* 1412 */  vReg_rule,
  /* 1413 */  _MulVI_vReg_vReg_rule,
  /* 1414 */  vReg_rule,
  /* 1415 */  _MulVL_vReg_vReg_rule,
  /* 1416 */  vReg_rule,
  /* 1417 */  pRegGov_rule,
  /* 1418 */  pRegGov_rule,
  /* 1419 */  pRegGov_rule,
  /* 1420 */  pRegGov_rule,
  /* 1421 */  _Binary_vReg_vReg_rule,
  /* 1422 */  _Binary_vReg_vReg_rule,
  /* 1423 */  _Binary_vReg_pRegGov_rule,
  /* 1424 */  _Binary_vReg_pRegGov_rule,
  /* 1425 */  _MulVB_vReg_vReg_rule,
  /* 1426 */  _MulVS_vReg_vReg_rule,
  /* 1427 */  _MulVI_vReg_vReg_rule,
  /* 1428 */  _MulVL_vReg_vReg_rule,
  /* 1429 */  pRegGov_rule,
  /* 1430 */  pRegGov_rule,
  /* 1431 */  pRegGov_rule,
  /* 1432 */  pRegGov_rule,
  /* 1433 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1434 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1435 */  _Binary_vReg_pRegGov_rule,
  /* 1436 */  _Binary_vReg_pRegGov_rule,
  /* 1437 */  _Binary_vReg__NegVF_vReg__rule,
  /* 1438 */  _Binary_vReg__NegVD_vReg__rule,
  /* 1439 */  _Binary__NegVF_vReg__pRegGov_rule,
  /* 1440 */  _Binary__NegVD_vReg__pRegGov_rule,
  /* 1441 */  _Binary_vReg_vReg_rule,
  /* 1442 */  _Binary_vReg_vReg_rule,
  /* 1443 */  _Binary__NegVF_vReg__pRegGov_rule,
  /* 1444 */  _Binary__NegVD_vReg__pRegGov_rule,
  /* 1445 */  vReg_rule,
  /* 1446 */  vReg_rule,
  /* 1447 */  vReg_rule,
  /* 1448 */  vReg_rule,
  /* 1449 */  vReg_rule,
  /* 1450 */  vReg_rule,
  /* 1451 */  vReg_rule,
  /* 1452 */  vReg_rule,
  /* 1453 */  vReg_rule,
  /* 1454 */  vReg_rule,
  /* 1455 */  vReg_rule,
  /* 1456 */  vReg_rule,
  /* 1457 */  vReg_rule,
  /* 1458 */  vReg_rule,
  /* 1459 */  vReg_rule,
  /* 1460 */  vReg_rule,
  /* 1461 */  vReg_rule,
  /* 1462 */  vReg_rule,
  /* 1463 */  vReg_rule,
  /* 1464 */  vReg_rule,
  /* 1465 */  vReg_rule,
  /* 1466 */  vReg_rule,
  /* 1467 */  vReg_rule,
  /* 1468 */  vReg_rule,
  /* 1469 */  vReg_rule,
  /* 1470 */  vReg_rule,
  /* 1471 */  vReg_rule,
  /* 1472 */  vReg_rule,
  /* 1473 */  vReg_rule,
  /* 1474 */  vReg_rule,
  /* 1475 */  vReg_rule,
  /* 1476 */  vReg_rule,
  /* 1477 */  vReg_rule,
  /* 1478 */  _LShiftCntV_immI__rule,
  /* 1479 */  _LShiftCntV_immI__rule,
  /* 1480 */  _LShiftCntV_immI__rule,
  /* 1481 */  _LShiftCntV_immI__rule,
  /* 1482 */  _RShiftCntV_immI_positive__rule,
  /* 1483 */  _RShiftCntV_immI_positive__rule,
  /* 1484 */  _RShiftCntV_immI_positive__rule,
  /* 1485 */  _RShiftCntV_immI_positive__rule,
  /* 1486 */  _RShiftCntV_immI_positive__rule,
  /* 1487 */  _RShiftCntV_immI_positive__rule,
  /* 1488 */  _RShiftCntV_immI_positive__rule,
  /* 1489 */  _RShiftCntV_immI_positive__rule,
  /* 1490 */  _RShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1491 */  vReg_rule,
  /* 1492 */  _RShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1493 */  vReg_rule,
  /* 1494 */  _RShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1495 */  vReg_rule,
  /* 1496 */  _RShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1497 */  vReg_rule,
  /* 1498 */  _URShiftVB_vReg__RShiftCntV_immI_positive__rule,
  /* 1499 */  vReg_rule,
  /* 1500 */  _URShiftVS_vReg__RShiftCntV_immI_positive__rule,
  /* 1501 */  vReg_rule,
  /* 1502 */  _URShiftVI_vReg__RShiftCntV_immI_positive__rule,
  /* 1503 */  vReg_rule,
  /* 1504 */  _URShiftVL_vReg__RShiftCntV_immI_positive__rule,
  /* 1505 */  vReg_rule,
  /* 1506 */  pRegGov_rule,
  /* 1507 */  pRegGov_rule,
  /* 1508 */  pRegGov_rule,
  /* 1509 */  pRegGov_rule,
  /* 1510 */  pRegGov_rule,
  /* 1511 */  pRegGov_rule,
  /* 1512 */  pRegGov_rule,
  /* 1513 */  pRegGov_rule,
  /* 1514 */  pRegGov_rule,
  /* 1515 */  pRegGov_rule,
  /* 1516 */  pRegGov_rule,
  /* 1517 */  pRegGov_rule,
  /* 1518 */  pRegGov_rule,
  /* 1519 */  pRegGov_rule,
  /* 1520 */  pRegGov_rule,
  /* 1521 */  pRegGov_rule,
  /* 1522 */  pRegGov_rule,
  /* 1523 */  pRegGov_rule,
  /* 1524 */  pRegGov_rule,
  /* 1525 */  pRegGov_rule,
  /* 1526 */  pRegGov_rule,
  /* 1527 */  pRegGov_rule,
  /* 1528 */  pRegGov_rule,
  /* 1529 */  pRegGov_rule,
  /* 1530 */  vReg_rule,
  /* 1531 */  vReg_rule,
  /* 1532 */  vReg_rule,
  /* 1533 */  vReg_rule,
  /* 1534 */  vReg_rule,
  /* 1535 */  vReg_rule,
  /* 1536 */  vReg_rule,
  /* 1537 */  vReg_rule,
  /* 1538 */  vReg_rule,
  /* 1539 */  pRegGov_rule,
  /* 1540 */  pRegGov_rule,
  /* 1541 */  pRegGov_rule,
  /* 1542 */  pRegGov_rule,
  /* 1543 */  vReg_rule,
  /* 1544 */  vReg_rule,
  /* 1545 */  vReg_rule,
  /* 1546 */  vReg_rule,
  /* 1547 */  vReg_rule,
  /* 1548 */  vReg_rule,
  /* 1549 */  vReg_rule,
  /* 1550 */  vReg_rule,
  /* 1551 */  pRegGov_rule,
  /* 1552 */  pRegGov_rule,
  /* 1553 */  vReg_rule,
  /* 1554 */  vReg_rule,
  /* 1555 */  vReg_rule,
  /* 1556 */  vReg_rule,
  /* 1557 */  pRegGov_rule,
  /* 1558 */  pRegGov_rule,
  /* 1559 */  vReg_rule,
  /* 1560 */  vReg_rule,
  /* 1561 */  vReg_rule,
  /* 1562 */  vReg_rule,
  /* 1563 */  pRegGov_rule,
  /* 1564 */  pRegGov_rule,
  /* 1565 */  vReg_rule,
  /* 1566 */  vReg_rule,
  /* 1567 */  vReg_rule,
  /* 1568 */  vReg_rule,
  /* 1569 */  vReg_rule,
  /* 1570 */  vReg_rule,
  /* 1571 */  pRegGov_rule,
  /* 1572 */  pRegGov_rule,
  /* 1573 */  pRegGov_rule,
  /* 1574 */  pRegGov_rule,
  /* 1575 */  vReg_rule,
  /* 1576 */  vReg_rule,
  /* 1577 */  vReg_rule,
  /* 1578 */  vReg_rule,
  /* 1579 */  vReg_rule,
  /* 1580 */  vReg_rule,
  /* 1581 */  pRegGov_rule,
  /* 1582 */  pRegGov_rule,
  /* 1583 */  pRegGov_rule,
  /* 1584 */  pRegGov_rule,
  /* 1585 */  0,
  /* 1586 */  0,
  /* 1587 */  0,
  /* 1588 */  0,
  /* 1589 */  0,
  /* 1590 */  0,
  /* 1591 */  0,
  /* 1592 */  0,
  /* 1593 */  0,
  /* 1594 */  0,
  /* 1595 */  0,
  /* 1596 */  0,
  /* 1597 */  0,
  /* 1598 */  immI_rule,
  /* 1599 */  immI_rule,
  /* 1600 */  immI_rule,
  /* 1601 */  immI_rule,
  /* 1602 */  immI_rule,
  /* 1603 */  immI_rule,
  /* 1604 */  immI_rule,
  /* 1605 */  immI_rule,
  /* 1606 */  immI_rule,
  /* 1607 */  immI_rule,
  /* 1608 */  iRegI_rule,
  /* 1609 */  immI_rule,
  /* 1610 */  immI_rule,
  /* 1611 */  immI_rule,
  /* 1612 */  immI_rule,
  /* 1613 */  immI_rule,
  /* 1614 */  immI_rule,
  /* 1615 */  immI_rule,
  /* 1616 */  immI_rule,
  /* 1617 */  immI_rule,
  /* 1618 */  immI_rule,
  /* 1619 */  immI_rule,
  /* 1620 */  immI_rule,
  /* 1621 */  0,
  /* 1622 */  0,
  /* 1623 */  pRegGov_rule,
  /* 1624 */  pRegGov_rule,
  /* 1625 */  immI_1_rule,
  /* 1626 */  immI_gt_1_rule,
  /* 1627 */  immI_1_rule,
  /* 1628 */  immI_gt_1_rule,
  /* 1629 */  0,
  /* 1630 */  pRegGov_rule,
  /* 1631 */  0,
  /* 1632 */  pRegGov_rule,
  /* 1633 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /* 1634 */  _VectorStoreMask_pReg_immI_gt_1_rule,
  /* 1635 */  _Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov_rule,
  /* 1636 */  _Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov_rule,
  /* 1637 */  pReg_rule,
  /* 1638 */  pReg_rule,
  /* 1639 */  pReg_rule,
  /* 1640 */  _XorVMask_pReg__MaskAll_immI_M1__rule,
  /* 1641 */  _XorVMask_pReg__MaskAll_immL_M1__rule,
  /* 1642 */  immI_rule,
  /* 1643 */  immI_cmp_cond_rule,
  /* 1644 */  immI_cmp_cond_rule,
  /* 1645 */  immI_cmp_cond_rule,
  /* 1646 */  immI_cmp_cond_rule,
  /* 1647 */  immI_rule,
  /* 1648 */  immI_cmp_cond_rule,
  /* 1649 */  immI_cmpU_cond_rule,
  /* 1650 */  immI_cmp_cond_rule,
  /* 1651 */  immI_cmpU_cond_rule,
  /* 1652 */  _Binary_immI_pRegGov_rule,
  /* 1653 */  0,
  /* 1654 */  0,
  /* 1655 */  0,
  /* 1656 */  0,
  /* 1657 */  0,
  /* 1658 */  pReg_rule,
  /* 1659 */  0,
  /* 1660 */  0,
  /* 1661 */  0,
  /* 1662 */  0,
  /* 1663 */  0,
  /* 1664 */  pRegGov_rule,
  /* 1665 */  0,
  /* 1666 */  0,
  /* 1667 */  pRegGov_rule,
  /* 1668 */  0,
  /* 1669 */  0,
  /* 1670 */  0,
  /* 1671 */  0,
  /* 1672 */  pRegGov_rule,
  /* 1673 */  pRegGov_rule,
  /* 1674 */  vReg_rule,
  /* 1675 */  pReg_rule,
  /* 1676 */  0,
  /* 1677 */  0,
  /* 1678 */  0,
  /* 1679 */  0,
  /* 1680 */  immI_rule,
  /* 1681 */  vReg_rule,
  /* 1682 */  vReg_rule,
  /* 1683 */  vReg_rule,
  /* 1684 */  vReg_rule,
  /* 1685 */  _Binary_vReg_pRegGov_rule,
  /* 1686 */  _Binary_vReg_pRegGov_rule,
  /* 1687 */  _Binary_vReg_vReg_rule,
  /* 1688 */  _Binary_vReg_vReg_rule,
  /* 1689 */  _Binary_vReg__Binary_vReg_pRegGov_rule,
  /* 1690 */  _Binary_vReg__Binary_vReg_pRegGov_rule,
  /* 1691 */  pRegGov_rule,
  /* 1692 */  pRegGov_rule,
  /* 1693 */  pRegGov_rule,
  /* 1694 */  pRegGov_rule,
  /* 1695 */  immI_rule,
  /* 1696 */  0,
  /* 1697 */  pRegGov_rule,
  /* 1698 */  pReg_rule,
  /* 1699 */  pReg_rule,
  /* 1700 */  pRegGov_rule,
  /* 1701 */  _Binary_vReg_vReg_rule,
  /* 1702 */  _Binary_vReg_vReg_rule,
  /* 1703 */  _Binary_vReg_vReg_rule,
  /* 1704 */  _Binary_vReg_vReg_rule,
  /* 1705 */  vReg_rule,
  /* 1706 */  vReg_rule,
  /* 1707 */  _Binary_iRegP_iRegP_rule,
  /* 1708 */  _Binary_iRegN_iRegN_rule,
  /* 1709 */  _Binary_iRegP_iRegP_rule,
  /* 1710 */  _Binary_iRegN_iRegN_rule,
  /* 1711 */  _Binary_iRegN_iRegN_rule,
  /* 1712 */  _Binary_iRegP_iRegP_rule,
  /* 1713 */  _Binary_iRegN_iRegN_rule,
  /* 1714 */  _Binary_iRegP_iRegP_rule,
  /* 1715 */  _Binary_iRegN_iRegN_rule,
  /* 1716 */  _Binary_iRegP_iRegP_rule,
  /* 1717 */  _Binary_iRegN_iRegN_rule,
  /* 1718 */  _Binary_iRegP_iRegP_rule,
  /* 1719 */  0,
  /* 1720 */  0,
  /* 1721 */  _Binary_iRegP_iRegP_rule,
  /* 1722 */  _Binary_iRegP_iRegP_rule,
  /* 1723 */  _Binary_iRegP_iRegP_rule,
  /* 1724 */  _Binary_iRegP_iRegP_rule,
  /* 1725 */  _Binary_iRegP_iRegP_rule,
  /* 1726 */  _Binary_iRegP_iRegP_rule,
  /* 1727 */  iRegP_rule,
  /* 1728 */  iRegP_rule,
  /* 1729 */  0,
  /* 1730 */  0,
  /* 1731 */  iRegP_rule,
  /* 1732 */  iRegP_rule,
  /* 1733 */  _Binary_iRegP_iRegP_rule,
  /* 1734 */  _Binary_iRegP_iRegP_rule,
  /* 1735 */  _Binary_iRegP_iRegP_rule,
  /* 1736 */  _Binary_iRegP_iRegP_rule,
  /* 1737 */  _Binary_iRegP_iRegP_rule,
  /* 1738 */  _Binary_iRegP_iRegP_rule,
  /* 1739 */  iRegP_rule,
  /* 1740 */  iRegP_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMIEXT",
  /*   13 */  "IMMI_GT_1",
  /*   14 */  "IMMI_LE_4",
  /*   15 */  "IMMI_16",
  /*   16 */  "IMMI_24",
  /*   17 */  "IMMI_32",
  /*   18 */  "IMMI_48",
  /*   19 */  "IMMI_56",
  /*   20 */  "IMMI_63",
  /*   21 */  "IMMI_64",
  /*   22 */  "IMMI_255",
  /*   23 */  "IMMI_65535",
  /*   24 */  "IMMI_POSITIVE",
  /*   25 */  "IMMI_CMP_COND",
  /*   26 */  "IMMI_CMPU_COND",
  /*   27 */  "IMML_255",
  /*   28 */  "IMML_65535",
  /*   29 */  "IMML_4294967295",
  /*   30 */  "IMML_BITMASK",
  /*   31 */  "IMMI_BITMASK",
  /*   32 */  "IMML_POSITIVE_BITMASKI",
  /*   33 */  "IMMISCALE",
  /*   34 */  "IMMI26",
  /*   35 */  "IMMI19",
  /*   36 */  "IMMI5",
  /*   37 */  "IMMIU7",
  /*   38 */  "IMMIU12",
  /*   39 */  "IMMLU12",
  /*   40 */  "IMMIOFFSET",
  /*   41 */  "IMMIOFFSET1",
  /*   42 */  "IMMIOFFSET2",
  /*   43 */  "IMMIOFFSET4",
  /*   44 */  "IMMIOFFSET8",
  /*   45 */  "IMMIOFFSET16",
  /*   46 */  "IMMLOFFSET",
  /*   47 */  "IMMLOFFSET1",
  /*   48 */  "IMMLOFFSET2",
  /*   49 */  "IMMLOFFSET4",
  /*   50 */  "IMMLOFFSET8",
  /*   51 */  "IMMLOFFSET16",
  /*   52 */  "IMML5",
  /*   53 */  "IMMLU7",
  /*   54 */  "IMMI8",
  /*   55 */  "IMMI8_SHIFT8",
  /*   56 */  "IMML8_SHIFT8",
  /*   57 */  "IMMBADDSUBV",
  /*   58 */  "IMMIADDSUB",
  /*   59 */  "IMMIADDSUBV",
  /*   60 */  "IMMBLOG",
  /*   61 */  "IMMSLOG",
  /*   62 */  "IMMILOG",
  /*   63 */  "IMML",
  /*   64 */  "IMML0",
  /*   65 */  "IMML_1",
  /*   66 */  "IMML_M1",
  /*   67 */  "IMML_PC_OFF",
  /*   68 */  "IMMLADDSUB",
  /*   69 */  "IMMLADDSUBV",
  /*   70 */  "IMMLLOG",
  /*   71 */  "IMML_32BITS",
  /*   72 */  "IMMP",
  /*   73 */  "IMMP0",
  /*   74 */  "IMMP_1",
  /*   75 */  "IMMBYTEMAPBASE",
  /*   76 */  "IMMP_M1",
  /*   77 */  "IMMP_M2",
  /*   78 */  "IMMD",
  /*   79 */  "IMMD0",
  /*   80 */  "IMMDPACKED",
  /*   81 */  "IMMF",
  /*   82 */  "IMMF0",
  /*   83 */  "IMMFPACKED",
  /*   84 */  "IMMN",
  /*   85 */  "IMMN0",
  /*   86 */  "IMMNKLASS",
  /*   87 */  "IREGI",
  /*   88 */  "IREGINOSP",
  /*   89 */  "IREGL",
  /*   90 */  "IREGLNOSP",
  /*   91 */  "IREGP",
  /*   92 */  "IREGPNOSP",
  /*   93 */  "IREGP_R0",
  /*   94 */  "IREGP_R1",
  /*   95 */  "IREGP_R2",
  /*   96 */  "IREGP_R3",
  /*   97 */  "IREGP_R4",
  /*   98 */  "IREGP_R5",
  /*   99 */  "IREGP_R10",
  /*  100 */  "IREGL_R0",
  /*  101 */  "IREGL_R2",
  /*  102 */  "IREGL_R3",
  /*  103 */  "IREGL_R11",
  /*  104 */  "IREGP_FP",
  /*  105 */  "IREGI_R0",
  /*  106 */  "IREGI_R2",
  /*  107 */  "IREGI_R3",
  /*  108 */  "IREGI_R4",
  /*  109 */  "IREGN",
  /*  110 */  "IREGN_R0",
  /*  111 */  "IREGN_R2",
  /*  112 */  "IREGN_R3",
  /*  113 */  "IREGNNOSP",
  /*  114 */  "VREGF",
  /*  115 */  "VREGD",
  /*  116 */  "VREG",
  /*  117 */  "VECA",
  /*  118 */  "VECD",
  /*  119 */  "VECX",
  /*  120 */  "VREGD_V0",
  /*  121 */  "VREGD_V1",
  /*  122 */  "VREGD_V2",
  /*  123 */  "VREGD_V3",
  /*  124 */  "VREGD_V4",
  /*  125 */  "VREGD_V5",
  /*  126 */  "VREGD_V6",
  /*  127 */  "VREGD_V7",
  /*  128 */  "VREGD_V8",
  /*  129 */  "VREGD_V9",
  /*  130 */  "VREGD_V10",
  /*  131 */  "VREGD_V11",
  /*  132 */  "VREGD_V12",
  /*  133 */  "VREGD_V13",
  /*  134 */  "VREGD_V14",
  /*  135 */  "VREGD_V15",
  /*  136 */  "VREGD_V16",
  /*  137 */  "VREGD_V17",
  /*  138 */  "VREGD_V18",
  /*  139 */  "VREGD_V19",
  /*  140 */  "VREGD_V20",
  /*  141 */  "VREGD_V21",
  /*  142 */  "VREGD_V22",
  /*  143 */  "VREGD_V23",
  /*  144 */  "VREGD_V24",
  /*  145 */  "VREGD_V25",
  /*  146 */  "VREGD_V26",
  /*  147 */  "VREGD_V27",
  /*  148 */  "VREGD_V28",
  /*  149 */  "VREGD_V29",
  /*  150 */  "VREGD_V30",
  /*  151 */  "VREGD_V31",
  /*  152 */  "PREG",
  /*  153 */  "PREGGOV",
  /*  154 */  "PREGGOV_P0",
  /*  155 */  "PREGGOV_P1",
  /*  156 */  "RFLAGSREG",
  /*  157 */  "RFLAGSREGU",
  /*  158 */  "INLINE_CACHE_REGP",
  /*  159 */  "THREAD_REGP",
  /*  160 */  "LR_REGP",
  /*  161 */  "INDIRECT",
  /*  162 */  "INDINDEXSCALEDI2L",
  /*  163 */  "INDINDEXSCALED",
  /*  164 */  "INDINDEXI2L",
  /*  165 */  "INDINDEX",
  /*  166 */  "INDOFFI",
  /*  167 */  "INDOFFI1",
  /*  168 */  "INDOFFI2",
  /*  169 */  "INDOFFI4",
  /*  170 */  "INDOFFI8",
  /*  171 */  "INDOFFI16",
  /*  172 */  "INDOFFL",
  /*  173 */  "INDOFFL1",
  /*  174 */  "INDOFFL2",
  /*  175 */  "INDOFFL4",
  /*  176 */  "INDOFFL8",
  /*  177 */  "INDOFFL16",
  /*  178 */  "INDIRECTN",
  /*  179 */  "INDINDEXSCALEDI2LN",
  /*  180 */  "INDINDEXSCALEDN",
  /*  181 */  "INDINDEXI2LN",
  /*  182 */  "INDINDEXN",
  /*  183 */  "INDOFFIN",
  /*  184 */  "INDOFFLN",
  /*  185 */  "THREAD_ANCHOR_PC",
  /*  186 */  "STACKSLOTP",
  /*  187 */  "STACKSLOTI",
  /*  188 */  "STACKSLOTF",
  /*  189 */  "STACKSLOTD",
  /*  190 */  "STACKSLOTL",
  /*  191 */  "CMPOP",
  /*  192 */  "CMPOPU",
  /*  193 */  "CMPOPEQNE",
  /*  194 */  "CMPOPLTGE",
  /*  195 */  "CMPOPUEQNELTGE",
  /*  196 */  "IREGL2I",
  /*  197 */  "VMEMA_IMMIOFFSET4",
  /*  198 */  "VMEMA_IMMLOFFSET4",
  /*  199 */  "VMEMA_INDOFFI4",
  /*  200 */  "VMEMA_INDOFFL4",
  // last operand
  /*  201 */  "VMEM2",
  /*  202 */  "VMEM4",
  /*  203 */  "VMEM8",
  /*  204 */  "VMEM16",
  /*  205 */  "MEMORY1",
  /*  206 */  "MEMORY2",
  /*  207 */  "MEMORY4",
  /*  208 */  "MEMORY8",
  /*  209 */  "MEMORY",
  /*  210 */  "IREGIORL2I",
  /*  211 */  "VMEMA",
  // last operand class
  /*  212 */  "_ConvI2L_iRegI_",
  /*  213 */  "_LShiftL__ConvI2L_iRegI__immIScale",
  /*  214 */  "_LShiftL_iRegL_immIScale",
  /*  215 */  "_DecodeN_iRegN_",
  /*  216 */  "_LoadB_memory1_",
  /*  217 */  "_LoadUB_memory1_",
  /*  218 */  "_LoadS_memory2_",
  /*  219 */  "_LoadUS_memory2_",
  /*  220 */  "_LoadI_memory4_",
  /*  221 */  "_ConvI2L__LoadI_memory4__",
  /*  222 */  "_LoadB_indirect_",
  /*  223 */  "_LoadUB_indirect_",
  /*  224 */  "_LoadUS_indirect_",
  /*  225 */  "_LoadS_indirect_",
  /*  226 */  "_LoadI_indirect_",
  /*  227 */  "_ConvI2L__LoadI_indirect__",
  /*  228 */  "_LoadL_memory8_",
  /*  229 */  "_CastP2X_iRegP_",
  /*  230 */  "_CastP2X__DecodeN_iRegN__",
  /*  231 */  "_Binary_iRegINoSp_iRegINoSp",
  /*  232 */  "_Binary_iRegLNoSp_iRegLNoSp",
  /*  233 */  "_Binary_iRegP_iRegP",
  /*  234 */  "_Binary_iRegNNoSp_iRegNNoSp",
  /*  235 */  "_Binary_iRegI_iRegI",
  /*  236 */  "_Binary_iRegL_iRegL",
  /*  237 */  "_Binary_iRegN_iRegN",
  /*  238 */  "_Binary_cmpOp_rFlagsReg",
  /*  239 */  "_Binary_iRegIorL2I_iRegIorL2I",
  /*  240 */  "_Binary_cmpOpU_rFlagsRegU",
  /*  241 */  "_Binary_immI0_iRegIorL2I",
  /*  242 */  "_Binary_iRegIorL2I_immI0",
  /*  243 */  "_Binary_immI_1_immI0",
  /*  244 */  "_Binary_iRegL_immL0",
  /*  245 */  "_Binary_immL0_iRegL",
  /*  246 */  "_Binary_iRegP_immP0",
  /*  247 */  "_Binary_immP0_iRegP",
  /*  248 */  "_Binary_iRegN_immN0",
  /*  249 */  "_Binary_immN0_iRegN",
  /*  250 */  "_Binary_vRegF_vRegF",
  /*  251 */  "_Binary_vRegD_vRegD",
  /*  252 */  "_ConvL2I_iRegL_",
  /*  253 */  "_ConvI2L_iRegIorL2I_",
  /*  254 */  "_LShiftL__ConvI2L_iRegIorL2I__immIScale",
  /*  255 */  "_MulI_iRegIorL2I_iRegIorL2I",
  /*  256 */  "_SubI_immI0_iRegIorL2I",
  /*  257 */  "_MulL_iRegL_iRegL",
  /*  258 */  "_SubL_immL0_iRegL",
  /*  259 */  "_MulL__ConvI2L_iRegIorL2I___ConvI2L_iRegIorL2I_",
  /*  260 */  "_SubL_immL0__ConvI2L_iRegIorL2I_",
  /*  261 */  "_URShiftI_iRegIorL2I_immI",
  /*  262 */  "_RShiftI_iRegIorL2I_immI",
  /*  263 */  "_LShiftI_iRegIorL2I_immI",
  /*  264 */  "_URShiftL_iRegL_immI",
  /*  265 */  "_RShiftL_iRegL_immI",
  /*  266 */  "_LShiftL_iRegL_immI",
  /*  267 */  "_XorI_iRegIorL2I_immI_M1",
  /*  268 */  "_XorL_iRegL_immL_M1",
  /*  269 */  "_XorI_iRegIorL2I_iRegIorL2I",
  /*  270 */  "_XorL_iRegL_iRegL",
  /*  271 */  "_XorI__URShiftI_iRegIorL2I_immI_immI_M1",
  /*  272 */  "_XorL__URShiftL_iRegL_immI_immL_M1",
  /*  273 */  "_XorI__RShiftI_iRegIorL2I_immI_immI_M1",
  /*  274 */  "_XorL__RShiftL_iRegL_immI_immL_M1",
  /*  275 */  "_RotateRight_iRegIorL2I_immI",
  /*  276 */  "_XorI__RotateRight_iRegIorL2I_immI_immI_M1",
  /*  277 */  "_RotateRight_iRegL_immI",
  /*  278 */  "_XorL__RotateRight_iRegL_immI_immL_M1",
  /*  279 */  "_XorI__LShiftI_iRegIorL2I_immI_immI_M1",
  /*  280 */  "_XorL__LShiftL_iRegL_immI_immL_M1",
  /*  281 */  "_XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  282 */  "_XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI",
  /*  283 */  "_XorL__URShiftL_iRegL_immI_iRegL",
  /*  284 */  "_XorL_iRegL__URShiftL_iRegL_immI",
  /*  285 */  "_XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  286 */  "_XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI",
  /*  287 */  "_XorL__RShiftL_iRegL_immI_iRegL",
  /*  288 */  "_XorL_iRegL__RShiftL_iRegL_immI",
  /*  289 */  "_XorI__RotateRight_iRegIorL2I_immI_iRegIorL2I",
  /*  290 */  "_XorI_iRegIorL2I__RotateRight_iRegIorL2I_immI",
  /*  291 */  "_XorL__RotateRight_iRegL_immI_iRegL",
  /*  292 */  "_XorL_iRegL__RotateRight_iRegL_immI",
  /*  293 */  "_XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  294 */  "_XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI",
  /*  295 */  "_XorL__LShiftL_iRegL_immI_iRegL",
  /*  296 */  "_XorL_iRegL__LShiftL_iRegL_immI",
  /*  297 */  "_AndI__URShiftI_iRegIorL2I_immI_immI_bitmask",
  /*  298 */  "_AndI_iRegIorL2I_immI_bitmask",
  /*  299 */  "_AndL_iRegL_immL_bitmask",
  /*  300 */  "_LShiftI__AndI_iRegIorL2I_immI_bitmask_immI",
  /*  301 */  "_AndL_iRegL_immL_positive_bitmaskI",
  /*  302 */  "_LShiftL__AndL_iRegL_immL_positive_bitmaskI_immI",
  /*  303 */  "_ConvI2L__AndI_iRegIorL2I_immI_bitmask_",
  /*  304 */  "_ConvL2I__AndL_iRegL_immL_positive_bitmaskI_",
  /*  305 */  "_AndI_iRegI_immI_bitmask",
  /*  306 */  "_LShiftI_iRegIorL2I_immI_16",
  /*  307 */  "_RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16",
  /*  308 */  "_LShiftI_iRegIorL2I_immI_24",
  /*  309 */  "_RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  310 */  "_URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  311 */  "_LShiftL_iRegL_immI_48",
  /*  312 */  "_RShiftL__LShiftL_iRegL_immI_48_immI_48",
  /*  313 */  "_LShiftL_iRegL_immI_32",
  /*  314 */  "_RShiftL__LShiftL_iRegL_immI_32_immI_32",
  /*  315 */  "_LShiftL_iRegL_immI_56",
  /*  316 */  "_RShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  317 */  "_URShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  318 */  "_AndI_iRegIorL2I_immI_255",
  /*  319 */  "_AndI_iRegIorL2I_immI_65535",
  /*  320 */  "_AndL_iRegL_immL_255",
  /*  321 */  "_AndL_iRegL_immL_65535",
  /*  322 */  "_AndL_iRegL_immL_4294967295",
  /*  323 */  "_LShiftL__RShiftL__LShiftL_iRegL_immI_56_immI_56_immIExt",
  /*  324 */  "_LShiftL__RShiftL__LShiftL_iRegL_immI_48_immI_48_immIExt",
  /*  325 */  "_LShiftL__RShiftL__LShiftL_iRegL_immI_32_immI_32_immIExt",
  /*  326 */  "_LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_immIExt",
  /*  327 */  "_LShiftI__RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_immIExt",
  /*  328 */  "_LShiftL__ConvI2L_iRegIorL2I__immIExt",
  /*  329 */  "_LShiftL__AndL_iRegL_immL_255_immIExt",
  /*  330 */  "_LShiftL__AndL_iRegL_immL_65535_immIExt",
  /*  331 */  "_LShiftL__AndL_iRegL_immL_4294967295_immIExt",
  /*  332 */  "_LShiftI__AndI_iRegIorL2I_immI_255_immIExt",
  /*  333 */  "_LShiftI__AndI_iRegIorL2I_immI_65535_immIExt",
  /*  334 */  "_NegF_vRegF_",
  /*  335 */  "_Binary_vRegF__NegF_vRegF_",
  /*  336 */  "_NegD_vRegD_",
  /*  337 */  "_Binary_vRegD__NegD_vRegD_",
  /*  338 */  "_SubF_vRegF_vRegF",
  /*  339 */  "_SubD_vRegD_vRegD",
  /*  340 */  "_OverflowMulI_iRegIorL2I_iRegIorL2I",
  /*  341 */  "_OverflowMulL_iRegL_iRegL",
  /*  342 */  "_CmpI_iRegIorL2I_immI0",
  /*  343 */  "_CmpL_iRegL_immL0",
  /*  344 */  "_CmpP_iRegP_immP0",
  /*  345 */  "_CmpN_iRegN_immN0",
  /*  346 */  "_CmpP__DecodeN_iRegN__immP0",
  /*  347 */  "_CmpU_iRegIorL2I_immI0",
  /*  348 */  "_CmpUL_iRegL_immL0",
  /*  349 */  "_AndL_iRegL_immL",
  /*  350 */  "_CmpL__AndL_iRegL_immL_immL0",
  /*  351 */  "_AndI_iRegIorL2I_immI",
  /*  352 */  "_CmpI__AndI_iRegIorL2I_immI_immI0",
  /*  353 */  "_AndL_iRegL_iRegL",
  /*  354 */  "_AndI_iRegIorL2I_iRegIorL2I",
  /*  355 */  "_PartialSubtypeCheck_iRegP_R4_iRegP_R0",
  /*  356 */  "_Binary_iRegP_R1_iRegI_R2",
  /*  357 */  "_Binary_iRegP_R3_iRegI_R4",
  /*  358 */  "_Binary_iRegP_R1_iRegI_R4",
  /*  359 */  "_Binary_iRegP_R3_iRegI_R2",
  /*  360 */  "_Binary_iRegP_R3_immI_le_4",
  /*  361 */  "_Binary_iRegP_R3_immI_1",
  /*  362 */  "_Binary_iRegP_R1_iRegP_R3",
  /*  363 */  "_Binary_iRegP_R1_iRegI_R3",
  /*  364 */  "_Binary_vReg_pRegGov",
  /*  365 */  "_Binary_vReg_vReg",
  /*  366 */  "_Replicate_immBAddSubV_",
  /*  367 */  "_Replicate_immIAddSubV_",
  /*  368 */  "_Replicate_immLAddSubV_",
  /*  369 */  "_Replicate_immBLog_",
  /*  370 */  "_Replicate_immSLog_",
  /*  371 */  "_Replicate_immILog_",
  /*  372 */  "_Replicate_immLLog_",
  /*  373 */  "_XorV_vReg_vReg",
  /*  374 */  "_Replicate_immI_M1_",
  /*  375 */  "_Replicate_immL_M1_",
  /*  376 */  "_Binary_vReg__Replicate_immI_M1_",
  /*  377 */  "_Binary_vReg__Replicate_immL_M1_",
  /*  378 */  "_XorV_vReg__Replicate_immI_M1_",
  /*  379 */  "_XorV__Replicate_immI_M1__vReg",
  /*  380 */  "_XorV_vReg__Replicate_immL_M1_",
  /*  381 */  "_XorV__Replicate_immL_M1__vReg",
  /*  382 */  "_Binary_vReg__XorV_vReg__Replicate_immI_M1_",
  /*  383 */  "_Binary_vReg__XorV__Replicate_immI_M1__vReg",
  /*  384 */  "_Binary_vReg__XorV_vReg__Replicate_immL_M1_",
  /*  385 */  "_Binary_vReg__XorV__Replicate_immL_M1__vReg",
  /*  386 */  "_SubVF_vReg_vReg",
  /*  387 */  "_SubVD_vReg_vReg",
  /*  388 */  "_SubVF__Binary_vReg_vReg_pRegGov",
  /*  389 */  "_SubVD__Binary_vReg_vReg_pRegGov",
  /*  390 */  "_MulVB_vReg_vReg",
  /*  391 */  "_MulVS_vReg_vReg",
  /*  392 */  "_MulVI_vReg_vReg",
  /*  393 */  "_MulVL_vReg_vReg",
  /*  394 */  "_Binary_vReg__MulVB_vReg_vReg",
  /*  395 */  "_Binary_vReg__MulVS_vReg_vReg",
  /*  396 */  "_Binary_vReg__MulVI_vReg_vReg",
  /*  397 */  "_Binary_vReg__MulVL_vReg_vReg",
  /*  398 */  "_NegVF_vReg_",
  /*  399 */  "_Binary_vReg__NegVF_vReg_",
  /*  400 */  "_NegVD_vReg_",
  /*  401 */  "_Binary_vReg__NegVD_vReg_",
  /*  402 */  "_Binary__NegVF_vReg__pRegGov",
  /*  403 */  "_Binary__NegVD_vReg__pRegGov",
  /*  404 */  "_LShiftCntV_immI_",
  /*  405 */  "_RShiftCntV_immI_positive_",
  /*  406 */  "_RShiftVB_vReg__RShiftCntV_immI_positive_",
  /*  407 */  "_RShiftVS_vReg__RShiftCntV_immI_positive_",
  /*  408 */  "_RShiftVI_vReg__RShiftCntV_immI_positive_",
  /*  409 */  "_RShiftVL_vReg__RShiftCntV_immI_positive_",
  /*  410 */  "_URShiftVB_vReg__RShiftCntV_immI_positive_",
  /*  411 */  "_URShiftVS_vReg__RShiftCntV_immI_positive_",
  /*  412 */  "_URShiftVI_vReg__RShiftCntV_immI_positive_",
  /*  413 */  "_URShiftVL_vReg__RShiftCntV_immI_positive_",
  /*  414 */  "_Binary_vReg__LShiftCntV_immI_",
  /*  415 */  "_Binary_vReg__RShiftCntV_immI_positive_",
  /*  416 */  "_Binary_iRegIorL2I_vReg",
  /*  417 */  "_Binary_iRegL_vReg",
  /*  418 */  "_Binary_vRegF_vReg",
  /*  419 */  "_Binary_vRegD_vReg",
  /*  420 */  "_Binary_vReg_iRegIorL2I",
  /*  421 */  "_Binary_vReg_iRegL",
  /*  422 */  "_Binary_vReg_vRegF",
  /*  423 */  "_Binary_vReg_vRegD",
  /*  424 */  "_LoadVector_indirect_",
  /*  425 */  "_LoadVectorMasked_vmemA_pRegGov",
  /*  426 */  "_VectorStoreMask_pReg_immI_gt_1",
  /*  427 */  "_Binary__VectorStoreMask_pReg_immI_gt_1_pRegGov",
  /*  428 */  "_MaskAll_immI_M1_",
  /*  429 */  "_XorVMask_pReg__MaskAll_immI_M1_",
  /*  430 */  "_MaskAll_immL_M1_",
  /*  431 */  "_XorVMask_pReg__MaskAll_immL_M1_",
  /*  432 */  "_Replicate_immI0_",
  /*  433 */  "_Binary_vReg__Replicate_immI0_",
  /*  434 */  "_Replicate_immL0_",
  /*  435 */  "_Binary_vReg__Replicate_immL0_",
  /*  436 */  "_Replicate_immF0_",
  /*  437 */  "_Binary_vReg__Replicate_immF0_",
  /*  438 */  "_Replicate_immD0_",
  /*  439 */  "_Binary_vReg__Replicate_immD0_",
  /*  440 */  "_Replicate_immI5_",
  /*  441 */  "_Binary_vReg__Replicate_immI5_",
  /*  442 */  "_Replicate_immIU7_",
  /*  443 */  "_Binary_vReg__Replicate_immIU7_",
  /*  444 */  "_Replicate_immL5_",
  /*  445 */  "_Binary_vReg__Replicate_immL5_",
  /*  446 */  "_Replicate_immLU7_",
  /*  447 */  "_Binary_vReg__Replicate_immLU7_",
  /*  448 */  "_Binary_immI_pRegGov",
  /*  449 */  "_VectorStoreMask_vReg_immI_gt_1",
  /*  450 */  "_SubL_iRegL_iRegL",
  /*  451 */  "_Binary_vReg__Binary_vReg_pRegGov",
  // last internally defined operand
  /*  452 */  "loadConI",
  /*  453 */  "loadConL",
  /*  454 */  "loadConP",
  /*  455 */  "loadConP0",
  /*  456 */  "loadConP1",
  /*  457 */  "loadByteMapBase",
  /*  458 */  "loadConN",
  /*  459 */  "loadConN0",
  /*  460 */  "loadConNKlass",
  /*  461 */  "loadConF_packed",
  /*  462 */  "loadConF",
  /*  463 */  "loadConD_packed",
  /*  464 */  "loadConD",
  /*  465 */  "countLeadingZerosI",
  /*  466 */  "countLeadingZerosL",
  /*  467 */  "countTrailingZerosI",
  /*  468 */  "countTrailingZerosL",
  /*  469 */  "castX2P",
  /*  470 */  "castP2X",
  /*  471 */  "checkCastPP",
  /*  472 */  "castPP",
  /*  473 */  "castII",
  /*  474 */  "castLL",
  /*  475 */  "castFF",
  /*  476 */  "castDD",
  /*  477 */  "castVV",
  /*  478 */  "castVVMask",
  /*  479 */  "bits_reverse_I",
  /*  480 */  "bits_reverse_L",
  /*  481 */  "negF_reg_reg",
  /*  482 */  "negD_reg_reg",
  /*  483 */  "absF_reg",
  /*  484 */  "absD_reg",
  /*  485 */  "MoveF2I_stack_reg",
  /*  486 */  "MoveI2F_stack_reg",
  /*  487 */  "MoveD2L_stack_reg",
  /*  488 */  "MoveL2D_stack_reg",
  /*  489 */  "MoveF2I_reg_reg",
  /*  490 */  "MoveI2F_reg_reg",
  /*  491 */  "MoveD2L_reg_reg",
  /*  492 */  "MoveL2D_reg_reg",
  /*  493 */  "overflowAddI_reg_reg",
  /*  494 */  "overflowAddI_reg_imm",
  /*  495 */  "overflowAddL_reg_reg",
  /*  496 */  "overflowAddL_reg_imm",
  /*  497 */  "overflowSubI_reg_reg",
  /*  498 */  "overflowSubI_reg_imm",
  /*  499 */  "overflowSubL_reg_reg",
  /*  500 */  "overflowSubL_reg_imm",
  /*  501 */  "overflowNegI_reg",
  /*  502 */  "overflowNegL_reg",
  /*  503 */  "overflowMulI_reg",
  /*  504 */  "overflowMulL_reg",
  /*  505 */  "compI_reg_reg",
  /*  506 */  "compI_reg_immI0",
  /*  507 */  "compI_reg_immIAddSub",
  /*  508 */  "compI_reg_immI",
  /*  509 */  "compU_reg_reg",
  /*  510 */  "compU_reg_immI0",
  /*  511 */  "compU_reg_immIAddSub",
  /*  512 */  "compU_reg_immI",
  /*  513 */  "compL_reg_reg",
  /*  514 */  "compL_reg_immL0",
  /*  515 */  "compL_reg_immLAddSub",
  /*  516 */  "compL_reg_immL",
  /*  517 */  "compUL_reg_reg",
  /*  518 */  "compUL_reg_immL0",
  /*  519 */  "compUL_reg_immLAddSub",
  /*  520 */  "compUL_reg_immL",
  /*  521 */  "compP_reg_reg",
  /*  522 */  "compN_reg_reg",
  /*  523 */  "testP_reg",
  /*  524 */  "testN_reg",
  /*  525 */  "compF_reg_reg",
  /*  526 */  "compF_reg_zero",
  /*  527 */  "compD_reg_reg",
  /*  528 */  "compD_reg_zero",
  /*  529 */  "compI_reg_imm0",
  /*  530 */  "cmpL_and",
  /*  531 */  "cmpI_and",
  /*  532 */  "cmpL_and_reg",
  /*  533 */  "cmpI_and_reg",
  /*  534 */  "cmpFastLock",
  /*  535 */  "cmpFastUnlock",
  /*  536 */  "partialSubtypeCheckVsZero",
  /*  537 */  "tlsLoadP",
  /*  538 */  "vloadcon",
  /*  539 */  "vabsB",
  /*  540 */  "vabsS",
  /*  541 */  "vabsI",
  /*  542 */  "vabsL",
  /*  543 */  "vabsF",
  /*  544 */  "vabsD",
  /*  545 */  "vnegI",
  /*  546 */  "vnegL",
  /*  547 */  "vnegF",
  /*  548 */  "vnegD",
  /*  549 */  "vsqrtF",
  /*  550 */  "vsqrtD",
  /*  551 */  "vshiftcntL",
  /*  552 */  "vshiftcntR",
  /*  553 */  "reinterpret_same_size",
  /*  554 */  "reinterpret_resize_le128b",
  /*  555 */  "vzeroExtBtoX",
  /*  556 */  "vzeroExtStoX",
  /*  557 */  "vzeroExtItoX",
  /*  558 */  "vcvtBtoX",
  /*  559 */  "vcvtStoB_neon",
  /*  560 */  "vcvtStoX_extend",
  /*  561 */  "vcvtItoX",
  /*  562 */  "vcvtLtoI_neon",
  /*  563 */  "vcvtLtoD",
  /*  564 */  "vcvtFtoX",
  /*  565 */  "vcvtDtoL",
  /*  566 */  "vcvtDtoF_64b",
  /*  567 */  "vcvtHFtoF",
  /*  568 */  "vcvtFtoHF_neon",
  /*  569 */  "replicateI",
  /*  570 */  "replicateL",
  /*  571 */  "replicateF",
  /*  572 */  "replicateD",
  /*  573 */  "replicateI_imm_le128b",
  /*  574 */  "replicateB_imm8_gt128b",
  /*  575 */  "replicateI_imm8_gt128b",
  /*  576 */  "replicateL_imm_128b",
  /*  577 */  "replicateL_imm8_gt128b",
  /*  578 */  "vloadmask_neon",
  /*  579 */  "vmaskcast_same_esize_neon",
  /*  580 */  "vmaskcast_extend_neon",
  /*  581 */  "vmaskcast_narrow_neon",
  /*  582 */  "vmaskcast_same_esize_sve",
  /*  583 */  "vmaskcast_extend_sve",
  /*  584 */  "vmask_reinterpret_same_esize",
  /*  585 */  "vmask_truecount_sve",
  /*  586 */  "vmask_firsttrue_neon",
  /*  587 */  "vmask_lasttrue_neon",
  /*  588 */  "vmask_tolong_neon",
  /*  589 */  "vpopcountI",
  /*  590 */  "vpopcountL",
  /*  591 */  "vtest_anytrue_neon",
  /*  592 */  "vtest_anytrue_sve",
  /*  593 */  "vtest_alltrue_neon",
  /*  594 */  "vtest_alltrue_sve",
  /*  595 */  "loadshuffle",
  /*  596 */  "vcountLeadingZeros",
  /*  597 */  "vcountTrailingZeros",
  /*  598 */  "vreverse",
  /*  599 */  "vreverseBytes",
  /*  600 */  "loadB",
  /*  601 */  "loadB2L",
  /*  602 */  "loadUB",
  /*  603 */  "loadUB2L",
  /*  604 */  "loadS",
  /*  605 */  "loadS2L",
  /*  606 */  "loadUS",
  /*  607 */  "loadUS2L",
  /*  608 */  "loadI",
  /*  609 */  "loadI2L",
  /*  610 */  "loadUI2L",
  /*  611 */  "loadL",
  /*  612 */  "loadRange",
  /*  613 */  "loadP",
  /*  614 */  "loadN",
  /*  615 */  "loadKlass",
  /*  616 */  "loadNKlass",
  /*  617 */  "loadF",
  /*  618 */  "loadD",
  /*  619 */  "storeimmCM0",
  /*  620 */  "storeimmCM0_ordered",
  /*  621 */  "storeB",
  /*  622 */  "storeimmB0",
  /*  623 */  "storeC",
  /*  624 */  "storeimmC0",
  /*  625 */  "storeI",
  /*  626 */  "storeimmI0",
  /*  627 */  "storeL",
  /*  628 */  "storeimmL0",
  /*  629 */  "storeP",
  /*  630 */  "storeimmP0",
  /*  631 */  "storeN",
  /*  632 */  "storeImmN0",
  /*  633 */  "storeF",
  /*  634 */  "storeD",
  /*  635 */  "storeNKlass",
  /*  636 */  "prefetchalloc",
  /*  637 */  "loadB_volatile",
  /*  638 */  "loadB2L_volatile",
  /*  639 */  "loadUB_volatile",
  /*  640 */  "loadUB2L_volatile",
  /*  641 */  "loadS_volatile",
  /*  642 */  "loadUS_volatile",
  /*  643 */  "loadUS2L_volatile",
  /*  644 */  "loadS2L_volatile",
  /*  645 */  "loadI_volatile",
  /*  646 */  "loadUI2L_volatile",
  /*  647 */  "loadL_volatile",
  /*  648 */  "loadP_volatile",
  /*  649 */  "loadN_volatile",
  /*  650 */  "loadF_volatile",
  /*  651 */  "loadD_volatile",
  /*  652 */  "storeB_volatile",
  /*  653 */  "storeimmB0_volatile",
  /*  654 */  "storeC_volatile",
  /*  655 */  "storeimmC0_volatile",
  /*  656 */  "storeI_volatile",
  /*  657 */  "storeimmI0_volatile",
  /*  658 */  "storeL_volatile",
  /*  659 */  "storeimmL0_volatile",
  /*  660 */  "storeP_volatile",
  /*  661 */  "storeimmP0_volatile",
  /*  662 */  "storeN_volatile",
  /*  663 */  "storeimmN0_volatile",
  /*  664 */  "storeF_volatile",
  /*  665 */  "storeD_volatile",
  /*  666 */  "cacheWB",
  /*  667 */  "cacheWBPreSync",
  /*  668 */  "cacheWBPostSync",
  /*  669 */  "bytes_reverse_int",
  /*  670 */  "bytes_reverse_long",
  /*  671 */  "bytes_reverse_unsigned_short",
  /*  672 */  "bytes_reverse_short",
  /*  673 */  "popCountI",
  /*  674 */  "popCountI_mem",
  /*  675 */  "popCountL",
  /*  676 */  "popCountL_mem",
  /*  677 */  "load_fence",
  /*  678 */  "unnecessary_membar_acquire",
  /*  679 */  "membar_acquire",
  /*  680 */  "membar_acquire_lock",
  /*  681 */  "store_fence",
  /*  682 */  "unnecessary_membar_release",
  /*  683 */  "membar_release",
  /*  684 */  "membar_storestore",
  /*  685 */  "membar_storestore_0",
  /*  686 */  "membar_release_lock",
  /*  687 */  "unnecessary_membar_volatile",
  /*  688 */  "membar_volatile",
  /*  689 */  "convP2I",
  /*  690 */  "convN2I",
  /*  691 */  "encodeHeapOop",
  /*  692 */  "encodeHeapOop_not_null",
  /*  693 */  "decodeHeapOop",
  /*  694 */  "decodeHeapOop_not_null",
  /*  695 */  "encodeKlass_not_null",
  /*  696 */  "decodeKlass_not_null",
  /*  697 */  "compareAndSwapB",
  /*  698 */  "compareAndSwapS",
  /*  699 */  "compareAndSwapI",
  /*  700 */  "compareAndSwapL",
  /*  701 */  "compareAndSwapP",
  /*  702 */  "compareAndSwapN",
  /*  703 */  "compareAndSwapBAcq",
  /*  704 */  "compareAndSwapSAcq",
  /*  705 */  "compareAndSwapIAcq",
  /*  706 */  "compareAndSwapLAcq",
  /*  707 */  "compareAndSwapPAcq",
  /*  708 */  "compareAndSwapNAcq",
  /*  709 */  "compareAndExchangeB",
  /*  710 */  "compareAndExchangeS",
  /*  711 */  "compareAndExchangeI",
  /*  712 */  "compareAndExchangeL",
  /*  713 */  "compareAndExchangeN",
  /*  714 */  "compareAndExchangeP",
  /*  715 */  "compareAndExchangeBAcq",
  /*  716 */  "compareAndExchangeSAcq",
  /*  717 */  "compareAndExchangeIAcq",
  /*  718 */  "compareAndExchangeLAcq",
  /*  719 */  "compareAndExchangeNAcq",
  /*  720 */  "compareAndExchangePAcq",
  /*  721 */  "weakCompareAndSwapB",
  /*  722 */  "weakCompareAndSwapS",
  /*  723 */  "weakCompareAndSwapI",
  /*  724 */  "weakCompareAndSwapL",
  /*  725 */  "weakCompareAndSwapN",
  /*  726 */  "weakCompareAndSwapP",
  /*  727 */  "weakCompareAndSwapBAcq",
  /*  728 */  "weakCompareAndSwapSAcq",
  /*  729 */  "weakCompareAndSwapIAcq",
  /*  730 */  "weakCompareAndSwapLAcq",
  /*  731 */  "weakCompareAndSwapNAcq",
  /*  732 */  "weakCompareAndSwapPAcq",
  /*  733 */  "get_and_setI",
  /*  734 */  "get_and_setL",
  /*  735 */  "get_and_setN",
  /*  736 */  "get_and_setP",
  /*  737 */  "get_and_setIAcq",
  /*  738 */  "get_and_setLAcq",
  /*  739 */  "get_and_setNAcq",
  /*  740 */  "get_and_setPAcq",
  /*  741 */  "get_and_addL",
  /*  742 */  "get_and_addL_no_res",
  /*  743 */  "get_and_addLi",
  /*  744 */  "get_and_addLi_no_res",
  /*  745 */  "get_and_addI",
  /*  746 */  "get_and_addI_no_res",
  /*  747 */  "get_and_addIi",
  /*  748 */  "get_and_addIi_no_res",
  /*  749 */  "get_and_addLAcq",
  /*  750 */  "get_and_addL_no_resAcq",
  /*  751 */  "get_and_addLiAcq",
  /*  752 */  "get_and_addLi_no_resAcq",
  /*  753 */  "get_and_addIAcq",
  /*  754 */  "get_and_addI_no_resAcq",
  /*  755 */  "get_and_addIiAcq",
  /*  756 */  "get_and_addIi_no_resAcq",
  /*  757 */  "cmpU3_reg_reg",
  /*  758 */  "cmpU3_reg_imm",
  /*  759 */  "cmpUL3_reg_reg",
  /*  760 */  "cmpUL3_reg_imm",
  /*  761 */  "cmpL3_reg_reg",
  /*  762 */  "cmpL3_reg_imm",
  /*  763 */  "cmovI_reg_reg",
  /*  764 */  "cmovUI_reg_reg",
  /*  765 */  "cmovI_zero_reg",
  /*  766 */  "cmovUI_zero_reg",
  /*  767 */  "cmovI_reg_zero",
  /*  768 */  "cmovUI_reg_zero",
  /*  769 */  "cmovI_reg_zero_one",
  /*  770 */  "cmovUI_reg_zero_one",
  /*  771 */  "cmovL_reg_reg",
  /*  772 */  "cmovUL_reg_reg",
  /*  773 */  "cmovL_reg_zero",
  /*  774 */  "cmovUL_reg_zero",
  /*  775 */  "cmovL_zero_reg",
  /*  776 */  "cmovUL_zero_reg",
  /*  777 */  "cmovP_reg_reg",
  /*  778 */  "cmovUP_reg_reg",
  /*  779 */  "cmovP_reg_zero",
  /*  780 */  "cmovUP_reg_zero",
  /*  781 */  "cmovP_zero_reg",
  /*  782 */  "cmovUP_zero_reg",
  /*  783 */  "cmovN_reg_reg",
  /*  784 */  "cmovUN_reg_reg",
  /*  785 */  "cmovN_reg_zero",
  /*  786 */  "cmovUN_reg_zero",
  /*  787 */  "cmovN_zero_reg",
  /*  788 */  "cmovUN_zero_reg",
  /*  789 */  "cmovF_reg",
  /*  790 */  "cmovUF_reg",
  /*  791 */  "cmovD_reg",
  /*  792 */  "cmovUD_reg",
  /*  793 */  "addI_reg_reg",
  /*  794 */  "addI_reg_imm",
  /*  795 */  "addI_reg_imm_i2l",
  /*  796 */  "addP_reg_reg",
  /*  797 */  "addP_reg_reg_ext",
  /*  798 */  "addP_reg_reg_lsl",
  /*  799 */  "addP_reg_reg_ext_shift",
  /*  800 */  "lshift_ext",
  /*  801 */  "addP_reg_imm",
  /*  802 */  "addL_reg_reg",
  /*  803 */  "addL_reg_imm",
  /*  804 */  "subI_reg_reg",
  /*  805 */  "subI_reg_imm",
  /*  806 */  "subL_reg_reg",
  /*  807 */  "subL_reg_imm",
  /*  808 */  "negI_reg",
  /*  809 */  "negL_reg",
  /*  810 */  "mulI",
  /*  811 */  "smulI",
  /*  812 */  "smulI_0",
  /*  813 */  "mulL",
  /*  814 */  "mulHiL_rReg",
  /*  815 */  "umulHiL_rReg",
  /*  816 */  "maddI",
  /*  817 */  "maddI_0",
  /*  818 */  "msubI",
  /*  819 */  "mnegI",
  /*  820 */  "mnegI_0",
  /*  821 */  "maddL",
  /*  822 */  "maddL_0",
  /*  823 */  "msubL",
  /*  824 */  "mnegL",
  /*  825 */  "mnegL_0",
  /*  826 */  "smaddL",
  /*  827 */  "smaddL_1",
  /*  828 */  "smaddL_0",
  /*  829 */  "smaddL_2",
  /*  830 */  "smsubL",
  /*  831 */  "smsubL_0",
  /*  832 */  "smnegL",
  /*  833 */  "smnegL_0",
  /*  834 */  "muladdS2I",
  /*  835 */  "divI",
  /*  836 */  "divL",
  /*  837 */  "modI",
  /*  838 */  "modL",
  /*  839 */  "UdivI_reg_reg",
  /*  840 */  "UdivL_reg_reg",
  /*  841 */  "UmodI_reg_reg",
  /*  842 */  "UModL_reg_reg",
  /*  843 */  "lShiftI_reg_reg",
  /*  844 */  "lShiftI_reg_imm",
  /*  845 */  "urShiftI_reg_reg",
  /*  846 */  "urShiftI_reg_imm",
  /*  847 */  "rShiftI_reg_reg",
  /*  848 */  "rShiftI_reg_imm",
  /*  849 */  "lShiftL_reg_reg",
  /*  850 */  "lShiftL_reg_imm",
  /*  851 */  "urShiftL_reg_reg",
  /*  852 */  "urShiftL_reg_imm",
  /*  853 */  "urShiftP_reg_imm",
  /*  854 */  "rShiftL_reg_reg",
  /*  855 */  "rShiftL_reg_imm",
  /*  856 */  "regL_not_reg",
  /*  857 */  "regI_not_reg",
  /*  858 */  "NegI_reg_URShift_reg",
  /*  859 */  "NegI_reg_RShift_reg",
  /*  860 */  "NegI_reg_LShift_reg",
  /*  861 */  "NegL_reg_URShift_reg",
  /*  862 */  "NegL_reg_RShift_reg",
  /*  863 */  "NegL_reg_LShift_reg",
  /*  864 */  "AndI_reg_not_reg",
  /*  865 */  "AndI_reg_not_reg_0",
  /*  866 */  "AndL_reg_not_reg",
  /*  867 */  "AndL_reg_not_reg_0",
  /*  868 */  "OrI_reg_not_reg",
  /*  869 */  "OrI_reg_not_reg_0",
  /*  870 */  "OrL_reg_not_reg",
  /*  871 */  "OrL_reg_not_reg_0",
  /*  872 */  "XorI_reg_not_reg",
  /*  873 */  "XorI_reg_not_reg_0",
  /*  874 */  "XorL_reg_not_reg",
  /*  875 */  "XorL_reg_not_reg_0",
  /*  876 */  "AndI_reg_URShift_not_reg",
  /*  877 */  "AndI_reg_URShift_not_reg_0",
  /*  878 */  "AndL_reg_URShift_not_reg",
  /*  879 */  "AndL_reg_URShift_not_reg_0",
  /*  880 */  "AndI_reg_RShift_not_reg",
  /*  881 */  "AndI_reg_RShift_not_reg_0",
  /*  882 */  "AndL_reg_RShift_not_reg",
  /*  883 */  "AndL_reg_RShift_not_reg_0",
  /*  884 */  "AndI_reg_RotateRight_not_reg",
  /*  885 */  "AndI_reg_RotateRight_not_reg_0",
  /*  886 */  "AndL_reg_RotateRight_not_reg",
  /*  887 */  "AndL_reg_RotateRight_not_reg_0",
  /*  888 */  "AndI_reg_LShift_not_reg",
  /*  889 */  "AndI_reg_LShift_not_reg_0",
  /*  890 */  "AndL_reg_LShift_not_reg",
  /*  891 */  "AndL_reg_LShift_not_reg_0",
  /*  892 */  "XorI_reg_URShift_not_reg",
  /*  893 */  "XorI_reg_URShift_not_reg_1",
  /*  894 */  "XorI_reg_URShift_not_reg_0",
  /*  895 */  "XorI_reg_URShift_not_reg_2",
  /*  896 */  "XorL_reg_URShift_not_reg",
  /*  897 */  "XorL_reg_URShift_not_reg_1",
  /*  898 */  "XorL_reg_URShift_not_reg_0",
  /*  899 */  "XorL_reg_URShift_not_reg_2",
  /*  900 */  "XorI_reg_RShift_not_reg",
  /*  901 */  "XorI_reg_RShift_not_reg_1",
  /*  902 */  "XorI_reg_RShift_not_reg_0",
  /*  903 */  "XorI_reg_RShift_not_reg_2",
  /*  904 */  "XorL_reg_RShift_not_reg",
  /*  905 */  "XorL_reg_RShift_not_reg_1",
  /*  906 */  "XorL_reg_RShift_not_reg_0",
  /*  907 */  "XorL_reg_RShift_not_reg_2",
  /*  908 */  "XorI_reg_RotateRight_not_reg",
  /*  909 */  "XorI_reg_RotateRight_not_reg_1",
  /*  910 */  "XorI_reg_RotateRight_not_reg_0",
  /*  911 */  "XorI_reg_RotateRight_not_reg_2",
  /*  912 */  "XorL_reg_RotateRight_not_reg",
  /*  913 */  "XorL_reg_RotateRight_not_reg_1",
  /*  914 */  "XorL_reg_RotateRight_not_reg_0",
  /*  915 */  "XorL_reg_RotateRight_not_reg_2",
  /*  916 */  "XorI_reg_LShift_not_reg",
  /*  917 */  "XorI_reg_LShift_not_reg_1",
  /*  918 */  "XorI_reg_LShift_not_reg_0",
  /*  919 */  "XorI_reg_LShift_not_reg_2",
  /*  920 */  "XorL_reg_LShift_not_reg",
  /*  921 */  "XorL_reg_LShift_not_reg_1",
  /*  922 */  "XorL_reg_LShift_not_reg_0",
  /*  923 */  "XorL_reg_LShift_not_reg_2",
  /*  924 */  "OrI_reg_URShift_not_reg",
  /*  925 */  "OrI_reg_URShift_not_reg_0",
  /*  926 */  "OrL_reg_URShift_not_reg",
  /*  927 */  "OrL_reg_URShift_not_reg_0",
  /*  928 */  "OrI_reg_RShift_not_reg",
  /*  929 */  "OrI_reg_RShift_not_reg_0",
  /*  930 */  "OrL_reg_RShift_not_reg",
  /*  931 */  "OrL_reg_RShift_not_reg_0",
  /*  932 */  "OrI_reg_RotateRight_not_reg",
  /*  933 */  "OrI_reg_RotateRight_not_reg_0",
  /*  934 */  "OrL_reg_RotateRight_not_reg",
  /*  935 */  "OrL_reg_RotateRight_not_reg_0",
  /*  936 */  "OrI_reg_LShift_not_reg",
  /*  937 */  "OrI_reg_LShift_not_reg_0",
  /*  938 */  "OrL_reg_LShift_not_reg",
  /*  939 */  "OrL_reg_LShift_not_reg_0",
  /*  940 */  "AndI_reg_URShift_reg",
  /*  941 */  "AndI_reg_URShift_reg_0",
  /*  942 */  "AndL_reg_URShift_reg",
  /*  943 */  "AndL_reg_URShift_reg_0",
  /*  944 */  "AndI_reg_RShift_reg",
  /*  945 */  "AndI_reg_RShift_reg_0",
  /*  946 */  "AndL_reg_RShift_reg",
  /*  947 */  "AndL_reg_RShift_reg_0",
  /*  948 */  "AndI_reg_LShift_reg",
  /*  949 */  "AndI_reg_LShift_reg_0",
  /*  950 */  "AndL_reg_LShift_reg",
  /*  951 */  "AndL_reg_LShift_reg_0",
  /*  952 */  "AndI_reg_RotateRight_reg",
  /*  953 */  "AndI_reg_RotateRight_reg_0",
  /*  954 */  "AndL_reg_RotateRight_reg",
  /*  955 */  "AndL_reg_RotateRight_reg_0",
  /*  956 */  "XorI_reg_URShift_reg",
  /*  957 */  "XorI_reg_URShift_reg_0",
  /*  958 */  "XorL_reg_URShift_reg",
  /*  959 */  "XorL_reg_URShift_reg_0",
  /*  960 */  "XorI_reg_RShift_reg",
  /*  961 */  "XorI_reg_RShift_reg_0",
  /*  962 */  "XorL_reg_RShift_reg",
  /*  963 */  "XorL_reg_RShift_reg_0",
  /*  964 */  "XorI_reg_LShift_reg",
  /*  965 */  "XorI_reg_LShift_reg_0",
  /*  966 */  "XorL_reg_LShift_reg",
  /*  967 */  "XorL_reg_LShift_reg_0",
  /*  968 */  "XorI_reg_RotateRight_reg",
  /*  969 */  "XorI_reg_RotateRight_reg_0",
  /*  970 */  "XorL_reg_RotateRight_reg",
  /*  971 */  "XorL_reg_RotateRight_reg_0",
  /*  972 */  "OrI_reg_URShift_reg",
  /*  973 */  "OrI_reg_URShift_reg_0",
  /*  974 */  "OrL_reg_URShift_reg",
  /*  975 */  "OrL_reg_URShift_reg_0",
  /*  976 */  "OrI_reg_RShift_reg",
  /*  977 */  "OrI_reg_RShift_reg_0",
  /*  978 */  "OrL_reg_RShift_reg",
  /*  979 */  "OrL_reg_RShift_reg_0",
  /*  980 */  "OrI_reg_LShift_reg",
  /*  981 */  "OrI_reg_LShift_reg_0",
  /*  982 */  "OrL_reg_LShift_reg",
  /*  983 */  "OrL_reg_LShift_reg_0",
  /*  984 */  "OrI_reg_RotateRight_reg",
  /*  985 */  "OrI_reg_RotateRight_reg_0",
  /*  986 */  "OrL_reg_RotateRight_reg",
  /*  987 */  "OrL_reg_RotateRight_reg_0",
  /*  988 */  "AddI_reg_URShift_reg",
  /*  989 */  "AddI_reg_URShift_reg_0",
  /*  990 */  "AddL_reg_URShift_reg",
  /*  991 */  "AddL_reg_URShift_reg_0",
  /*  992 */  "AddI_reg_RShift_reg",
  /*  993 */  "AddI_reg_RShift_reg_0",
  /*  994 */  "AddL_reg_RShift_reg",
  /*  995 */  "AddL_reg_RShift_reg_0",
  /*  996 */  "AddI_reg_LShift_reg",
  /*  997 */  "AddI_reg_LShift_reg_0",
  /*  998 */  "AddL_reg_LShift_reg",
  /*  999 */  "AddL_reg_LShift_reg_0",
  /* 1000 */  "SubI_reg_URShift_reg",
  /* 1001 */  "SubL_reg_URShift_reg",
  /* 1002 */  "SubI_reg_RShift_reg",
  /* 1003 */  "SubL_reg_RShift_reg",
  /* 1004 */  "SubI_reg_LShift_reg",
  /* 1005 */  "SubL_reg_LShift_reg",
  /* 1006 */  "sbfmL",
  /* 1007 */  "sbfmwI",
  /* 1008 */  "ubfmL",
  /* 1009 */  "ubfmwI",
  /* 1010 */  "ubfxwI",
  /* 1011 */  "ubfxL",
  /* 1012 */  "ubfxIConvI2L",
  /* 1013 */  "ubfizwI",
  /* 1014 */  "ubfizL",
  /* 1015 */  "ubfizwIConvI2L",
  /* 1016 */  "ubfizLConvL2I",
  /* 1017 */  "ubfizIConvI2L",
  /* 1018 */  "ubfizLConvL2Ix",
  /* 1019 */  "ubfizIConvI2LAndI",
  /* 1020 */  "extrOrL",
  /* 1021 */  "extrOrL_0",
  /* 1022 */  "extrOrI",
  /* 1023 */  "extrOrI_0",
  /* 1024 */  "extrAddL",
  /* 1025 */  "extrAddL_0",
  /* 1026 */  "extrAddI",
  /* 1027 */  "extrAddI_0",
  /* 1028 */  "rorI_imm",
  /* 1029 */  "rorL_imm",
  /* 1030 */  "rorI_reg",
  /* 1031 */  "rorL_reg",
  /* 1032 */  "rolI_reg",
  /* 1033 */  "rolL_reg",
  /* 1034 */  "AddExtI",
  /* 1035 */  "AddExtI_0",
  /* 1036 */  "SubExtI",
  /* 1037 */  "AddExtI_sxth",
  /* 1038 */  "AddExtI_sxth_0",
  /* 1039 */  "AddExtI_sxtb",
  /* 1040 */  "AddExtI_sxtb_0",
  /* 1041 */  "AddExtI_uxtb",
  /* 1042 */  "AddExtI_uxtb_0",
  /* 1043 */  "AddExtL_sxth",
  /* 1044 */  "AddExtL_sxth_0",
  /* 1045 */  "AddExtL_sxtw",
  /* 1046 */  "AddExtL_sxtw_0",
  /* 1047 */  "AddExtL_sxtb",
  /* 1048 */  "AddExtL_sxtb_0",
  /* 1049 */  "AddExtL_uxtb",
  /* 1050 */  "AddExtL_uxtb_0",
  /* 1051 */  "AddExtI_uxtb_and",
  /* 1052 */  "AddExtI_uxtb_and_0",
  /* 1053 */  "AddExtI_uxth_and",
  /* 1054 */  "AddExtI_uxth_and_0",
  /* 1055 */  "AddExtL_uxtb_and",
  /* 1056 */  "AddExtL_uxtb_and_0",
  /* 1057 */  "AddExtL_uxth_and",
  /* 1058 */  "AddExtL_uxth_and_0",
  /* 1059 */  "AddExtL_uxtw_and",
  /* 1060 */  "AddExtL_uxtw_and_0",
  /* 1061 */  "SubExtI_uxtb_and",
  /* 1062 */  "SubExtI_uxth_and",
  /* 1063 */  "SubExtL_uxtb_and",
  /* 1064 */  "SubExtL_uxth_and",
  /* 1065 */  "SubExtL_uxtw_and",
  /* 1066 */  "AddExtL_sxtb_shift",
  /* 1067 */  "AddExtL_sxtb_shift_0",
  /* 1068 */  "AddExtL_sxth_shift",
  /* 1069 */  "AddExtL_sxth_shift_0",
  /* 1070 */  "AddExtL_sxtw_shift",
  /* 1071 */  "AddExtL_sxtw_shift_0",
  /* 1072 */  "SubExtL_sxtb_shift",
  /* 1073 */  "SubExtL_sxth_shift",
  /* 1074 */  "SubExtL_sxtw_shift",
  /* 1075 */  "AddExtI_sxtb_shift",
  /* 1076 */  "AddExtI_sxtb_shift_0",
  /* 1077 */  "AddExtI_sxth_shift",
  /* 1078 */  "AddExtI_sxth_shift_0",
  /* 1079 */  "SubExtI_sxtb_shift",
  /* 1080 */  "SubExtI_sxth_shift",
  /* 1081 */  "AddExtI_shift",
  /* 1082 */  "AddExtI_shift_0",
  /* 1083 */  "SubExtI_shift",
  /* 1084 */  "AddExtL_uxtb_and_shift",
  /* 1085 */  "AddExtL_uxtb_and_shift_0",
  /* 1086 */  "AddExtL_uxth_and_shift",
  /* 1087 */  "AddExtL_uxth_and_shift_0",
  /* 1088 */  "AddExtL_uxtw_and_shift",
  /* 1089 */  "AddExtL_uxtw_and_shift_0",
  /* 1090 */  "SubExtL_uxtb_and_shift",
  /* 1091 */  "SubExtL_uxth_and_shift",
  /* 1092 */  "SubExtL_uxtw_and_shift",
  /* 1093 */  "AddExtI_uxtb_and_shift",
  /* 1094 */  "AddExtI_uxtb_and_shift_0",
  /* 1095 */  "AddExtI_uxth_and_shift",
  /* 1096 */  "AddExtI_uxth_and_shift_0",
  /* 1097 */  "SubExtI_uxtb_and_shift",
  /* 1098 */  "SubExtI_uxth_and_shift",
  /* 1099 */  "cmovI_reg_reg_lt",
  /* 1100 */  "cmovI_reg_reg_gt",
  /* 1101 */  "cmovI_reg_imm0_lt",
  /* 1102 */  "cmovI_reg_imm0_gt",
  /* 1103 */  "cmovI_reg_imm1_le",
  /* 1104 */  "cmovI_reg_imm1_gt",
  /* 1105 */  "cmovI_reg_immM1_lt",
  /* 1106 */  "cmovI_reg_immM1_ge",
  /* 1107 */  "minI_reg_imm0",
  /* 1108 */  "minI_imm0_reg",
  /* 1109 */  "minI_reg_imm1",
  /* 1110 */  "minI_imm1_reg",
  /* 1111 */  "minI_reg_immM1",
  /* 1112 */  "minI_immM1_reg",
  /* 1113 */  "maxI_reg_imm0",
  /* 1114 */  "maxI_imm0_reg",
  /* 1115 */  "maxI_reg_imm1",
  /* 1116 */  "maxI_imm1_reg",
  /* 1117 */  "maxI_reg_immM1",
  /* 1118 */  "maxI_immM1_reg",
  /* 1119 */  "addF_reg_reg",
  /* 1120 */  "addD_reg_reg",
  /* 1121 */  "subF_reg_reg",
  /* 1122 */  "subD_reg_reg",
  /* 1123 */  "mulF_reg_reg",
  /* 1124 */  "mulD_reg_reg",
  /* 1125 */  "maddF_reg_reg",
  /* 1126 */  "maddD_reg_reg",
  /* 1127 */  "msubF_reg_reg",
  /* 1128 */  "msubD_reg_reg",
  /* 1129 */  "mnaddF_reg_reg",
  /* 1130 */  "mnaddD_reg_reg",
  /* 1131 */  "mnsubF_reg_reg",
  /* 1132 */  "mnsubD_reg_reg",
  /* 1133 */  "maxF_reg_reg",
  /* 1134 */  "minF_reg_reg",
  /* 1135 */  "maxD_reg_reg",
  /* 1136 */  "minD_reg_reg",
  /* 1137 */  "divF_reg_reg",
  /* 1138 */  "divD_reg_reg",
  /* 1139 */  "absI_reg",
  /* 1140 */  "absL_reg",
  /* 1141 */  "absdF_reg",
  /* 1142 */  "absdD_reg",
  /* 1143 */  "sqrtD_reg",
  /* 1144 */  "sqrtF_reg",
  /* 1145 */  "roundD_reg",
  /* 1146 */  "copySignD_reg",
  /* 1147 */  "copySignF_reg",
  /* 1148 */  "signumD_reg",
  /* 1149 */  "signumF_reg",
  /* 1150 */  "onspinwait",
  /* 1151 */  "andI_reg_reg",
  /* 1152 */  "andI_reg_imm",
  /* 1153 */  "orI_reg_reg",
  /* 1154 */  "orI_reg_imm",
  /* 1155 */  "xorI_reg_reg",
  /* 1156 */  "xorI_reg_imm",
  /* 1157 */  "andL_reg_reg",
  /* 1158 */  "andL_reg_imm",
  /* 1159 */  "orL_reg_reg",
  /* 1160 */  "orL_reg_imm",
  /* 1161 */  "xorL_reg_reg",
  /* 1162 */  "xorL_reg_imm",
  /* 1163 */  "convI2L_reg_reg",
  /* 1164 */  "convUI2L_reg_reg",
  /* 1165 */  "convL2I_reg",
  /* 1166 */  "convD2F_reg",
  /* 1167 */  "convF2D_reg",
  /* 1168 */  "convF2I_reg_reg",
  /* 1169 */  "convF2L_reg_reg",
  /* 1170 */  "convF2HF_reg_reg",
  /* 1171 */  "convHF2F_reg_reg",
  /* 1172 */  "convI2F_reg_reg",
  /* 1173 */  "convL2F_reg_reg",
  /* 1174 */  "convD2I_reg_reg",
  /* 1175 */  "convD2L_reg_reg",
  /* 1176 */  "convI2D_reg_reg",
  /* 1177 */  "convL2D_reg_reg",
  /* 1178 */  "round_double_reg",
  /* 1179 */  "round_float_reg",
  /* 1180 */  "MoveF2I_reg_stack",
  /* 1181 */  "MoveI2F_reg_stack",
  /* 1182 */  "MoveD2L_reg_stack",
  /* 1183 */  "MoveL2D_reg_stack",
  /* 1184 */  "clearArray_reg_reg",
  /* 1185 */  "clearArray_imm_reg",
  /* 1186 */  "overflowMulI_reg_branch",
  /* 1187 */  "overflowMulL_reg_branch",
  /* 1188 */  "compF3_reg_reg",
  /* 1189 */  "compD3_reg_reg",
  /* 1190 */  "compF3_reg_immF0",
  /* 1191 */  "compD3_reg_immD0",
  /* 1192 */  "cmpLTMask_reg_reg",
  /* 1193 */  "cmpLTMask_reg_zero",
  /* 1194 */  "minI_reg_reg",
  /* 1195 */  "maxI_reg_reg",
  /* 1196 */  "branch",
  /* 1197 */  "branchCon",
  /* 1198 */  "branchConU",
  /* 1199 */  "cmpI_imm0_branch",
  /* 1200 */  "cmpL_imm0_branch",
  /* 1201 */  "cmpP_imm0_branch",
  /* 1202 */  "cmpN_imm0_branch",
  /* 1203 */  "cmpP_narrowOop_imm0_branch",
  /* 1204 */  "cmpUI_imm0_branch",
  /* 1205 */  "cmpUL_imm0_branch",
  /* 1206 */  "cmpL_branch_sign",
  /* 1207 */  "cmpI_branch_sign",
  /* 1208 */  "cmpL_branch_bit",
  /* 1209 */  "cmpI_branch_bit",
  /* 1210 */  "far_cmpL_branch_sign",
  /* 1211 */  "far_cmpI_branch_sign",
  /* 1212 */  "far_cmpL_branch_bit",
  /* 1213 */  "far_cmpI_branch_bit",
  /* 1214 */  "branchLoopEnd",
  /* 1215 */  "safePoint",
  /* 1216 */  "CallStaticJavaDirect",
  /* 1217 */  "CallDynamicJavaDirect",
  /* 1218 */  "CallRuntimeDirect",
  /* 1219 */  "CallLeafDirect",
  /* 1220 */  "CallLeafNoFPDirect",
  /* 1221 */  "TailCalljmpInd",
  /* 1222 */  "TailjmpInd",
  /* 1223 */  "CreateException",
  /* 1224 */  "RethrowException",
  /* 1225 */  "Ret",
  /* 1226 */  "ShouldNotReachHere",
  /* 1227 */  "partialSubtypeCheck",
  /* 1228 */  "string_compareU",
  /* 1229 */  "string_compareL",
  /* 1230 */  "string_compareUL",
  /* 1231 */  "string_compareLU",
  /* 1232 */  "string_compareLL_sve",
  /* 1233 */  "string_compareLU_sve",
  /* 1234 */  "string_compareUL_sve",
  /* 1235 */  "string_compareUU_sve",
  /* 1236 */  "string_indexofUU",
  /* 1237 */  "string_indexofLL",
  /* 1238 */  "string_indexofUL",
  /* 1239 */  "string_indexof_conUU",
  /* 1240 */  "string_indexof_conLL",
  /* 1241 */  "string_indexof_conUL",
  /* 1242 */  "string_indexof_char",
  /* 1243 */  "stringL_indexof_char",
  /* 1244 */  "stringL_indexof_char_sve",
  /* 1245 */  "stringU_indexof_char_sve",
  /* 1246 */  "string_equalsL",
  /* 1247 */  "string_equalsU",
  /* 1248 */  "array_equalsB",
  /* 1249 */  "array_equalsC",
  /* 1250 */  "count_positives",
  /* 1251 */  "string_compress",
  /* 1252 */  "string_inflate",
  /* 1253 */  "encode_iso_array",
  /* 1254 */  "encode_ascii_array",
  /* 1255 */  "compressBitsI_reg",
  /* 1256 */  "compressBitsI_memcon",
  /* 1257 */  "compressBitsL_reg",
  /* 1258 */  "compressBitsL_memcon",
  /* 1259 */  "expandBitsI_reg",
  /* 1260 */  "expandBitsI_memcon",
  /* 1261 */  "expandBitsL_reg",
  /* 1262 */  "expandBitsL_memcon",
  /* 1263 */  "loadV2",
  /* 1264 */  "storeV2",
  /* 1265 */  "loadV4",
  /* 1266 */  "storeV4",
  /* 1267 */  "loadV8",
  /* 1268 */  "storeV8",
  /* 1269 */  "loadV16",
  /* 1270 */  "storeV16",
  /* 1271 */  "loadV",
  /* 1272 */  "storeV",
  /* 1273 */  "loadV_masked",
  /* 1274 */  "storeV_masked",
  /* 1275 */  "vaddB",
  /* 1276 */  "vaddS",
  /* 1277 */  "vaddI",
  /* 1278 */  "vaddL",
  /* 1279 */  "vaddF",
  /* 1280 */  "vaddD",
  /* 1281 */  "vaddB_masked",
  /* 1282 */  "vaddS_masked",
  /* 1283 */  "vaddI_masked",
  /* 1284 */  "vaddL_masked",
  /* 1285 */  "vaddF_masked",
  /* 1286 */  "vaddD_masked",
  /* 1287 */  "vaddImmB",
  /* 1288 */  "vaddImmB_0",
  /* 1289 */  "vaddImmS",
  /* 1290 */  "vaddImmS_0",
  /* 1291 */  "vaddImmI",
  /* 1292 */  "vaddImmI_0",
  /* 1293 */  "vaddImmL",
  /* 1294 */  "vaddImmL_0",
  /* 1295 */  "vsubB",
  /* 1296 */  "vsubS",
  /* 1297 */  "vsubI",
  /* 1298 */  "vsubL",
  /* 1299 */  "vsubF",
  /* 1300 */  "vsubD",
  /* 1301 */  "vsubB_masked",
  /* 1302 */  "vsubS_masked",
  /* 1303 */  "vsubI_masked",
  /* 1304 */  "vsubL_masked",
  /* 1305 */  "vsubF_masked",
  /* 1306 */  "vsubD_masked",
  /* 1307 */  "vmulB_neon",
  /* 1308 */  "vmulB_sve",
  /* 1309 */  "vmulS_neon",
  /* 1310 */  "vmulS_sve",
  /* 1311 */  "vmulI_neon",
  /* 1312 */  "vmulI_sve",
  /* 1313 */  "vmulL_neon",
  /* 1314 */  "vmulL_sve",
  /* 1315 */  "vmulF",
  /* 1316 */  "vmulD",
  /* 1317 */  "vmulB_masked",
  /* 1318 */  "vmulS_masked",
  /* 1319 */  "vmulI_masked",
  /* 1320 */  "vmulL_masked",
  /* 1321 */  "vmulF_masked",
  /* 1322 */  "vmulD_masked",
  /* 1323 */  "vdivF_neon",
  /* 1324 */  "vdivF_sve",
  /* 1325 */  "vdivD_neon",
  /* 1326 */  "vdivD_sve",
  /* 1327 */  "vdivF_masked",
  /* 1328 */  "vdivD_masked",
  /* 1329 */  "vand",
  /* 1330 */  "vand_masked",
  /* 1331 */  "vandImmB",
  /* 1332 */  "vandImmB_0",
  /* 1333 */  "vandImmS",
  /* 1334 */  "vandImmS_0",
  /* 1335 */  "vandImmI",
  /* 1336 */  "vandImmI_0",
  /* 1337 */  "vandImmL",
  /* 1338 */  "vandImmL_0",
  /* 1339 */  "vor",
  /* 1340 */  "vor_masked",
  /* 1341 */  "vorImmB",
  /* 1342 */  "vorImmB_0",
  /* 1343 */  "vorImmS",
  /* 1344 */  "vorImmS_0",
  /* 1345 */  "vorImmI",
  /* 1346 */  "vorImmI_0",
  /* 1347 */  "vorImmL",
  /* 1348 */  "vorImmL_0",
  /* 1349 */  "vxor",
  /* 1350 */  "vxor_masked",
  /* 1351 */  "vxorImmB",
  /* 1352 */  "vxorImmB_0",
  /* 1353 */  "vxorImmS",
  /* 1354 */  "vxorImmS_0",
  /* 1355 */  "vxorImmI",
  /* 1356 */  "vxorImmI_0",
  /* 1357 */  "vxorImmL",
  /* 1358 */  "vxorImmL_0",
  /* 1359 */  "veor3_neon",
  /* 1360 */  "veor3_neon_0",
  /* 1361 */  "veor3_sve",
  /* 1362 */  "veor3_sve_0",
  /* 1363 */  "vnotI",
  /* 1364 */  "vnotI_0",
  /* 1365 */  "vnotL",
  /* 1366 */  "vnotL_0",
  /* 1367 */  "vnotI_masked",
  /* 1368 */  "vnotL_masked",
  /* 1369 */  "vand_notI",
  /* 1370 */  "vand_notI_1",
  /* 1371 */  "vand_notI_0",
  /* 1372 */  "vand_notI_2",
  /* 1373 */  "vand_notL",
  /* 1374 */  "vand_notL_1",
  /* 1375 */  "vand_notL_0",
  /* 1376 */  "vand_notL_2",
  /* 1377 */  "vand_notI_masked",
  /* 1378 */  "vand_notI_masked_0",
  /* 1379 */  "vand_notL_masked",
  /* 1380 */  "vand_notL_masked_0",
  /* 1381 */  "vabsB_masked",
  /* 1382 */  "vabsS_masked",
  /* 1383 */  "vabsI_masked",
  /* 1384 */  "vabsL_masked",
  /* 1385 */  "vabsF_masked",
  /* 1386 */  "vabsD_masked",
  /* 1387 */  "vfabd_neon",
  /* 1388 */  "vfabd_neon_0",
  /* 1389 */  "vfabd_sve",
  /* 1390 */  "vfabd_sve_0",
  /* 1391 */  "vfabd_masked",
  /* 1392 */  "vfabd_masked_0",
  /* 1393 */  "vnegI_masked",
  /* 1394 */  "vnegL_masked",
  /* 1395 */  "vnegF_masked",
  /* 1396 */  "vnegD_masked",
  /* 1397 */  "vsqrtF_masked",
  /* 1398 */  "vsqrtD_masked",
  /* 1399 */  "vminL_neon",
  /* 1400 */  "vminL_sve",
  /* 1401 */  "vmin_neon",
  /* 1402 */  "vmin_sve",
  /* 1403 */  "vmin_masked",
  /* 1404 */  "vmaxL_neon",
  /* 1405 */  "vmaxL_sve",
  /* 1406 */  "vmax_neon",
  /* 1407 */  "vmax_sve",
  /* 1408 */  "vmax_masked",
  /* 1409 */  "vmla",
  /* 1410 */  "vmla_0",
  /* 1411 */  "vmla_1",
  /* 1412 */  "vmla_2",
  /* 1413 */  "vmla_3",
  /* 1414 */  "vmla_4",
  /* 1415 */  "vmlaL",
  /* 1416 */  "vmlaL_0",
  /* 1417 */  "vmla_masked",
  /* 1418 */  "vmla_masked_0",
  /* 1419 */  "vmla_masked_1",
  /* 1420 */  "vmla_masked_2",
  /* 1421 */  "vfmla",
  /* 1422 */  "vfmla_0",
  /* 1423 */  "vfmad_masked",
  /* 1424 */  "vfmad_masked_0",
  /* 1425 */  "vmls",
  /* 1426 */  "vmls_0",
  /* 1427 */  "vmls_1",
  /* 1428 */  "vmlsL",
  /* 1429 */  "vmls_masked",
  /* 1430 */  "vmls_masked_0",
  /* 1431 */  "vmls_masked_1",
  /* 1432 */  "vmls_masked_2",
  /* 1433 */  "vfmls",
  /* 1434 */  "vfmls_0",
  /* 1435 */  "vfmsb_masked",
  /* 1436 */  "vfmsb_masked_0",
  /* 1437 */  "vfnmla",
  /* 1438 */  "vfnmla_0",
  /* 1439 */  "vfnmad_masked",
  /* 1440 */  "vfnmad_masked_0",
  /* 1441 */  "vfnmls",
  /* 1442 */  "vfnmls_0",
  /* 1443 */  "vfnmsb_masked",
  /* 1444 */  "vfnmsb_masked_0",
  /* 1445 */  "vmuladdS2I",
  /* 1446 */  "vlsl_neon",
  /* 1447 */  "vlsl_neon_0",
  /* 1448 */  "vlsl_neon_1",
  /* 1449 */  "vlsl_neon_2",
  /* 1450 */  "vlsl_sve",
  /* 1451 */  "vlsl_sve_0",
  /* 1452 */  "vlsl_sve_1",
  /* 1453 */  "vlsl_sve_2",
  /* 1454 */  "vasr_neon",
  /* 1455 */  "vasr_neon_0",
  /* 1456 */  "vasr_neon_1",
  /* 1457 */  "vasr_neon_2",
  /* 1458 */  "vasr_neon_var",
  /* 1459 */  "vasr_neon_var_0",
  /* 1460 */  "vasr_neon_var_1",
  /* 1461 */  "vasr_neon_var_2",
  /* 1462 */  "vasr_sve",
  /* 1463 */  "vasr_sve_0",
  /* 1464 */  "vasr_sve_1",
  /* 1465 */  "vasr_sve_2",
  /* 1466 */  "vlsr_neon",
  /* 1467 */  "vlsr_neon_0",
  /* 1468 */  "vlsr_neon_1",
  /* 1469 */  "vlsr_neon_2",
  /* 1470 */  "vlsr_neon_var",
  /* 1471 */  "vlsr_neon_var_0",
  /* 1472 */  "vlsr_neon_var_1",
  /* 1473 */  "vlsr_neon_var_2",
  /* 1474 */  "vlsr_sve",
  /* 1475 */  "vlsr_sve_0",
  /* 1476 */  "vlsr_sve_1",
  /* 1477 */  "vlsr_sve_2",
  /* 1478 */  "vlsl_imm",
  /* 1479 */  "vlsl_imm_0",
  /* 1480 */  "vlsl_imm_1",
  /* 1481 */  "vlsl_imm_2",
  /* 1482 */  "vasr_imm",
  /* 1483 */  "vasr_imm_0",
  /* 1484 */  "vasr_imm_1",
  /* 1485 */  "vasr_imm_2",
  /* 1486 */  "vlsr_imm",
  /* 1487 */  "vlsr_imm_0",
  /* 1488 */  "vlsr_imm_1",
  /* 1489 */  "vlsr_imm_2",
  /* 1490 */  "vasra_imm",
  /* 1491 */  "vasra_imm_0",
  /* 1492 */  "vasra_imm_1",
  /* 1493 */  "vasra_imm_2",
  /* 1494 */  "vasra_imm_3",
  /* 1495 */  "vasra_imm_4",
  /* 1496 */  "vasra_imm_5",
  /* 1497 */  "vasra_imm_6",
  /* 1498 */  "vlsra_imm",
  /* 1499 */  "vlsra_imm_0",
  /* 1500 */  "vlsra_imm_1",
  /* 1501 */  "vlsra_imm_2",
  /* 1502 */  "vlsra_imm_3",
  /* 1503 */  "vlsra_imm_4",
  /* 1504 */  "vlsra_imm_5",
  /* 1505 */  "vlsra_imm_6",
  /* 1506 */  "vlsl_masked",
  /* 1507 */  "vlsl_masked_0",
  /* 1508 */  "vlsl_masked_1",
  /* 1509 */  "vlsl_masked_2",
  /* 1510 */  "vasr_masked",
  /* 1511 */  "vasr_masked_0",
  /* 1512 */  "vasr_masked_1",
  /* 1513 */  "vasr_masked_2",
  /* 1514 */  "vlsr_masked",
  /* 1515 */  "vlsr_masked_0",
  /* 1516 */  "vlsr_masked_1",
  /* 1517 */  "vlsr_masked_2",
  /* 1518 */  "vlsl_imm_masked",
  /* 1519 */  "vlsl_imm_masked_0",
  /* 1520 */  "vlsl_imm_masked_1",
  /* 1521 */  "vlsl_imm_masked_2",
  /* 1522 */  "vasr_imm_masked",
  /* 1523 */  "vasr_imm_masked_0",
  /* 1524 */  "vasr_imm_masked_1",
  /* 1525 */  "vasr_imm_masked_2",
  /* 1526 */  "vlsr_imm_masked",
  /* 1527 */  "vlsr_imm_masked_0",
  /* 1528 */  "vlsr_imm_masked_1",
  /* 1529 */  "vlsr_imm_masked_2",
  /* 1530 */  "reduce_addI_neon",
  /* 1531 */  "reduce_addI_sve",
  /* 1532 */  "reduce_addL_neon",
  /* 1533 */  "reduce_addL_sve",
  /* 1534 */  "reduce_add2F_neon",
  /* 1535 */  "reduce_add4F_neon",
  /* 1536 */  "reduce_addF_sve",
  /* 1537 */  "reduce_addD_neon",
  /* 1538 */  "reduce_addD_sve",
  /* 1539 */  "reduce_addI_masked",
  /* 1540 */  "reduce_addL_masked",
  /* 1541 */  "reduce_addF_masked",
  /* 1542 */  "reduce_addD_masked",
  /* 1543 */  "reduce_mulI",
  /* 1544 */  "reduce_mulL",
  /* 1545 */  "reduce_mulF",
  /* 1546 */  "reduce_mulD",
  /* 1547 */  "reduce_andI_neon",
  /* 1548 */  "reduce_andI_sve",
  /* 1549 */  "reduce_andL_neon",
  /* 1550 */  "reduce_andL_sve",
  /* 1551 */  "reduce_andI_masked",
  /* 1552 */  "reduce_andL_masked",
  /* 1553 */  "reduce_orI_neon",
  /* 1554 */  "reduce_orI_sve",
  /* 1555 */  "reduce_orL_neon",
  /* 1556 */  "reduce_orL_sve",
  /* 1557 */  "reduce_orI_masked",
  /* 1558 */  "reduce_orL_masked",
  /* 1559 */  "reduce_xorI_neon",
  /* 1560 */  "reduce_xorI_sve",
  /* 1561 */  "reduce_xorL_neon",
  /* 1562 */  "reduce_xorL_sve",
  /* 1563 */  "reduce_xorI_masked",
  /* 1564 */  "reduce_xorL_masked",
  /* 1565 */  "reduce_maxI_neon",
  /* 1566 */  "reduce_maxI_sve",
  /* 1567 */  "reduce_maxL_neon",
  /* 1568 */  "reduce_maxL_sve",
  /* 1569 */  "reduce_maxF",
  /* 1570 */  "reduce_maxD",
  /* 1571 */  "reduce_maxI_masked",
  /* 1572 */  "reduce_maxL_masked",
  /* 1573 */  "reduce_maxF_masked",
  /* 1574 */  "reduce_maxD_masked",
  /* 1575 */  "reduce_minI_neon",
  /* 1576 */  "reduce_minI_sve",
  /* 1577 */  "reduce_minL_neon",
  /* 1578 */  "reduce_minL_sve",
  /* 1579 */  "reduce_minF",
  /* 1580 */  "reduce_minD",
  /* 1581 */  "reduce_minI_masked",
  /* 1582 */  "reduce_minL_masked",
  /* 1583 */  "reduce_minF_masked",
  /* 1584 */  "reduce_minD_masked",
  /* 1585 */  "reinterpret_resize_gt128b",
  /* 1586 */  "vcvtStoB_sve",
  /* 1587 */  "vcvtItoX_narrow_neon",
  /* 1588 */  "vcvtItoX_narrow_sve",
  /* 1589 */  "vcvtLtoI_sve",
  /* 1590 */  "vcvtLtoF_neon",
  /* 1591 */  "vcvtLtoF_sve",
  /* 1592 */  "vcvtFtoX_narrow_neon",
  /* 1593 */  "vcvtFtoX_narrow_sve",
  /* 1594 */  "vcvtDtoI_neon",
  /* 1595 */  "vcvtDtoI_sve",
  /* 1596 */  "vcvtDtoF_gt64b",
  /* 1597 */  "vcvtFtoHF_sve",
  /* 1598 */  "insertI_le128b",
  /* 1599 */  "insertI_index_lt32",
  /* 1600 */  "insertI_index_ge32",
  /* 1601 */  "insertL_128b",
  /* 1602 */  "insertL_gt128b",
  /* 1603 */  "insertF_le128b",
  /* 1604 */  "insertF_index_lt32",
  /* 1605 */  "insertF_index_ge32",
  /* 1606 */  "insertD_128b",
  /* 1607 */  "insertD_gt128b",
  /* 1608 */  "extractUB_ireg",
  /* 1609 */  "extractUB_index_lt16",
  /* 1610 */  "extractUB_index_ge16",
  /* 1611 */  "extractB_index_lt16",
  /* 1612 */  "extractB_index_ge16",
  /* 1613 */  "extractS_index_lt8",
  /* 1614 */  "extractS_index_ge8",
  /* 1615 */  "extractI_index_lt4",
  /* 1616 */  "extractI_index_ge4",
  /* 1617 */  "extractL_index_lt2",
  /* 1618 */  "extractL_index_ge2",
  /* 1619 */  "extractF",
  /* 1620 */  "extractD",
  /* 1621 */  "vloadmaskB_sve",
  /* 1622 */  "vloadmask_extend_sve",
  /* 1623 */  "vloadmaskB_masked",
  /* 1624 */  "vloadmask_extend_masked",
  /* 1625 */  "vstoremaskB_neon",
  /* 1626 */  "vstoremask_narrow_neon",
  /* 1627 */  "vstoremaskB_sve",
  /* 1628 */  "vstoremask_narrow_sve",
  /* 1629 */  "vloadmask_loadV",
  /* 1630 */  "vloadmask_loadV_masked",
  /* 1631 */  "vloadmask_loadVMasked",
  /* 1632 */  "vloadmask_loadVMasked_masked",
  /* 1633 */  "storeV_vstoremask",
  /* 1634 */  "storeV_vstoremask_masked",
  /* 1635 */  "storeVMasked_vstoremask",
  /* 1636 */  "storeVMasked_vstoremask_masked",
  /* 1637 */  "vmask_and",
  /* 1638 */  "vmask_or",
  /* 1639 */  "vmask_xor",
  /* 1640 */  "vmask_and_notI",
  /* 1641 */  "vmask_and_notL",
  /* 1642 */  "vmaskcmp_neon",
  /* 1643 */  "vmaskcmp_zeroI_neon",
  /* 1644 */  "vmaskcmp_zeroL_neon",
  /* 1645 */  "vmaskcmp_zeroF_neon",
  /* 1646 */  "vmaskcmp_zeroD_neon",
  /* 1647 */  "vmaskcmp_sve",
  /* 1648 */  "vmaskcmp_immI_sve",
  /* 1649 */  "vmaskcmpU_immI_sve",
  /* 1650 */  "vmaskcmp_immL_sve",
  /* 1651 */  "vmaskcmpU_immL_sve",
  /* 1652 */  "vmaskcmp_masked",
  /* 1653 */  "vmaskcast_narrow_sve",
  /* 1654 */  "vmask_reinterpret_diff_esize",
  /* 1655 */  "vmask_truecount_neon",
  /* 1656 */  "vstoremask_truecount_neon",
  /* 1657 */  "vmask_firsttrue_sve",
  /* 1658 */  "vmask_firsttrue_masked",
  /* 1659 */  "vmask_lasttrue_sve",
  /* 1660 */  "vmask_tolong_sve",
  /* 1661 */  "vmask_fromlong",
  /* 1662 */  "vmaskAll_immI",
  /* 1663 */  "vmaskAllI",
  /* 1664 */  "vmaskAllI_masked",
  /* 1665 */  "vmaskAll_immL",
  /* 1666 */  "vmaskAllL",
  /* 1667 */  "vmaskAllL_masked",
  /* 1668 */  "vmask_gen_I",
  /* 1669 */  "vmask_gen_L",
  /* 1670 */  "vmask_gen_imm",
  /* 1671 */  "vmask_gen_sub",
  /* 1672 */  "vpopcountI_masked",
  /* 1673 */  "vpopcountL_masked",
  /* 1674 */  "vblend_neon",
  /* 1675 */  "vblend_sve",
  /* 1676 */  "vround_le128b",
  /* 1677 */  "vround_le128b_0",
  /* 1678 */  "vround_gt128b",
  /* 1679 */  "vround_gt128b_0",
  /* 1680 */  "vroundD",
  /* 1681 */  "rearrange_HS_neon",
  /* 1682 */  "rearrange",
  /* 1683 */  "gather_loadS",
  /* 1684 */  "gather_loadD",
  /* 1685 */  "gather_loadS_masked",
  /* 1686 */  "gather_loadD_masked",
  /* 1687 */  "scatter_storeS",
  /* 1688 */  "scatter_storeD",
  /* 1689 */  "scatter_storeS_masked",
  /* 1690 */  "scatter_storeD_masked",
  /* 1691 */  "vcountLeadingZeros_masked",
  /* 1692 */  "vcountTrailingZeros_masked",
  /* 1693 */  "vreverse_masked",
  /* 1694 */  "vreverseBytes_masked",
  /* 1695 */  "populateindex",
  /* 1696 */  "mcompress",
  /* 1697 */  "vcompress",
  /* 1698 */  "vcompressB",
  /* 1699 */  "vcompressS",
  /* 1700 */  "vexpand",
  /* 1701 */  "vsignum_le128b",
  /* 1702 */  "vsignum_le128b_0",
  /* 1703 */  "vsignum_gt128b",
  /* 1704 */  "vsignum_gt128b_0",
  /* 1705 */  "vcompressBits",
  /* 1706 */  "vexpandBits",
  /* 1707 */  "compareAndSwapP_shenandoah",
  /* 1708 */  "compareAndSwapN_shenandoah",
  /* 1709 */  "compareAndSwapPAcq_shenandoah",
  /* 1710 */  "compareAndSwapNAcq_shenandoah",
  /* 1711 */  "compareAndExchangeN_shenandoah",
  /* 1712 */  "compareAndExchangeP_shenandoah",
  /* 1713 */  "compareAndExchangeNAcq_shenandoah",
  /* 1714 */  "compareAndExchangePAcq_shenandoah",
  /* 1715 */  "weakCompareAndSwapN_shenandoah",
  /* 1716 */  "weakCompareAndSwapP_shenandoah",
  /* 1717 */  "weakCompareAndSwapNAcq_shenandoah",
  /* 1718 */  "weakCompareAndSwapPAcq_shenandoah",
  /* 1719 */  "xLoadP",
  /* 1720 */  "xLoadPVolatile",
  /* 1721 */  "xCompareAndSwapP",
  /* 1722 */  "xCompareAndSwapP_0",
  /* 1723 */  "xCompareAndSwapPAcq",
  /* 1724 */  "xCompareAndSwapPAcq_0",
  /* 1725 */  "xCompareAndExchangeP",
  /* 1726 */  "xCompareAndExchangePAcq",
  /* 1727 */  "xGetAndSetP",
  /* 1728 */  "xGetAndSetPAcq",
  /* 1729 */  "zLoadP",
  /* 1730 */  "zLoadPVolatile",
  /* 1731 */  "zStoreP",
  /* 1732 */  "zStorePVolatile",
  /* 1733 */  "zCompareAndSwapP",
  /* 1734 */  "zCompareAndSwapP_0",
  /* 1735 */  "zCompareAndSwapPAcq",
  /* 1736 */  "zCompareAndSwapPAcq_0",
  /* 1737 */  "zCompareAndExchangeP",
  /* 1738 */  "zCompareAndExchangePAcq",
  /* 1739 */  "zGetAndSetP",
  /* 1740 */  "zGetAndSetPAcq",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  true,
  /*   60 */  true,
  /*   61 */  true,
  /*   62 */  true,
  /*   63 */  true,
  /*   64 */  true,
  /*   65 */  true,
  /*   66 */  true,
  /*   67 */  true,
  /*   68 */  true,
  /*   69 */  true,
  /*   70 */  true,
  /*   71 */  true,
  /*   72 */  true,
  /*   73 */  true,
  /*   74 */  true,
  /*   75 */  true,
  /*   76 */  true,
  /*   77 */  true,
  /*   78 */  true,
  /*   79 */  true,
  /*   80 */  true,
  /*   81 */  true,
  /*   82 */  true,
  /*   83 */  true,
  /*   84 */  true,
  /*   85 */  true,
  /*   86 */  true,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  true,
  /*  192 */  true,
  /*  193 */  true,
  /*  194 */  true,
  /*  195 */  true,
  /*  196 */  false,
  /*  197 */  true,
  /*  198 */  true,
  /*  199 */  false,
  /*  200 */  false,
  // last operand
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  // last operand class
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  // last internally defined operand
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  /*  855 */  false,
  /*  856 */  false,
  /*  857 */  false,
  /*  858 */  false,
  /*  859 */  false,
  /*  860 */  false,
  /*  861 */  false,
  /*  862 */  false,
  /*  863 */  false,
  /*  864 */  false,
  /*  865 */  false,
  /*  866 */  false,
  /*  867 */  false,
  /*  868 */  false,
  /*  869 */  false,
  /*  870 */  false,
  /*  871 */  false,
  /*  872 */  false,
  /*  873 */  false,
  /*  874 */  false,
  /*  875 */  false,
  /*  876 */  false,
  /*  877 */  false,
  /*  878 */  false,
  /*  879 */  false,
  /*  880 */  false,
  /*  881 */  false,
  /*  882 */  false,
  /*  883 */  false,
  /*  884 */  false,
  /*  885 */  false,
  /*  886 */  false,
  /*  887 */  false,
  /*  888 */  false,
  /*  889 */  false,
  /*  890 */  false,
  /*  891 */  false,
  /*  892 */  false,
  /*  893 */  false,
  /*  894 */  false,
  /*  895 */  false,
  /*  896 */  false,
  /*  897 */  false,
  /*  898 */  false,
  /*  899 */  false,
  /*  900 */  false,
  /*  901 */  false,
  /*  902 */  false,
  /*  903 */  false,
  /*  904 */  false,
  /*  905 */  false,
  /*  906 */  false,
  /*  907 */  false,
  /*  908 */  false,
  /*  909 */  false,
  /*  910 */  false,
  /*  911 */  false,
  /*  912 */  false,
  /*  913 */  false,
  /*  914 */  false,
  /*  915 */  false,
  /*  916 */  false,
  /*  917 */  false,
  /*  918 */  false,
  /*  919 */  false,
  /*  920 */  false,
  /*  921 */  false,
  /*  922 */  false,
  /*  923 */  false,
  /*  924 */  false,
  /*  925 */  false,
  /*  926 */  false,
  /*  927 */  false,
  /*  928 */  false,
  /*  929 */  false,
  /*  930 */  false,
  /*  931 */  false,
  /*  932 */  false,
  /*  933 */  false,
  /*  934 */  false,
  /*  935 */  false,
  /*  936 */  false,
  /*  937 */  false,
  /*  938 */  false,
  /*  939 */  false,
  /*  940 */  false,
  /*  941 */  false,
  /*  942 */  false,
  /*  943 */  false,
  /*  944 */  false,
  /*  945 */  false,
  /*  946 */  false,
  /*  947 */  false,
  /*  948 */  false,
  /*  949 */  false,
  /*  950 */  false,
  /*  951 */  false,
  /*  952 */  false,
  /*  953 */  false,
  /*  954 */  false,
  /*  955 */  false,
  /*  956 */  false,
  /*  957 */  false,
  /*  958 */  false,
  /*  959 */  false,
  /*  960 */  false,
  /*  961 */  false,
  /*  962 */  false,
  /*  963 */  false,
  /*  964 */  false,
  /*  965 */  false,
  /*  966 */  false,
  /*  967 */  false,
  /*  968 */  false,
  /*  969 */  false,
  /*  970 */  false,
  /*  971 */  false,
  /*  972 */  false,
  /*  973 */  false,
  /*  974 */  false,
  /*  975 */  false,
  /*  976 */  false,
  /*  977 */  false,
  /*  978 */  false,
  /*  979 */  false,
  /*  980 */  false,
  /*  981 */  false,
  /*  982 */  false,
  /*  983 */  false,
  /*  984 */  false,
  /*  985 */  false,
  /*  986 */  false,
  /*  987 */  false,
  /*  988 */  false,
  /*  989 */  false,
  /*  990 */  false,
  /*  991 */  false,
  /*  992 */  false,
  /*  993 */  false,
  /*  994 */  false,
  /*  995 */  false,
  /*  996 */  false,
  /*  997 */  false,
  /*  998 */  false,
  /*  999 */  false,
  /* 1000 */  false,
  /* 1001 */  false,
  /* 1002 */  false,
  /* 1003 */  false,
  /* 1004 */  false,
  /* 1005 */  false,
  /* 1006 */  false,
  /* 1007 */  false,
  /* 1008 */  false,
  /* 1009 */  false,
  /* 1010 */  false,
  /* 1011 */  false,
  /* 1012 */  false,
  /* 1013 */  false,
  /* 1014 */  false,
  /* 1015 */  false,
  /* 1016 */  false,
  /* 1017 */  false,
  /* 1018 */  false,
  /* 1019 */  false,
  /* 1020 */  false,
  /* 1021 */  false,
  /* 1022 */  false,
  /* 1023 */  false,
  /* 1024 */  false,
  /* 1025 */  false,
  /* 1026 */  false,
  /* 1027 */  false,
  /* 1028 */  false,
  /* 1029 */  false,
  /* 1030 */  false,
  /* 1031 */  false,
  /* 1032 */  false,
  /* 1033 */  false,
  /* 1034 */  false,
  /* 1035 */  false,
  /* 1036 */  false,
  /* 1037 */  false,
  /* 1038 */  false,
  /* 1039 */  false,
  /* 1040 */  false,
  /* 1041 */  false,
  /* 1042 */  false,
  /* 1043 */  false,
  /* 1044 */  false,
  /* 1045 */  false,
  /* 1046 */  false,
  /* 1047 */  false,
  /* 1048 */  false,
  /* 1049 */  false,
  /* 1050 */  false,
  /* 1051 */  false,
  /* 1052 */  false,
  /* 1053 */  false,
  /* 1054 */  false,
  /* 1055 */  false,
  /* 1056 */  false,
  /* 1057 */  false,
  /* 1058 */  false,
  /* 1059 */  false,
  /* 1060 */  false,
  /* 1061 */  false,
  /* 1062 */  false,
  /* 1063 */  false,
  /* 1064 */  false,
  /* 1065 */  false,
  /* 1066 */  false,
  /* 1067 */  false,
  /* 1068 */  false,
  /* 1069 */  false,
  /* 1070 */  false,
  /* 1071 */  false,
  /* 1072 */  false,
  /* 1073 */  false,
  /* 1074 */  false,
  /* 1075 */  false,
  /* 1076 */  false,
  /* 1077 */  false,
  /* 1078 */  false,
  /* 1079 */  false,
  /* 1080 */  false,
  /* 1081 */  false,
  /* 1082 */  false,
  /* 1083 */  false,
  /* 1084 */  false,
  /* 1085 */  false,
  /* 1086 */  false,
  /* 1087 */  false,
  /* 1088 */  false,
  /* 1089 */  false,
  /* 1090 */  false,
  /* 1091 */  false,
  /* 1092 */  false,
  /* 1093 */  false,
  /* 1094 */  false,
  /* 1095 */  false,
  /* 1096 */  false,
  /* 1097 */  false,
  /* 1098 */  false,
  /* 1099 */  false,
  /* 1100 */  false,
  /* 1101 */  false,
  /* 1102 */  false,
  /* 1103 */  false,
  /* 1104 */  false,
  /* 1105 */  false,
  /* 1106 */  false,
  /* 1107 */  false,
  /* 1108 */  false,
  /* 1109 */  false,
  /* 1110 */  false,
  /* 1111 */  false,
  /* 1112 */  false,
  /* 1113 */  false,
  /* 1114 */  false,
  /* 1115 */  false,
  /* 1116 */  false,
  /* 1117 */  false,
  /* 1118 */  false,
  /* 1119 */  false,
  /* 1120 */  false,
  /* 1121 */  false,
  /* 1122 */  false,
  /* 1123 */  false,
  /* 1124 */  false,
  /* 1125 */  false,
  /* 1126 */  false,
  /* 1127 */  false,
  /* 1128 */  false,
  /* 1129 */  false,
  /* 1130 */  false,
  /* 1131 */  false,
  /* 1132 */  false,
  /* 1133 */  false,
  /* 1134 */  false,
  /* 1135 */  false,
  /* 1136 */  false,
  /* 1137 */  false,
  /* 1138 */  false,
  /* 1139 */  false,
  /* 1140 */  false,
  /* 1141 */  false,
  /* 1142 */  false,
  /* 1143 */  false,
  /* 1144 */  false,
  /* 1145 */  false,
  /* 1146 */  false,
  /* 1147 */  false,
  /* 1148 */  false,
  /* 1149 */  false,
  /* 1150 */  false,
  /* 1151 */  false,
  /* 1152 */  false,
  /* 1153 */  false,
  /* 1154 */  false,
  /* 1155 */  false,
  /* 1156 */  false,
  /* 1157 */  false,
  /* 1158 */  false,
  /* 1159 */  false,
  /* 1160 */  false,
  /* 1161 */  false,
  /* 1162 */  false,
  /* 1163 */  false,
  /* 1164 */  false,
  /* 1165 */  false,
  /* 1166 */  false,
  /* 1167 */  false,
  /* 1168 */  false,
  /* 1169 */  false,
  /* 1170 */  false,
  /* 1171 */  false,
  /* 1172 */  false,
  /* 1173 */  false,
  /* 1174 */  false,
  /* 1175 */  false,
  /* 1176 */  false,
  /* 1177 */  false,
  /* 1178 */  false,
  /* 1179 */  false,
  /* 1180 */  false,
  /* 1181 */  false,
  /* 1182 */  false,
  /* 1183 */  false,
  /* 1184 */  false,
  /* 1185 */  false,
  /* 1186 */  false,
  /* 1187 */  false,
  /* 1188 */  false,
  /* 1189 */  false,
  /* 1190 */  false,
  /* 1191 */  false,
  /* 1192 */  false,
  /* 1193 */  false,
  /* 1194 */  false,
  /* 1195 */  false,
  /* 1196 */  false,
  /* 1197 */  false,
  /* 1198 */  false,
  /* 1199 */  false,
  /* 1200 */  false,
  /* 1201 */  false,
  /* 1202 */  false,
  /* 1203 */  false,
  /* 1204 */  false,
  /* 1205 */  false,
  /* 1206 */  false,
  /* 1207 */  false,
  /* 1208 */  false,
  /* 1209 */  false,
  /* 1210 */  false,
  /* 1211 */  false,
  /* 1212 */  false,
  /* 1213 */  false,
  /* 1214 */  false,
  /* 1215 */  false,
  /* 1216 */  false,
  /* 1217 */  false,
  /* 1218 */  false,
  /* 1219 */  false,
  /* 1220 */  false,
  /* 1221 */  false,
  /* 1222 */  false,
  /* 1223 */  false,
  /* 1224 */  false,
  /* 1225 */  false,
  /* 1226 */  false,
  /* 1227 */  false,
  /* 1228 */  false,
  /* 1229 */  false,
  /* 1230 */  false,
  /* 1231 */  false,
  /* 1232 */  false,
  /* 1233 */  false,
  /* 1234 */  false,
  /* 1235 */  false,
  /* 1236 */  false,
  /* 1237 */  false,
  /* 1238 */  false,
  /* 1239 */  false,
  /* 1240 */  false,
  /* 1241 */  false,
  /* 1242 */  false,
  /* 1243 */  false,
  /* 1244 */  false,
  /* 1245 */  false,
  /* 1246 */  false,
  /* 1247 */  false,
  /* 1248 */  false,
  /* 1249 */  false,
  /* 1250 */  false,
  /* 1251 */  false,
  /* 1252 */  false,
  /* 1253 */  false,
  /* 1254 */  false,
  /* 1255 */  false,
  /* 1256 */  false,
  /* 1257 */  false,
  /* 1258 */  false,
  /* 1259 */  false,
  /* 1260 */  false,
  /* 1261 */  false,
  /* 1262 */  false,
  /* 1263 */  false,
  /* 1264 */  false,
  /* 1265 */  false,
  /* 1266 */  false,
  /* 1267 */  false,
  /* 1268 */  false,
  /* 1269 */  false,
  /* 1270 */  false,
  /* 1271 */  false,
  /* 1272 */  false,
  /* 1273 */  false,
  /* 1274 */  false,
  /* 1275 */  false,
  /* 1276 */  false,
  /* 1277 */  false,
  /* 1278 */  false,
  /* 1279 */  false,
  /* 1280 */  false,
  /* 1281 */  false,
  /* 1282 */  false,
  /* 1283 */  false,
  /* 1284 */  false,
  /* 1285 */  false,
  /* 1286 */  false,
  /* 1287 */  false,
  /* 1288 */  false,
  /* 1289 */  false,
  /* 1290 */  false,
  /* 1291 */  false,
  /* 1292 */  false,
  /* 1293 */  false,
  /* 1294 */  false,
  /* 1295 */  false,
  /* 1296 */  false,
  /* 1297 */  false,
  /* 1298 */  false,
  /* 1299 */  false,
  /* 1300 */  false,
  /* 1301 */  false,
  /* 1302 */  false,
  /* 1303 */  false,
  /* 1304 */  false,
  /* 1305 */  false,
  /* 1306 */  false,
  /* 1307 */  false,
  /* 1308 */  false,
  /* 1309 */  false,
  /* 1310 */  false,
  /* 1311 */  false,
  /* 1312 */  false,
  /* 1313 */  false,
  /* 1314 */  false,
  /* 1315 */  false,
  /* 1316 */  false,
  /* 1317 */  false,
  /* 1318 */  false,
  /* 1319 */  false,
  /* 1320 */  false,
  /* 1321 */  false,
  /* 1322 */  false,
  /* 1323 */  false,
  /* 1324 */  false,
  /* 1325 */  false,
  /* 1326 */  false,
  /* 1327 */  false,
  /* 1328 */  false,
  /* 1329 */  false,
  /* 1330 */  false,
  /* 1331 */  false,
  /* 1332 */  false,
  /* 1333 */  false,
  /* 1334 */  false,
  /* 1335 */  false,
  /* 1336 */  false,
  /* 1337 */  false,
  /* 1338 */  false,
  /* 1339 */  false,
  /* 1340 */  false,
  /* 1341 */  false,
  /* 1342 */  false,
  /* 1343 */  false,
  /* 1344 */  false,
  /* 1345 */  false,
  /* 1346 */  false,
  /* 1347 */  false,
  /* 1348 */  false,
  /* 1349 */  false,
  /* 1350 */  false,
  /* 1351 */  false,
  /* 1352 */  false,
  /* 1353 */  false,
  /* 1354 */  false,
  /* 1355 */  false,
  /* 1356 */  false,
  /* 1357 */  false,
  /* 1358 */  false,
  /* 1359 */  false,
  /* 1360 */  false,
  /* 1361 */  false,
  /* 1362 */  false,
  /* 1363 */  false,
  /* 1364 */  false,
  /* 1365 */  false,
  /* 1366 */  false,
  /* 1367 */  false,
  /* 1368 */  false,
  /* 1369 */  false,
  /* 1370 */  false,
  /* 1371 */  false,
  /* 1372 */  false,
  /* 1373 */  false,
  /* 1374 */  false,
  /* 1375 */  false,
  /* 1376 */  false,
  /* 1377 */  false,
  /* 1378 */  false,
  /* 1379 */  false,
  /* 1380 */  false,
  /* 1381 */  false,
  /* 1382 */  false,
  /* 1383 */  false,
  /* 1384 */  false,
  /* 1385 */  false,
  /* 1386 */  false,
  /* 1387 */  false,
  /* 1388 */  false,
  /* 1389 */  false,
  /* 1390 */  false,
  /* 1391 */  false,
  /* 1392 */  false,
  /* 1393 */  false,
  /* 1394 */  false,
  /* 1395 */  false,
  /* 1396 */  false,
  /* 1397 */  false,
  /* 1398 */  false,
  /* 1399 */  false,
  /* 1400 */  false,
  /* 1401 */  false,
  /* 1402 */  false,
  /* 1403 */  false,
  /* 1404 */  false,
  /* 1405 */  false,
  /* 1406 */  false,
  /* 1407 */  false,
  /* 1408 */  false,
  /* 1409 */  false,
  /* 1410 */  false,
  /* 1411 */  false,
  /* 1412 */  false,
  /* 1413 */  false,
  /* 1414 */  false,
  /* 1415 */  false,
  /* 1416 */  false,
  /* 1417 */  false,
  /* 1418 */  false,
  /* 1419 */  false,
  /* 1420 */  false,
  /* 1421 */  false,
  /* 1422 */  false,
  /* 1423 */  false,
  /* 1424 */  false,
  /* 1425 */  false,
  /* 1426 */  false,
  /* 1427 */  false,
  /* 1428 */  false,
  /* 1429 */  false,
  /* 1430 */  false,
  /* 1431 */  false,
  /* 1432 */  false,
  /* 1433 */  false,
  /* 1434 */  false,
  /* 1435 */  false,
  /* 1436 */  false,
  /* 1437 */  false,
  /* 1438 */  false,
  /* 1439 */  false,
  /* 1440 */  false,
  /* 1441 */  false,
  /* 1442 */  false,
  /* 1443 */  false,
  /* 1444 */  false,
  /* 1445 */  false,
  /* 1446 */  false,
  /* 1447 */  false,
  /* 1448 */  false,
  /* 1449 */  false,
  /* 1450 */  false,
  /* 1451 */  false,
  /* 1452 */  false,
  /* 1453 */  false,
  /* 1454 */  false,
  /* 1455 */  false,
  /* 1456 */  false,
  /* 1457 */  false,
  /* 1458 */  false,
  /* 1459 */  false,
  /* 1460 */  false,
  /* 1461 */  false,
  /* 1462 */  false,
  /* 1463 */  false,
  /* 1464 */  false,
  /* 1465 */  false,
  /* 1466 */  false,
  /* 1467 */  false,
  /* 1468 */  false,
  /* 1469 */  false,
  /* 1470 */  false,
  /* 1471 */  false,
  /* 1472 */  false,
  /* 1473 */  false,
  /* 1474 */  false,
  /* 1475 */  false,
  /* 1476 */  false,
  /* 1477 */  false,
  /* 1478 */  false,
  /* 1479 */  false,
  /* 1480 */  false,
  /* 1481 */  false,
  /* 1482 */  false,
  /* 1483 */  false,
  /* 1484 */  false,
  /* 1485 */  false,
  /* 1486 */  false,
  /* 1487 */  false,
  /* 1488 */  false,
  /* 1489 */  false,
  /* 1490 */  false,
  /* 1491 */  false,
  /* 1492 */  false,
  /* 1493 */  false,
  /* 1494 */  false,
  /* 1495 */  false,
  /* 1496 */  false,
  /* 1497 */  false,
  /* 1498 */  false,
  /* 1499 */  false,
  /* 1500 */  false,
  /* 1501 */  false,
  /* 1502 */  false,
  /* 1503 */  false,
  /* 1504 */  false,
  /* 1505 */  false,
  /* 1506 */  false,
  /* 1507 */  false,
  /* 1508 */  false,
  /* 1509 */  false,
  /* 1510 */  false,
  /* 1511 */  false,
  /* 1512 */  false,
  /* 1513 */  false,
  /* 1514 */  false,
  /* 1515 */  false,
  /* 1516 */  false,
  /* 1517 */  false,
  /* 1518 */  false,
  /* 1519 */  false,
  /* 1520 */  false,
  /* 1521 */  false,
  /* 1522 */  false,
  /* 1523 */  false,
  /* 1524 */  false,
  /* 1525 */  false,
  /* 1526 */  false,
  /* 1527 */  false,
  /* 1528 */  false,
  /* 1529 */  false,
  /* 1530 */  false,
  /* 1531 */  false,
  /* 1532 */  false,
  /* 1533 */  false,
  /* 1534 */  false,
  /* 1535 */  false,
  /* 1536 */  false,
  /* 1537 */  false,
  /* 1538 */  false,
  /* 1539 */  false,
  /* 1540 */  false,
  /* 1541 */  false,
  /* 1542 */  false,
  /* 1543 */  false,
  /* 1544 */  false,
  /* 1545 */  false,
  /* 1546 */  false,
  /* 1547 */  false,
  /* 1548 */  false,
  /* 1549 */  false,
  /* 1550 */  false,
  /* 1551 */  false,
  /* 1552 */  false,
  /* 1553 */  false,
  /* 1554 */  false,
  /* 1555 */  false,
  /* 1556 */  false,
  /* 1557 */  false,
  /* 1558 */  false,
  /* 1559 */  false,
  /* 1560 */  false,
  /* 1561 */  false,
  /* 1562 */  false,
  /* 1563 */  false,
  /* 1564 */  false,
  /* 1565 */  false,
  /* 1566 */  false,
  /* 1567 */  false,
  /* 1568 */  false,
  /* 1569 */  false,
  /* 1570 */  false,
  /* 1571 */  false,
  /* 1572 */  false,
  /* 1573 */  false,
  /* 1574 */  false,
  /* 1575 */  false,
  /* 1576 */  false,
  /* 1577 */  false,
  /* 1578 */  false,
  /* 1579 */  false,
  /* 1580 */  false,
  /* 1581 */  false,
  /* 1582 */  false,
  /* 1583 */  false,
  /* 1584 */  false,
  /* 1585 */  false,
  /* 1586 */  false,
  /* 1587 */  false,
  /* 1588 */  false,
  /* 1589 */  false,
  /* 1590 */  false,
  /* 1591 */  false,
  /* 1592 */  false,
  /* 1593 */  false,
  /* 1594 */  false,
  /* 1595 */  false,
  /* 1596 */  false,
  /* 1597 */  false,
  /* 1598 */  false,
  /* 1599 */  false,
  /* 1600 */  false,
  /* 1601 */  false,
  /* 1602 */  false,
  /* 1603 */  false,
  /* 1604 */  false,
  /* 1605 */  false,
  /* 1606 */  false,
  /* 1607 */  false,
  /* 1608 */  false,
  /* 1609 */  false,
  /* 1610 */  false,
  /* 1611 */  false,
  /* 1612 */  false,
  /* 1613 */  false,
  /* 1614 */  false,
  /* 1615 */  false,
  /* 1616 */  false,
  /* 1617 */  false,
  /* 1618 */  false,
  /* 1619 */  false,
  /* 1620 */  false,
  /* 1621 */  false,
  /* 1622 */  false,
  /* 1623 */  false,
  /* 1624 */  false,
  /* 1625 */  false,
  /* 1626 */  false,
  /* 1627 */  false,
  /* 1628 */  false,
  /* 1629 */  false,
  /* 1630 */  false,
  /* 1631 */  false,
  /* 1632 */  false,
  /* 1633 */  false,
  /* 1634 */  false,
  /* 1635 */  false,
  /* 1636 */  false,
  /* 1637 */  false,
  /* 1638 */  false,
  /* 1639 */  false,
  /* 1640 */  false,
  /* 1641 */  false,
  /* 1642 */  false,
  /* 1643 */  false,
  /* 1644 */  false,
  /* 1645 */  false,
  /* 1646 */  false,
  /* 1647 */  false,
  /* 1648 */  false,
  /* 1649 */  false,
  /* 1650 */  false,
  /* 1651 */  false,
  /* 1652 */  false,
  /* 1653 */  false,
  /* 1654 */  false,
  /* 1655 */  false,
  /* 1656 */  false,
  /* 1657 */  false,
  /* 1658 */  false,
  /* 1659 */  false,
  /* 1660 */  false,
  /* 1661 */  false,
  /* 1662 */  false,
  /* 1663 */  false,
  /* 1664 */  false,
  /* 1665 */  false,
  /* 1666 */  false,
  /* 1667 */  false,
  /* 1668 */  false,
  /* 1669 */  false,
  /* 1670 */  false,
  /* 1671 */  false,
  /* 1672 */  false,
  /* 1673 */  false,
  /* 1674 */  false,
  /* 1675 */  false,
  /* 1676 */  false,
  /* 1677 */  false,
  /* 1678 */  false,
  /* 1679 */  false,
  /* 1680 */  false,
  /* 1681 */  false,
  /* 1682 */  false,
  /* 1683 */  false,
  /* 1684 */  false,
  /* 1685 */  false,
  /* 1686 */  false,
  /* 1687 */  false,
  /* 1688 */  false,
  /* 1689 */  false,
  /* 1690 */  false,
  /* 1691 */  false,
  /* 1692 */  false,
  /* 1693 */  false,
  /* 1694 */  false,
  /* 1695 */  false,
  /* 1696 */  false,
  /* 1697 */  false,
  /* 1698 */  false,
  /* 1699 */  false,
  /* 1700 */  false,
  /* 1701 */  false,
  /* 1702 */  false,
  /* 1703 */  false,
  /* 1704 */  false,
  /* 1705 */  false,
  /* 1706 */  false,
  /* 1707 */  false,
  /* 1708 */  false,
  /* 1709 */  false,
  /* 1710 */  false,
  /* 1711 */  false,
  /* 1712 */  false,
  /* 1713 */  false,
  /* 1714 */  false,
  /* 1715 */  false,
  /* 1716 */  false,
  /* 1717 */  false,
  /* 1718 */  false,
  /* 1719 */  false,
  /* 1720 */  false,
  /* 1721 */  false,
  /* 1722 */  false,
  /* 1723 */  false,
  /* 1724 */  false,
  /* 1725 */  false,
  /* 1726 */  false,
  /* 1727 */  false,
  /* 1728 */  false,
  /* 1729 */  false,
  /* 1730 */  false,
  /* 1731 */  false,
  /* 1732 */  false,
  /* 1733 */  false,
  /* 1734 */  false,
  /* 1735 */  false,
  /* 1736 */  false,
  /* 1737 */  false,
  /* 1738 */  false,
  /* 1739 */  false,
  /* 1740 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // VecA: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // VecZ: 13
  0, // RegVectMask: 14
  0, // RegFlags: 15
  0, // _last_machine_leaf: 16
  0, // AbsD: 17
  0, // AbsF: 18
  0, // AbsI: 19
  0, // AbsL: 20
  0, // AddD: 21
  0, // AddF: 22
  0, // AddI: 23
  0, // AddL: 24
  0, // AddP: 25
  0, // Allocate: 26
  0, // AllocateArray: 27
  0, // AndI: 28
  0, // AndL: 29
  0, // ArrayCopy: 30
  0, // AryEq: 31
  0, // AtanD: 32
  1, // Binary: 33
  0, // Blackhole: 34
  1, // Bool: 35
  0, // BoxLock: 36
  0, // ReverseBytesI: 37
  0, // ReverseBytesL: 38
  0, // ReverseBytesUS: 39
  0, // ReverseBytesS: 40
  0, // ReverseBytesV: 41
  0, // CProj: 42
  0, // CacheWB: 43
  0, // CacheWBPreSync: 44
  0, // CacheWBPostSync: 45
  0, // CallDynamicJava: 46
  0, // CallJava: 47
  0, // CallLeaf: 48
  0, // CallLeafNoFP: 49
  0, // CallLeafVector: 50
  0, // CallRuntime: 51
  0, // CallStaticJava: 52
  0, // CastDD: 53
  0, // CastFF: 54
  0, // CastII: 55
  0, // CastLL: 56
  0, // CastVV: 57
  0, // CastX2P: 58
  0, // CastP2X: 59
  0, // CastPP: 60
  0, // Catch: 61
  0, // CatchProj: 62
  0, // CheckCastPP: 63
  0, // ClearArray: 64
  0, // CompressBits: 65
  0, // ExpandBits: 66
  0, // CompressBitsV: 67
  0, // ExpandBitsV: 68
  0, // ConstraintCast: 69
  0, // CMoveD: 70
  0, // CMoveF: 71
  0, // CMoveI: 72
  0, // CMoveL: 73
  0, // CMoveP: 74
  0, // CMoveN: 75
  1, // CmpN: 76
  1, // CmpD: 77
  0, // CmpD3: 78
  1, // CmpF: 79
  0, // CmpF3: 80
  1, // CmpI: 81
  1, // CmpL: 82
  0, // CmpL3: 83
  0, // CmpLTMask: 84
  1, // CmpP: 85
  1, // CmpU: 86
  0, // CmpU3: 87
  1, // CmpUL: 88
  0, // CmpUL3: 89
  0, // CompareAndSwapB: 90
  0, // CompareAndSwapS: 91
  0, // CompareAndSwapI: 92
  0, // CompareAndSwapL: 93
  0, // CompareAndSwapP: 94
  0, // CompareAndSwapN: 95
  0, // WeakCompareAndSwapB: 96
  0, // WeakCompareAndSwapS: 97
  0, // WeakCompareAndSwapI: 98
  0, // WeakCompareAndSwapL: 99
  0, // WeakCompareAndSwapP: 100
  0, // WeakCompareAndSwapN: 101
  0, // CompareAndExchangeB: 102
  0, // CompareAndExchangeS: 103
  0, // CompareAndExchangeI: 104
  0, // CompareAndExchangeL: 105
  0, // CompareAndExchangeP: 106
  0, // CompareAndExchangeN: 107
  0, // GetAndAddB: 108
  0, // GetAndAddS: 109
  0, // GetAndAddI: 110
  0, // GetAndAddL: 111
  0, // GetAndSetB: 112
  0, // GetAndSetS: 113
  0, // GetAndSetI: 114
  0, // GetAndSetL: 115
  0, // GetAndSetP: 116
  0, // GetAndSetN: 117
  0, // Con: 118
  0, // ConN: 119
  0, // ConNKlass: 120
  0, // ConD: 121
  0, // ConF: 122
  0, // ConI: 123
  0, // ConL: 124
  0, // ConP: 125
  0, // Conv2B: 126
  0, // ConvD2F: 127
  0, // ConvD2I: 128
  0, // ConvD2L: 129
  0, // ConvF2D: 130
  0, // ConvF2I: 131
  0, // ConvF2L: 132
  0, // ConvI2D: 133
  0, // ConvI2F: 134
  0, // ConvI2L: 135
  0, // ConvL2D: 136
  0, // ConvL2F: 137
  0, // ConvL2I: 138
  0, // ConvF2HF: 139
  0, // ConvHF2F: 140
  0, // CountedLoop: 141
  0, // CountedLoopEnd: 142
  0, // OuterStripMinedLoop: 143
  0, // OuterStripMinedLoopEnd: 144
  0, // LongCountedLoop: 145
  0, // LongCountedLoopEnd: 146
  0, // CountLeadingZerosI: 147
  0, // CountLeadingZerosL: 148
  0, // CountLeadingZerosV: 149
  0, // CountTrailingZerosI: 150
  0, // CountTrailingZerosL: 151
  0, // CountTrailingZerosV: 152
  0, // CreateEx: 153
  0, // DecodeN: 154
  0, // DecodeNKlass: 155
  0, // DivD: 156
  0, // DivF: 157
  0, // DivI: 158
  0, // DivL: 159
  0, // UDivI: 160
  0, // UDivL: 161
  0, // DivMod: 162
  0, // DivModI: 163
  0, // DivModL: 164
  0, // UDivModI: 165
  0, // UDivModL: 166
  0, // EncodeISOArray: 167
  0, // EncodeP: 168
  0, // EncodePKlass: 169
  1, // FastLock: 170
  1, // FastUnlock: 171
  0, // FmaD: 172
  0, // FmaF: 173
  0, // Goto: 174
  0, // Halt: 175
  0, // CountPositives: 176
  0, // If: 177
  0, // RangeCheck: 178
  0, // IfFalse: 179
  0, // IfTrue: 180
  0, // Initialize: 181
  0, // JProj: 182
  0, // Jump: 183
  0, // JumpProj: 184
  0, // LShiftI: 185
  0, // LShiftL: 186
  0, // LoadB: 187
  0, // LoadUB: 188
  0, // LoadUS: 189
  0, // LoadD: 190
  0, // LoadD_unaligned: 191
  0, // LoadF: 192
  0, // LoadI: 193
  0, // LoadKlass: 194
  0, // LoadNKlass: 195
  0, // LoadL: 196
  0, // LoadL_unaligned: 197
  0, // LoadP: 198
  0, // LoadN: 199
  0, // LoadRange: 200
  0, // LoadS: 201
  0, // Lock: 202
  0, // Loop: 203
  0, // LoopLimit: 204
  0, // Mach: 205
  0, // MachNullCheck: 206
  0, // MachProj: 207
  0, // MulAddS2I: 208
  0, // MaxI: 209
  0, // MaxL: 210
  0, // MaxD: 211
  0, // MaxF: 212
  0, // MemBarAcquire: 213
  0, // LoadFence: 214
  0, // MemBarAcquireLock: 215
  0, // MemBarCPUOrder: 216
  0, // MemBarRelease: 217
  0, // StoreFence: 218
  0, // StoreStoreFence: 219
  0, // MemBarReleaseLock: 220
  0, // MemBarVolatile: 221
  0, // MemBarStoreStore: 222
  0, // MergeMem: 223
  0, // MinI: 224
  0, // MinL: 225
  0, // MinF: 226
  0, // MinD: 227
  0, // ModD: 228
  0, // ModF: 229
  0, // ModI: 230
  0, // ModL: 231
  0, // UModI: 232
  0, // UModL: 233
  0, // MoveI2F: 234
  0, // MoveF2I: 235
  0, // MoveL2D: 236
  0, // MoveD2L: 237
  0, // IsInfiniteF: 238
  0, // IsFiniteF: 239
  0, // IsInfiniteD: 240
  0, // IsFiniteD: 241
  0, // MulD: 242
  0, // MulF: 243
  0, // MulHiL: 244
  0, // UMulHiL: 245
  0, // MulI: 246
  0, // MulL: 247
  0, // Multi: 248
  0, // NegI: 249
  0, // NegL: 250
  0, // NegD: 251
  0, // NegF: 252
  0, // NeverBranch: 253
  0, // OnSpinWait: 254
  0, // Opaque1: 255
  0, // OpaqueLoopInit: 256
  0, // OpaqueLoopStride: 257
  0, // OpaqueZeroTripGuard: 258
  0, // Opaque3: 259
  0, // Opaque4: 260
  0, // ProfileBoolean: 261
  0, // OrI: 262
  0, // OrL: 263
  1, // OverflowAddI: 264
  1, // OverflowSubI: 265
  1, // OverflowMulI: 266
  1, // OverflowAddL: 267
  1, // OverflowSubL: 268
  1, // OverflowMulL: 269
  0, // PCTable: 270
  0, // Parm: 271
  0, // ParsePredicate: 272
  0, // PartialSubtypeCheck: 273
  0, // SubTypeCheck: 274
  0, // Phi: 275
  0, // PopCountI: 276
  0, // PopCountL: 277
  0, // PopCountVI: 278
  0, // PopCountVL: 279
  0, // PopulateIndex: 280
  0, // PrefetchAllocation: 281
  0, // Proj: 282
  0, // RShiftI: 283
  0, // RShiftL: 284
  0, // Region: 285
  0, // Rethrow: 286
  0, // Return: 287
  0, // ReverseI: 288
  0, // ReverseL: 289
  0, // ReverseV: 290
  0, // Root: 291
  0, // RoundDouble: 292
  0, // RoundDoubleMode: 293
  0, // RoundDoubleModeV: 294
  0, // RoundFloat: 295
  0, // RotateLeft: 296
  0, // RotateLeftV: 297
  0, // RotateRight: 298
  0, // RotateRightV: 299
  0, // SafePoint: 300
  0, // SafePointScalarObject: 301
  0, // SafePointScalarMerge: 302
  0, // ShenandoahCompareAndExchangeP: 303
  0, // ShenandoahCompareAndExchangeN: 304
  0, // ShenandoahCompareAndSwapN: 305
  0, // ShenandoahCompareAndSwapP: 306
  0, // ShenandoahWeakCompareAndSwapN: 307
  0, // ShenandoahWeakCompareAndSwapP: 308
  0, // ShenandoahIUBarrier: 309
  0, // ShenandoahLoadReferenceBarrier: 310
  0, // SCMemProj: 311
  0, // CopySignD: 312
  0, // CopySignF: 313
  0, // SignumD: 314
  0, // SignumF: 315
  0, // SignumVF: 316
  0, // SignumVD: 317
  0, // SqrtD: 318
  0, // SqrtF: 319
  0, // RoundF: 320
  0, // RoundD: 321
  0, // Start: 322
  0, // StartOSR: 323
  0, // StoreB: 324
  0, // StoreC: 325
  0, // StoreCM: 326
  0, // StoreD: 327
  0, // StoreF: 328
  0, // StoreI: 329
  0, // StoreL: 330
  0, // StoreP: 331
  0, // StoreN: 332
  0, // StoreNKlass: 333
  0, // StrComp: 334
  0, // StrCompressedCopy: 335
  0, // StrEquals: 336
  0, // StrIndexOf: 337
  0, // StrIndexOfChar: 338
  0, // StrInflatedCopy: 339
  0, // SubD: 340
  0, // SubF: 341
  0, // SubI: 342
  0, // SubL: 343
  0, // TailCall: 344
  0, // TailJump: 345
  0, // MacroLogicV: 346
  0, // ThreadLocal: 347
  0, // Unlock: 348
  0, // URShiftB: 349
  0, // URShiftS: 350
  0, // URShiftI: 351
  0, // URShiftL: 352
  0, // XorI: 353
  0, // XorL: 354
  0, // Vector: 355
  0, // AddVB: 356
  0, // AddVS: 357
  0, // AddVI: 358
  0, // AddReductionVI: 359
  0, // AddVL: 360
  0, // AddReductionVL: 361
  0, // AddVF: 362
  0, // AddReductionVF: 363
  0, // AddVD: 364
  0, // AddReductionVD: 365
  0, // SubVB: 366
  0, // SubVS: 367
  0, // SubVI: 368
  0, // SubVL: 369
  0, // SubVF: 370
  0, // SubVD: 371
  0, // MulVB: 372
  0, // MulVS: 373
  0, // MulVI: 374
  0, // MulReductionVI: 375
  0, // MulVL: 376
  0, // MulReductionVL: 377
  0, // MulVF: 378
  0, // MulReductionVF: 379
  0, // MulVD: 380
  0, // MulReductionVD: 381
  0, // MulAddVS2VI: 382
  0, // FmaVD: 383
  0, // FmaVF: 384
  0, // DivVF: 385
  0, // DivVD: 386
  0, // AbsVB: 387
  0, // AbsVS: 388
  0, // AbsVI: 389
  0, // AbsVL: 390
  0, // AbsVF: 391
  0, // AbsVD: 392
  0, // NegVI: 393
  0, // NegVL: 394
  0, // NegVF: 395
  0, // NegVD: 396
  0, // SqrtVD: 397
  0, // SqrtVF: 398
  0, // LShiftCntV: 399
  0, // RShiftCntV: 400
  0, // LShiftVB: 401
  0, // LShiftVS: 402
  0, // LShiftVI: 403
  0, // LShiftVL: 404
  0, // RShiftVB: 405
  0, // RShiftVS: 406
  0, // RShiftVI: 407
  0, // RShiftVL: 408
  0, // URShiftVB: 409
  0, // URShiftVS: 410
  0, // URShiftVI: 411
  0, // URShiftVL: 412
  0, // AndV: 413
  0, // AndReductionV: 414
  0, // OrV: 415
  0, // OrReductionV: 416
  0, // XorV: 417
  0, // XorReductionV: 418
  0, // MinV: 419
  0, // MaxV: 420
  0, // MinReductionV: 421
  0, // MaxReductionV: 422
  0, // CompressV: 423
  0, // CompressM: 424
  0, // ExpandV: 425
  0, // LoadVector: 426
  0, // LoadVectorGather: 427
  0, // LoadVectorGatherMasked: 428
  0, // StoreVector: 429
  0, // StoreVectorScatter: 430
  0, // StoreVectorScatterMasked: 431
  0, // LoadVectorMasked: 432
  0, // StoreVectorMasked: 433
  0, // VectorCmpMasked: 434
  0, // VectorMaskGen: 435
  0, // VectorMaskOp: 436
  0, // VectorMaskTrueCount: 437
  0, // VectorMaskFirstTrue: 438
  0, // VectorMaskLastTrue: 439
  0, // VectorMaskToLong: 440
  0, // VectorLongToMask: 441
  0, // Pack: 442
  0, // PackB: 443
  0, // PackS: 444
  0, // PackI: 445
  0, // PackL: 446
  0, // PackF: 447
  0, // PackD: 448
  0, // Pack2L: 449
  0, // Pack2D: 450
  0, // Replicate: 451
  0, // RoundVF: 452
  0, // RoundVD: 453
  0, // Extract: 454
  0, // ExtractB: 455
  0, // ExtractUB: 456
  0, // ExtractC: 457
  0, // ExtractS: 458
  0, // ExtractI: 459
  0, // ExtractL: 460
  0, // ExtractF: 461
  0, // ExtractD: 462
  0, // Digit: 463
  0, // LowerCase: 464
  0, // UpperCase: 465
  0, // Whitespace: 466
  0, // VectorBox: 467
  0, // VectorBoxAllocate: 468
  0, // VectorUnbox: 469
  0, // VectorMaskWrapper: 470
  0, // VectorMaskCmp: 471
  0, // VectorMaskCast: 472
  1, // VectorTest: 473
  0, // VectorBlend: 474
  0, // VectorRearrange: 475
  0, // VectorLoadMask: 476
  0, // VectorLoadShuffle: 477
  0, // VectorLoadConst: 478
  0, // VectorStoreMask: 479
  0, // VectorReinterpret: 480
  0, // VectorCast: 481
  0, // VectorCastB2X: 482
  0, // VectorCastS2X: 483
  0, // VectorCastI2X: 484
  0, // VectorCastL2X: 485
  0, // VectorCastF2X: 486
  0, // VectorCastD2X: 487
  0, // VectorCastF2HF: 488
  0, // VectorCastHF2F: 489
  0, // VectorUCastB2X: 490
  0, // VectorUCastS2X: 491
  0, // VectorUCastI2X: 492
  0, // VectorizedHashCode: 493
  0, // VectorInsert: 494
  0, // MaskAll: 495
  0, // AndVMask: 496
  0, // OrVMask: 497
  0 // no trailing comma // XorVMask: 498
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R12",
  "R12_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R18",
  "R18_H",
  "R0",
  "R0_H",
  "R1",
  "R1_H",
  "R2",
  "R2_H",
  "R3",
  "R3_H",
  "R4",
  "R4_H",
  "R5",
  "R5_H",
  "R6",
  "R6_H",
  "R7",
  "R7_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R23",
  "R23_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R27",
  "R27_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "R8",
  "R8_H",
  "R9",
  "R9_H",
  "V16",
  "V16_H",
  "V16_J",
  "V16_K",
  "V17",
  "V17_H",
  "V17_J",
  "V17_K",
  "V18",
  "V18_H",
  "V18_J",
  "V18_K",
  "V19",
  "V19_H",
  "V19_J",
  "V19_K",
  "V20",
  "V20_H",
  "V20_J",
  "V20_K",
  "V21",
  "V21_H",
  "V21_J",
  "V21_K",
  "V22",
  "V22_H",
  "V22_J",
  "V22_K",
  "V23",
  "V23_H",
  "V23_J",
  "V23_K",
  "V24",
  "V24_H",
  "V24_J",
  "V24_K",
  "V25",
  "V25_H",
  "V25_J",
  "V25_K",
  "V26",
  "V26_H",
  "V26_J",
  "V26_K",
  "V27",
  "V27_H",
  "V27_J",
  "V27_K",
  "V28",
  "V28_H",
  "V28_J",
  "V28_K",
  "V29",
  "V29_H",
  "V29_J",
  "V29_K",
  "V30",
  "V30_H",
  "V30_J",
  "V30_K",
  "V31",
  "V31_H",
  "V31_J",
  "V31_K",
  "V0",
  "V0_H",
  "V0_J",
  "V0_K",
  "V1",
  "V1_H",
  "V1_J",
  "V1_K",
  "V2",
  "V2_H",
  "V2_J",
  "V2_K",
  "V3",
  "V3_H",
  "V3_J",
  "V3_K",
  "V4",
  "V4_H",
  "V4_J",
  "V4_K",
  "V5",
  "V5_H",
  "V5_J",
  "V5_K",
  "V6",
  "V6_H",
  "V6_J",
  "V6_K",
  "V7",
  "V7_H",
  "V7_J",
  "V7_K",
  "V8",
  "V8_H",
  "V8_J",
  "V8_K",
  "V9",
  "V9_H",
  "V9_J",
  "V9_K",
  "V10",
  "V10_H",
  "V10_J",
  "V10_K",
  "V11",
  "V11_H",
  "V11_J",
  "V11_K",
  "V12",
  "V12_H",
  "V12_J",
  "V12_K",
  "V13",
  "V13_H",
  "V13_J",
  "V13_K",
  "V14",
  "V14_H",
  "V14_J",
  "V14_K",
  "V15",
  "V15_H",
  "V15_J",
  "V15_K",
  "P0",
  "P1",
  "P2",
  "P3",
  "P4",
  "P5",
  "P6",
  "P8",
  "P9",
  "P10",
  "P11",
  "P12",
  "P13",
  "P14",
  "P15",
  "P7",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	r10->as_VMReg()        ,
	r10->as_VMReg()->next(),
	r11->as_VMReg()        ,
	r11->as_VMReg()->next(),
	r12->as_VMReg()        ,
	r12->as_VMReg()->next(),
	r13->as_VMReg()        ,
	r13->as_VMReg()->next(),
	r14->as_VMReg()        ,
	r14->as_VMReg()->next(),
	r15->as_VMReg()        ,
	r15->as_VMReg()->next(),
	r16->as_VMReg()        ,
	r16->as_VMReg()->next(),
	r17->as_VMReg()        ,
	r17->as_VMReg()->next(),
	r18_tls->as_VMReg()        ,
	r18_tls->as_VMReg()->next(),
	r0->as_VMReg()         ,
	r0->as_VMReg()->next() ,
	r1->as_VMReg()         ,
	r1->as_VMReg()->next() ,
	r2->as_VMReg()         ,
	r2->as_VMReg()->next() ,
	r3->as_VMReg()         ,
	r3->as_VMReg()->next() ,
	r4->as_VMReg()         ,
	r4->as_VMReg()->next() ,
	r5->as_VMReg()         ,
	r5->as_VMReg()->next() ,
	r6->as_VMReg()         ,
	r6->as_VMReg()->next() ,
	r7->as_VMReg()         ,
	r7->as_VMReg()->next() ,
	r19->as_VMReg()        ,
	r19->as_VMReg()->next(),
	r20->as_VMReg()        ,
	r20->as_VMReg()->next(),
	r21->as_VMReg()        ,
	r21->as_VMReg()->next(),
	r22->as_VMReg()        ,
	r22->as_VMReg()->next(),
	r23->as_VMReg()        ,
	r23->as_VMReg()->next(),
	r24->as_VMReg()        ,
	r24->as_VMReg()->next(),
	r25->as_VMReg()        ,
	r25->as_VMReg()->next(),
	r26->as_VMReg()        ,
	r26->as_VMReg()->next(),
	r27->as_VMReg()        ,
	r27->as_VMReg()->next(),
	r28->as_VMReg()        ,
	r28->as_VMReg()->next(),
	r29->as_VMReg()        ,
	r29->as_VMReg()->next(),
	r30->as_VMReg()        ,
	r30->as_VMReg()->next(),
	r31_sp->as_VMReg()     ,
	r31_sp->as_VMReg()->next(),
	r8->as_VMReg()         ,
	r8->as_VMReg()->next() ,
	r9->as_VMReg()         ,
	r9->as_VMReg()->next() ,
	v16->as_VMReg()          ,
	v16->as_VMReg()->next()  ,
	v16->as_VMReg()->next(2) ,
	v16->as_VMReg()->next(3) ,
	v17->as_VMReg()          ,
	v17->as_VMReg()->next()  ,
	v17->as_VMReg()->next(2) ,
	v17->as_VMReg()->next(3) ,
	v18->as_VMReg()          ,
	v18->as_VMReg()->next()  ,
	v18->as_VMReg()->next(2) ,
	v18->as_VMReg()->next(3) ,
	v19->as_VMReg()          ,
	v19->as_VMReg()->next()  ,
	v19->as_VMReg()->next(2) ,
	v19->as_VMReg()->next(3) ,
	v20->as_VMReg()          ,
	v20->as_VMReg()->next()  ,
	v20->as_VMReg()->next(2) ,
	v20->as_VMReg()->next(3) ,
	v21->as_VMReg()          ,
	v21->as_VMReg()->next()  ,
	v21->as_VMReg()->next(2) ,
	v21->as_VMReg()->next(3) ,
	v22->as_VMReg()          ,
	v22->as_VMReg()->next()  ,
	v22->as_VMReg()->next(2) ,
	v22->as_VMReg()->next(3) ,
	v23->as_VMReg()          ,
	v23->as_VMReg()->next()  ,
	v23->as_VMReg()->next(2) ,
	v23->as_VMReg()->next(3) ,
	v24->as_VMReg()          ,
	v24->as_VMReg()->next()  ,
	v24->as_VMReg()->next(2) ,
	v24->as_VMReg()->next(3) ,
	v25->as_VMReg()          ,
	v25->as_VMReg()->next()  ,
	v25->as_VMReg()->next(2) ,
	v25->as_VMReg()->next(3) ,
	v26->as_VMReg()          ,
	v26->as_VMReg()->next()  ,
	v26->as_VMReg()->next(2) ,
	v26->as_VMReg()->next(3) ,
	v27->as_VMReg()          ,
	v27->as_VMReg()->next()  ,
	v27->as_VMReg()->next(2) ,
	v27->as_VMReg()->next(3) ,
	v28->as_VMReg()          ,
	v28->as_VMReg()->next()  ,
	v28->as_VMReg()->next(2) ,
	v28->as_VMReg()->next(3) ,
	v29->as_VMReg()          ,
	v29->as_VMReg()->next()  ,
	v29->as_VMReg()->next(2) ,
	v29->as_VMReg()->next(3) ,
	v30->as_VMReg()          ,
	v30->as_VMReg()->next()  ,
	v30->as_VMReg()->next(2) ,
	v30->as_VMReg()->next(3) ,
	v31->as_VMReg()          ,
	v31->as_VMReg()->next()  ,
	v31->as_VMReg()->next(2) ,
	v31->as_VMReg()->next(3) ,
	v0->as_VMReg()          ,
	v0->as_VMReg()->next()  ,
	v0->as_VMReg()->next(2) ,
	v0->as_VMReg()->next(3) ,
	v1->as_VMReg()          ,
	v1->as_VMReg()->next()  ,
	v1->as_VMReg()->next(2) ,
	v1->as_VMReg()->next(3) ,
	v2->as_VMReg()          ,
	v2->as_VMReg()->next()  ,
	v2->as_VMReg()->next(2) ,
	v2->as_VMReg()->next(3) ,
	v3->as_VMReg()          ,
	v3->as_VMReg()->next()  ,
	v3->as_VMReg()->next(2) ,
	v3->as_VMReg()->next(3) ,
	v4->as_VMReg()          ,
	v4->as_VMReg()->next()  ,
	v4->as_VMReg()->next(2) ,
	v4->as_VMReg()->next(3) ,
	v5->as_VMReg()          ,
	v5->as_VMReg()->next()  ,
	v5->as_VMReg()->next(2) ,
	v5->as_VMReg()->next(3) ,
	v6->as_VMReg()          ,
	v6->as_VMReg()->next()  ,
	v6->as_VMReg()->next(2) ,
	v6->as_VMReg()->next(3) ,
	v7->as_VMReg()          ,
	v7->as_VMReg()->next()  ,
	v7->as_VMReg()->next(2) ,
	v7->as_VMReg()->next(3) ,
	v8->as_VMReg()          ,
	v8->as_VMReg()->next()  ,
	v8->as_VMReg()->next(2) ,
	v8->as_VMReg()->next(3) ,
	v9->as_VMReg()          ,
	v9->as_VMReg()->next()  ,
	v9->as_VMReg()->next(2) ,
	v9->as_VMReg()->next(3) ,
	v10->as_VMReg()          ,
	v10->as_VMReg()->next()  ,
	v10->as_VMReg()->next(2) ,
	v10->as_VMReg()->next(3) ,
	v11->as_VMReg()          ,
	v11->as_VMReg()->next()  ,
	v11->as_VMReg()->next(2) ,
	v11->as_VMReg()->next(3) ,
	v12->as_VMReg()          ,
	v12->as_VMReg()->next()  ,
	v12->as_VMReg()->next(2) ,
	v12->as_VMReg()->next(3) ,
	v13->as_VMReg()          ,
	v13->as_VMReg()->next()  ,
	v13->as_VMReg()->next(2) ,
	v13->as_VMReg()->next(3) ,
	v14->as_VMReg()          ,
	v14->as_VMReg()->next()  ,
	v14->as_VMReg()->next(2) ,
	v14->as_VMReg()->next(3) ,
	v15->as_VMReg()          ,
	v15->as_VMReg()->next()  ,
	v15->as_VMReg()->next(2) ,
	v15->as_VMReg()->next(3) ,
	p0->as_VMReg(),
	p1->as_VMReg(),
	p2->as_VMReg(),
	p3->as_VMReg(),
	p4->as_VMReg(),
	p5->as_VMReg(),
	p6->as_VMReg(),
	p8->as_VMReg(),
	p9->as_VMReg(),
	p10->as_VMReg(),
	p11->as_VMReg(),
	p12->as_VMReg(),
	p13->as_VMReg(),
	p14->as_VMReg(),
	p15->as_VMReg(),
	p7->as_VMReg(),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x1',  // R1
  (unsigned char)'\x1',  // R1_H
  (unsigned char)'\x2',  // R2
  (unsigned char)'\x2',  // R2_H
  (unsigned char)'\x3',  // R3
  (unsigned char)'\x3',  // R3_H
  (unsigned char)'\x4',  // R4
  (unsigned char)'\x4',  // R4_H
  (unsigned char)'\x5',  // R5
  (unsigned char)'\x5',  // R5_H
  (unsigned char)'\x6',  // R6
  (unsigned char)'\x6',  // R6_H
  (unsigned char)'\x7',  // R7
  (unsigned char)'\x7',  // R7_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\x8',  // R8
  (unsigned char)'\x8',  // R8_H
  (unsigned char)'\x9',  // R9
  (unsigned char)'\x9',  // R9_H
  (unsigned char)'\x10',  // V16
  (unsigned char)'\x10',  // V16_H
  (unsigned char)'\x10',  // V16_J
  (unsigned char)'\x10',  // V16_K
  (unsigned char)'\x11',  // V17
  (unsigned char)'\x11',  // V17_H
  (unsigned char)'\x11',  // V17_J
  (unsigned char)'\x11',  // V17_K
  (unsigned char)'\x12',  // V18
  (unsigned char)'\x12',  // V18_H
  (unsigned char)'\x12',  // V18_J
  (unsigned char)'\x12',  // V18_K
  (unsigned char)'\x13',  // V19
  (unsigned char)'\x13',  // V19_H
  (unsigned char)'\x13',  // V19_J
  (unsigned char)'\x13',  // V19_K
  (unsigned char)'\x14',  // V20
  (unsigned char)'\x14',  // V20_H
  (unsigned char)'\x14',  // V20_J
  (unsigned char)'\x14',  // V20_K
  (unsigned char)'\x15',  // V21
  (unsigned char)'\x15',  // V21_H
  (unsigned char)'\x15',  // V21_J
  (unsigned char)'\x15',  // V21_K
  (unsigned char)'\x16',  // V22
  (unsigned char)'\x16',  // V22_H
  (unsigned char)'\x16',  // V22_J
  (unsigned char)'\x16',  // V22_K
  (unsigned char)'\x17',  // V23
  (unsigned char)'\x17',  // V23_H
  (unsigned char)'\x17',  // V23_J
  (unsigned char)'\x17',  // V23_K
  (unsigned char)'\x18',  // V24
  (unsigned char)'\x18',  // V24_H
  (unsigned char)'\x18',  // V24_J
  (unsigned char)'\x18',  // V24_K
  (unsigned char)'\x19',  // V25
  (unsigned char)'\x19',  // V25_H
  (unsigned char)'\x19',  // V25_J
  (unsigned char)'\x19',  // V25_K
  (unsigned char)'\x1A',  // V26
  (unsigned char)'\x1A',  // V26_H
  (unsigned char)'\x1A',  // V26_J
  (unsigned char)'\x1A',  // V26_K
  (unsigned char)'\x1B',  // V27
  (unsigned char)'\x1B',  // V27_H
  (unsigned char)'\x1B',  // V27_J
  (unsigned char)'\x1B',  // V27_K
  (unsigned char)'\x1C',  // V28
  (unsigned char)'\x1C',  // V28_H
  (unsigned char)'\x1C',  // V28_J
  (unsigned char)'\x1C',  // V28_K
  (unsigned char)'\x1D',  // V29
  (unsigned char)'\x1D',  // V29_H
  (unsigned char)'\x1D',  // V29_J
  (unsigned char)'\x1D',  // V29_K
  (unsigned char)'\x1E',  // V30
  (unsigned char)'\x1E',  // V30_H
  (unsigned char)'\x1E',  // V30_J
  (unsigned char)'\x1E',  // V30_K
  (unsigned char)'\x1F',  // V31
  (unsigned char)'\x1F',  // V31_H
  (unsigned char)'\x1F',  // V31_J
  (unsigned char)'\x1F',  // V31_K
  (unsigned char)'\x0',  // V0
  (unsigned char)'\x0',  // V0_H
  (unsigned char)'\x0',  // V0_J
  (unsigned char)'\x0',  // V0_K
  (unsigned char)'\x1',  // V1
  (unsigned char)'\x1',  // V1_H
  (unsigned char)'\x1',  // V1_J
  (unsigned char)'\x1',  // V1_K
  (unsigned char)'\x2',  // V2
  (unsigned char)'\x2',  // V2_H
  (unsigned char)'\x2',  // V2_J
  (unsigned char)'\x2',  // V2_K
  (unsigned char)'\x3',  // V3
  (unsigned char)'\x3',  // V3_H
  (unsigned char)'\x3',  // V3_J
  (unsigned char)'\x3',  // V3_K
  (unsigned char)'\x4',  // V4
  (unsigned char)'\x4',  // V4_H
  (unsigned char)'\x4',  // V4_J
  (unsigned char)'\x4',  // V4_K
  (unsigned char)'\x5',  // V5
  (unsigned char)'\x5',  // V5_H
  (unsigned char)'\x5',  // V5_J
  (unsigned char)'\x5',  // V5_K
  (unsigned char)'\x6',  // V6
  (unsigned char)'\x6',  // V6_H
  (unsigned char)'\x6',  // V6_J
  (unsigned char)'\x6',  // V6_K
  (unsigned char)'\x7',  // V7
  (unsigned char)'\x7',  // V7_H
  (unsigned char)'\x7',  // V7_J
  (unsigned char)'\x7',  // V7_K
  (unsigned char)'\x8',  // V8
  (unsigned char)'\x8',  // V8_H
  (unsigned char)'\x8',  // V8_J
  (unsigned char)'\x8',  // V8_K
  (unsigned char)'\x9',  // V9
  (unsigned char)'\x9',  // V9_H
  (unsigned char)'\x9',  // V9_J
  (unsigned char)'\x9',  // V9_K
  (unsigned char)'\xA',  // V10
  (unsigned char)'\xA',  // V10_H
  (unsigned char)'\xA',  // V10_J
  (unsigned char)'\xA',  // V10_K
  (unsigned char)'\xB',  // V11
  (unsigned char)'\xB',  // V11_H
  (unsigned char)'\xB',  // V11_J
  (unsigned char)'\xB',  // V11_K
  (unsigned char)'\xC',  // V12
  (unsigned char)'\xC',  // V12_H
  (unsigned char)'\xC',  // V12_J
  (unsigned char)'\xC',  // V12_K
  (unsigned char)'\xD',  // V13
  (unsigned char)'\xD',  // V13_H
  (unsigned char)'\xD',  // V13_J
  (unsigned char)'\xD',  // V13_K
  (unsigned char)'\xE',  // V14
  (unsigned char)'\xE',  // V14_H
  (unsigned char)'\xE',  // V14_J
  (unsigned char)'\xE',  // V14_K
  (unsigned char)'\xF',  // V15
  (unsigned char)'\xF',  // V15_H
  (unsigned char)'\xF',  // V15_J
  (unsigned char)'\xF',  // V15_K
  (unsigned char)'\x0',  // P0
  (unsigned char)'\x1',  // P1
  (unsigned char)'\x2',  // P2
  (unsigned char)'\x3',  // P3
  (unsigned char)'\x4',  // P4
  (unsigned char)'\x5',  // P5
  (unsigned char)'\x6',  // P6
  (unsigned char)'\x8',  // P8
  (unsigned char)'\x9',  // P9
  (unsigned char)'\xA',  // P10
  (unsigned char)'\xB',  // P11
  (unsigned char)'\xC',  // P12
  (unsigned char)'\xD',  // P13
  (unsigned char)'\xE',  // P14
  (unsigned char)'\xF',  // P15
  (unsigned char)'\x7',  // P7
  (unsigned char)'\x20' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone() const {
  return  new labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone() const {
  return  new methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegINoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *iRegLNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *iRegPNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_PTR_REG_mask();
}

const RegMask *iRegP_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegP_R1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R1_REG_mask();
}

const RegMask *iRegP_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegP_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegP_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R4_REG_mask();
}

const RegMask *iRegP_R5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R5_REG_mask();
}

const RegMask *iRegP_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *iRegL_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegL_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegL_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegL_R11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R11_REG_mask();
}

const RegMask *iRegP_FPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_REG_mask();
}

const RegMask *iRegI_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R0_REG_mask();
}

const RegMask *iRegI_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R2_REG_mask();
}

const RegMask *iRegI_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R3_REG_mask();
}

const RegMask *iRegI_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R4_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegN_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegN_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegN_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegNNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *vRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *vRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *vRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &RegMask::Empty;
}

const RegMask *vecAOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORA_REG_mask();
}

const RegMask *vecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORD_REG_mask();
}

const RegMask *vecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_mask();
}

const RegMask *vRegD_V0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_REG_mask();
}

const RegMask *vRegD_V1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_REG_mask();
}

const RegMask *vRegD_V2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V2_REG_mask();
}

const RegMask *vRegD_V3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V3_REG_mask();
}

const RegMask *vRegD_V4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V4_REG_mask();
}

const RegMask *vRegD_V5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V5_REG_mask();
}

const RegMask *vRegD_V6Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V6_REG_mask();
}

const RegMask *vRegD_V7Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V7_REG_mask();
}

const RegMask *vRegD_V8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V8_REG_mask();
}

const RegMask *vRegD_V9Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V9_REG_mask();
}

const RegMask *vRegD_V10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V10_REG_mask();
}

const RegMask *vRegD_V11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V11_REG_mask();
}

const RegMask *vRegD_V12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V12_REG_mask();
}

const RegMask *vRegD_V13Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V13_REG_mask();
}

const RegMask *vRegD_V14Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V14_REG_mask();
}

const RegMask *vRegD_V15Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V15_REG_mask();
}

const RegMask *vRegD_V16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V16_REG_mask();
}

const RegMask *vRegD_V17Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V17_REG_mask();
}

const RegMask *vRegD_V18Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V18_REG_mask();
}

const RegMask *vRegD_V19Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V19_REG_mask();
}

const RegMask *vRegD_V20Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V20_REG_mask();
}

const RegMask *vRegD_V21Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V21_REG_mask();
}

const RegMask *vRegD_V22Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V22_REG_mask();
}

const RegMask *vRegD_V23Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V23_REG_mask();
}

const RegMask *vRegD_V24Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V24_REG_mask();
}

const RegMask *vRegD_V25Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V25_REG_mask();
}

const RegMask *vRegD_V26Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V26_REG_mask();
}

const RegMask *vRegD_V27Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V27_REG_mask();
}

const RegMask *vRegD_V28Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V28_REG_mask();
}

const RegMask *vRegD_V29Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V29_REG_mask();
}

const RegMask *vRegD_V30Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V30_REG_mask();
}

const RegMask *vRegD_V31Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V31_REG_mask();
}

const RegMask *pRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PR_REG_mask();
}

const RegMask *pRegGovOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &GOV_PR_mask();
}

const RegMask *pRegGov_P0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P0_REG_mask();
}

const RegMask *pRegGov_P1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P1_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *inline_cache_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *thread_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &THREAD_REG_mask();
}

const RegMask *lr_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LR_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indIndexScaledI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexScaledOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffI16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffL16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indirectNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *thread_anchor_pcOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *iRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *vmemA_indOffI4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *vmemA_indOffL4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

//------------------Define members for classes derived from MachNode----------
// Build short branch version of this instruction
MachNode *far_cmpL_branch_signNode::short_branch_version() {
  cmpL_branch_signNode *node = new cmpL_branch_signNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_branch_signNode::short_branch_version() {
  cmpI_branch_signNode *node = new cmpI_branch_signNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpL_branch_bitNode::short_branch_version() {
  cmpL_branch_bitNode *node = new cmpL_branch_bitNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_branch_bitNode::short_branch_version() {
  cmpI_branch_bitNode *node = new cmpI_branch_bitNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

void overflowMulI_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulI_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void overflowMulL_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulL_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_narrowOop_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_narrowOop_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpUI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpUI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpUL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpUL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_branch_signNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_branch_signNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_branch_bitNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_branch_bitNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(5));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP1Node::reloc() const {
  return 1;
}

int loadByteMapBaseNode::reloc() const {
  return 1;
}

int loadConF_packedNode::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_packedNode::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeimmCM0Node::reloc() const {
  return 2;
}

int storeimmCM0_orderedNode::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 3;
}

int storeimmB0Node::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 3;
}

int storeimmC0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeimmI0Node::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeimmL0Node::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeimmP0Node::reloc() const {
  return 3;
}

int storeNNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int prefetchallocNode::reloc() const {
  return 1;
}

int storeB_volatileNode::reloc() const {
  return 1;
}

int storeC_volatileNode::reloc() const {
  return 1;
}

int storeI_volatileNode::reloc() const {
  return 1;
}

int storeimmP0_volatileNode::reloc() const {
  return 1;
}

int bytes_reverse_intNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_shortNode::reloc() const {
  return 1;
}

int bytes_reverse_shortNode::reloc() const {
  return 1;
}

int countLeadingZerosINode::reloc() const {
  return 1;
}

int countTrailingZerosINode::reloc() const {
  return 1;
}

int popCountINode::reloc() const {
  return 1;
}

int popCountI_memNode::reloc() const {
  return 1;
}

int popCountL_memNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int get_and_addIAcqNode::reloc() const {
  return 1;
}

int get_and_addI_no_resAcqNode::reloc() const {
  return 1;
}

int cmovI_reg_regNode::reloc() const {
  return 2;
}

int cmovUI_reg_regNode::reloc() const {
  return 2;
}

int cmovI_zero_regNode::reloc() const {
  return 1;
}

int cmovUI_zero_regNode::reloc() const {
  return 1;
}

int cmovI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_zero_regNode::reloc() const {
  return 1;
}

int cmovUP_zero_regNode::reloc() const {
  return 1;
}

int addI_reg_regNode::reloc() const {
  return 2;
}

int addI_reg_immNode::reloc() const {
  return 1;
}

int addP_reg_reg_extNode::reloc() const {
  return 1;
}

int addP_reg_reg_ext_shiftNode::reloc() const {
  return 1;
}

int lshift_extNode::reloc() const {
  return 1;
}

int subI_reg_regNode::reloc() const {
  return 2;
}

int subI_reg_immNode::reloc() const {
  return 1;
}

int negI_regNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 2;
}

int smulINode::reloc() const {
  return 2;
}

int smulI_0Node::reloc() const {
  return 2;
}

int maddINode::reloc() const {
  return 3;
}

int maddI_0Node::reloc() const {
  return 3;
}

int msubINode::reloc() const {
  return 3;
}

int mnegINode::reloc() const {
  return 2;
}

int mnegI_0Node::reloc() const {
  return 2;
}

int smaddLNode::reloc() const {
  return 2;
}

int smaddL_1Node::reloc() const {
  return 2;
}

int smaddL_0Node::reloc() const {
  return 2;
}

int smaddL_2Node::reloc() const {
  return 2;
}

int smsubLNode::reloc() const {
  return 2;
}

int smsubL_0Node::reloc() const {
  return 2;
}

int smnegLNode::reloc() const {
  return 2;
}

int smnegL_0Node::reloc() const {
  return 2;
}

int muladdS2INode::reloc() const {
  return 4;
}

int divINode::reloc() const {
  return 2;
}

int modINode::reloc() const {
  return 2;
}

int UdivI_reg_regNode::reloc() const {
  return 2;
}

int UmodI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_immNode::reloc() const {
  return 1;
}

int urShiftI_reg_regNode::reloc() const {
  return 2;
}

int urShiftI_reg_immNode::reloc() const {
  return 1;
}

int rShiftI_reg_regNode::reloc() const {
  return 2;
}

int rShiftI_reg_immNode::reloc() const {
  return 1;
}

int lShiftL_reg_regNode::reloc() const {
  return 1;
}

int urShiftL_reg_regNode::reloc() const {
  return 1;
}

int rShiftL_reg_regNode::reloc() const {
  return 1;
}

int regI_not_regNode::reloc() const {
  return 1;
}

int NegI_reg_URShift_regNode::reloc() const {
  return 1;
}

int NegI_reg_RShift_regNode::reloc() const {
  return 1;
}

int NegI_reg_LShift_regNode::reloc() const {
  return 1;
}

int AndI_reg_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_2Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_regNode::reloc() const {
  return 2;
}

int AndI_reg_RotateRight_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_regNode::reloc() const {
  return 2;
}

int XorI_reg_RotateRight_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_regNode::reloc() const {
  return 2;
}

int OrI_reg_RotateRight_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int SubI_reg_URShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_RShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_LShift_regNode::reloc() const {
  return 2;
}

int sbfmwINode::reloc() const {
  return 1;
}

int ubfmwINode::reloc() const {
  return 1;
}

int ubfxwINode::reloc() const {
  return 1;
}

int ubfxIConvI2LNode::reloc() const {
  return 1;
}

int ubfizwINode::reloc() const {
  return 1;
}

int ubfizwIConvI2LNode::reloc() const {
  return 1;
}

int ubfizIConvI2LNode::reloc() const {
  return 1;
}

int extrOrINode::reloc() const {
  return 2;
}

int extrOrI_0Node::reloc() const {
  return 2;
}

int extrAddINode::reloc() const {
  return 2;
}

int extrAddI_0Node::reloc() const {
  return 2;
}

int AddExtINode::reloc() const {
  return 1;
}

int AddExtI_0Node::reloc() const {
  return 1;
}

int SubExtINode::reloc() const {
  return 1;
}

int AddExtI_sxthNode::reloc() const {
  return 2;
}

int AddExtI_sxth_0Node::reloc() const {
  return 2;
}

int AddExtI_sxtbNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtbNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtb_andNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_and_0Node::reloc() const {
  return 2;
}

int AddExtI_uxth_andNode::reloc() const {
  return 2;
}

int AddExtI_uxth_and_0Node::reloc() const {
  return 2;
}

int SubExtI_uxtb_andNode::reloc() const {
  return 2;
}

int SubExtI_uxth_andNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_shiftNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_shift_0Node::reloc() const {
  return 2;
}

int AddExtI_sxth_shiftNode::reloc() const {
  return 2;
}

int AddExtI_sxth_shift_0Node::reloc() const {
  return 2;
}

int SubExtI_sxtb_shiftNode::reloc() const {
  return 2;
}

int SubExtI_sxth_shiftNode::reloc() const {
  return 2;
}

int AddExtI_shiftNode::reloc() const {
  return 1;
}

int AddExtI_shift_0Node::reloc() const {
  return 1;
}

int SubExtI_shiftNode::reloc() const {
  return 1;
}

int AddExtI_uxtb_and_shiftNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_and_shift_0Node::reloc() const {
  return 2;
}

int AddExtI_uxth_and_shiftNode::reloc() const {
  return 2;
}

int AddExtI_uxth_and_shift_0Node::reloc() const {
  return 2;
}

int SubExtI_uxtb_and_shiftNode::reloc() const {
  return 2;
}

int SubExtI_uxth_and_shiftNode::reloc() const {
  return 2;
}

int minI_reg_imm0Node::reloc() const {
  return 1;
}

int minI_imm0_regNode::reloc() const {
  return 1;
}

int minI_reg_imm1Node::reloc() const {
  return 1;
}

int minI_imm1_regNode::reloc() const {
  return 1;
}

int minI_reg_immM1Node::reloc() const {
  return 1;
}

int minI_immM1_regNode::reloc() const {
  return 1;
}

int maxI_reg_imm0Node::reloc() const {
  return 1;
}

int maxI_imm0_regNode::reloc() const {
  return 1;
}

int maxI_reg_imm1Node::reloc() const {
  return 1;
}

int maxI_imm1_regNode::reloc() const {
  return 1;
}

int maxI_reg_immM1Node::reloc() const {
  return 1;
}

int maxI_immM1_regNode::reloc() const {
  return 1;
}

int bits_reverse_INode::reloc() const {
  return 1;
}

int mnsubF_reg_regNode::reloc() const {
  return 1;
}

int mnsubD_reg_regNode::reloc() const {
  return 1;
}

int absI_regNode::reloc() const {
  return 1;
}

int andI_reg_regNode::reloc() const {
  return 2;
}

int andI_reg_immNode::reloc() const {
  return 1;
}

int orI_reg_regNode::reloc() const {
  return 2;
}

int orI_reg_immNode::reloc() const {
  return 1;
}

int xorI_reg_regNode::reloc() const {
  return 2;
}

int xorI_reg_immNode::reloc() const {
  return 1;
}

int convI2L_reg_regNode::reloc() const {
  return 1;
}

int convUI2L_reg_regNode::reloc() const {
  return 1;
}

int convI2F_reg_regNode::reloc() const {
  return 1;
}

int convI2D_reg_regNode::reloc() const {
  return 1;
}

int overflowAddI_reg_regNode::reloc() const {
  return 2;
}

int overflowAddI_reg_immNode::reloc() const {
  return 1;
}

int overflowSubI_reg_regNode::reloc() const {
  return 2;
}

int overflowSubI_reg_immNode::reloc() const {
  return 1;
}

int overflowNegI_regNode::reloc() const {
  return 1;
}

int overflowMulI_regNode::reloc() const {
  return 2;
}

int overflowMulI_reg_branchNode::reloc() const {
  return 2;
}

int testP_regNode::reloc() const {
  return 1;
}

int compF_reg_zeroNode::reloc() const {
  return 1;
}

int compD_reg_zeroNode::reloc() const {
  return 1;
}

int compF3_reg_immF0Node::reloc() const {
  return 1;
}

int compD3_reg_immD0Node::reloc() const {
  return 1;
}

int cmpLTMask_reg_regNode::reloc() const {
  return 2;
}

int cmpLTMask_reg_zeroNode::reloc() const {
  return 1;
}

int minI_reg_regNode::reloc() const {
  return 2;
}

int maxI_reg_regNode::reloc() const {
  return 2;
}

int cmpI_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_narrowOop_imm0_branchNode::reloc() const {
  return 1;
}

int cmpUI_imm0_branchNode::reloc() const {
  return 1;
}

int cmpI_branch_signNode::reloc() const {
  return 1;
}

int cmpI_branch_bitNode::reloc() const {
  return 1;
}

int far_cmpI_branch_signNode::reloc() const {
  return 1;
}

int far_cmpI_branch_bitNode::reloc() const {
  return 1;
}

int cmpI_andNode::reloc() const {
  return 1;
}

int cmpI_and_regNode::reloc() const {
  return 2;
}

int safePointNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int TailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int partialSubtypeCheckVsZeroNode::reloc() const {
  return 1;
}

int compressBitsI_regNode::reloc() const {
  return 2;
}

int compressBitsI_memconNode::reloc() const {
  return 1;
}

int compressBitsL_memconNode::reloc() const {
  return 1;
}

int expandBitsI_regNode::reloc() const {
  return 2;
}

int expandBitsI_memconNode::reloc() const {
  return 1;
}

int expandBitsL_memconNode::reloc() const {
  return 1;
}

int loadV2Node::reloc() const {
  return 1;
}

int storeV2Node::reloc() const {
  return 2;
}

int loadV4Node::reloc() const {
  return 1;
}

int storeV4Node::reloc() const {
  return 2;
}

int loadV8Node::reloc() const {
  return 1;
}

int storeV8Node::reloc() const {
  return 2;
}

int loadV16Node::reloc() const {
  return 1;
}

int storeV16Node::reloc() const {
  return 2;
}

int loadVNode::reloc() const {
  return 1;
}

int storeVNode::reloc() const {
  return 2;
}

int loadV_maskedNode::reloc() const {
  return 1;
}

int storeV_maskedNode::reloc() const {
  return 2;
}

int vshiftcntLNode::reloc() const {
  return 1;
}

int vshiftcntRNode::reloc() const {
  return 1;
}

int reduce_addI_neonNode::reloc() const {
  return 1;
}

int reduce_addI_sveNode::reloc() const {
  return 1;
}

int reduce_addI_maskedNode::reloc() const {
  return 1;
}

int reduce_mulINode::reloc() const {
  return 1;
}

int reduce_andI_neonNode::reloc() const {
  return 1;
}

int reduce_andI_sveNode::reloc() const {
  return 1;
}

int reduce_andI_maskedNode::reloc() const {
  return 1;
}

int reduce_orI_neonNode::reloc() const {
  return 1;
}

int reduce_orI_sveNode::reloc() const {
  return 1;
}

int reduce_orI_maskedNode::reloc() const {
  return 1;
}

int reduce_xorI_neonNode::reloc() const {
  return 1;
}

int reduce_xorI_sveNode::reloc() const {
  return 1;
}

int reduce_xorI_maskedNode::reloc() const {
  return 1;
}

int reduce_maxI_neonNode::reloc() const {
  return 1;
}

int reduce_maxI_sveNode::reloc() const {
  return 1;
}

int reduce_maxI_maskedNode::reloc() const {
  return 1;
}

int reduce_minI_neonNode::reloc() const {
  return 1;
}

int reduce_minI_sveNode::reloc() const {
  return 1;
}

int reduce_minI_maskedNode::reloc() const {
  return 1;
}

int replicateINode::reloc() const {
  return 1;
}

int insertI_le128bNode::reloc() const {
  return 1;
}

int insertI_index_lt32Node::reloc() const {
  return 1;
}

int insertI_index_ge32Node::reloc() const {
  return 1;
}

int vloadmask_loadVMaskedNode::reloc() const {
  return 1;
}

int vloadmask_loadVMasked_maskedNode::reloc() const {
  return 1;
}

int storeVMasked_vstoremaskNode::reloc() const {
  return 2;
}

int storeVMasked_vstoremask_maskedNode::reloc() const {
  return 2;
}

int vmaskcmp_zeroF_neonNode::reloc() const {
  return 1;
}

int vmaskcmp_zeroD_neonNode::reloc() const {
  return 1;
}

int vmaskAllINode::reloc() const {
  return 1;
}

int vmaskAllI_maskedNode::reloc() const {
  return 1;
}

int vmask_gen_INode::reloc() const {
  return 1;
}

int populateindexNode::reloc() const {
  return 1;
}

int xLoadPNode::reloc() const {
  return 1;
}

int zLoadPNode::reloc() const {
  return 1;
}

int zStorePNode::reloc() const {
  return 2;
}


void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2843 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsbw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 14826 "ad_aarch64.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2851 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 14843 "ad_aarch64.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2867 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 14860 "ad_aarch64.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2867 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 14877 "ad_aarch64.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2875 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrshw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 14894 "ad_aarch64.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2883 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 14911 "ad_aarch64.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2899 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 14928 "ad_aarch64.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2899 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 14945 "ad_aarch64.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2915 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 14962 "ad_aarch64.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2923 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrsw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 14979 "ad_aarch64.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 2915 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 14997 "ad_aarch64.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2931 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15014 "ad_aarch64.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2915 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15031 "ad_aarch64.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2931 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15048 "ad_aarch64.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2915 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15065 "ad_aarch64.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2931 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15082 "ad_aarch64.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2915 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15099 "ad_aarch64.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2939 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15116 "ad_aarch64.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2947 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15133 "ad_aarch64.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3407 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    uint32_t con = (uint32_t)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (con == 0) {
      __ movw(dst_reg, zr);
    } else {
      __ movw(dst_reg, con);
    }
  
#line 15155 "ad_aarch64.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3418 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    uint64_t con = (uint64_t)opnd_array(1)->constantL();
    if (con == 0) {
      __ mov(dst_reg, zr);
    } else {
      __ mov(dst_reg, con);
    }
  
#line 15177 "ad_aarch64.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3429 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL || con == (address)1) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      if (rtype == relocInfo::oop_type) {
        __ movoop(dst_reg, (jobject)con);
      } else if (rtype == relocInfo::metadata_type) {
        __ mov_metadata(dst_reg, (Metadata*)con);
      } else {
        assert(rtype == relocInfo::none, "unexpected reloc type");
        if (! __ is_valid_AArch64_address(con) ||
            con < (address)(uintptr_t)os::vm_page_size()) {
          __ mov(dst_reg, con);
        } else {
          uint64_t offset;
          __ adrp(dst_reg, con, offset);
          __ add(dst_reg, dst_reg, offset);
        }
      }
    }
  
#line 15214 "ad_aarch64.cpp"
  }
}

void loadConP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3455 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 15231 "ad_aarch64.cpp"
  }
}

void loadConP1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3461 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, (uint64_t)1);
  
#line 15248 "ad_aarch64.cpp"
  }
}

void loadByteMapBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3467 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ load_byte_map_base(opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 15264 "ad_aarch64.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3472 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::oop_type, "unexpected reloc type");
      __ set_narrow_oop(dst_reg, (jobject)con);
    }
  
#line 15288 "ad_aarch64.cpp"
  }
}

void loadConN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3485 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 15305 "ad_aarch64.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 3491 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::metadata_type, "unexpected reloc type");
      __ set_narrow_klass(dst_reg, (Klass *)con);
    }
  
#line 15329 "ad_aarch64.cpp"
  }
}

void loadConF_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7305 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), (double)opnd_array(1)->constantF());
  
#line 15345 "ad_aarch64.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7323 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 15361 "ad_aarch64.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 7324 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 15370 "ad_aarch64.cpp"
  }
}
void loadConD_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7336 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constantD());
  
#line 15385 "ad_aarch64.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7353 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 15401 "ad_aarch64.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 7354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 15410 "ad_aarch64.cpp"
  }
}
void storeimmCM0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2963 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15427 "ad_aarch64.cpp"
  }
}

void storeimmCM0_orderedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3043 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

      C2_MacroAssembler _masm(&cbuf);
      __ membar(Assembler::StoreStore);
      loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15446 "ad_aarch64.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2955 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strb, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15464 "ad_aarch64.cpp"
  }
}

void storeimmB0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2963 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 1);
  
#line 15482 "ad_aarch64.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2971 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strh, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15500 "ad_aarch64.cpp"
  }
}

void storeimmC0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2979 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strh, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 2);
  
#line 15518 "ad_aarch64.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15536 "ad_aarch64.cpp"
  }
}

void storeimmI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2995 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15554 "ad_aarch64.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3003 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15580 "ad_aarch64.cpp"
  }
}

void storeimmL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3019 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15598 "ad_aarch64.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3003 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15624 "ad_aarch64.cpp"
  }
}

void storeimmP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3019 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15642 "ad_aarch64.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15660 "ad_aarch64.cpp"
  }
}

void storeImmN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2995 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15678 "ad_aarch64.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3027 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strs, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15696 "ad_aarch64.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3035 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strd, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
  
#line 15714 "ad_aarch64.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
  
#line 15732 "ad_aarch64.cpp"
  }
}

void prefetchallocNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 3386 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1KEEP);
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1KEEP);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1KEEP);
      }
    }
  
#line 15762 "ad_aarch64.cpp"
  }
}

void loadB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3140 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
    __ sxtb(dst_reg, dst_reg);
  
#line 15780 "ad_aarch64.cpp"
  }
}

void loadB2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3140 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
    __ sxtb(dst_reg, dst_reg);
  
#line 15798 "ad_aarch64.cpp"
  }
}

void loadUB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3152 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
  
#line 15814 "ad_aarch64.cpp"
  }
}

void loadUB2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3152 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarb);
  
#line 15830 "ad_aarch64.cpp"
  }
}

void loadS_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3157 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
    __ sxthw(dst_reg, dst_reg);
  
#line 15848 "ad_aarch64.cpp"
  }
}

void loadUS_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3171 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
  
#line 15864 "ad_aarch64.cpp"
  }
}

void loadUS2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3176 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
  
#line 15880 "ad_aarch64.cpp"
  }
}

void loadS2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3164 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarh);
    __ sxth(dst_reg, dst_reg);
  
#line 15898 "ad_aarch64.cpp"
  }
}

void loadI_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3186 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
  
#line 15914 "ad_aarch64.cpp"
  }
}

void loadUI2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 3186 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
  
#line 15931 "ad_aarch64.cpp"
  }
}

void loadL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3191 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldar);
  
#line 15947 "ad_aarch64.cpp"
  }
}

void loadP_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3191 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldar);
  
#line 15963 "ad_aarch64.cpp"
  }
}

void loadN_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3186 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
  
#line 15979 "ad_aarch64.cpp"
  }
}

void loadF_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3196 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(rscratch1, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldarw);
    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), rscratch1);
  
#line 15996 "ad_aarch64.cpp"
  }
}

void loadD_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(rscratch1, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
             rscratch1, ldar);
    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), rscratch1);
  
#line 16013 "ad_aarch64.cpp"
  }
}

void storeB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3103 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrb);
  
#line 16030 "ad_aarch64.cpp"
  }
}

void storeimmB0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3108 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrb);
  
#line 16047 "ad_aarch64.cpp"
  }
}

void storeC_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3113 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrh);
  
#line 16064 "ad_aarch64.cpp"
  }
}

void storeimmC0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3118 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrh);
  
#line 16081 "ad_aarch64.cpp"
  }
}

void storeI_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3123 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16098 "ad_aarch64.cpp"
  }
}

void storeimmI0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3128 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16115 "ad_aarch64.cpp"
  }
}

void storeL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3208 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    MOV_VOLATILE(src_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16141 "ad_aarch64.cpp"
  }
}

void storeimmL0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16158 "ad_aarch64.cpp"
  }
}

void storeP_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3208 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      C2_MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    MOV_VOLATILE(src_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16184 "ad_aarch64.cpp"
  }
}

void storeimmP0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16201 "ad_aarch64.cpp"
  }
}

void storeN_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3123 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16218 "ad_aarch64.cpp"
  }
}

void storeimmN0_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3128 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    MOV_VOLATILE(zr, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16235 "ad_aarch64.cpp"
  }
}

void storeF_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3227 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    {
      C2_MacroAssembler _masm(&cbuf);
      FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
      __ fmovs(rscratch2, src_reg);
    }
    MOV_VOLATILE(rscratch2, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlrw);
  
#line 16257 "ad_aarch64.cpp"
  }
}

void storeD_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3237 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    {
      C2_MacroAssembler _masm(&cbuf);
      FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
      __ fmovd(rscratch2, src_reg);
    }
    MOV_VOLATILE(rscratch2, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
                 rscratch1, stlr);
  
#line 16279 "ad_aarch64.cpp"
  }
}

void cacheWBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8008 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(opnd_array(1)->index_position() < 0, "should be");
    assert(opnd_array(1)->disp(ra_,this,idx1)== 0, "should be");
    __ cache_wb(Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), 0));
  
#line 16297 "ad_aarch64.cpp"
  }
}

void cacheWBPreSyncNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8023 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cache_wbsync(true);
  
#line 16313 "ad_aarch64.cpp"
  }
}

void cacheWBPostSyncNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8036 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cache_wbsync(false);
  
#line 16329 "ad_aarch64.cpp"
  }
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8051 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ revw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16345 "ad_aarch64.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8064 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rev(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16361 "ad_aarch64.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8077 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16377 "ad_aarch64.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8091 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), 0U, 15U);
  
#line 16394 "ad_aarch64.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8107 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16410 "ad_aarch64.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8119 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16426 "ad_aarch64.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8132 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbitw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 16443 "ad_aarch64.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8146 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbit(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 16460 "ad_aarch64.cpp"
  }
}

void popCountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8167 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); // ensure top 32 bits 0
    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16481 "ad_aarch64.cpp"
  }
}

void popCountI_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8187 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister tmp_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, tmp_reg, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16503 "ad_aarch64.cpp"
  }
}

void popCountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8209 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16523 "ad_aarch64.cpp"
  }
}

void popCountL_memNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8228 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister tmp_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, tmp_reg, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
    __ cnt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ T8B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ D, 0);
  
#line 16545 "ad_aarch64.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8249 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 16561 "ad_aarch64.cpp"
  }
}

void unnecessary_membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8262 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_acquire (elided)");
  
#line 16577 "ad_aarch64.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8276 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_acquire");
    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 16594 "ad_aarch64.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8291 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_acquire_lock (elided)");
  
#line 16610 "ad_aarch64.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8304 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 16626 "ad_aarch64.cpp"
  }
}

void unnecessary_membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8317 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_release (elided)");
  
#line 16642 "ad_aarch64.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8330 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_release");
    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 16659 "ad_aarch64.cpp"
  }
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8344 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 16675 "ad_aarch64.cpp"
  }
}

void membar_storestore_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8344 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 16691 "ad_aarch64.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8356 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_release_lock (elided)");
  
#line 16707 "ad_aarch64.cpp"
  }
}

void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8370 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_volatile (elided)");
  
#line 16723 "ad_aarch64.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8384 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ block_comment("membar_volatile");
    __ membar(Assembler::StoreLoad);
  
#line 16740 "ad_aarch64.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8401 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 16758 "ad_aarch64.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8416 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 16776 "ad_aarch64.cpp"
  }
}

void convP2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8431 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16792 "ad_aarch64.cpp"
  }
}

void convN2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8447 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16808 "ad_aarch64.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8462 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ encode_heap_oop(d, s);
  
#line 16826 "ad_aarch64.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8475 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16842 "ad_aarch64.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8487 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop(d, s);
  
#line 16860 "ad_aarch64.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8501 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop_not_null(d, s);
  
#line 16878 "ad_aarch64.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8519 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ encode_klass_not_null(dst_reg, src_reg);
  
#line 16896 "ad_aarch64.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8534 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (dst_reg != src_reg) {
      __ decode_klass_not_null(dst_reg, src_reg);
    } else {
      __ decode_klass_not_null(dst_reg);
    }
  
#line 16918 "ad_aarch64.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castLLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castFFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castFFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castDDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castDDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVMaskNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void compareAndSwapBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3332 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17043 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17053 "ad_aarch64.cpp"
  }
}

void compareAndSwapSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3324 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17074 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17084 "ad_aarch64.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3316 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17105 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17115 "ad_aarch64.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3308 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17136 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17146 "ad_aarch64.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3308 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17167 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17177 "ad_aarch64.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3316 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17198 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17208 "ad_aarch64.cpp"
  }
}

void compareAndSwapBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3369 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17229 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17239 "ad_aarch64.cpp"
  }
}

void compareAndSwapSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3361 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17260 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17270 "ad_aarch64.cpp"
  }
}

void compareAndSwapIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3353 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17291 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17301 "ad_aarch64.cpp"
  }
}

void compareAndSwapLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3345 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17322 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17332 "ad_aarch64.cpp"
  }
}

void compareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3345 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17353 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17363 "ad_aarch64.cpp"
  }
}

void compareAndSwapNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 3353 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, noreg);
  
#line 17384 "ad_aarch64.cpp"
  }
  {

#line 3378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 17394 "ad_aarch64.cpp"
  }
}

void compareAndExchangeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8892 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxtbw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17416 "ad_aarch64.cpp"
  }
}

void compareAndExchangeSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8910 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxthw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17438 "ad_aarch64.cpp"
  }
}

void compareAndExchangeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8928 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17459 "ad_aarch64.cpp"
  }
}

void compareAndExchangeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8945 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17480 "ad_aarch64.cpp"
  }
}

void compareAndExchangeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8962 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17501 "ad_aarch64.cpp"
  }
}

void compareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8980 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17522 "ad_aarch64.cpp"
  }
}

void compareAndExchangeBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8998 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxtbw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17544 "ad_aarch64.cpp"
  }
}

void compareAndExchangeSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9017 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ sxthw(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17566 "ad_aarch64.cpp"
  }
}

void compareAndExchangeIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9036 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17587 "ad_aarch64.cpp"
  }
}

void compareAndExchangeLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9054 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17608 "ad_aarch64.cpp"
  }
}

void compareAndExchangeNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9072 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17629 "ad_aarch64.cpp"
  }
}

void compareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9090 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ false, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 17650 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9108 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17671 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9127 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17692 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9146 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17713 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9165 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17734 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9184 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17755 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9204 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ false, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17776 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9224 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::byte, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17797 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9244 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::halfword, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17818 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9264 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17839 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9284 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17860 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9304 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::word, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17881 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9324 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
               Assembler::xword, /*acquire*/ true, /*release*/ true,
               /*weak*/ true, noreg);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* res */, Assembler::EQ);
  
#line 17902 "ad_aarch64.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9340 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 17919 "ad_aarch64.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9350 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 17936 "ad_aarch64.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9360 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 17953 "ad_aarch64.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9371 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 17970 "ad_aarch64.cpp"
  }
}

void get_and_setIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9382 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgalw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 17987 "ad_aarch64.cpp"
  }
}

void get_and_setLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9393 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgal(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18004 "ad_aarch64.cpp"
  }
}

void get_and_setNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9404 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgalw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18021 "ad_aarch64.cpp"
  }
}

void get_and_setPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9415 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_xchgal(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18038 "ad_aarch64.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9426 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18055 "ad_aarch64.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9437 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18072 "ad_aarch64.cpp"
  }
}

void get_and_addLiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9447 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18089 "ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9458 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18106 "ad_aarch64.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9468 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18123 "ad_aarch64.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9479 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18140 "ad_aarch64.cpp"
  }
}

void get_and_addIiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9489 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18157 "ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18174 "ad_aarch64.cpp"
  }
}

void get_and_addLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9511 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18191 "ad_aarch64.cpp"
  }
}

void get_and_addL_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9522 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18208 "ad_aarch64.cpp"
  }
}

void get_and_addLiAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9533 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18225 "ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9544 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addal(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18242 "ad_aarch64.cpp"
  }
}

void get_and_addIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9555 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18259 "ad_aarch64.cpp"
  }
}

void get_and_addI_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9566 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18276 "ad_aarch64.cpp"
  }
}

void get_and_addIiAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9577 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18293 "ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9588 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ atomic_addalw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 18310 "ad_aarch64.cpp"
  }
}

void cmpU3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9607 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18329 "ad_aarch64.cpp"
  }
}

void cmpU3_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9627 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subsw(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int32_t)opnd_array(2)->constant());
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18348 "ad_aarch64.cpp"
  }
}

void cmpUL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9649 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18367 "ad_aarch64.cpp"
  }
}

void cmpUL3_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9669 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subs(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int32_t)opnd_array(2)->constantL());
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LO);
  
#line 18386 "ad_aarch64.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9691 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 18405 "ad_aarch64.cpp"
  }
}

void cmpL3_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9711 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subs(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int32_t)opnd_array(2)->constantL());
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 18424 "ad_aarch64.cpp"
  }
}

void cmovI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9739 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18446 "ad_aarch64.cpp"
  }
}

void cmovUI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9755 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18468 "ad_aarch64.cpp"
  }
}

void cmovI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9780 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18490 "ad_aarch64.cpp"
  }
}

void cmovUI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9796 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18512 "ad_aarch64.cpp"
  }
}

void cmovI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9812 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18534 "ad_aarch64.cpp"
  }
}

void cmovUI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9828 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18556 "ad_aarch64.cpp"
  }
}

void cmovI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9849 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18581 "ad_aarch64.cpp"
  }
}

void cmovUI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9868 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18606 "ad_aarch64.cpp"
  }
}

void cmovL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9887 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18628 "ad_aarch64.cpp"
  }
}

void cmovUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9903 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18650 "ad_aarch64.cpp"
  }
}

void cmovL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9921 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18672 "ad_aarch64.cpp"
  }
}

void cmovUL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9937 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18694 "ad_aarch64.cpp"
  }
}

void cmovL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9953 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18716 "ad_aarch64.cpp"
  }
}

void cmovUL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9969 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18738 "ad_aarch64.cpp"
  }
}

void cmovP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9985 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18760 "ad_aarch64.cpp"
  }
}

void cmovUP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18782 "ad_aarch64.cpp"
  }
}

void cmovP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10019 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18804 "ad_aarch64.cpp"
  }
}

void cmovUP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10035 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18826 "ad_aarch64.cpp"
  }
}

void cmovP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10051 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18848 "ad_aarch64.cpp"
  }
}

void cmovUP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10067 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18870 "ad_aarch64.cpp"
  }
}

void cmovN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10083 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18892 "ad_aarch64.cpp"
  }
}

void cmovUN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10099 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18914 "ad_aarch64.cpp"
  }
}

void cmovN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10117 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18936 "ad_aarch64.cpp"
  }
}

void cmovUN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10133 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18958 "ad_aarch64.cpp"
  }
}

void cmovN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10149 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 18980 "ad_aarch64.cpp"
  }
}

void cmovUN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10165 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 19002 "ad_aarch64.cpp"
  }
}

void cmovF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10182 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19025 "ad_aarch64.cpp"
  }
}

void cmovUF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10200 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19048 "ad_aarch64.cpp"
  }
}

void cmovD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10218 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19071 "ad_aarch64.cpp"
  }
}

void cmovUD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10236 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 19094 "ad_aarch64.cpp"
  }
}

void addI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10265 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19113 "ad_aarch64.cpp"
  }
}

void addI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3506 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 19139 "ad_aarch64.cpp"
  }
}

void addI_reg_imm_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3506 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 19165 "ad_aarch64.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10309 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19184 "ad_aarch64.cpp"
  }
}

void addP_reg_reg_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10324 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
  
#line 19203 "ad_aarch64.cpp"
  }
}

void addP_reg_reg_lslNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10339 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                   Address::lsl(opnd_array(3)->constant())));
  
#line 19223 "ad_aarch64.cpp"
  }
}

void addP_reg_reg_ext_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                   Address::sxtw(opnd_array(3)->constant())));
  
#line 19243 "ad_aarch64.cpp"
  }
}

void lshift_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10369 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sbfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
          opnd_array(2)->constant()& 63, MIN2(32, (int)((-opnd_array(2)->constant()) & 63)));
  
#line 19262 "ad_aarch64.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3520 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 19288 "ad_aarch64.cpp"
  }
}

void addL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10403 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19307 "ad_aarch64.cpp"
  }
}

void addL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3520 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 19333 "ad_aarch64.cpp"
  }
}

void subI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10434 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19352 "ad_aarch64.cpp"
  }
}

void subI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3506 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 19378 "ad_aarch64.cpp"
  }
}

void subL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10466 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19397 "ad_aarch64.cpp"
  }
}

void subL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3520 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 19423 "ad_aarch64.cpp"
  }
}

void negI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10498 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 19441 "ad_aarch64.cpp"
  }
}

void negL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10514 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 19459 "ad_aarch64.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10530 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mulw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19478 "ad_aarch64.cpp"
  }
}

void smulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10545 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19497 "ad_aarch64.cpp"
  }
}

void smulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10545 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 19516 "ad_aarch64.cpp"
  }
}

void mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10562 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mul(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19535 "ad_aarch64.cpp"
  }
}

void mulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10578 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19554 "ad_aarch64.cpp"
  }
}

void umulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10594 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ umulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 19573 "ad_aarch64.cpp"
  }
}

void maddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10611 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19594 "ad_aarch64.cpp"
  }
}

void maddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10611 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 19615 "ad_aarch64.cpp"
  }
}

void msubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10627 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ msubw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19636 "ad_aarch64.cpp"
  }
}

void mnegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10645 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mnegw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */));
  
#line 19656 "ad_aarch64.cpp"
  }
}

void mnegI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10645 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mnegw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 19676 "ad_aarch64.cpp"
  }
}

void maddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10662 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19697 "ad_aarch64.cpp"
  }
}

void maddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10662 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 19718 "ad_aarch64.cpp"
  }
}

void msubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10678 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ msub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19739 "ad_aarch64.cpp"
  }
}

void mnegLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mneg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */));
  
#line 19759 "ad_aarch64.cpp"
  }
}

void mnegL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mneg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 19779 "ad_aarch64.cpp"
  }
}

void smaddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10713 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19800 "ad_aarch64.cpp"
  }
}

void smaddL_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10713 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 19821 "ad_aarch64.cpp"
  }
}

void smaddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10713 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19842 "ad_aarch64.cpp"
  }
}

void smaddL_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10713 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smaddl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 19863 "ad_aarch64.cpp"
  }
}

void smsubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10729 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smsubl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19884 "ad_aarch64.cpp"
  }
}

void smsubL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10729 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smsubl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 19905 "ad_aarch64.cpp"
  }
}

void smnegLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10745 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smnegl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */));
  
#line 19925 "ad_aarch64.cpp"
  }
}

void smnegL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10745 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smnegl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 19945 "ad_aarch64.cpp"
  }
}

void muladdS2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10763 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mulw(rscratch1, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src4 */), rscratch1); 
#line 19964 "ad_aarch64.cpp"
  }
}

void divINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3534 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 19984 "ad_aarch64.cpp"
  }
}

void divLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3542 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 20004 "ad_aarch64.cpp"
  }
}

void modINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3550 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 20024 "ad_aarch64.cpp"
  }
}

void modLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3558 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 20044 "ad_aarch64.cpp"
  }
}

void UdivI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10828 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udivw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
  
#line 20061 "ad_aarch64.cpp"
  }
}

void UdivL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10843 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udiv(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
  
#line 20078 "ad_aarch64.cpp"
  }
}

void UmodI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10859 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udivw(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ msubw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
  
#line 20096 "ad_aarch64.cpp"
  }
}

void UModL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10876 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ udiv(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ msub(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
  
#line 20114 "ad_aarch64.cpp"
  }
}

void lShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10893 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lslvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20133 "ad_aarch64.cpp"
  }
}

void lShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10909 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lslw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 20152 "ad_aarch64.cpp"
  }
}

void urShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10925 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20171 "ad_aarch64.cpp"
  }
}

void urShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10941 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 20190 "ad_aarch64.cpp"
  }
}

void rShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10957 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20209 "ad_aarch64.cpp"
  }
}

void rShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10973 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 20228 "ad_aarch64.cpp"
  }
}

void lShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10994 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lslv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20247 "ad_aarch64.cpp"
  }
}

void lShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11010 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x3f);
  
#line 20266 "ad_aarch64.cpp"
  }
}

void urShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11026 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20285 "ad_aarch64.cpp"
  }
}

void urShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11042 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 20304 "ad_aarch64.cpp"
  }
}

void urShiftP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11058 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 20323 "ad_aarch64.cpp"
  }
}

void rShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11074 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 20342 "ad_aarch64.cpp"
  }
}

void rShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11090 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 20361 "ad_aarch64.cpp"
  }
}

void regL_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11111 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 20381 "ad_aarch64.cpp"
  }
}

void regI_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11130 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 20401 "ad_aarch64.cpp"
  }
}

void NegI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11149 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSR, opnd_array(3)->constant()& 0x1f);
  
#line 20420 "ad_aarch64.cpp"
  }
}

void NegI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11166 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::ASR, opnd_array(3)->constant()& 0x1f);
  
#line 20439 "ad_aarch64.cpp"
  }
}

void NegI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11183 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSL, opnd_array(3)->constant()& 0x1f);
  
#line 20458 "ad_aarch64.cpp"
  }
}

void NegL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11200 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSR, opnd_array(3)->constant()& 0x3f);
  
#line 20477 "ad_aarch64.cpp"
  }
}

void NegL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11217 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::ASR, opnd_array(3)->constant()& 0x3f);
  
#line 20496 "ad_aarch64.cpp"
  }
}

void NegL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11234 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            Assembler::LSL, opnd_array(3)->constant()& 0x3f);
  
#line 20515 "ad_aarch64.cpp"
  }
}

void AndI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11250 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20536 "ad_aarch64.cpp"
  }
}

void AndI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11250 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20557 "ad_aarch64.cpp"
  }
}

void AndL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11268 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20578 "ad_aarch64.cpp"
  }
}

void AndL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11268 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20599 "ad_aarch64.cpp"
  }
}

void OrI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11286 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20620 "ad_aarch64.cpp"
  }
}

void OrI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11286 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20641 "ad_aarch64.cpp"
  }
}

void OrL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11304 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20662 "ad_aarch64.cpp"
  }
}

void OrL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11304 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20683 "ad_aarch64.cpp"
  }
}

void XorI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20704 "ad_aarch64.cpp"
  }
}

void XorI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20725 "ad_aarch64.cpp"
  }
}

void XorL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11340 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 20746 "ad_aarch64.cpp"
  }
}

void XorL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11340 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 20767 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11360 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 20790 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11360 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 20813 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11381 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 20836 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11381 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 20859 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11402 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 20882 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11402 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 20905 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11423 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 20928 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11423 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 20951 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11444 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 20974 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11444 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 20997 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11465 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21020 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11465 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21043 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11486 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 21066 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11486 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 21089 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11507 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 21112 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11507 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 21135 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11528 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21158 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11528 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21181 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11528 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x1f);
  
#line 21204 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11528 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21227 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21250 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21273 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 21296 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21319 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11570 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21342 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11570 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21365 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11570 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x1f);
  
#line 21388 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11570 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21411 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11591 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21434 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11591 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21457 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11591 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 21480 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11591 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21503 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11612 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21526 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11612 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21549 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11612 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ROR,
              opnd_array(4)->constant()& 0x1f);
  
#line 21572 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11612 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21595 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21618 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21641 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ROR,
              opnd_array(4)->constant()& 0x3f);
  
#line 21664 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21687 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11654 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 21710 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11654 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 21733 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11654 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x1f);
  
#line 21756 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11654 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 21779 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11675 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 21802 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11675 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 21825 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11675 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 21848 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11675 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 21871 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21894 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 21917 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11717 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 21940 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11717 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 21963 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11738 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 21986 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11738 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22009 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11759 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22032 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11759 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22055 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11780 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22078 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11780 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22101 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11801 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22124 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11801 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22147 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11822 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22170 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11822 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 22193 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11843 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22216 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11843 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 22239 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11864 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22261 "ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11864 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22283 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11885 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22305 "ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11885 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22327 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11906 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22349 "ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11906 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22371 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11927 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22393 "ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11927 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22415 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11948 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22437 "ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11948 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 22459 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11969 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22481 "ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11969 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 22503 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11990 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22525 "ad_aarch64.cpp"
  }
}

void AndI_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 11990 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22547 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12011 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22569 "ad_aarch64.cpp"
  }
}

void AndL_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12011 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22591 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12032 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22613 "ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12032 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22635 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12053 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22657 "ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12053 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22679 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12074 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22701 "ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12074 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22723 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12095 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22745 "ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12095 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22767 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12116 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 22789 "ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12116 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 22811 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12137 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 22833 "ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12137 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 22855 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12158 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22877 "ad_aarch64.cpp"
  }
}

void XorI_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12158 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22899 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12179 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 22921 "ad_aarch64.cpp"
  }
}

void XorL_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12179 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 22943 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12200 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 22965 "ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12200 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 22987 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12221 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23009 "ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12221 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23031 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23053 "ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23075 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12263 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23097 "ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12263 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23119 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12284 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 23141 "ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12284 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 23163 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12305 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 23185 "ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12305 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 23207 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12326 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23229 "ad_aarch64.cpp"
  }
}

void OrI_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12326 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23251 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12347 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ROR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23273 "ad_aarch64.cpp"
  }
}

void OrL_reg_RotateRight_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12347 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ROR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23295 "ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12368 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23317 "ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12368 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23339 "ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12389 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23361 "ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12389 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23383 "ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12410 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23405 "ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12410 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x1f);
  
#line 23427 "ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12431 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23449 "ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12431 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 23471 "ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12452 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 23493 "ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12452 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x1f);
  
#line 23515 "ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12473 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 23537 "ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12473 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 23559 "ad_aarch64.cpp"
  }
}

void SubI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12494 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23581 "ad_aarch64.cpp"
  }
}

void SubL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23603 "ad_aarch64.cpp"
  }
}

void SubI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12536 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x1f);
  
#line 23625 "ad_aarch64.cpp"
  }
}

void SubL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12557 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 23647 "ad_aarch64.cpp"
  }
}

void SubI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12578 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x1f);
  
#line 23669 "ad_aarch64.cpp"
  }
}

void SubL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12599 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 23691 "ad_aarch64.cpp"
  }
}

void sbfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12620 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 63;
    int rshift = opnd_array(3)->constant()& 63;
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ sbfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 23715 "ad_aarch64.cpp"
  }
}

void sbfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12643 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 31;
    int rshift = opnd_array(3)->constant()& 31;
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 23739 "ad_aarch64.cpp"
  }
}

void ubfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12666 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 63;
    int rshift = opnd_array(3)->constant()& 63;
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ ubfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 23763 "ad_aarch64.cpp"
  }
}

void ubfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12689 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(2)->constant()& 31;
    int rshift = opnd_array(3)->constant()& 31;
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ ubfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
            r, s);
  
#line 23787 "ad_aarch64.cpp"
  }
}

void ubfxwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12714 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int rshift = opnd_array(2)->constant()& 31;
    intptr_t mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfxw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 23809 "ad_aarch64.cpp"
  }
}

void ubfxLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12734 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int rshift = opnd_array(2)->constant()& 63;
    intptr_t mask = opnd_array(3)->constantL();
    int width = exact_log2_long(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 23831 "ad_aarch64.cpp"
  }
}

void ubfxIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12758 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int rshift = opnd_array(2)->constant()& 31;
    intptr_t mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 23853 "ad_aarch64.cpp"
  }
}

void ubfizwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12781 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 31;
    intptr_t mask = opnd_array(2)->constant();
    int width = exact_log2(mask+1);
    __ ubfizw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 23875 "ad_aarch64.cpp"
  }
}

void ubfizLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12803 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 63;
    intptr_t mask = opnd_array(2)->constantL();
    int width = exact_log2_long(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 23897 "ad_aarch64.cpp"
  }
}

void ubfizwIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12825 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 31;
    intptr_t mask = opnd_array(2)->constant();
    int width = exact_log2(mask+1);
    __ ubfizw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 23919 "ad_aarch64.cpp"
  }
}

void ubfizLConvL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12847 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 63;
    intptr_t mask = opnd_array(2)->constantL();
    int width = exact_log2_long(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 23941 "ad_aarch64.cpp"
  }
}

void ubfizIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12869 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 63;
    intptr_t mask = opnd_array(2)->constant();
    int width = exact_log2(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 23963 "ad_aarch64.cpp"
  }
}

void ubfizLConvL2IxNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12890 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int lshift = opnd_array(3)->constant()& 31;
    intptr_t mask = opnd_array(2)->constantL();
    int width = exact_log2(mask+1);
    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), lshift, width);
  
#line 23985 "ad_aarch64.cpp"
  }
}

void ubfizIConvI2LAndINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// msk
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12909 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ubfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0, exact_log2(opnd_array(2)->constant()+ 1));
  
#line 24002 "ad_aarch64.cpp"
  }
}

void extrOrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12928 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 24022 "ad_aarch64.cpp"
  }
}

void extrOrL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12928 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 24042 "ad_aarch64.cpp"
  }
}

void extrOrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12946 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 24062 "ad_aarch64.cpp"
  }
}

void extrOrI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12946 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 24082 "ad_aarch64.cpp"
  }
}

void extrAddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12964 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 24102 "ad_aarch64.cpp"
  }
}

void extrAddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12964 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 24122 "ad_aarch64.cpp"
  }
}

void extrAddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12982 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 24142 "ad_aarch64.cpp"
  }
}

void extrAddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12982 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 24162 "ad_aarch64.cpp"
  }
}

void rorI_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 12998 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               opnd_array(2)->constant()& 0x1f);
  
#line 24180 "ad_aarch64.cpp"
  }
}

void rorL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13014 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               opnd_array(2)->constant()& 0x3f);
  
#line 24198 "ad_aarch64.cpp"
  }
}

void rorI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13030 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 24215 "ad_aarch64.cpp"
  }
}

void rorL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13045 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 24232 "ad_aarch64.cpp"
  }
}

void rolI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13060 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
     __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rscratch1);
  
#line 24250 "ad_aarch64.cpp"
  }
}

void rolL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13076 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
     __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rscratch1);
  
#line 24268 "ad_aarch64.cpp"
  }
}

void AddExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13094 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 24286 "ad_aarch64.cpp"
  }
}

void AddExtI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13094 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 24304 "ad_aarch64.cpp"
  }
}

void SubExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13109 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 24322 "ad_aarch64.cpp"
  }
}

void AddExtI_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13124 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 24342 "ad_aarch64.cpp"
  }
}

void AddExtI_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13124 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 24362 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13139 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 24382 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13139 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 24402 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13154 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24422 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13154 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24442 "ad_aarch64.cpp"
  }
}

void AddExtL_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13169 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 24462 "ad_aarch64.cpp"
  }
}

void AddExtL_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13169 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 24482 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13184 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 24502 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13184 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 24522 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13199 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 24542 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13199 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 24562 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13214 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24582 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13214 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24602 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13229 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24621 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13229 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24640 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13244 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 24659 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13244 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 24678 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13259 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24697 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13259 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 24716 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13274 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 24735 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13274 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 24754 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13289 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 24773 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13289 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw);
   
#line 24792 "ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13304 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24811 "ad_aarch64.cpp"
  }
}

void SubExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13319 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 24830 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13334 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 24849 "ad_aarch64.cpp"
  }
}

void SubExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13349 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 24868 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13364 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 24887 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13380 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 24908 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13380 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb, (opnd_array(4)->constant()));
   
#line 24929 "ad_aarch64.cpp"
  }
}

void AddExtL_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13395 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 24950 "ad_aarch64.cpp"
  }
}

void AddExtL_sxth_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13395 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth, (opnd_array(4)->constant()));
   
#line 24971 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13410 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(5)->constant()));
   
#line 24992 "ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13410 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw, (opnd_array(4)->constant()));
   
#line 25013 "ad_aarch64.cpp"
  }
}

void SubExtL_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13425 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25034 "ad_aarch64.cpp"
  }
}

void SubExtL_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13440 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25055 "ad_aarch64.cpp"
  }
}

void SubExtL_sxtw_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13455 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(5)->constant()));
   
#line 25076 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13470 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25097 "ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13470 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb, (opnd_array(4)->constant()));
   
#line 25118 "ad_aarch64.cpp"
  }
}

void AddExtI_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13485 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25139 "ad_aarch64.cpp"
  }
}

void AddExtI_sxth_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13485 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth, (opnd_array(4)->constant()));
   
#line 25160 "ad_aarch64.cpp"
  }
}

void SubExtI_sxtb_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb, (opnd_array(5)->constant()));
   
#line 25181 "ad_aarch64.cpp"
  }
}

void SubExtI_sxth_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// lshift2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth, (opnd_array(5)->constant()));
   
#line 25202 "ad_aarch64.cpp"
  }
}

void AddExtI_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13530 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(3)->constant()));
   
#line 25221 "ad_aarch64.cpp"
  }
}

void AddExtI_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13530 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw, (opnd_array(2)->constant()));
   
#line 25240 "ad_aarch64.cpp"
  }
}

void SubExtI_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13545 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw, (opnd_array(3)->constant()));
   
#line 25259 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13560 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25279 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13560 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb, (opnd_array(3)->constant()));
   
#line 25299 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25319 "ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth, (opnd_array(3)->constant()));
   
#line 25339 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13590 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw, (opnd_array(4)->constant()));
   
#line 25359 "ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13590 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw, (opnd_array(3)->constant()));
   
#line 25379 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13605 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25399 "ad_aarch64.cpp"
  }
}

void SubExtL_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13620 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25419 "ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13635 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw, (opnd_array(4)->constant()));
   
#line 25439 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13650 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25459 "ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13650 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb, (opnd_array(3)->constant()));
   
#line 25479 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13665 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25499 "ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_shift_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13665 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth, (opnd_array(3)->constant()));
   
#line 25519 "ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13680 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb, (opnd_array(4)->constant()));
   
#line 25539 "ad_aarch64.cpp"
  }
}

void SubExtI_uxth_and_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13695 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth, (opnd_array(4)->constant()));
   
#line 25559 "ad_aarch64.cpp"
  }
}

void cmovI_reg_reg_ltNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13710 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */,
             Assembler::LT);
  
#line 25580 "ad_aarch64.cpp"
  }
}

void cmovI_reg_reg_gtNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13727 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */,
             Assembler::GT);
  
#line 25601 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm0_ltNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13744 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::LT);
  
#line 25621 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm0_gtNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13761 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cselw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::GT);
  
#line 25641 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm1_leNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13778 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csincw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::LE);
  
#line 25661 "ad_aarch64.cpp"
  }
}

void cmovI_reg_imm1_gtNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13795 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csincw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::GT);
  
#line 25681 "ad_aarch64.cpp"
  }
}

void cmovI_reg_immM1_ltNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13812 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csinvw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::LT);
  
#line 25701 "ad_aarch64.cpp"
  }
}

void cmovI_reg_immM1_geNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 13829 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ csinvw(opnd_array(0)->as_Register(ra_,this)/* dst */,
             opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
             zr,
             Assembler::GE);
  
#line 25721 "ad_aarch64.cpp"
  }
}

void bits_reverse_INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbitw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 25737 "ad_aarch64.cpp"
  }
}

void bits_reverse_LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14014 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 25753 "ad_aarch64.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14033 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 25772 "ad_aarch64.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14048 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ faddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 25791 "ad_aarch64.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14063 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 25810 "ad_aarch64.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14078 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 25829 "ad_aarch64.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14093 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmuls(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 25848 "ad_aarch64.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14108 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmuld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 25867 "ad_aarch64.cpp"
  }
}

void maddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14123 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 25889 "ad_aarch64.cpp"
  }
}

void maddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14140 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmaddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 25911 "ad_aarch64.cpp"
  }
}

void msubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14158 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 25933 "ad_aarch64.cpp"
  }
}

void msubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14176 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 25955 "ad_aarch64.cpp"
  }
}

void mnaddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14194 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 25977 "ad_aarch64.cpp"
  }
}

void mnaddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14212 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmaddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 25999 "ad_aarch64.cpp"
  }
}

void mnsubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14229 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26021 "ad_aarch64.cpp"
  }
}

void mnsubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14246 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    // n.b. insn name should be fnmsubd
    __ fnmsub(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 26044 "ad_aarch64.cpp"
  }
}

void maxF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14264 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmaxs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26063 "ad_aarch64.cpp"
  }
}

void minF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14278 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmins(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26082 "ad_aarch64.cpp"
  }
}

void maxD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14292 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmaxd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26101 "ad_aarch64.cpp"
  }
}

void minD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14306 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmind(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26120 "ad_aarch64.cpp"
  }
}

void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fdivs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26139 "ad_aarch64.cpp"
  }
}

void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14337 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fdivd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26158 "ad_aarch64.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14352 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnegs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26175 "ad_aarch64.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14366 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fnegd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26192 "ad_aarch64.cpp"
  }
}

void absI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14384 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cnegw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::LT);
  
#line 26209 "ad_aarch64.cpp"
  }
}

void absL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14401 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cneg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::LT);
  
#line 26226 "ad_aarch64.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14413 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabss(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26243 "ad_aarch64.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14426 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabsd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26260 "ad_aarch64.cpp"
  }
}

void absdF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14439 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26279 "ad_aarch64.cpp"
  }
}

void absdD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14453 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fabdd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26298 "ad_aarch64.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14467 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsqrtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26315 "ad_aarch64.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14480 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fsqrts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26332 "ad_aarch64.cpp"
  }
}

void roundD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14492 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    switch (opnd_array(2)->constant()) {
      case RoundDoubleModeNode::rmode_rint:
        __ frintnd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                   as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
        break;
      case RoundDoubleModeNode::rmode_floor:
        __ frintmd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                   as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
        break;
      case RoundDoubleModeNode::rmode_ceil:
        __ frintpd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                   as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
        break;
    }
  
#line 26362 "ad_aarch64.cpp"
  }
}

void copySignD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                  src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                  zero = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* zero */);
    __ fnegd(dst, zero);
    __ bsl(dst, __ T8B, src2, src1);
  
#line 26386 "ad_aarch64.cpp"
  }
}

void copySignF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14530 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                  src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ movi(dst, __ T2S, 0x80, 24);
    __ bsl(dst, __ T8B, src2, src1);
  
#line 26408 "ad_aarch64.cpp"
  }
}

void signumD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14544 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                  dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                  zero = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* zero */),
                  one = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */);
    __ facgtd(dst, src, zero); // dst=0 for +-0.0 and NaN. 0xFFF..F otherwise
    __ ushrd(dst, dst, 1);     // dst=0 for +-0.0 and NaN. 0x7FF..F otherwise
    // Bit selection instruction gets bit from "one" for each enabled bit in
    // "dst", otherwise gets a bit from "src". For "src" that contains +-0.0 or
    // NaN the whole "src" will be copied because "dst" is zero. For all other
    // "src" values dst is 0x7FF..F, which means only the sign bit is copied
    // from "src", and all other bits are copied from 1.0.
    __ bsl(dst, __ T8B, one, src);
  
#line 26438 "ad_aarch64.cpp"
  }
}

void signumF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14565 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                  dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                  zero = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* zero */),
                  one = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */);
    __ facgts(dst, src, zero);    // dst=0 for +-0.0 and NaN. 0xFFF..F otherwise
    __ ushr(dst, __ T2S, dst, 1); // dst=0 for +-0.0 and NaN. 0x7FF..F otherwise
    // Bit selection instruction gets bit from "one" for each enabled bit in
    // "dst", otherwise gets a bit from "src". For "src" that contains +-0.0 or
    // NaN the whole "src" will be copied because "dst" is zero. For all other
    // "src" values dst is 0x7FF..F, which means only the sign bit is copied
    // from "src", and all other bits are copied from 1.0.
    __ bsl(dst, __ T8B, one, src);
  
#line 26468 "ad_aarch64.cpp"
  }
}

void onspinwaitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14588 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ spin_wait();
  
#line 26484 "ad_aarch64.cpp"
  }
}

void andI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14608 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26503 "ad_aarch64.cpp"
  }
}

void andI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14623 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constant()));
  
#line 26522 "ad_aarch64.cpp"
  }
}

void orI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14640 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26541 "ad_aarch64.cpp"
  }
}

void orI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14655 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constant()));
  
#line 26560 "ad_aarch64.cpp"
  }
}

void xorI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14672 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26579 "ad_aarch64.cpp"
  }
}

void xorI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14687 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constant()));
  
#line 26598 "ad_aarch64.cpp"
  }
}

void andL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14705 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26617 "ad_aarch64.cpp"
  }
}

void andL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14720 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (uint64_t)(opnd_array(2)->constantL()));
  
#line 26636 "ad_aarch64.cpp"
  }
}

void orL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14737 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26655 "ad_aarch64.cpp"
  }
}

void orL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14752 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (uint64_t)(opnd_array(2)->constantL()));
  
#line 26674 "ad_aarch64.cpp"
  }
}

void xorL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14769 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 26693 "ad_aarch64.cpp"
  }
}

void xorL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14784 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (uint64_t)(opnd_array(2)->constantL()));
  
#line 26712 "ad_aarch64.cpp"
  }
}

void convI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14799 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ sbfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 26728 "ad_aarch64.cpp"
  }
}

void convUI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14812 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ubfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 26745 "ad_aarch64.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14825 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ movw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26761 "ad_aarch64.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14838 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26777 "ad_aarch64.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14851 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26793 "ad_aarch64.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14864 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzsw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26809 "ad_aarch64.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14877 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzs(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26825 "ad_aarch64.cpp"
  }
}

void convF2HF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14890 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

      __ flt_to_flt16(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 26842 "ad_aarch64.cpp"
  }
}

void convHF2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14902 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

      __ flt16_to_flt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 26859 "ad_aarch64.cpp"
  }
}

void convI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14914 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfws(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26875 "ad_aarch64.cpp"
  }
}

void convL2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14927 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26891 "ad_aarch64.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14940 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzdw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26907 "ad_aarch64.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14953 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcvtzd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26923 "ad_aarch64.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14966 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfwd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26939 "ad_aarch64.cpp"
  }
}

void convL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14979 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ scvtfd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 26955 "ad_aarch64.cpp"
  }
}

void round_double_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ftmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 14991 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ java_round_double(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                         as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* ftmp */));
  
#line 26974 "ad_aarch64.cpp"
  }
}

void round_float_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ftmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15003 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ java_round_float(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                        as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* ftmp */));
  
#line 26993 "ad_aarch64.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15022 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrw(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27009 "ad_aarch64.cpp"
  }
}

void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15040 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27025 "ad_aarch64.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15058 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldr(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27041 "ad_aarch64.cpp"
  }
}

void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15076 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 27057 "ad_aarch64.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15094 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ strs(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27073 "ad_aarch64.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15112 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ strw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27089 "ad_aarch64.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15130 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ strd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27105 "ad_aarch64.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15148 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ str(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 27121 "ad_aarch64.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15166 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovs(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27137 "ad_aarch64.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15184 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27153 "ad_aarch64.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 27169 "ad_aarch64.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15220 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27185 "ad_aarch64.cpp"
  }
}

void clearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15239 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ zero_words(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 27206 "ad_aarch64.cpp"
  }
}

void clearArray_imm_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// temp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15260 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ zero_words(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, (uint64_t)opnd_array(1)->constantL());
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 27228 "ad_aarch64.cpp"
  }
}

void overflowAddI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15280 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27245 "ad_aarch64.cpp"
  }
}

void overflowAddI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15293 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 27262 "ad_aarch64.cpp"
  }
}

void overflowAddL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15306 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmn(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27279 "ad_aarch64.cpp"
  }
}

void overflowAddL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15319 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ adds(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 27296 "ad_aarch64.cpp"
  }
}

void overflowSubI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15332 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27313 "ad_aarch64.cpp"
  }
}

void overflowSubI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15345 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 27330 "ad_aarch64.cpp"
  }
}

void overflowSubL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15358 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 27347 "ad_aarch64.cpp"
  }
}

void overflowSubL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15371 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ subs(zr, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 27364 "ad_aarch64.cpp"
  }
}

void overflowNegI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15384 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 27381 "ad_aarch64.cpp"
  }
}

void overflowNegL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15397 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmp(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 27398 "ad_aarch64.cpp"
  }
}

void overflowMulI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15414 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ smull(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 27419 "ad_aarch64.cpp"
  }
}

void overflowMulI_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15436 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ smull(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 27442 "ad_aarch64.cpp"
  }
}

void overflowMulL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15458 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mul(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 63);    // Top is pure sign ext
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 27464 "ad_aarch64.cpp"
  }
}

void overflowMulL_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15482 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ mul(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 63);    // Top is pure sign ext
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 27488 "ad_aarch64.cpp"
  }
}

void compI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3568 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 27507 "ad_aarch64.cpp"
  }
}

void compI_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 27530 "ad_aarch64.cpp"
  }
}

void compI_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 27553 "ad_aarch64.cpp"
  }
}

void compI_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3586 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint32_t val = (uint32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 27573 "ad_aarch64.cpp"
  }
}

void compU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3568 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 27592 "ad_aarch64.cpp"
  }
}

void compU_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 27615 "ad_aarch64.cpp"
  }
}

void compU_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 27638 "ad_aarch64.cpp"
  }
}

void compU_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3586 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint32_t val = (uint32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 27658 "ad_aarch64.cpp"
  }
}

void compL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3594 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 27677 "ad_aarch64.cpp"
  }
}

void compL_reg_immL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3601 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 27704 "ad_aarch64.cpp"
  }
}

void compL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3601 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 27731 "ad_aarch64.cpp"
  }
}

void compL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3616 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint64_t val = (uint64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 27751 "ad_aarch64.cpp"
  }
}

void compUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3594 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 27770 "ad_aarch64.cpp"
  }
}

void compUL_reg_immL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3601 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 27797 "ad_aarch64.cpp"
  }
}

void compUL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3601 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (uint64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 27824 "ad_aarch64.cpp"
  }
}

void compUL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3616 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    uint64_t val = (uint64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 27844 "ad_aarch64.cpp"
  }
}

void compP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3624 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 27863 "ad_aarch64.cpp"
  }
}

void compN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 3631 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 27882 "ad_aarch64.cpp"
  }
}

void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3638 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmp(reg, zr);
  
#line 27900 "ad_aarch64.cpp"
  }
}

void testN_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 3644 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmpw(reg, zr);
  
#line 27918 "ad_aarch64.cpp"
  }
}

void compF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15793 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 27935 "ad_aarch64.cpp"
  }
}

void compF_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15807 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0);
  
#line 27952 "ad_aarch64.cpp"
  }
}

void compD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15822 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 27969 "ad_aarch64.cpp"
  }
}

void compD_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15836 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0);
  
#line 27986 "ad_aarch64.cpp"
  }
}

void compF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15854 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28012 "ad_aarch64.cpp"
  }
}

void compD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15882 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28038 "ad_aarch64.cpp"
  }
}

void compF3_reg_immF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15909 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, 0.0);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28063 "ad_aarch64.cpp"
  }
}

void compD3_reg_immD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15936 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, 0.0);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 28088 "ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15963 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* p */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* q */));
    __ csetw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::LT);
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 28107 "ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15981 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 31);
  
#line 28124 "ad_aarch64.cpp"
  }
}

void compI_reg_imm0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 15999 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0);
  
#line 28140 "ad_aarch64.cpp"
  }
}

void branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3650 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(1)->label();
    __ b(*L);
  
#line 28157 "ad_aarch64.cpp"
  }
}

void branchConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 3656 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 28176 "ad_aarch64.cpp"
  }
}

void branchConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 3662 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 28195 "ad_aarch64.cpp"
  }
}

void cmpI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16100 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28219 "ad_aarch64.cpp"
  }
}

void cmpL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16117 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28243 "ad_aarch64.cpp"
  }
}

void cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16134 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28267 "ad_aarch64.cpp"
  }
}

void cmpN_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16151 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28291 "ad_aarch64.cpp"
  }
}

void cmpP_narrowOop_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16168 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* oop */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* oop */, *L);
  
#line 28315 "ad_aarch64.cpp"
  }
}

void cmpUI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16185 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ || cond == Assembler::LS)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28339 "ad_aarch64.cpp"
  }
}

void cmpUL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ || cond == Assembler::LS)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 28363 "ad_aarch64.cpp"
  }
}

void cmpL_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 63, *L);
  
#line 28385 "ad_aarch64.cpp"
  }
}

void cmpI_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16238 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 31, *L);
  
#line 28407 "ad_aarch64.cpp"
  }
}

void cmpL_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16255 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2_long(opnd_array(3)->constantL());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L);
  
#line 28430 "ad_aarch64.cpp"
  }
}

void cmpI_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16272 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2((juint)opnd_array(3)->constant());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L);
  
#line 28453 "ad_aarch64.cpp"
  }
}

void far_cmpL_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16289 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 63, *L, /*far*/true);
  
#line 28475 "ad_aarch64.cpp"
  }
}

void far_cmpI_branch_signNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16304 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond =
      ((Assembler::Condition)opnd_array(1)->ccode()== Assembler::LT) ? Assembler::NE : Assembler::EQ;
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, 31, *L, /*far*/true);
  
#line 28497 "ad_aarch64.cpp"
  }
}

void far_cmpL_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16320 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2_long(opnd_array(3)->constantL());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L, /*far*/true);
  
#line 28520 "ad_aarch64.cpp"
  }
}

void far_cmpI_branch_bitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// labl
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16336 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    Label* L = opnd_array(5)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    int bit = exact_log2((juint)opnd_array(3)->constant());
    __ tbr(cond, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, bit, *L, /*far*/true);
  
#line 28543 "ad_aarch64.cpp"
  }
}

void cmpL_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tst(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 28561 "ad_aarch64.cpp"
  }
}

void cmpI_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16367 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tstw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 28579 "ad_aarch64.cpp"
  }
}

void cmpL_and_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16378 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tst(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 28597 "ad_aarch64.cpp"
  }
}

void cmpI_and_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16389 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ tstw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 28615 "ad_aarch64.cpp"
  }
}

void branchLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 3656 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 28634 "ad_aarch64.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16433 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */);
  
#line 28654 "ad_aarch64.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16448 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 28673 "ad_aarch64.cpp"
  }
}

void safePointNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// cr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16470 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ read_polling_page(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* poll */), relocInfo::poll_type);
  
#line 28689 "ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3686 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    address addr = (address)opnd_array(1)->method();
    address call;
    if (!_method) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      call = __ trampoline_call(Address(addr, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
    } else if (_method->intrinsic_id() == vmIntrinsicID::_ensureMaterializedForStackWalk) {
      // The NOP here is purely to ensure that eliding a call to
      // JVM_EnsureMaterializedForStackWalk doesn't change the code size.
      __ nop();
      __ block_comment("call JVM_EnsureMaterializedForStackWalk (elided)");
    } else {
      int method_index = resolved_method_index(cbuf);
      RelocationHolder rspec = _optimized_virtual ? opt_virtual_call_Relocation::spec(method_index)
                                                  : static_call_Relocation::spec(method_index);
      call = __ trampoline_call(Address(addr, rspec));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      if (CodeBuffer::supports_shared_stubs() && _method->can_be_statically_bound()) {
        // Calls of the same statically bound method can share
        // a stub to the interpreter.
        cbuf.shared_stub_to_interp_for(_method, call - cbuf.insts_begin());
      } else {
        // Emit stub for static call
        address stub = CompiledStaticCall::emit_to_interp_stub(cbuf, call);
        if (stub == NULL) {
          ciEnv::current()->record_failure("CodeCache is full");
          return;
        }
      }
    }

    __ post_call_nop();

    // Only non uncommon_trap calls need to reinitialize ptrue.
    if (Compile::current()->max_vector_size() > 0 && uncommon_trap_request() == 0) {
      __ reinitialize_ptrue();
    }
  
#line 28748 "ad_aarch64.cpp"
  }
  {

#line 3748 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 28760 "ad_aarch64.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3734 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    int method_index = resolved_method_index(cbuf);
    address call = __ ic_call((address)opnd_array(1)->method(), method_index);
    if (call == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
    __ post_call_nop();
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 28785 "ad_aarch64.cpp"
  }
  {

#line 3748 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 28797 "ad_aarch64.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3756 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blr(rscratch1);
      __ bind(retaddr);
      __ post_call_nop();
      __ add(sp, sp, 2 * wordSize);
    }
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 28840 "ad_aarch64.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3756 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blr(rscratch1);
      __ bind(retaddr);
      __ post_call_nop();
      __ add(sp, sp, 2 * wordSize);
    }
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 28883 "ad_aarch64.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3756 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ adr(rscratch2, retaddr);
      __ lea(rscratch1, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ stp(zr, rscratch2, Address(__ pre(sp, -2 * wordSize)));
      __ blr(rscratch1);
      __ bind(retaddr);
      __ post_call_nop();
      __ add(sp, sp, 2 * wordSize);
    }
    if (Compile::current()->max_vector_size() > 0) {
      __ reinitialize_ptrue();
    }
  
#line 28926 "ad_aarch64.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 3803 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    __ br(target_reg);
  
#line 28944 "ad_aarch64.cpp"
  }
}

void TailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 3809 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    // exception oop should be in r0
    // ret addr has been popped into lr
    // callee expects it in r3
    __ mov(r3, lr);
    __ br(target_reg);
  
#line 28966 "ad_aarch64.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 3788 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ far_jump(RuntimeAddress(OptoRuntime::rethrow_stub()));
  
#line 28995 "ad_aarch64.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 3793 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    C2_MacroAssembler _masm(&cbuf);
#ifdef ASSERT
    if (Compile::current()->max_vector_size() > 0) {
      __ verify_ptrue();
    }
#endif
    __ ret(lr);
  
#line 29016 "ad_aarch64.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16650 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    if (is_reachable()) {
      __ stop(_halt_reason);
    }
  
#line 29034 "ad_aarch64.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 3669 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(opnd_array(0)->reg(ra_,this)/* result */);

     Label miss;
     C2_MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x1 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 29063 "ad_aarch64.cpp"
  }
}

void partialSubtypeCheckVsZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 3669 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(R5_enc);

     Label miss;
     C2_MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x0 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 29093 "ad_aarch64.cpp"
  }
}

void string_compareUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      fnoreg, fnoreg, fnoreg, pnoreg, pnoreg, StrIntrinsicNode::UU);
  
#line 29116 "ad_aarch64.cpp"
  }
}

void string_compareLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16725 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      fnoreg, fnoreg, fnoreg, pnoreg, pnoreg, StrIntrinsicNode::LL);
  
#line 29138 "ad_aarch64.cpp"
  }
}

void string_compareULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16744 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                      as_FloatRegister(V2_enc), pnoreg, pnoreg, StrIntrinsicNode::UL);
  
#line 29161 "ad_aarch64.cpp"
  }
}

void string_compareLUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16764 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc), as_Register(R11_enc),
                      as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                      as_FloatRegister(V2_enc), pnoreg, pnoreg, StrIntrinsicNode::LU);
  
#line 29184 "ad_aarch64.cpp"
  }
}

void string_compareLL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16789 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::LL);
  
#line 29215 "ad_aarch64.cpp"
  }
}

void string_compareLU_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16812 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::LU);
  
#line 29246 "ad_aarch64.cpp"
  }
}

void string_compareUL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16835 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::UL);
  
#line 29277 "ad_aarch64.cpp"
  }
}

void string_compareUU_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp1
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// pgtmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16858 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp1 */, opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp2 */, fnoreg,
                      as_PRegister(opnd_array(9)->reg(ra_,this,idx9)/* pgtmp1 */), as_PRegister(opnd_array(10)->reg(ra_,this,idx10)/* pgtmp2 */),
                      StrIntrinsicNode::UU);
  
#line 29308 "ad_aarch64.cpp"
  }
}

void string_indexofUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp0
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16883 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      opnd_array(9)->as_Register(ra_,this,idx9)/* tmp5 */, opnd_array(10)->as_Register(ra_,this,idx10)/* tmp6 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UU);
  
#line 29340 "ad_aarch64.cpp"
  }
}

void string_indexofLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp0
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16907 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      opnd_array(9)->as_Register(ra_,this,idx9)/* tmp5 */, opnd_array(10)->as_Register(ra_,this,idx10)/* tmp6 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::LL);
  
#line 29372 "ad_aarch64.cpp"
  }
}

void string_indexofULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp0
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16931 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      opnd_array(9)->as_Register(ra_,this,idx9)/* tmp5 */, opnd_array(10)->as_Register(ra_,this,idx10)/* tmp6 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UL);
  
#line 29404 "ad_aarch64.cpp"
  }
}

void string_indexof_conUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16953 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, zr, zr,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UU);
  
#line 29432 "ad_aarch64.cpp"
  }
}

void string_indexof_conLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16975 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, zr, zr,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::LL);
  
#line 29460 "ad_aarch64.cpp"
  }
}

void string_indexof_conULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 16997 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, zr, zr,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */, StrIntrinsicNode::UL);
  
#line 29488 "ad_aarch64.cpp"
  }
}

void string_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17019 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                           opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                           opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 29511 "ad_aarch64.cpp"
  }
}

void stringL_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17038 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ stringL_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                            opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                            opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 29534 "ad_aarch64.cpp"
  }
}

void stringL_indexof_char_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ztmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ztmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17053 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof_char_sve(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                               opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* ztmp1 */,
                               opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* ztmp2 */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                               opnd_array(7)->as_PRegister(ra_,this,idx7)/* ptmp */, true /* isL */);
  
#line 29559 "ad_aarch64.cpp"
  }
}

void stringU_indexof_char_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ztmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ztmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17069 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ string_indexof_char_sve(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                               opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* ztmp1 */,
                               opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* ztmp2 */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                               opnd_array(7)->as_PRegister(ra_,this,idx7)/* ptmp */, false /* isL */);
  
#line 29584 "ad_aarch64.cpp"
  }
}

void string_equalsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17086 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 1);
  
#line 29604 "ad_aarch64.cpp"
  }
}

void string_equalsUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17102 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 2);
  
#line 29624 "ad_aarch64.cpp"
  }
}

void array_equalsBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp0
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp3
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// vtmp4
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp5
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp6
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// vtmp7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17123 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                                   opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                                   opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc), 1);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 29658 "ad_aarch64.cpp"
  }
}

void array_equalsCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp0
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp3
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// vtmp4
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp5
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// vtmp6
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// vtmp7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17148 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                                   opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                                   opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc), 2);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 29692 "ad_aarch64.cpp"
  }
}

void count_positivesNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17165 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ count_positives(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */, opnd_array(0)->as_Register(ra_,this)/* result */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 29713 "ad_aarch64.cpp"
  }
}

void string_compressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp0
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17186 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ char_array_compress(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                           opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* vtmp0 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* vtmp1 */,
                           opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* vtmp2 */, opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp3 */,
                           opnd_array(8)->as_FloatRegister(ra_,this,idx8)/* vtmp4 */, opnd_array(9)->as_FloatRegister(ra_,this,idx9)/* vtmp5 */);
  
#line 29740 "ad_aarch64.cpp"
  }
}

void string_inflateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp0
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// vtmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// vtmp4
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// vtmp5
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// vtmp6
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17206 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    address tpc = __ byte_array_inflate(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                                        opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* vtmp0 */, opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* vtmp1 */,
                                        opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* vtmp2 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 29772 "ad_aarch64.cpp"
  }
}

void encode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17230 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(0)->as_Register(ra_,this)/* result */, false,
                        as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                        as_FloatRegister(V2_enc), as_FloatRegister(V3_enc),
                        as_FloatRegister(V4_enc), as_FloatRegister(V5_enc));
  
#line 29794 "ad_aarch64.cpp"
  }
}

void encode_ascii_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17251 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(0)->as_Register(ra_,this)/* result */, true,
                        as_FloatRegister(V0_enc), as_FloatRegister(V1_enc),
                        as_FloatRegister(V2_enc), as_FloatRegister(V3_enc),
                        as_FloatRegister(V4_enc), as_FloatRegister(V5_enc));
  
#line 29816 "ad_aarch64.cpp"
  }
}

void compressBitsI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17272 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ S, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ S, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 29839 "ad_aarch64.cpp"
  }
}

void compressBitsI_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17290 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
    __ ldrs(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 29863 "ad_aarch64.cpp"
  }
}

void compressBitsI_memconNode::eval_constant(Compile* C) {
  {

#line 17293 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 29872 "ad_aarch64.cpp"
  }
}
void compressBitsL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17309 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ D, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 29894 "ad_aarch64.cpp"
  }
}

void compressBitsL_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17327 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
    __ ldrd(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 29918 "ad_aarch64.cpp"
  }
}

void compressBitsL_memconNode::eval_constant(Compile* C) {
  {

#line 17330 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 29927 "ad_aarch64.cpp"
  }
}
void expandBitsI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17346 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ S, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ S, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 29949 "ad_aarch64.cpp"
  }
}

void expandBitsI_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17364 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrs, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 4);
    __ ldrs(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ S, 0);
  
#line 29973 "ad_aarch64.cpp"
  }
}

void expandBitsI_memconNode::eval_constant(Compile* C) {
  {

#line 17367 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 29982 "ad_aarch64.cpp"
  }
}
void expandBitsL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17383 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, __ D, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, __ D, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 30004 "ad_aarch64.cpp"
  }
}

void expandBitsL_memconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tsrc
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 17402 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldrd, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(1)->opcode(),
              as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), 8);
    __ ldrd(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ sve_bdep(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tsrc */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmask */);
    __ mov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tdst */, __ D, 0);
  
#line 30028 "ad_aarch64.cpp"
  }
}

void expandBitsL_memconNode::eval_constant(Compile* C) {
  {

#line 17405 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 30037 "ad_aarch64.cpp"
  }
}
void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void loadV2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3053 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::H,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30066 "ad_aarch64.cpp"
  }
}

void storeV2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3077 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::H,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30084 "ad_aarch64.cpp"
  }
}

void loadV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3059 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::S,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30101 "ad_aarch64.cpp"
  }
}

void storeV4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3083 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::S,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30119 "ad_aarch64.cpp"
  }
}

void loadV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3065 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::D,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30136 "ad_aarch64.cpp"
  }
}

void storeV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3089 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::D,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30154 "ad_aarch64.cpp"
  }
}

void loadV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3071 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, MacroAssembler::Q,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30171 "ad_aarch64.cpp"
  }
}

void storeV16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3095 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, MacroAssembler::Q,
       opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30189 "ad_aarch64.cpp"
  }
}

void loadVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 420 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ false,
                          opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, ptrue, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30211 "ad_aarch64.cpp"
  }
}

void storeVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 437 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ true,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, ptrue, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30234 "ad_aarch64.cpp"
  }
}

void loadV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 455 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ false, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */,
                          opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30254 "ad_aarch64.cpp"
  }
}

void storeV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 468 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), /* is_store */ true, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */,
                          opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, bt, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 30275 "ad_aarch64.cpp"
  }
}

void vloadconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 482 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (UseSVE == 0) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      assert(length_in_bytes <= 16, "must be");
      // The iota indices are ordered by type B/S/I/L/F/D, and the offset between two types is 16.
      int offset = exact_log2(type2aelembytes(bt)) << 4;
      if (is_floating_point_type(bt)) {
        offset += 32;
      }
      __ lea(rscratch1, ExternalAddress(StubRoutines::aarch64::vector_iota_indices() + offset));
      if (length_in_bytes == 16) {
        __ ldrq(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, rscratch1);
      } else {
        __ ldrd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, rscratch1);
      }
    } else {
      Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
      __ sve_index(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, 0, 1);
      if (is_floating_point_type(bt)) {
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size);
      }
    }
  
#line 30312 "ad_aarch64.cpp"
  }
}

void vaddBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 516 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30336 "ad_aarch64.cpp"
  }
}

void vaddSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 532 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30360 "ad_aarch64.cpp"
  }
}

void vaddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 548 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30384 "ad_aarch64.cpp"
  }
}

void vaddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 564 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ addv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_add(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30408 "ad_aarch64.cpp"
  }
}

void vaddFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 580 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30432 "ad_aarch64.cpp"
  }
}

void vaddDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 596 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fadd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30456 "ad_aarch64.cpp"
  }
}

void vaddB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 615 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30474 "ad_aarch64.cpp"
  }
}

void vaddS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 625 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30492 "ad_aarch64.cpp"
  }
}

void vaddI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 635 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30510 "ad_aarch64.cpp"
  }
}

void vaddL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 645 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30528 "ad_aarch64.cpp"
  }
}

void vaddF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 655 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30546 "ad_aarch64.cpp"
  }
}

void vaddD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 665 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30564 "ad_aarch64.cpp"
  }
}

void vaddImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 677 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, -val);
    }
  
#line 30586 "ad_aarch64.cpp"
  }
}

void vaddImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 677 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, -val);
    }
  
#line 30608 "ad_aarch64.cpp"
  }
}

void vaddImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 692 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, -val);
    }
  
#line 30630 "ad_aarch64.cpp"
  }
}

void vaddImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 692 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, -val);
    }
  
#line 30652 "ad_aarch64.cpp"
  }
}

void vaddImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, -val);
    }
  
#line 30674 "ad_aarch64.cpp"
  }
}

void vaddImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constant();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, -val);
    }
  
#line 30696 "ad_aarch64.cpp"
  }
}

void vaddImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(2)->constantL();
    if (val > 0) {
      __ sve_add(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, val);
    } else {
      __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, -val);
    }
  
#line 30718 "ad_aarch64.cpp"
  }
}

void vaddImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int val = (int)opnd_array(1)->constantL();
    if (val > 0) {
      __ sve_add(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, val);
    } else {
      __ sve_sub(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, -val);
    }
  
#line 30740 "ad_aarch64.cpp"
  }
}

void vsubBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 740 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30764 "ad_aarch64.cpp"
  }
}

void vsubSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 756 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30788 "ad_aarch64.cpp"
  }
}

void vsubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 772 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30812 "ad_aarch64.cpp"
  }
}

void vsubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 788 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ subv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_sub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30836 "ad_aarch64.cpp"
  }
}

void vsubFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 804 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30860 "ad_aarch64.cpp"
  }
}

void vsubDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 820 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsub(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 30884 "ad_aarch64.cpp"
  }
}

void vsubB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 839 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30902 "ad_aarch64.cpp"
  }
}

void vsubS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 849 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30920 "ad_aarch64.cpp"
  }
}

void vsubI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 859 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30938 "ad_aarch64.cpp"
  }
}

void vsubL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 869 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_sub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30956 "ad_aarch64.cpp"
  }
}

void vsubF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 879 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30974 "ad_aarch64.cpp"
  }
}

void vsubD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 889 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsub(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 30992 "ad_aarch64.cpp"
  }
}

void vmulB_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 903 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mulv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31010 "ad_aarch64.cpp"
  }
}

void vmulB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 914 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31028 "ad_aarch64.cpp"
  }
}

void vmulS_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 925 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mulv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31046 "ad_aarch64.cpp"
  }
}

void vmulS_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 936 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31064 "ad_aarch64.cpp"
  }
}

void vmulI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 947 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mulv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31082 "ad_aarch64.cpp"
  }
}

void vmulI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 958 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31100 "ad_aarch64.cpp"
  }
}

void vmulL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 971 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == 16, "must be");
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, __ D, 0);
    __ umov(rscratch2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, __ D, 0);
    __ mul(rscratch2, rscratch2, rscratch1);
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0, rscratch2);
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, __ D, 1);
    __ umov(rscratch2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, __ D, 1);
    __ mul(rscratch2, rscratch2, rscratch1);
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1, rscratch2);
  
#line 31126 "ad_aarch64.cpp"
  }
}

void vmulL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 990 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31143 "ad_aarch64.cpp"
  }
}

void vmulFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31167 "ad_aarch64.cpp"
  }
}

void vmulDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1017 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fmul(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31191 "ad_aarch64.cpp"
  }
}

void vmulB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1036 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31209 "ad_aarch64.cpp"
  }
}

void vmulS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1046 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ H, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31227 "ad_aarch64.cpp"
  }
}

void vmulI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1056 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31245 "ad_aarch64.cpp"
  }
}

void vmulL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1066 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_mul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31263 "ad_aarch64.cpp"
  }
}

void vmulF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1076 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31281 "ad_aarch64.cpp"
  }
}

void vmulD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1086 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmul(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31299 "ad_aarch64.cpp"
  }
}

void vdivF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1100 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fdiv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31317 "ad_aarch64.cpp"
  }
}

void vdivF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1111 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31335 "ad_aarch64.cpp"
  }
}

void vdivD_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1122 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fdiv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31353 "ad_aarch64.cpp"
  }
}

void vdivD_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1133 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31371 "ad_aarch64.cpp"
  }
}

void vdivF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1146 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31389 "ad_aarch64.cpp"
  }
}

void vdivD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1156 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fdiv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31407 "ad_aarch64.cpp"
  }
}

void vandNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1169 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ andr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_and(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31431 "ad_aarch64.cpp"
  }
}

void vand_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1188 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31451 "ad_aarch64.cpp"
  }
}

void vandImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, (uint64_t)(opnd_array(2)->constant()));
  
#line 31468 "ad_aarch64.cpp"
  }
}

void vandImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, (uint64_t)(opnd_array(1)->constant()));
  
#line 31485 "ad_aarch64.cpp"
  }
}

void vandImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1212 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, (uint64_t)(opnd_array(2)->constant()));
  
#line 31502 "ad_aarch64.cpp"
  }
}

void vandImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1212 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, (uint64_t)(opnd_array(1)->constant()));
  
#line 31519 "ad_aarch64.cpp"
  }
}

void vandImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, (uint64_t)(opnd_array(2)->constant()));
  
#line 31536 "ad_aarch64.cpp"
  }
}

void vandImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, (uint64_t)(opnd_array(1)->constant()));
  
#line 31553 "ad_aarch64.cpp"
  }
}

void vandImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1232 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, (uint64_t)(opnd_array(2)->constantL()));
  
#line 31570 "ad_aarch64.cpp"
  }
}

void vandImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1232 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 31587 "ad_aarch64.cpp"
  }
}

void vorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1245 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31611 "ad_aarch64.cpp"
  }
}

void vor_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1264 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31631 "ad_aarch64.cpp"
  }
}

void vorImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1278 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, (uint64_t)(opnd_array(2)->constant()));
  
#line 31648 "ad_aarch64.cpp"
  }
}

void vorImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1278 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, (uint64_t)(opnd_array(1)->constant()));
  
#line 31665 "ad_aarch64.cpp"
  }
}

void vorImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1288 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, (uint64_t)(opnd_array(2)->constant()));
  
#line 31682 "ad_aarch64.cpp"
  }
}

void vorImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1288 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, (uint64_t)(opnd_array(1)->constant()));
  
#line 31699 "ad_aarch64.cpp"
  }
}

void vorImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1298 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, (uint64_t)(opnd_array(2)->constant()));
  
#line 31716 "ad_aarch64.cpp"
  }
}

void vorImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1298 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, (uint64_t)(opnd_array(1)->constant()));
  
#line 31733 "ad_aarch64.cpp"
  }
}

void vorImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1308 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, (uint64_t)(opnd_array(2)->constantL()));
  
#line 31750 "ad_aarch64.cpp"
  }
}

void vorImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1308 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 31767 "ad_aarch64.cpp"
  }
}

void vxorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1321 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 31791 "ad_aarch64.cpp"
  }
}

void vxor_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1340 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 31811 "ad_aarch64.cpp"
  }
}

void vxorImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, (uint64_t)(opnd_array(2)->constant()));
  
#line 31828 "ad_aarch64.cpp"
  }
}

void vxorImmB_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ B, (uint64_t)(opnd_array(1)->constant()));
  
#line 31845 "ad_aarch64.cpp"
  }
}

void vxorImmSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1364 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, (uint64_t)(opnd_array(2)->constant()));
  
#line 31862 "ad_aarch64.cpp"
  }
}

void vxorImmS_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1364 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ H, (uint64_t)(opnd_array(1)->constant()));
  
#line 31879 "ad_aarch64.cpp"
  }
}

void vxorImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1374 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, (uint64_t)(opnd_array(2)->constant()));
  
#line 31896 "ad_aarch64.cpp"
  }
}

void vxorImmI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1374 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ S, (uint64_t)(opnd_array(1)->constant()));
  
#line 31913 "ad_aarch64.cpp"
  }
}

void vxorImmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1384 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, (uint64_t)(opnd_array(2)->constantL()));
  
#line 31930 "ad_aarch64.cpp"
  }
}

void vxorImmL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1384 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst_src */, __ D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 31947 "ad_aarch64.cpp"
  }
}

void veor3_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1397 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ eor3(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 31966 "ad_aarch64.cpp"
  }
}

void veor3_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1397 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ eor3(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */,
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
  
#line 31985 "ad_aarch64.cpp"
  }
}

void veor3_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1408 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor3(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 32003 "ad_aarch64.cpp"
  }
}

void veor3_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1408 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor3(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
  
#line 32021 "ad_aarch64.cpp"
  }
}

void vnotINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1421 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32045 "ad_aarch64.cpp"
  }
}

void vnotI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1421 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    }
  
#line 32069 "ad_aarch64.cpp"
  }
}

void vnotLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1437 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32093 "ad_aarch64.cpp"
  }
}

void vnotL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1437 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ notr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_not(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */);
    }
  
#line 32117 "ad_aarch64.cpp"
  }
}

void vnotI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1456 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_not(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, get_reg_variant(this),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32136 "ad_aarch64.cpp"
  }
}

void vnotL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1467 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_not(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, get_reg_variant(this),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32155 "ad_aarch64.cpp"
  }
}

void vand_notINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1481 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32180 "ad_aarch64.cpp"
  }
}

void vand_notI_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1481 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    }
  
#line 32205 "ad_aarch64.cpp"
  }
}

void vand_notI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1481 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    }
  
#line 32230 "ad_aarch64.cpp"
  }
}

void vand_notI_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1481 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32255 "ad_aarch64.cpp"
  }
}

void vand_notLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1497 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32280 "ad_aarch64.cpp"
  }
}

void vand_notL_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1497 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */);
    }
  
#line 32305 "ad_aarch64.cpp"
  }
}

void vand_notL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1497 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
    }
  
#line 32330 "ad_aarch64.cpp"
  }
}

void vand_notL_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1497 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_bic(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 32355 "ad_aarch64.cpp"
  }
}

void vand_notI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1516 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_reg_variant(this),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32375 "ad_aarch64.cpp"
  }
}

void vand_notI_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1516 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_reg_variant(this),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 32395 "ad_aarch64.cpp"
  }
}

void vand_notL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1527 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_reg_variant(this),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32415 "ad_aarch64.cpp"
  }
}

void vand_notL_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1527 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_reg_variant(this),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 32435 "ad_aarch64.cpp"
  }
}

void vabsBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1541 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32457 "ad_aarch64.cpp"
  }
}

void vabsSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1556 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32479 "ad_aarch64.cpp"
  }
}

void vabsINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1571 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32501 "ad_aarch64.cpp"
  }
}

void vabsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1586 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ absr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_abs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32523 "ad_aarch64.cpp"
  }
}

void vabsFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1601 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32545 "ad_aarch64.cpp"
  }
}

void vabsDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1616 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fabs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32567 "ad_aarch64.cpp"
  }
}

void vabsB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1634 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ B, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32584 "ad_aarch64.cpp"
  }
}

void vabsS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1644 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ H, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32601 "ad_aarch64.cpp"
  }
}

void vabsI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1654 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32618 "ad_aarch64.cpp"
  }
}

void vabsL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1664 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_abs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32635 "ad_aarch64.cpp"
  }
}

void vabsF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1674 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fabs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32652 "ad_aarch64.cpp"
  }
}

void vabsD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1684 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fabs(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32669 "ad_aarch64.cpp"
  }
}

void vfabd_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1699 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fabd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32687 "ad_aarch64.cpp"
  }
}

void vfabd_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1699 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ fabd(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32705 "ad_aarch64.cpp"
  }
}

void vfabd_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1711 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32725 "ad_aarch64.cpp"
  }
}

void vfabd_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1711 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32745 "ad_aarch64.cpp"
  }
}

void vfabd_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1727 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32765 "ad_aarch64.cpp"
  }
}

void vfabd_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1727 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fabd(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 32785 "ad_aarch64.cpp"
  }
}

void vnegINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1742 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_neg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32809 "ad_aarch64.cpp"
  }
}

void vnegLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1759 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_neg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32831 "ad_aarch64.cpp"
  }
}

void vnegFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1774 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32853 "ad_aarch64.cpp"
  }
}

void vnegDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1789 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fneg(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32875 "ad_aarch64.cpp"
  }
}

void vnegI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1807 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_neg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32894 "ad_aarch64.cpp"
  }
}

void vnegL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1819 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_neg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32911 "ad_aarch64.cpp"
  }
}

void vnegF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1829 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fneg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32928 "ad_aarch64.cpp"
  }
}

void vnegD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1839 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fneg(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 32945 "ad_aarch64.cpp"
  }
}

void vsqrtFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1852 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32967 "ad_aarch64.cpp"
  }
}

void vsqrtDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1867 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fsqrt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 32989 "ad_aarch64.cpp"
  }
}

void vsqrtF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1885 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsqrt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ S, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33006 "ad_aarch64.cpp"
  }
}

void vsqrtD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1895 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fsqrt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 33023 "ad_aarch64.cpp"
  }
}

void vminL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1910 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ cm(Assembler::GT, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ bsl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
  
#line 33042 "ad_aarch64.cpp"
  }
}

void vminL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1921 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_smin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33059 "ad_aarch64.cpp"
  }
}

void vmin_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1934 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ fmin(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ minv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33084 "ad_aarch64.cpp"
  }
}

void vmin_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1953 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ sve_smin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33110 "ad_aarch64.cpp"
  }
}

void vmin_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1974 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt), "unsupported type");
      __ sve_smin(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33136 "ad_aarch64.cpp"
  }
}

void vmaxL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1997 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ cm(Assembler::GT, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ bsl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33155 "ad_aarch64.cpp"
  }
}

void vmaxL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2008 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_smax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 33172 "ad_aarch64.cpp"
  }
}

void vmax_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2021 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ fmax(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ maxv(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33197 "ad_aarch64.cpp"
  }
}

void vmax_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2040 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt) && bt != T_LONG, "unsupported type");
      __ sve_smax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33223 "ad_aarch64.cpp"
  }
}

void vmax_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2061 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ sve_fmax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    } else {
      assert(is_integral_type(bt), "unsupported type");
      __ sve_smax(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    }
  
#line 33249 "ad_aarch64.cpp"
  }
}

void vmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2085 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33276 "ad_aarch64.cpp"
  }
}

void vmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2085 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    }
  
#line 33303 "ad_aarch64.cpp"
  }
}

void vmla_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2085 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33330 "ad_aarch64.cpp"
  }
}

void vmla_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2085 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    }
  
#line 33357 "ad_aarch64.cpp"
  }
}

void vmla_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2085 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33384 "ad_aarch64.cpp"
  }
}

void vmla_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2085 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlav(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, get_arrangement(this),
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
    }
  
#line 33411 "ad_aarch64.cpp"
  }
}

void vmlaLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2104 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33431 "ad_aarch64.cpp"
  }
}

void vmlaL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2104 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst_src1 */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src2 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src3 */);
  
#line 33451 "ad_aarch64.cpp"
  }
}

void vmla_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2119 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33472 "ad_aarch64.cpp"
  }
}

void vmla_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2119 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33493 "ad_aarch64.cpp"
  }
}

void vmla_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2119 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33514 "ad_aarch64.cpp"
  }
}

void vmla_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2119 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33535 "ad_aarch64.cpp"
  }
}

void vfmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2134 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33563 "ad_aarch64.cpp"
  }
}

void vfmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2134 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33591 "ad_aarch64.cpp"
  }
}

void vfmad_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2158 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33613 "ad_aarch64.cpp"
  }
}

void vfmad_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2158 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33635 "ad_aarch64.cpp"
  }
}

void vmlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2175 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlsv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33662 "ad_aarch64.cpp"
  }
}

void vmls_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2175 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlsv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33689 "ad_aarch64.cpp"
  }
}

void vmls_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2175 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ mlsv(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33716 "ad_aarch64.cpp"
  }
}

void vmlsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2194 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33736 "ad_aarch64.cpp"
  }
}

void vmls_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2209 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33757 "ad_aarch64.cpp"
  }
}

void vmls_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2209 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33778 "ad_aarch64.cpp"
  }
}

void vmls_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2209 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33799 "ad_aarch64.cpp"
  }
}

void vmls_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2209 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_mls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33820 "ad_aarch64.cpp"
  }
}

void vfmlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2225 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33848 "ad_aarch64.cpp"
  }
}

void vfmls_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2225 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, get_arrangement(this),
              opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_fmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                  ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
    }
  
#line 33876 "ad_aarch64.cpp"
  }
}

void vfmsb_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2249 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33898 "ad_aarch64.cpp"
  }
}

void vfmsb_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2249 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33920 "ad_aarch64.cpp"
  }
}

void vfnmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2267 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33941 "ad_aarch64.cpp"
  }
}

void vfnmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2267 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmla(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33962 "ad_aarch64.cpp"
  }
}

void vfnmad_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2284 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 33984 "ad_aarch64.cpp"
  }
}

void vfnmad_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2284 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmad(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34006 "ad_aarch64.cpp"
  }
}

void vfnmlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2301 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34027 "ad_aarch64.cpp"
  }
}

void vfnmls_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2301 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmls(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34048 "ad_aarch64.cpp"
  }
}

void vfnmsb_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2318 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34070 "ad_aarch64.cpp"
  }
}

void vfnmsb_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2318 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fnmsb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
                 opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */);
  
#line 34092 "ad_aarch64.cpp"
  }
}

void vmuladdS2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2336 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smullv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ T4H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ smullv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T8H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    __ addpv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34113 "ad_aarch64.cpp"
  }
}

void vshiftcntLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2380 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    }
  
#line 34136 "ad_aarch64.cpp"
  }
}

void vshiftcntRNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2396 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (UseSVE == 0) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      assert(length_in_bytes <= 16, "must be");
      __ negw(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), rscratch1);
    } else {
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    }
  
#line 34160 "ad_aarch64.cpp"
  }
}

void vlsl_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2419 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34178 "ad_aarch64.cpp"
  }
}

void vlsl_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2419 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34196 "ad_aarch64.cpp"
  }
}

void vlsl_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2419 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34214 "ad_aarch64.cpp"
  }
}

void vlsl_neon_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2419 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34232 "ad_aarch64.cpp"
  }
}

void vlsl_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2433 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34252 "ad_aarch64.cpp"
  }
}

void vlsl_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2433 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34272 "ad_aarch64.cpp"
  }
}

void vlsl_sve_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2433 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34292 "ad_aarch64.cpp"
  }
}

void vlsl_sve_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2433 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34312 "ad_aarch64.cpp"
  }
}

void vasr_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2451 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34330 "ad_aarch64.cpp"
  }
}

void vasr_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2451 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34348 "ad_aarch64.cpp"
  }
}

void vasr_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2451 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34366 "ad_aarch64.cpp"
  }
}

void vasr_neon_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2451 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sshl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34384 "ad_aarch64.cpp"
  }
}

void vasr_neon_varNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34406 "ad_aarch64.cpp"
  }
}

void vasr_neon_var_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34428 "ad_aarch64.cpp"
  }
}

void vasr_neon_var_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34450 "ad_aarch64.cpp"
  }
}

void vasr_neon_var_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2466 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ sshl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34472 "ad_aarch64.cpp"
  }
}

void vasr_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2483 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34491 "ad_aarch64.cpp"
  }
}

void vasr_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2483 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34510 "ad_aarch64.cpp"
  }
}

void vasr_sve_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2483 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34529 "ad_aarch64.cpp"
  }
}

void vasr_sve_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2483 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34548 "ad_aarch64.cpp"
  }
}

void vlsr_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34566 "ad_aarch64.cpp"
  }
}

void vlsr_neon_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34584 "ad_aarch64.cpp"
  }
}

void vlsr_neon_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34602 "ad_aarch64.cpp"
  }
}

void vlsr_neon_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ ushl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34620 "ad_aarch64.cpp"
  }
}

void vlsr_neon_varNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34642 "ad_aarch64.cpp"
  }
}

void vlsr_neon_var_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34664 "ad_aarch64.cpp"
  }
}

void vlsr_neon_var_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34686 "ad_aarch64.cpp"
  }
}

void vlsr_neon_var_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2515 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ negr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
    __ ushl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this),
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 34708 "ad_aarch64.cpp"
  }
}

void vlsr_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2532 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34727 "ad_aarch64.cpp"
  }
}

void vlsr_sve_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2532 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34746 "ad_aarch64.cpp"
  }
}

void vlsr_sve_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2532 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34765 "ad_aarch64.cpp"
  }
}

void vlsr_sve_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2532 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shift */);
  
#line 34784 "ad_aarch64.cpp"
  }
}

void vlsl_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 34823 "ad_aarch64.cpp"
  }
}

void vlsl_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 34862 "ad_aarch64.cpp"
  }
}

void vlsl_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 34901 "ad_aarch64.cpp"
  }
}

void vlsl_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2549 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ shl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 34940 "ad_aarch64.cpp"
  }
}

void vasr_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2584 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 34970 "ad_aarch64.cpp"
  }
}

void vasr_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2584 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35000 "ad_aarch64.cpp"
  }
}

void vasr_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2584 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35030 "ad_aarch64.cpp"
  }
}

void vasr_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2584 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ sshr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_asr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35060 "ad_aarch64.cpp"
  }
}

void vlsr_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2610 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35099 "ad_aarch64.cpp"
  }
}

void vlsr_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2610 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35138 "ad_aarch64.cpp"
  }
}

void vlsr_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2610 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35177 "ad_aarch64.cpp"
  }
}

void vlsr_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2610 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Optimize for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_eor(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
        return;
      }
    }
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ ushr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_lsr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35216 "ad_aarch64.cpp"
  }
}

void vasra_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 35241 "ad_aarch64.cpp"
  }
}

void vasra_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 35266 "ad_aarch64.cpp"
  }
}

void vasra_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 35291 "ad_aarch64.cpp"
  }
}

void vasra_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 35316 "ad_aarch64.cpp"
  }
}

void vasra_imm_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 35341 "ad_aarch64.cpp"
  }
}

void vasra_imm_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 35366 "ad_aarch64.cpp"
  }
}

void vasra_imm_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
  
#line 35391 "ad_aarch64.cpp"
  }
}

void vasra_imm_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) {
      // Refine con for B/S
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con >= esize_in_bits) con = esize_in_bits - 1;
    }
    __ ssra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
  
#line 35416 "ad_aarch64.cpp"
  }
}

void vlsra_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 35444 "ad_aarch64.cpp"
  }
}

void vlsra_imm_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35472 "ad_aarch64.cpp"
  }
}

void vlsra_imm_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 35500 "ad_aarch64.cpp"
  }
}

void vlsra_imm_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35528 "ad_aarch64.cpp"
  }
}

void vlsra_imm_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 35556 "ad_aarch64.cpp"
  }
}

void vlsra_imm_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35584 "ad_aarch64.cpp"
  }
}

void vlsra_imm_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(3)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, get_arrangement(this), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, con);
    }
  
#line 35612 "ad_aarch64.cpp"
  }
}

void vlsra_imm_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int con = (int)opnd_array(2)->constant();
    if (is_subword_type(bt)) { // for B/H
      int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
      if (con < esize_in_bits) {
        __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
      }
    } else { // for S/D
      assert(type2aelembytes(bt) == 4 || type2aelembytes(bt) == 8, "unsupported type");
      __ usra(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, con);
    }
  
#line 35640 "ad_aarch64.cpp"
  }
}

void vlsl_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2692 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35660 "ad_aarch64.cpp"
  }
}

void vlsl_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2692 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35680 "ad_aarch64.cpp"
  }
}

void vlsl_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2692 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35700 "ad_aarch64.cpp"
  }
}

void vlsl_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2692 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35720 "ad_aarch64.cpp"
  }
}

void vasr_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35740 "ad_aarch64.cpp"
  }
}

void vasr_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35760 "ad_aarch64.cpp"
  }
}

void vasr_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35780 "ad_aarch64.cpp"
  }
}

void vasr_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35800 "ad_aarch64.cpp"
  }
}

void vlsr_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35820 "ad_aarch64.cpp"
  }
}

void vlsr_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35840 "ad_aarch64.cpp"
  }
}

void vlsr_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35860 "ad_aarch64.cpp"
  }
}

void vlsr_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 35880 "ad_aarch64.cpp"
  }
}

void vlsl_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2739 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 35903 "ad_aarch64.cpp"
  }
}

void vlsl_imm_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2739 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 35926 "ad_aarch64.cpp"
  }
}

void vlsl_imm_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2739 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 35949 "ad_aarch64.cpp"
  }
}

void vlsl_imm_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2739 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con >= 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsl(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 35972 "ad_aarch64.cpp"
  }
}

void vasr_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2757 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 35995 "ad_aarch64.cpp"
  }
}

void vasr_imm_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2757 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36018 "ad_aarch64.cpp"
  }
}

void vasr_imm_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2757 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36041 "ad_aarch64.cpp"
  }
}

void vasr_imm_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2757 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_asr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36064 "ad_aarch64.cpp"
  }
}

void vlsr_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2775 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36087 "ad_aarch64.cpp"
  }
}

void vlsr_imm_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2775 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36110 "ad_aarch64.cpp"
  }
}

void vlsr_imm_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2775 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36133 "ad_aarch64.cpp"
  }
}

void vlsr_imm_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2775 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int esize_in_bits = type2aelembytes(bt) * BitsPerByte;
    int con = (int)opnd_array(2)->constant();
    assert(con > 0 && con < esize_in_bits, "invalid shift immediate");
    __ sve_lsr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, con);
  
#line 36156 "ad_aarch64.cpp"
  }
}

void reduce_addI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2795 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_add_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36179 "ad_aarch64.cpp"
  }
}

void reduce_addI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2810 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36204 "ad_aarch64.cpp"
  }
}

void reduce_addL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2829 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_add_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36227 "ad_aarch64.cpp"
  }
}

void reduce_addL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2844 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36252 "ad_aarch64.cpp"
  }
}

void reduce_add2F_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2865 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ faddp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ S);
    __ fadds(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 36271 "ad_aarch64.cpp"
  }
}

void reduce_add4F_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2877 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ faddp(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ faddp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ S);
    __ fadds(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 36292 "ad_aarch64.cpp"
  }
}

void reduce_addF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2889 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36311 "ad_aarch64.cpp"
  }
}

void reduce_addD_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2906 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ faddp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ D);
    __ faddd(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 36330 "ad_aarch64.cpp"
  }
}

void reduce_addD_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2917 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36349 "ad_aarch64.cpp"
  }
}

void reduce_addI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2932 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36372 "ad_aarch64.cpp"
  }
}

void reduce_addL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2946 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36395 "ad_aarch64.cpp"
  }
}

void reduce_addF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2959 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ S,
                 opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36414 "ad_aarch64.cpp"
  }
}

void reduce_addD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2970 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fadda(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src1 */, __ D,
                 opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 36433 "ad_aarch64.cpp"
  }
}

void reduce_mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2986 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_mul_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt, opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */,
                                opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes,
                                opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
  
#line 36457 "ad_aarch64.cpp"
  }
}

void reduce_mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_mul_integral(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG, opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */,
                                opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, 16, fnoreg, fnoreg);
  
#line 36476 "ad_aarch64.cpp"
  }
}

void reduce_mulFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3013 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_mul_fp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, T_FLOAT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36497 "ad_aarch64.cpp"
  }
}

void reduce_mulDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3026 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_mul_fp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, T_DOUBLE, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, 16, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36517 "ad_aarch64.cpp"
  }
}

void reduce_andI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3042 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 36538 "ad_aarch64.cpp"
  }
}

void reduce_andI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3056 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36562 "ad_aarch64.cpp"
  }
}

void reduce_andL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3074 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 36583 "ad_aarch64.cpp"
  }
}

void reduce_andL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3088 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36607 "ad_aarch64.cpp"
  }
}

void reduce_andI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3106 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36630 "ad_aarch64.cpp"
  }
}

void reduce_andL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3120 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36653 "ad_aarch64.cpp"
  }
}

void reduce_orI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3138 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 36674 "ad_aarch64.cpp"
  }
}

void reduce_orI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3152 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36698 "ad_aarch64.cpp"
  }
}

void reduce_orL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3170 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 36719 "ad_aarch64.cpp"
  }
}

void reduce_orL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3184 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36743 "ad_aarch64.cpp"
  }
}

void reduce_orI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36766 "ad_aarch64.cpp"
  }
}

void reduce_orL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3216 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36789 "ad_aarch64.cpp"
  }
}

void reduce_xorI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3234 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 36810 "ad_aarch64.cpp"
  }
}

void reduce_xorI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3248 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36834 "ad_aarch64.cpp"
  }
}

void reduce_xorL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3266 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_logical(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, length_in_bytes);
  
#line 36855 "ad_aarch64.cpp"
  }
}

void reduce_xorL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3280 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36879 "ad_aarch64.cpp"
  }
}

void reduce_xorI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3298 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36902 "ad_aarch64.cpp"
  }
}

void reduce_xorL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3312 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 36925 "ad_aarch64.cpp"
  }
}

void reduce_maxI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3334 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36948 "ad_aarch64.cpp"
  }
}

void reduce_maxI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3353 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 36973 "ad_aarch64.cpp"
  }
}

void reduce_maxL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3372 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   /* vector_length_in_bytes */ 16, fnoreg);
  
#line 36993 "ad_aarch64.cpp"
  }
}

void reduce_maxL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3386 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37016 "ad_aarch64.cpp"
  }
}

void reduce_maxFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3403 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      if (length_in_bytes == 8) {
        __ fmaxp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ S);
      } else {
        __ fmaxv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fmaxv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmaxs(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37046 "ad_aarch64.cpp"
  }
}

void reduce_maxDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3428 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fmaxp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ D);
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fmaxv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmaxd(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 37072 "ad_aarch64.cpp"
  }
}

void reduce_maxI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3453 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37095 "ad_aarch64.cpp"
  }
}

void reduce_maxL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3468 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37118 "ad_aarch64.cpp"
  }
}

void reduce_maxF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3482 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmaxv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmaxs(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37138 "ad_aarch64.cpp"
  }
}

void reduce_maxD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3494 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fmaxv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmaxd(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 37158 "ad_aarch64.cpp"
  }
}

void reduce_minI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3514 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   length_in_bytes, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37181 "ad_aarch64.cpp"
  }
}

void reduce_minI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3533 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37206 "ad_aarch64.cpp"
  }
}

void reduce_minL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3552 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ neon_reduce_minmax_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                                   opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                                   /* vector_length_in_bytes */ 16, fnoreg);
  
#line 37226 "ad_aarch64.cpp"
  }
}

void reduce_minL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3566 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, T_LONG,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           ptrue, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 37249 "ad_aarch64.cpp"
  }
}

void reduce_minFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3583 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      if (length_in_bytes == 8) {
        __ fminp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ S);
      } else {
        __ fminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ S, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmins(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37279 "ad_aarch64.cpp"
  }
}

void reduce_minDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3608 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ fminp(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */, __ D);
    } else {
      assert(UseSVE > 0, "must be sve");
      assert(length_in_bytes == MaxVectorSize, "invalid vector length");
      __ sve_fminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ D, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    }
    __ fmind(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 37305 "ad_aarch64.cpp"
  }
}

void reduce_minI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37328 "ad_aarch64.cpp"
  }
}

void reduce_minL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// isrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3648 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ sve_reduce_integral(this->ideal_Opcode(), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, bt,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* isrc */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */,
                           opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 37351 "ad_aarch64.cpp"
  }
}

void reduce_minF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// fsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3662 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fminv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmins(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* fsrc */);
  
#line 37371 "ad_aarch64.cpp"
  }
}

void reduce_minD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dsrc
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// vsrc
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3674 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_fminv(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* vsrc */);
    __ fmind(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dsrc */);
  
#line 37391 "ad_aarch64.cpp"
  }
}

void reinterpret_same_sizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void reinterpret_resize_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3698 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    // The higher bits in "dst" register must be cleared to zero.
    if ((length_in_bytes_src == 4 && length_in_bytes_dst == 8) ||
        (length_in_bytes_src == 8 && length_in_bytes_dst == 4)) {
      // Reinterpret between 32 bits and 64 bits
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if ((length_in_bytes_src == 4 && length_in_bytes_dst == 16) ||
               (length_in_bytes_src == 16 && length_in_bytes_dst == 4)) {
      // Reinterpret between 32 bits and 128 bits
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if ((length_in_bytes_src == 8 && length_in_bytes_dst == 16) ||
               (length_in_bytes_src == 16 && length_in_bytes_dst == 8)) {
      // Reinterpret between 64 bits and 128 bits
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(false, "invalid vector length");
      ShouldNotReachHere();
    }
  
#line 37433 "ad_aarch64.cpp"
  }
}

void reinterpret_resize_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3729 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_resize = length_in_bytes_src < length_in_bytes_dst ?
                                  length_in_bytes_src : length_in_bytes_dst;
    assert(length_in_bytes_src <= MaxVectorSize && length_in_bytes_dst <= MaxVectorSize,
           "invalid vector length");
    __ sve_gen_mask_imm(opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */, T_BYTE, length_in_bytes_resize);
    __ sve_dup(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ B, 0);
    __ sve_sel(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ B, opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */,
               opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
  
#line 37461 "ad_aarch64.cpp"
  }
}

void vzeroExtBtoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3750 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    assert(bt == T_SHORT || bt == T_INT || bt == T_LONG, "must be");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4B to 4S/4I, 8B to 8S
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt, length_in_bytes,
                            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_BYTE, /* is_unsigned */ true);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                           opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B, /* is_unsigned */ true);
    }
  
#line 37488 "ad_aarch64.cpp"
  }
}

void vzeroExtStoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3770 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    assert(bt == T_INT || bt == T_LONG, "must be");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4S to 4I
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_INT, length_in_bytes,
                            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_SHORT, /* is_unsigned */ true);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                           opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H, /* is_unsigned */ true);
    }
  
#line 37515 "ad_aarch64.cpp"
  }
}

void vzeroExtItoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3790 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    assert(bt == T_LONG, "must be");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 2I to 2L
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_LONG, length_in_bytes,
                            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_INT, /* is_unsigned */ true);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D,
                           opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S, /* is_unsigned */ true);
    }
  
#line 37542 "ad_aarch64.cpp"
  }
}

void vcvtBtoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3814 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4B to 4S/4I/4F, 8B to 8S
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt == T_FLOAT ? T_INT : bt,
                            length_in_bytes, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_BYTE);
      if (bt == T_FLOAT) {
        __ scvtfv(__ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
      if (is_floating_point_type(bt)) {
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size);
      }
    }
  
#line 37574 "ad_aarch64.cpp"
  }
}

void vcvtStoB_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3843 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4S/8S to 4B/8B
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_BYTE,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_SHORT, length_in_bytes);
  
#line 37593 "ad_aarch64.cpp"
  }
}

void vcvtStoB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3858 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B,
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */);
  
#line 37612 "ad_aarch64.cpp"
  }
}

void vcvtStoX_extendNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3870 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4S to 4I/4F
      __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_INT, length_in_bytes,
                            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_SHORT);
      if (bt == T_FLOAT) {
        __ scvtfv(__ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H);
      if (is_floating_point_type(bt)) {
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size);
      }
    }
  
#line 37644 "ad_aarch64.cpp"
  }
}

void vcvtItoX_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3901 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4I to 4B/4S
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, bt,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_INT, length_in_bytes);
  
#line 37665 "ad_aarch64.cpp"
  }
}

void vcvtItoX_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3918 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 37686 "ad_aarch64.cpp"
  }
}

void vcvtItoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3931 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes =  Matcher::vector_length_in_bytes(this);
    if (bt == T_FLOAT) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 2I/4I to 2F/4F
        __ scvtfv(get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
      }
    } else {
      assert(type2aelembytes(bt) == 8, "unsupported type");
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 2I to 2L/2D
        __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_LONG, length_in_bytes,
                              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_INT);
        if (bt == T_DOUBLE) {
          __ scvtfv(__ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        }
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
        if (bt == T_DOUBLE) {
          __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D);
        }
      }
    }
  
#line 37728 "ad_aarch64.cpp"
  }
}

void vcvtLtoI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3970 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2L to 2I
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_INT,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, T_LONG, length_in_bytes);
  
#line 37747 "ad_aarch64.cpp"
  }
}

void vcvtLtoI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 37768 "ad_aarch64.cpp"
  }
}

void vcvtLtoF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2L to 2F
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 0);
    __ scvtfs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, rscratch1);
    __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 1);
    __ scvtfs(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, rscratch1);
    __ ins(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 1, 0);
  
#line 37791 "ad_aarch64.cpp"
  }
}

void vcvtLtoF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4017 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_scvtf(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S,
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 37811 "ad_aarch64.cpp"
  }
}

void vcvtLtoDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4029 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 2L to 2D
      __ scvtfv(__ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_scvtf(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    }
  
#line 37834 "ad_aarch64.cpp"
  }
}

void vcvtFtoX_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4051 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4F to 4B/4S
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ fcvtzs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ T4S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ neon_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, bt,
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, T_INT, length_in_bytes);
  
#line 37856 "ad_aarch64.cpp"
  }
}

void vcvtFtoX_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4069 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fcvtzs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 37878 "ad_aarch64.cpp"
  }
}

void vcvtFtoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4083 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes =  Matcher::vector_length_in_bytes(this);
    if (bt == T_INT) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 2F/4F to 2I/4I
        __ fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
      }
    } else if (bt == T_LONG) {
      if (UseSVE == 0) {
        // 2F to 2L
        __ fcvtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2S);
        __ fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      } else {
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
        __ sve_fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S);
      }
    } else {
      assert(bt == T_DOUBLE, "unsupported type");
      if (length_in_bytes == 16) {
        // 2F to 2D
        __ fcvtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2S);
      } else {
        assert(UseSVE > 0 && length_in_bytes > 16, "must be");
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
        __ sve_fcvt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S);
      }
    }
  
#line 37923 "ad_aarch64.cpp"
  }
}

void vcvtDtoI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4125 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2D to 2I
    __ ins(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0, 1);
    // We can't use fcvtzs(vector, integer) instruction here because we need
    // saturation arithmetic. See JDK-8276151.
    __ fcvtzdw(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ fcvtzdw(rscratch2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */);
    __ fmovs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, rscratch1);
    __ mov(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, 1, rscratch2);
  
#line 37947 "ad_aarch64.cpp"
  }
}

void vcvtDtoI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4146 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_fcvtzs(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ elemType_to_regVariant(bt),
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 37968 "ad_aarch64.cpp"
  }
}

void vcvtDtoLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4159 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes =  Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 2D to 2L
      __ fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_fcvtzs(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    }
  
#line 37991 "ad_aarch64.cpp"
  }
}

void vcvtDtoF_64bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4177 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 2D to 2F
    __ fcvtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2D);
  
#line 38008 "ad_aarch64.cpp"
  }
}

void vcvtDtoF_gt64bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4190 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fcvt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S,
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38029 "ad_aarch64.cpp"
  }
}

void vcvtHFtoFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4204 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      // 4HF to 4F
      __ fcvtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T4H);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H);
      __ sve_fcvt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ H);
    }
  
#line 38053 "ad_aarch64.cpp"
  }
}

void vcvtFtoHF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4224 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // 4F to 4HF
    __ fcvtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T4S);
  
#line 38070 "ad_aarch64.cpp"
  }
}

void vcvtFtoHF_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4236 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_fcvt(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ H, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S);
    __ sve_vector_narrow(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ H,
                         opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, __ S, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38091 "ad_aarch64.cpp"
  }
}

void replicateINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4252 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_reg_variant(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 38113 "ad_aarch64.cpp"
  }
}

void replicateLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4267 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_reg_variant(this), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 38135 "ad_aarch64.cpp"
  }
}

void replicateFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4282 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ S, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 38157 "ad_aarch64.cpp"
  }
}

void replicateDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4297 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 38179 "ad_aarch64.cpp"
  }
}

void replicateI_imm_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4316 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    int imm = (int)opnd_array(1)->constant();
    if (type2aelembytes(bt) == 1) {
      // Refine imm for B
      imm = imm & 0xff;
    } else if (type2aelembytes(bt) == 2) {
      // Refine imm for S
      imm = imm & 0xffff;
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), imm);
  
#line 38204 "ad_aarch64.cpp"
  }
}

void replicateB_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4336 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, (int)(opnd_array(1)->constant()));
  
#line 38221 "ad_aarch64.cpp"
  }
}

void replicateI_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4349 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_reg_variant(this), (int)(opnd_array(1)->constant()));
  
#line 38238 "ad_aarch64.cpp"
  }
}

void replicateL_imm_128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4360 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, (uint64_t)(opnd_array(1)->constantL()));
  
#line 38254 "ad_aarch64.cpp"
  }
}

void replicateL_imm8_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4370 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_dup(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, (int)(opnd_array(1)->constantL()));
  
#line 38271 "ad_aarch64.cpp"
  }
}

void insertI_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4388 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
           (int)(opnd_array(3)->constant()), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 38296 "ad_aarch64.cpp"
  }
}

void insertI_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4411 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, size, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, size, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, (int)(opnd_array(3)->constant()) - 16);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 38325 "ad_aarch64.cpp"
  }
}

void insertI_index_ge32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4435 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, size, 0, 1);
    __ sve_dup(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, size, (int)(opnd_array(3)->constant()));
    __ sve_cmp(Assembler::EQ, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, size, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 38356 "ad_aarch64.cpp"
  }
}

void insertL_128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4458 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, (int)(opnd_array(3)->constant()), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 38377 "ad_aarch64.cpp"
  }
}

void insertL_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4474 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ D, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ D, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, (int)(opnd_array(3)->constant()) - 16);
    if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 38404 "ad_aarch64.cpp"
  }
}

void insertF_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4495 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ ins(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, (int)(opnd_array(3)->constant()), 0);
  
#line 38428 "ad_aarch64.cpp"
  }
}

void insertF_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4514 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ S, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, (int)(opnd_array(3)->constant()) - 16);
    __ sve_orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 38453 "ad_aarch64.cpp"
  }
}

void insertF_index_ge32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4532 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, __ S, 0, 1);
    __ sve_dup(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, (int)(opnd_array(3)->constant()));
    __ sve_cmp(Assembler::EQ, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, __ S, ptrue,
               opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */);
    __ sve_orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ S, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 38480 "ad_aarch64.cpp"
  }
}

void insertD_128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4552 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
      __ orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ ins(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */, (int)(opnd_array(3)->constant()), 0);
  
#line 38502 "ad_aarch64.cpp"
  }
}

void insertD_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4568 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_index(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, -16, 1);
    __ sve_cmp(Assembler::EQ, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ D, ptrue,
               opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, (int)(opnd_array(3)->constant()) - 16);
    __ sve_orr(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, __ D, opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 38527 "ad_aarch64.cpp"
  }
}

void extractUB_iregNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4587 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.
    // "idx" is expected to be in range.

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ mov(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* idx */);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
    }
    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, 0);
  
#line 38558 "ad_aarch64.cpp"
  }
}

void extractUB_index_lt16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4610 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B, (int)(opnd_array(2)->constant()));
  
#line 38575 "ad_aarch64.cpp"
  }
}

void extractUB_index_ge16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4621 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_BYTE, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38595 "ad_aarch64.cpp"
  }
}

void extractB_index_lt16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4635 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B, (int)(opnd_array(2)->constant()));
  
#line 38612 "ad_aarch64.cpp"
  }
}

void extractB_index_ge16Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4646 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_BYTE, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38632 "ad_aarch64.cpp"
  }
}

void extractS_index_lt8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4660 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ H, (int)(opnd_array(2)->constant()));
  
#line 38649 "ad_aarch64.cpp"
  }
}

void extractS_index_ge8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4671 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_SHORT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38669 "ad_aarch64.cpp"
  }
}

void extractI_index_lt4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4685 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ S, (int)(opnd_array(2)->constant()));
  
#line 38686 "ad_aarch64.cpp"
  }
}

void extractI_index_ge4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_INT, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38706 "ad_aarch64.cpp"
  }
}

void extractL_index_lt2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4710 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, (int)(opnd_array(2)->constant()));
  
#line 38723 "ad_aarch64.cpp"
  }
}

void extractL_index_ge2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4721 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    __ sve_extract_integral(opnd_array(0)->as_Register(ra_,this)/* dst */, T_LONG, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                            (int)(opnd_array(2)->constant()), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 38743 "ad_aarch64.cpp"
  }
}

void extractFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4735 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int index = (int)opnd_array(2)->constant();
    if (index == 0) {
      __ fmovs(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if (index < 4) {
      __ ins(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0, index);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_orr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ sve_ext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, index << 2);
    }
  
#line 38770 "ad_aarch64.cpp"
  }
}

void extractDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4756 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int index = (int)opnd_array(2)->constant();
    if (index == 0) {
      __ fmovd(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else if (index < 2) {
      __ ins(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0, index);
    } else {
      assert(UseSVE > 0, "must be sve");
      __ sve_orr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ sve_ext(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, index << 3);
    }
  
#line 38797 "ad_aarch64.cpp"
  }
}

void vloadmask_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4781 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_BYTE) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
              opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T8B);
      if (type2aelembytes(bt) >= 4) {
        __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H);
      }
      if (type2aelembytes(bt) == 8) {
        __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2S);
      }
      __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    }
  
#line 38827 "ad_aarch64.cpp"
  }
}

void vloadmaskB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4806 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ B,
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 38844 "ad_aarch64.cpp"
  }
}

void vloadmask_extend_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4818 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_vector_extend(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 38864 "ad_aarch64.cpp"
  }
}

void vloadmaskB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4832 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ B,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 0);
  
#line 38882 "ad_aarch64.cpp"
  }
}

void vloadmask_extend_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4844 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_vector_extend(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 38904 "ad_aarch64.cpp"
  }
}

void vstoremaskB_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4860 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 38924 "ad_aarch64.cpp"
  }
}

void vstoremask_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4873 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int esize = (int)opnd_array(2)->constant();
    if (esize == 2) {
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T8H);
    } else if (esize == 4) {
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T4S);
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H);
    } else {
      assert(esize == 8, "must be");
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2S, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T2D);
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S);
      __ xtn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H);
    }
    __ negr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
  
#line 38953 "ad_aarch64.cpp"
  }
}

void vstoremaskB_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4897 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cpy(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, 1, false);
  
#line 38970 "ad_aarch64.cpp"
  }
}

void vstoremask_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4908 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::SIMD_RegVariant size = __ elemBytes_to_regVariant((int)opnd_array(2)->constant());
    __ sve_cpy(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, 1, false);
    __ sve_vector_narrow(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ B,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 38992 "ad_aarch64.cpp"
  }
}

void vloadmask_loadVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4926 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 39018 "ad_aarch64.cpp"
  }
}

void vloadmask_loadV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4949 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load valid mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    BasicType bt = Matcher::vector_element_basic_type(this);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */,
                          opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 39043 "ad_aarch64.cpp"
  }
}

void vloadmask_loadVMaskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4969 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    //
    // Note that we cannot use "pg" here, since it is the predicate used
    // for the vector load with boolean type. But the predicate used in
    // the extending "sve_ld1b" is based on the final extended vector type,
    // which is the full-sized predicate (ptrue) used in VectorLoadMask.
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               ptrue, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 39075 "ad_aarch64.cpp"
  }
}

void vloadmask_loadVMasked_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4997 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Load valid mask values which are boolean type, and extend them to the
    // defined vector element type. Convert the vector to predicate.
    //
    // Note that we cannot use "pg1" here, since it is the predicate used
    // for the vector load with boolean type. But the predicate used in
    // the extending "sve_ld1b" is based on the final extended vector type,
    // which is the "pg2" used in VectorLoadMask.
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), false, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */,
                          opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg2 */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg2 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, 0);
  
#line 39108 "ad_aarch64.cpp"
  }
}

void storeV_vstoremaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5026 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    assert(type2aelembytes(bt) == (int)opnd_array(3)->constant(), "unsupported type");
    Assembler::SIMD_RegVariant size = __ elemBytes_to_regVariant(opnd_array(3)->constant());
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 39135 "ad_aarch64.cpp"
  }
}

void storeV_vstoremask_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5048 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_cpy(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    __ sve_gen_mask_imm(opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, bt, Matcher::vector_length(this, opnd_array(2)));
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */,
                          opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 39163 "ad_aarch64.cpp"
  }
}

void storeVMasked_vstoremaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5069 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    //
    // Note that we cannot use "pg" here, since it is the predicate used
    // for the vector store with boolean type. But the predicate used in
    // the narrowing "sve_st1b" is based on the "src" vector type, which
    // is the full-sized predicate (ptrue) here.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    assert(type2aelembytes(bt) == (int)opnd_array(3)->constant(), "unsupported type.");
    Assembler::SIMD_RegVariant size = __ elemBytes_to_regVariant(opnd_array(3)->constant());
    __ sve_cpy(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */,
                          ptrue, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 39196 "ad_aarch64.cpp"
  }
}

void storeVMasked_vstoremask_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// esize
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5096 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Convert the valid src predicate to vector, and store the vector elements
    // as boolean values.
    //
    // Note that we cannot use "pg" here, since it is the predicate used for the
    // vector store with boolean type. But the predicate used in the narrowing
    // "sve_st1b" is based on the "src" vector type, which needed to be generated
    // here.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_cpy(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src */, 1, false);
    __ sve_gen_mask_imm(opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, bt, Matcher::vector_length(this, opnd_array(2)));
    loadStoreA_predicated(C2_MacroAssembler(&cbuf), true, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */,
                          opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */, T_BOOLEAN, bt, opnd_array(1)->opcode(),
                          as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 39230 "ad_aarch64.cpp"
  }
}

void vmask_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5123 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_and(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 39247 "ad_aarch64.cpp"
  }
}

void vmask_orNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5133 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_orr(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 39264 "ad_aarch64.cpp"
  }
}

void vmask_xorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5143 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eor(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 39281 "ad_aarch64.cpp"
  }
}

void vmask_and_notINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5153 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 39299 "ad_aarch64.cpp"
  }
}

void vmask_and_notLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pn
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5163 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_bic(opnd_array(0)->as_PRegister(ra_,this)/* pd */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pn */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pm */);
  
#line 39317 "ad_aarch64.cpp"
  }
}

void vmaskcmp_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5177 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, bt, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                    opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, condition, /* isQ */ length_in_bytes == 16);
  
#line 39339 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroI_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5191 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, Matcher::vector_element_basic_type(this),
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 39361 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroL_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5205 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_LONG,
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 39383 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroF_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5219 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_FLOAT,
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 39405 "ad_aarch64.cpp"
  }
}

void vmaskcmp_zeroD_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5233 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    __ neon_compare_zero(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, T_DOUBLE,
                         opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         condition, /* isQ */ length_in_bytes == 16);
  
#line 39427 "ad_aarch64.cpp"
  }
}

void vmaskcmp_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5248 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_compare(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                   opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, condition);
  
#line 39450 "ad_aarch64.cpp"
  }
}

void vmaskcmp_immI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5264 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, get_reg_variant(in(operand_index(opnd_array(1)))),
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 39472 "ad_aarch64.cpp"
  }
}

void vmaskcmpU_immI_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5279 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, get_reg_variant(in(operand_index(opnd_array(1)))),
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constant());
  
#line 39494 "ad_aarch64.cpp"
  }
}

void vmaskcmp_immL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5294 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, get_reg_variant(in(operand_index(opnd_array(1)))),
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constantL());
  
#line 39516 "ad_aarch64.cpp"
  }
}

void vmaskcmpU_immL_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5309 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_cmp(condition, opnd_array(0)->as_PRegister(ra_,this)/* dst */, get_reg_variant(in(operand_index(opnd_array(1)))),
               ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, (int)opnd_array(2)->constantL());
  
#line 39538 "ad_aarch64.cpp"
  }
}

void vmaskcmp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5325 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    Assembler::Condition condition = to_assembler_cond((BoolTest::mask)opnd_array(3)->constant());
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_compare(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */,
                   opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, condition);
  
#line 39560 "ad_aarch64.cpp"
  }
}

void vmaskcast_same_esize_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmaskcast_extend_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5352 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType dst_bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(dst_bt)) {
      dst_bt = (dst_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    BasicType src_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    if (is_floating_point_type(src_bt)) {
      src_bt = (src_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    __ neon_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, dst_bt, length_in_bytes_dst,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, src_bt);
  
#line 39594 "ad_aarch64.cpp"
  }
}

void vmaskcast_narrow_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5373 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType dst_bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(dst_bt)) {
      dst_bt = (dst_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    BasicType src_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    if (is_floating_point_type(src_bt)) {
      src_bt = (src_bt == T_FLOAT) ? T_INT : T_LONG;
    }
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ neon_vector_narrow(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, dst_bt,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, src_bt, length_in_bytes_src);
  
#line 39620 "ad_aarch64.cpp"
  }
}

void vmaskcast_same_esize_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmaskcast_extend_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5404 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes_dst == 2 * length_in_bytes_src ||
           length_in_bytes_dst == 4 * length_in_bytes_src ||
           length_in_bytes_dst == 8 * length_in_bytes_src, "invalid vector length");
    __ sve_vmaskcast_extend(opnd_array(0)->as_PRegister(ra_,this)/* dst */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */,
                            length_in_bytes_dst, length_in_bytes_src);
  
#line 39650 "ad_aarch64.cpp"
  }
}

void vmaskcast_narrow_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5422 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes_dst * 2 == length_in_bytes_src ||
           length_in_bytes_dst * 4 == length_in_bytes_src ||
           length_in_bytes_dst * 8 == length_in_bytes_src, "invalid vector length");
    __ sve_vmaskcast_narrow(opnd_array(2)->as_PRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */,
                            length_in_bytes_dst, length_in_bytes_src);
  
#line 39674 "ad_aarch64.cpp"
  }
}

void vmask_reinterpret_same_esizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmask_reinterpret_diff_esizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5454 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType from_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    Assembler::SIMD_RegVariant from_size = __ elemType_to_regVariant(from_bt);
    BasicType to_bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant to_size = __ elemType_to_regVariant(to_bt);
    __ sve_cpy(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, from_size, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, -1, false);
    __ sve_cmp(Assembler::EQ, opnd_array(0)->as_PRegister(ra_,this)/* dst */, to_size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, -1);
  
#line 39704 "ad_aarch64.cpp"
  }
}

void vmask_truecount_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5474 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector of boolean represented as bytes with
    // 0x00/0x01 as element values.
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ addv(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B,
            opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, __ B, 0);
  
#line 39728 "ad_aarch64.cpp"
  }
}

void vmask_truecount_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5491 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ sve_cntp(opnd_array(0)->as_Register(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */);
  
#line 39746 "ad_aarch64.cpp"
  }
}

void vstoremask_truecount_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5505 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector mask represented as lanes with
    // 0/-1 as element values.
    uint esize = (uint)opnd_array(2)->constant();
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    Assembler::SIMD_Arrangement arrangement = Assembler::esize2arrangement(esize,
                                                                           /* isQ */ length_in_bytes == 16);
    if (arrangement == __ T2D || arrangement == __ T2S) {
      __ addpv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* vtmp */, arrangement, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    } else {
      __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* vtmp */, arrangement, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
    __ smov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* vtmp */, __ B, 0);
    __ neg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 39776 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5529 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Returns the index of the first active lane of the
    // vector mask, or VLENGTH if no lane is active.
    //
    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.
    //
    // Computed by reversing the bits and counting the leading
    // zero bytes.

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    uint vlength = Matcher::vector_length(this, opnd_array(1));
    if (vlength <= 8) {
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      if (vlength == 2 || vlength == 4) {
        // Special handling for 2B or 4B cases:
        // Vector mask is moved to a 64-bit general register, but only the low 16/32 bits are
        // significant for 2B/4B cases. We initialize the 16th/32nd bit as bit 1, so as to generate
        // the expected result (i.e. VLENGTH) for the case that all lanes are zero.
        __ orr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, vlength == 2 ? 0x10000 : 0x100000000);
      }
      __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ lsrw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 3);
    } else {
      assert(vlength == 16, "must be");
      Label FIRST_TRUE_INDEX;

      // Try to compute the result from lower 64 bits.
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, zr);
      __ cbnz(opnd_array(0)->as_Register(ra_,this)/* dst */, FIRST_TRUE_INDEX);

      // Compute the result from the higher 64 bits.
      __ fmovhid(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, 8);

      // Reverse the bits and count the leading zero bytes.
      __ bind(FIRST_TRUE_INDEX);
      __ rbit(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ addw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LSR, 3);
    }
  
#line 39834 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5585 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_brkb(opnd_array(2)->as_PRegister(ra_,this,idx2)/* ptmp */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, false);
    __ sve_cntp(opnd_array(0)->as_Register(ra_,this)/* dst */, __ elemType_to_regVariant(bt), ptrue, opnd_array(2)->as_PRegister(ra_,this,idx2)/* ptmp */);
  
#line 39855 "ad_aarch64.cpp"
  }
}

void vmask_firsttrue_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5600 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ sve_brkb(opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, false);
    __ sve_cntp(opnd_array(0)->as_Register(ra_,this)/* dst */, __ elemType_to_regVariant(bt), ptrue, opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */);
  
#line 39875 "ad_aarch64.cpp"
  }
}

void vmask_lasttrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5614 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Returns the index of the last active lane of the
    // vector mask, or -1 if no lane is active.
    //
    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    assert(bt == T_BOOLEAN, "unsupported type");
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    if (length_in_bytes <= 8) {
      // Computed by counting the leading zero bytes and
      // subtracting it by 7 (VLENGTH - 1).
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ movw(rscratch1, 7);
      __ subw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LSR, 3);
    } else {
      assert(length_in_bytes == 16, "must be");
      Label LAST_TRUE_INDEX;

      // Try to compute the result from higher 64 bits.
      __ fmovhid(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, 16 - 1);
      __ cbnz(opnd_array(0)->as_Register(ra_,this)/* dst */, LAST_TRUE_INDEX);

      // Compute the result from the lower 64 bits.
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ movw(rscratch1, 8 - 1);

      // Count the leading zero bytes and subtract it by 15 (VLENGTH - 1).
      __ bind(LAST_TRUE_INDEX);
      __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ subw(opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LSR, 3);
    }
  
#line 39924 "ad_aarch64.cpp"
  }
}

void vmask_lasttrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5658 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ sve_vmask_lasttrue(opnd_array(0)->as_Register(ra_,this)/* dst */, bt, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* ptmp */);
  
#line 39942 "ad_aarch64.cpp"
  }
}

void vmask_tolong_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5671 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Input "src" is a vector of boolean represented as
    // bytes with 0x00/0x01 as element values.

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    if (length_in_bytes <= 8) {
      __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ bytemask_compress(opnd_array(0)->as_Register(ra_,this)/* dst */);
    } else {
      assert(length_in_bytes == 16, "must be");
      __ umov(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 0);
      __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 1);
      __ bytemask_compress(opnd_array(0)->as_Register(ra_,this)/* dst */);
      __ bytemask_compress(rscratch1);
      __ orr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, rscratch1, Assembler::LSL, 8);
    }
  
#line 39972 "ad_aarch64.cpp"
  }
}

void vmask_tolong_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_vmask_tolong(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src */,
                        Matcher::vector_element_basic_type(this, opnd_array(1)),
                        Matcher::vector_length(this, opnd_array(1)),
                        opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */);
  
#line 39993 "ad_aarch64.cpp"
  }
}

void vmask_fromlongNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5711 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_vmask_fromlong(opnd_array(0)->as_PRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */,
                          Matcher::vector_element_basic_type(this),
                          Matcher::vector_length(this),
                          opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */);
  
#line 40014 "ad_aarch64.cpp"
  }
}

void vmaskAll_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5729 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    int con = (int)opnd_array(1)->constant();
    if (con == 0) {
      __ sve_pfalse(opnd_array(0)->as_PRegister(ra_,this)/* dst */);
    } else {
      assert(con == -1, "invalid constant value for mask");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_gen_mask_imm(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, Matcher::vector_length(this));
    }
  
#line 40037 "ad_aarch64.cpp"
  }
}

void vmaskAllINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5747 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_dup(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 40059 "ad_aarch64.cpp"
  }
}

void vmaskAllI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5763 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_dup(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 40081 "ad_aarch64.cpp"
  }
}

void vmaskAll_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5778 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    long con = (long)opnd_array(1)->constantL();
    if (con == 0) {
      __ sve_pfalse(opnd_array(0)->as_PRegister(ra_,this)/* dst */);
    } else {
      assert(con == -1, "invalid constant value for mask");
      BasicType bt = Matcher::vector_element_basic_type(this);
      __ sve_gen_mask_imm(opnd_array(0)->as_PRegister(ra_,this)/* dst */, bt, Matcher::vector_length(this));
    }
  
#line 40104 "ad_aarch64.cpp"
  }
}

void vmaskAllLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5796 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_dup(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size, ptrue, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp */, 0);
  
#line 40126 "ad_aarch64.cpp"
  }
}

void vmaskAllL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5812 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_dup(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, size, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ sve_cmp(Assembler::NE, opnd_array(0)->as_PRegister(ra_,this)/* dst */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, 0);
  
#line 40148 "ad_aarch64.cpp"
  }
}

void vmask_gen_INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5829 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_whileltw(opnd_array(0)->as_PRegister(ra_,this)/* pd */, __ elemType_to_regVariant(bt), zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 40165 "ad_aarch64.cpp"
  }
}

void vmask_gen_LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5841 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_whilelt(opnd_array(0)->as_PRegister(ra_,this)/* pd */, __ elemType_to_regVariant(bt), zr, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 40182 "ad_aarch64.cpp"
  }
}

void vmask_gen_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5853 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_gen_mask_imm(opnd_array(0)->as_PRegister(ra_,this)/* pd */, bt, (uint)(opnd_array(1)->constantL()));
  
#line 40199 "ad_aarch64.cpp"
  }
}

void vmask_gen_subNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5865 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_whilelt(opnd_array(0)->as_PRegister(ra_,this)/* pd */, __ elemType_to_regVariant(bt), opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
  
#line 40217 "ad_aarch64.cpp"
  }
}

void vpopcountINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5879 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
               opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    } else {
      assert(bt == T_SHORT || bt == T_INT, "unsupported");
      if (UseSVE == 0) {
        assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
        __ cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
               opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                  opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        if (bt == T_INT) {
          __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T8H : __ T4H,
                    opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        }
      } else {
        __ sve_cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                   ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 40259 "ad_aarch64.cpp"
  }
}

void vpopcountLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5916 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    if (UseSVE == 0) {
      __ cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T16B, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      __ uaddlp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
    } else {
      __ sve_cnt(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
    }
  
#line 40282 "ad_aarch64.cpp"
  }
}

void vpopcountI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5935 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_cnt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 40301 "ad_aarch64.cpp"
  }
}

void vpopcountL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5947 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_cnt(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ D,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 40319 "ad_aarch64.cpp"
  }
}

void vblend_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5960 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ bsl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
           opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
  
#line 40340 "ad_aarch64.cpp"
  }
}

void vblend_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5973 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_sel(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
               opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
  
#line 40360 "ad_aarch64.cpp"
  }
}

void vround_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5992 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_round_neon(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                         opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp3 */, get_arrangement(this));
  
#line 40382 "ad_aarch64.cpp"
  }
}

void vround_le128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5992 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_round_neon(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                         opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp3 */, get_arrangement(this));
  
#line 40404 "ad_aarch64.cpp"
  }
}

void vround_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6007 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_round_sve(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                        opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                        opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ elemType_to_regVariant(bt));
  
#line 40428 "ad_aarch64.cpp"
  }
}

void vround_gt128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6007 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_round_sve(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                        opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp2 */,
                        opnd_array(5)->as_PRegister(ra_,this,idx5)/* pgtmp */, __ elemType_to_regVariant(bt));
  
#line 40452 "ad_aarch64.cpp"
  }
}

void vroundDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6025 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      switch (opnd_array(2)->constant()) {
        case RoundDoubleModeNode::rmode_rint:
          __ frintn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_floor:
          __ frintm(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_ceil:
          __ frintp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T2D, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        default:
          assert(false, "unsupported");
          ShouldNotReachHere();
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      switch (opnd_array(2)->constant()) {
        case RoundDoubleModeNode::rmode_rint:
          __ sve_frintn(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_floor:
          __ sve_frintm(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        case RoundDoubleModeNode::rmode_ceil:
          __ sve_frintp(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
          break;
        default:
          assert(false, "unsupported");
          ShouldNotReachHere();
      }
    }
  
#line 40501 "ad_aarch64.cpp"
  }
}

void vtest_anytrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6073 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // No need to use src2.
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ umov(rscratch1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, 0);
    __ cmpw(rscratch1, zr);
  
#line 40524 "ad_aarch64.cpp"
  }
}

void vtest_anytrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6089 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // "src2" is not used for sve.
    __ sve_ptest(ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src1 */);
  
#line 40542 "ad_aarch64.cpp"
  }
}

void vtest_alltrue_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6104 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // No need to use src2.
    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
    __ uminv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, length_in_bytes == 16 ? __ T16B : __ T8B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ umov(rscratch1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ B, 0);
    __ cmpw(rscratch1, 0xff);
  
#line 40565 "ad_aarch64.cpp"
  }
}

void vtest_alltrue_sveNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ptmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6121 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_eors(opnd_array(3)->as_PRegister(ra_,this,idx3)/* ptmp */, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* src2 */);
  
#line 40583 "ad_aarch64.cpp"
  }
}

void loadshuffleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6132 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
        if (VM_Version::use_neon_for_vector(length_in_bytes)) {
          __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        } else {
          assert(UseSVE > 0, "must be sve");
          __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
      }
    } else {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        // 4S/8S, 4I, 4F
        __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T8H, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ T8B);
        if (type2aelembytes(bt) == 4) {
          __ uxtl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4S, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ T4H);
        }
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_vector_extend(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */,  __ elemType_to_regVariant(bt),
                             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ B);
      }
    }
  
#line 40623 "ad_aarch64.cpp"
  }
}

void rearrange_HS_neonNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6192 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_SHORT) {
      uint length_in_bytes = Matcher::vector_length_in_bytes(this);
      assert(length_in_bytes == 8 || length_in_bytes == 16, "must be");
      Assembler::SIMD_Arrangement size1 = length_in_bytes == 16 ? __ T16B : __ T8B;
      Assembler::SIMD_Arrangement size2 = length_in_bytes == 16 ? __ T8H : __ T4H;
      __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, size1, 0x02);
      __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, size2, 0x0100);
      __ mulv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size2, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
      __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
      __ tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
    } else {
      assert(bt == T_INT || bt == T_FLOAT, "unsupported type");
      __ mov(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */, __ T16B, 0x04);
      __ mov(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, __ T4S, 0x03020100);
      __ mulv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T4S, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */);
      __ addv(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */);
      __ tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, __ T16B, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
    }
  
#line 40661 "ad_aarch64.cpp"
  }
}

void rearrangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6220 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt_dst = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt_dst == T_BYTE && VM_Version::use_neon_for_vector(length_in_bytes)) {
      __ tbl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
             opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, 1, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */);
    } else {
      assert(UseSVE > 0, "must be sve");
      BasicType bt_src = Matcher::vector_element_basic_type(this, opnd_array(1));
      __ sve_tbl(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt_src),
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* shuffle */);
    }
  
#line 40688 "ad_aarch64.cpp"
  }
}

void gather_loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6243 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_ld1w_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, ptrue,
                       as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
 
#line 40708 "ad_aarch64.cpp"
  }
}

void gather_loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6258 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_uunpklo(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */, __ D, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
    __ sve_ld1d_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, ptrue, as_Register(opnd_array(1)->base(ra_,this,idx1)),
                       opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp */);
  
#line 40730 "ad_aarch64.cpp"
  }
}

void gather_loadS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6273 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_ld1w_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */,
                       as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
  
#line 40749 "ad_aarch64.cpp"
  }
}

void gather_loadD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6286 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_uunpklo(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ D, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* idx */);
    __ sve_ld1d_gather(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(3)->as_PRegister(ra_,this,idx3)/* pg */,
                       as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 40770 "ad_aarch64.cpp"
  }
}

void scatter_storeSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6301 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_st1w_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, ptrue,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
  
#line 40791 "ad_aarch64.cpp"
  }
}

void scatter_storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6316 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    uint length_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(2));
    assert(length_in_bytes == MaxVectorSize, "invalid vector length");
    __ sve_uunpklo(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
    __ sve_st1d_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, ptrue,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp */);
  
#line 40814 "ad_aarch64.cpp"
  }
}

void scatter_storeS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6331 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_st1w_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
  
#line 40834 "ad_aarch64.cpp"
  }
}

void scatter_storeD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// pg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6344 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_uunpklo(opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, __ D, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* idx */);
    __ sve_st1d_scatter(opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */, opnd_array(4)->as_PRegister(ra_,this,idx4)/* pg */,
                        as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */);
  
#line 40856 "ad_aarch64.cpp"
  }
}

void vcountLeadingZerosNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6357 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_LONG) {
      if (UseSVE == 0) {
        __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 0);
        __ clz(rscratch1, rscratch1);
        __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0, rscratch1);
        __ umov(rscratch1, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, __ D, 1);
        __ clz(rscratch1, rscratch1);
        __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1, rscratch1);
      } else {
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    } else {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                   ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 40893 "ad_aarch64.cpp"
  }
}

void vcountLeadingZeros_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6391 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_clz(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 40912 "ad_aarch64.cpp"
  }
}

void vcountTrailingZerosNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6404 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    } else {
      assert(bt == T_SHORT || bt == T_INT || bt == T_LONG, "unsupported type");
      if (UseSVE == 0) {
        assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
        __ neon_reverse_bits(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                             bt, /* isQ */ length_in_bytes == 16);
        if (bt != T_LONG) {
          __ clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, get_arrangement(this), opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
        } else {
          __ umov(rscratch1, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0);
          __ clz(rscratch1, rscratch1);
          __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 0, rscratch1);
          __ umov(rscratch1, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1);
          __ clz(rscratch1, rscratch1);
          __ mov(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ D, 1, rscratch1);
        }
      } else {
        Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        __ sve_clz(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size, ptrue, opnd_array(0)->as_FloatRegister(ra_,this)/* dst */);
      }
    }
  
#line 40961 "ad_aarch64.cpp"
  }
}

void vcountTrailingZeros_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6449 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_rbit(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, size,
                opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
    __ sve_clz(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, size,
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 40983 "ad_aarch64.cpp"
  }
}

void vreverseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6465 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (bt == T_BYTE) {
      if (VM_Version::use_neon_for_vector(length_in_bytes)) {
        __ rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      } else {
        assert(UseSVE > 0, "must be sve");
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ B, ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    } else {
      assert(bt == T_SHORT || bt == T_INT || bt == T_LONG, "unsupported type");
      if (UseSVE == 0) {
        assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
        __ neon_reverse_bits(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                             bt, /* isQ */ length_in_bytes == 16);
      } else {
        __ sve_rbit(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                    ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 41019 "ad_aarch64.cpp"
  }
}

void vreverse_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6498 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_rbit(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
               opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
  
#line 41038 "ad_aarch64.cpp"
  }
}

void vreverseBytesNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6511 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint length_in_bytes = Matcher::vector_length_in_bytes(this);
    if (VM_Version::use_neon_for_vector(length_in_bytes)) {
      assert(length_in_bytes == 8 || length_in_bytes == 16, "unsupported");
      if (bt == T_BYTE) {
        if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
          __ orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, length_in_bytes == 16 ? __ T16B : __ T8B,
                 opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
      } else {
        __ neon_reverse_bytes(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */,
                              bt, /* isQ */ length_in_bytes == 16);
      }
    } else {
      assert(UseSVE > 0, "must be sve");
      if (bt == T_BYTE) {
        if (opnd_array(0)->as_FloatRegister(ra_,this)/* dst */!= opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */) {
          __ sve_orr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
        }
      } else {
        __ sve_revb(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                    ptrue, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
      }
    }
  
#line 41077 "ad_aarch64.cpp"
  }
}

void vreverseBytes_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6546 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_BYTE) {
      // do nothing
    } else {
      __ sve_revb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */, __ elemType_to_regVariant(bt),
                  opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst_src */);
    }
  
#line 41100 "ad_aarch64.cpp"
  }
}

void populateindexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6564 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_index(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                 opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (int)(opnd_array(2)->constant()));
  
#line 41119 "ad_aarch64.cpp"
  }
}

void mcompressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6579 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_cntp(rscratch1, size, ptrue, opnd_array(1)->as_PRegister(ra_,this,idx1)/* pg */);
    __ sve_whilelt(as_PRegister(opnd_array(0)->reg(ra_,this)/* dst */), size, zr, rscratch1);
  
#line 41138 "ad_aarch64.cpp"
  }
}

void vcompressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6593 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ sve_compact(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, __ elemType_to_regVariant(bt),
                   opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */);
  
#line 41157 "ad_aarch64.cpp"
  }
}

void vcompressBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// ptmp
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6607 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_compress_byte(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */,
                         opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */,opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */,
                         opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */,opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */,
                         opnd_array(8)->as_PRegister(ra_,this,idx8)/* ptmp */, opnd_array(9)->as_PRegister(ra_,this,idx9)/* pgtmp */);
  
#line 41184 "ad_aarch64.cpp"
  }
}

void vcompressSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6622 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ sve_compress_short(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */,
                          opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* tmp1 */,opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */);
  
#line 41206 "ad_aarch64.cpp"
  }
}

void vexpandNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// pg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    // Example input:   src   = 1 2 3 4 5 6 7 8
    //                  pg    = 1 0 0 1 1 0 1 1
    // Expected result: dst   = 4 0 0 5 6 0 7 8

    // The basic idea is to use TBL which can shuffle the elements in the given
    // vector flexibly. HISTCNT + SUB is used to generate the second source input
    // for TBL whose value is used to select the indexed element from src vector.

    BasicType bt = Matcher::vector_element_basic_type(this);
    assert(UseSVE == 2 && !is_subword_type(bt), "unsupported");
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    // dst = 0 0 0 0 0 0 0 0
    __ sve_dup(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, 0);
    // dst = 5 0 0 4 3 0 2 1
    __ sve_histcnt(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(2)->as_PRegister(ra_,this,idx2)/* pg */,
                   opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
    // dst = 4 -1 -1 3 2 -1 1 0
    __ sve_sub(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, 1);
    // dst = 4 0 0 5 6 0 7 8
    __ sve_tbl(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, size, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */);
  
#line 41243 "ad_aarch64.cpp"
  }
}

void vsignum_le128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6668 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_signum_neon(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                          opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, get_arrangement(this));
  
#line 41263 "ad_aarch64.cpp"
  }
}

void vsignum_le128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6668 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    __ vector_signum_neon(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                          opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, get_arrangement(this));
  
#line 41283 "ad_aarch64.cpp"
  }
}

void vsignum_gt128bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6681 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_signum_sve(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                         __ elemType_to_regVariant(bt));
  
#line 41308 "ad_aarch64.cpp"
  }
}

void vsignum_gt128b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// pgtmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6681 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    assert(UseSVE > 0, "must be sve");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_signum_sve(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* zero */,
                         opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* one */, opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* tmp */, opnd_array(6)->as_PRegister(ra_,this,idx6)/* pgtmp */,
                         __ elemType_to_regVariant(bt));
  
#line 41333 "ad_aarch64.cpp"
  }
}

void vcompressBitsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_bext(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 41353 "ad_aarch64.cpp"
  }
}

void vexpandBitsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6710 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64_vector.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SIMD_RegVariant size = __ elemType_to_regVariant(bt);
    __ sve_bdep(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, size,
                opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
  
#line 41373 "ad_aarch64.cpp"
  }
}

void compareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 31 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41396 "ad_aarch64.cpp"
  }
}

void compareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 77 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41417 "ad_aarch64.cpp"
  }
}

void compareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 40 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    MacroAssembler _masm(&cbuf);
    guarantee(opnd_array(1)->index(ra_,this,idx1) == -1 && opnd_array(1)->disp(ra_,this,idx1) == 0, "impossible encoding");
    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41440 "ad_aarch64.cpp"
  }
}

void compareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 115 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41461 "ad_aarch64.cpp"
  }
}

void compareAndExchangeN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 131 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 41484 "ad_aarch64.cpp"
  }
}

void compareAndExchangeP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 147 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 41507 "ad_aarch64.cpp"
  }
}

void compareAndExchangeNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 164 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 41530 "ad_aarch64.cpp"
  }
}

void compareAndExchangePAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 181 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ true, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 41553 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 198 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41576 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 215 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ false, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41599 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 234 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41622 "ad_aarch64.cpp"
  }
}

void weakCompareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 253 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/shenandoah/shenandoah_aarch64.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mov(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not currently supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   /*acquire*/ true, /*release*/ true, /*is_cae*/ false, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 41645 "ad_aarch64.cpp"
  }
}

void xLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 64 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    const Address ref_addr = mem2address(opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ ldr(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    x_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch2 /* tmp */, barrier_data());
  
#line 41664 "ad_aarch64.cpp"
  }
}

void xLoadPVolatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 84 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    __ ldar(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    x_load_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch2 /* tmp */, barrier_data());
  
#line 41682 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 103 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 false /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 41715 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 103 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 false /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 41748 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 135 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */ );
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 true /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 41781 "ad_aarch64.cpp"
  }
}

void xCompareAndSwapPAcq_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 135 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, rscratch2);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, rscratch2);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), rscratch2 /* ref */, rscratch1 /* tmp */ );
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 true /* acquire */, true /* release */, false /* weak */, rscratch2);
      __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
      __ bind(good);
    }
  
#line 41814 "ad_aarch64.cpp"
  }
}

void xCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 165 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(4)->as_Register(ra_,this,idx4)/* res */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 false /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ bind(good);
    }
  
#line 41845 "ad_aarch64.cpp"
  }
}

void xCompareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 193 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ldr(rscratch1, Address(rthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(rscratch1, rscratch1, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ cbz(rscratch1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(4)->as_Register(ra_,this,idx4)/* res */, rscratch1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::xword,
                 true /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ bind(good);
    }
  
#line 41876 "ad_aarch64.cpp"
  }
}

void xGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 221 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    __ atomic_xchg(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    x_load_barrier(_masm, this, Address(noreg, 0), opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2 /* tmp */, barrier_data());
  
#line 41895 "ad_aarch64.cpp"
  }
}

void xGetAndSetPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 238 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/x/x_aarch64.ad"

    __ atomic_xchgal(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    x_load_barrier(_masm, this, Address(noreg, 0), opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2 /* tmp */, barrier_data());
  
#line 41914 "ad_aarch64.cpp"
  }
}

void zLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 113 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = mem2address(opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    __ ldr(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    z_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch1);
  
#line 41933 "ad_aarch64.cpp"
  }
}

void zLoadPVolatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 133 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    __ ldar(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, rscratch1);
  
#line 41952 "ad_aarch64.cpp"
  }
}

void zStorePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 151 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = mem2address(opnd_array(1)->opcode(), as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
    z_store_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, rscratch2, false /* is_atomic */);
    __ str(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, ref_addr);
  
#line 41972 "ad_aarch64.cpp"
  }
}

void zStorePVolatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 168 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    const Address ref_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, rscratch2, false /* is_atomic */);
    __ stlr(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
  
#line 41992 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 187 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 42019 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 187 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 42046 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 211 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 42073 "ad_aarch64.cpp"
  }
}

void zCompareAndSwapPAcq_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 211 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, noreg);
    __ cset(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, Assembler::EQ);
  
#line 42100 "ad_aarch64.cpp"
  }
}

void zCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 235 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               false /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    z_uncolor(_masm, this, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 42127 "ad_aarch64.cpp"
  }
}

void zCompareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 258 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, rscratch2, true /* is_atomic */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::xword,
               true /* acquire */, true /* release */, false /* weak */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    z_uncolor(_masm, this, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 42154 "ad_aarch64.cpp"
  }
}

void zGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 280 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    z_store_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2, true /* is_atomic */);
    __ atomic_xchg(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_uncolor(_masm, this, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */);
  
#line 42174 "ad_aarch64.cpp"
  }
}

void zGetAndSetPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 298 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/gc/z/z_aarch64.ad"

    z_store_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, rscratch2, true /* is_atomic */);
    __ atomic_xchgal(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_uncolor(_masm, this, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */);
  
#line 42194 "ad_aarch64.cpp"
  }
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0_orderedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchallocNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadP_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadF_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeC_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeI_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeN_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmN0_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* cacheWBNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compressBitsI_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* compressBitsL_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* expandBitsI_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* expandBitsL_memconNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV2Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV2Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV4Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV16Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadVNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadVNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadVMaskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vloadmask_loadVMasked_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_vstoremaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_vstoremask_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVMasked_vstoremaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVMasked_vstoremask_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadS_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadD_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeSNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeS_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeD_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* xLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xLoadPVolatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPAcq_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* xGetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xGetAndSetPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPVolatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePVolatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPAcq_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zGetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zGetAndSetPAcqNode::memory_operand() const { return _opnds[1]; }


bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // VecA
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // VecZ
    false,  // RegVectMask
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    true ,  // AbsI
    true ,  // AbsL
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // ArrayCopy
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    false,  // Blackhole
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    true ,  // ReverseBytesV
    false,  // CProj
    true ,  // CacheWB
    true ,  // CacheWBPreSync
    true ,  // CacheWBPostSync
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    false,  // CallLeafVector
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastDD
    true ,  // CastFF
    true ,  // CastII
    true ,  // CastLL
    true ,  // CastVV
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    true ,  // CompressBits
    true ,  // ExpandBits
    true ,  // CompressBitsV
    true ,  // ExpandBitsV
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CmpU3
    true ,  // CmpUL
    true ,  // CmpUL3
    true ,  // CompareAndSwapB
    true ,  // CompareAndSwapS
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // WeakCompareAndSwapB
    true ,  // WeakCompareAndSwapS
    true ,  // WeakCompareAndSwapI
    true ,  // WeakCompareAndSwapL
    true ,  // WeakCompareAndSwapP
    true ,  // WeakCompareAndSwapN
    true ,  // CompareAndExchangeB
    true ,  // CompareAndExchangeS
    true ,  // CompareAndExchangeI
    true ,  // CompareAndExchangeL
    true ,  // CompareAndExchangeP
    true ,  // CompareAndExchangeN
    false,  // GetAndAddB
    false,  // GetAndAddS
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    false,  // GetAndSetB
    false,  // GetAndSetS
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    false,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    true ,  // ConvF2HF
    true ,  // ConvHF2F
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    false,  // OuterStripMinedLoop
    false,  // OuterStripMinedLoopEnd
    false,  // LongCountedLoop
    false,  // LongCountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountLeadingZerosV
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CountTrailingZerosV
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    true ,  // UDivI
    true ,  // UDivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    false,  // UDivModI
    false,  // UDivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // FmaD
    true ,  // FmaF
    true ,  // Goto
    true ,  // Halt
    true ,  // CountPositives
    true ,  // If
    false,  // RangeCheck
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachNullCheck
    false,  // MachProj
    true ,  // MulAddS2I
    true ,  // MaxI
    false,  // MaxL
    true ,  // MaxD
    true ,  // MaxF
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // StoreStoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // MinL
    true ,  // MinF
    true ,  // MinD
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // UModI
    true ,  // UModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    false,  // IsInfiniteF
    false,  // IsFiniteF
    false,  // IsInfiniteD
    false,  // IsFiniteD
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // UMulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    false,  // NegI
    false,  // NegL
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    true ,  // OnSpinWait
    false,  // Opaque1
    false,  // OpaqueLoopInit
    false,  // OpaqueLoopStride
    false,  // OpaqueZeroTripGuard
    false,  // Opaque3
    false,  // Opaque4
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    true ,  // OverflowMulI
    true ,  // OverflowAddL
    true ,  // OverflowSubL
    true ,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    false,  // ParsePredicate
    true ,  // PartialSubtypeCheck
    false,  // SubTypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    true ,  // PopCountVI
    true ,  // PopCountVL
    true ,  // PopulateIndex
    true ,  // PrefetchAllocation
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    true ,  // ReverseI
    true ,  // ReverseL
    true ,  // ReverseV
    false,  // Root
    false,  // RoundDouble
    true ,  // RoundDoubleMode
    true ,  // RoundDoubleModeV
    false,  // RoundFloat
    true ,  // RotateLeft
    false,  // RotateLeftV
    true ,  // RotateRight
    false,  // RotateRightV
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SafePointScalarMerge
    true ,  // ShenandoahCompareAndExchangeP
    true ,  // ShenandoahCompareAndExchangeN
    true ,  // ShenandoahCompareAndSwapN
    true ,  // ShenandoahCompareAndSwapP
    true ,  // ShenandoahWeakCompareAndSwapN
    true ,  // ShenandoahWeakCompareAndSwapP
    false,  // ShenandoahIUBarrier
    false,  // ShenandoahLoadReferenceBarrier
    false,  // SCMemProj
    true ,  // CopySignD
    true ,  // CopySignF
    true ,  // SignumD
    true ,  // SignumF
    true ,  // SignumVF
    true ,  // SignumVD
    true ,  // SqrtD
    true ,  // SqrtF
    true ,  // RoundF
    true ,  // RoundD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrCompressedCopy
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // StrIndexOfChar
    true ,  // StrInflatedCopy
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // MacroLogicV
    true ,  // ThreadLocal
    false,  // Unlock
    false,  // URShiftB
    false,  // URShiftS
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddReductionVI
    true ,  // AddVL
    true ,  // AddReductionVL
    true ,  // AddVF
    true ,  // AddReductionVF
    true ,  // AddVD
    true ,  // AddReductionVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVB
    true ,  // MulVS
    true ,  // MulVI
    true ,  // MulReductionVI
    true ,  // MulVL
    true ,  // MulReductionVL
    true ,  // MulVF
    true ,  // MulReductionVF
    true ,  // MulVD
    true ,  // MulReductionVD
    true ,  // MulAddVS2VI
    true ,  // FmaVD
    true ,  // FmaVF
    true ,  // DivVF
    true ,  // DivVD
    true ,  // AbsVB
    true ,  // AbsVS
    true ,  // AbsVI
    true ,  // AbsVL
    true ,  // AbsVF
    true ,  // AbsVD
    true ,  // NegVI
    true ,  // NegVL
    true ,  // NegVF
    true ,  // NegVD
    true ,  // SqrtVD
    true ,  // SqrtVF
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    true ,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    true ,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    true ,  // RShiftVL
    true ,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // AndReductionV
    true ,  // OrV
    true ,  // OrReductionV
    true ,  // XorV
    true ,  // XorReductionV
    true ,  // MinV
    true ,  // MaxV
    true ,  // MinReductionV
    true ,  // MaxReductionV
    true ,  // CompressV
    true ,  // CompressM
    true ,  // ExpandV
    true ,  // LoadVector
    true ,  // LoadVectorGather
    true ,  // LoadVectorGatherMasked
    true ,  // StoreVector
    true ,  // StoreVectorScatter
    true ,  // StoreVectorScatterMasked
    true ,  // LoadVectorMasked
    true ,  // StoreVectorMasked
    false,  // VectorCmpMasked
    true ,  // VectorMaskGen
    false,  // VectorMaskOp
    true ,  // VectorMaskTrueCount
    true ,  // VectorMaskFirstTrue
    true ,  // VectorMaskLastTrue
    true ,  // VectorMaskToLong
    true ,  // VectorLongToMask
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // Replicate
    true ,  // RoundVF
    true ,  // RoundVD
    false,  // Extract
    true ,  // ExtractB
    true ,  // ExtractUB
    false,  // ExtractC
    true ,  // ExtractS
    true ,  // ExtractI
    true ,  // ExtractL
    true ,  // ExtractF
    true ,  // ExtractD
    false,  // Digit
    false,  // LowerCase
    false,  // UpperCase
    false,  // Whitespace
    false,  // VectorBox
    false,  // VectorBoxAllocate
    false,  // VectorUnbox
    false,  // VectorMaskWrapper
    true ,  // VectorMaskCmp
    true ,  // VectorMaskCast
    true ,  // VectorTest
    true ,  // VectorBlend
    true ,  // VectorRearrange
    true ,  // VectorLoadMask
    true ,  // VectorLoadShuffle
    true ,  // VectorLoadConst
    true ,  // VectorStoreMask
    true ,  // VectorReinterpret
    false,  // VectorCast
    true ,  // VectorCastB2X
    true ,  // VectorCastS2X
    true ,  // VectorCastI2X
    true ,  // VectorCastL2X
    true ,  // VectorCastF2X
    true ,  // VectorCastD2X
    true ,  // VectorCastF2HF
    true ,  // VectorCastHF2F
    true ,  // VectorUCastB2X
    true ,  // VectorUCastS2X
    true ,  // VectorUCastI2X
    false,  // VectorizedHashCode
    true ,  // VectorInsert
    true ,  // MaskAll
    true ,  // AndVMask
    true ,  // OrVMask
    true    // XorVMask
};


int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              align_up((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes/BytesPerInt; }

OptoRegPair Matcher::return_value(uint ideal_reg) {

#line 3920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };

    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                      // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 42946 "ad_aarch64.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg) {

#line 3920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.1.ea.rolling.fc38.aarch64/jdk-22+36/src/hotspot/cpu/aarch64/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };

    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                      // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 42982 "ad_aarch64.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(R12_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(R29_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(R31_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_deep_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
// Check adlc -DASSERT=1
#ifndef ASSERT
#  error "ASSERT must be defined"
#endif // ASSERT
